
/*
  Natjecanje timova studenata informaticara hrvatskih sveucilista 2005
  Prvo natjecanje - Zadatak SWAP

  Opis algoritma:
  Za rjesavanje zadatka potrebno je primjetiti da sa jednom zamjenom mozemo 
  smanjiti ukupan broj grupa za najvise dva. Dakle rjesenje koje svakom zamjenom 
  smanji broj grupa za dva, kad god je to moguce, mora biti optimalno. Jedan 
  nacin da se ovo postigne je da se u svakom koraku zamjene grupe 3i-1 i 3i-2, 
  za sve prirodne brojeve i=1..min(k,n/2).
  Da bi rjesenje bilo dovoljno efikasno potrebno je koristiti strukturu podataka 
  koja omogucuje efikasnu setnju kroz grupe, mjenjanje broja elemenata u grupi, 
  te brisanje grupa.
  Donje rjesenje u tu svrhu koristi strukturu podataka set.
*/

#include <iostream>
#include <algorithm>
#include <set>

using namespace std;

set<int> skup;
int n, k;

void citaj_ulaz(void)
{
        cin >> n >> k;

	int staribroj=-1;

	for (int i=0; i<n; i++)
	{
		int novibroj;
                cin >> novibroj;
		if (staribroj!=novibroj)
		{
			skup.insert(i+1);
			staribroj=novibroj;
		}
	}
}

void rijesi (void)
{
	while (skup.size() > 2)
	{
		int koliko=min((int)skup.size()/3, k);
		set<int>::iterator prvi=skup.begin(), drugi, treci, cetvrti;
                cout << koliko << " ";

		while (koliko--)
		{
			drugi=prvi; drugi++;
			treci=drugi; treci++;
			cetvrti=treci; cetvrti++;

			int kraj;
			if (cetvrti==skup.end())
				kraj=n+1;
			else
				kraj=*cetvrti;

			cout << " " << *drugi << endl;

			int novi=*drugi+kraj-*treci;

			skup.erase (drugi); skup.erase (treci);
			if (cetvrti!=skup.end())
				skup.erase(cetvrti);

			prvi=skup.insert(novi).first;
		}

                cout << endl;
	}
        cout << 0 << endl;
}

int main (void)
{
        citaj_ulaz();
        rijesi();

	return 0;
}
