
/*
  Natjecanje timova studenata informaticara hrvatskih sveucilista 2005
  Drugo natjecanje - Zadatak HP

  Opis algoritma:
  Zadatak rjesavamo tako da najprije nadjemo sve moguce H-palindrome s najvise 
  10 znamenki, a nakon toga za svaki zadani broj A, odgovarajuci H-palindrom 
  odredjujemo binarnim pretrazivanjem.
  Prilikom trazenja svih mogucih H-palindroma potrebno je primjetiti da se na 
  temelju broja k i zadnje polovice znamenki moze jednoznacno odrediti prva 
  polovica. Rjesenje radi tako da za sve moguce mnozitelje k izmedju 2 i 15 
  rekurzivno proba sve moguce kombinacije za zadnju polovicu znamenki, na 
  temelju njih odredi prvu polovicu i provjeri da li je dobiveni broj doista 
  H-palindrom.
*/

#include <stdio.h>
#include <stdlib.h>

#define MAX 10
#define MAXHP 1000

typedef long long L;

int z[MAX];

int broj;
L svi[MAXHP];

void dodaj (int n)
{
        int i;
        L a=0;

        for (i=0; i<n; i++)
                a|=((L)z[i])<<(i*4);
        svi[broj++]=a;
}

void nadji_sve (int n, int k, int i, int c)
{
        int j;

        if (i*2>=n)
        {
                for (; i<n; i++)
                {
                        if ((c+k*z[i])%16!=z[n-1-i]) return ;
                        c=(c+k*z[i])/16;
                }
                if (c==0) dodaj(n);
                return ;
        }

        for (j=0; j<16; j++)
        {
                if (i==n-1-i && j!=(j*k+c)%16) continue ;
                if (i==0 && (j*k+c)%16==0) continue ;
                z[i]=j;
                z[n-1-i]=(j*k+c)%16;
                nadji_sve(n, k, i+1, (j*k+c)/16);
        }
}

int llcmp (const void *a, const void *b)
{
        L *aa=(L*)a;
        L *bb=(L*)b;
        if (*aa<*bb) return -1;
        if (*aa>*bb) return 1;
        return 0;
}

L nadji (L x, int lo, int hi)
{
        int mid=(hi+lo)/2;
        if (lo+1==hi) return svi[lo];
        if (svi[mid]>=x) return nadji(x, lo, mid);
        return nadji(x, mid, hi);
}

int main (void)
{
        int n;
        int i, j;
        L x;

        svi[0]=0;
        broj=1;

        for (i=1; i<=MAX; i++)
                for (j=2; j<16; j++)
                        nadji_sve(i, j, 0, 0);

        qsort(svi, broj, sizeof svi[0], llcmp);

        scanf("%d", &n);
        for (i=0; i<n; i++)
        {
                scanf("%llX", &x);
                if (x==0) printf("0\n");
                else printf("%llX\n", nadji(x, 0, broj));
        }

        return 0;
}
