
/*
  Natjecanje timova studenata informaticara hrvatskih sveucilista 2005
  Drugo natjecanje - Zadatak HP

  Opis algoritma:
  Zadatak rjesavamo tako da najprije nadjemo sve moguce H-palindrome s najvise 
  10 znamenki, a nakon toga za svaki zadani broj A, odgovarajuci H-palindrom 
  odredjujemo binarnim pretrazivanjem.
  Prilikom trazenja svih mogucih H-palindroma potrebno je primjetiti da se na 
  temelju broja k i zadnje polovice znamenki moze jednoznacno odrediti prva 
  polovica. Rjesenje radi tako da za sve moguce mnozitelje k izmedju 2 i 15 
  rekurzivno proba sve moguce kombinacije za zadnju polovicu znamenki, na 
  temelju njih odredi prvu polovicu i provjeri da li je dobiveni broj doista 
  H-palindrom.
*/

#include <iostream>
#include <set>
#include <cstdio>

using namespace std;

typedef long long L;

const int MAX=10;

int z[MAX];
set<L> svi;

void dodaj (int n)
{
        L a=0;
        for (int i=0; i<n; i++)
                a|=L(z[i])<<(i*4);
        svi.insert(a);
}

void nadji_sve (int n, int k, int i, int c)
{
        if (i*2>=n)
        {
                for (; i<n; i++)
                {
                        if ((c+k*z[i])%16!=z[n-1-i]) return ;
                        c=(c+k*z[i])/16;
                }
                if (c==0) dodaj(n);
                return ;
        }

        for (int j=0; j<16; j++)
        {
                if (i==n-1-i && j!=(j*k+c)%16) continue ;
                if (i==0 && (j*k+c)%16==0) continue ;
                z[i]=j;
                z[n-1-i]=(j*k+c)%16;
                nadji_sve(n, k, i+1, (j*k+c)/16);
        }
}

int main (void)
{
        svi.insert(0);
        for (int i=1; i<=MAX; i++)
                for (int j=2; j<16; j++)
                        nadji_sve(i, j, 0, 0);

        int n;
        scanf("%d", &n);
        for (int i=0; i<n; i++)
        {
                L x;
                scanf("%llX", &x);
                if (x==0) printf("0\n");
                else printf("%llX\n", *(--svi.lower_bound(x)));
        }

        return 0;
}
