
/*
  Natjecanje studenata informaticara hrvatskih sveucilista 2005
  Zadatak KINEZ

  Opis algoritma:
  Da bi se zadatak rjesio, potrebno je primjetiti sljedece: ako je moguce da,
  krecuci se najkracim putem od stanice a do stanice b, prodjemo kroz stanicu c
  tada mora vrijediti  D[a, b]=D[a, c]+D[c, b], gdje je sa D[x, y] oznacena
  duljina najkraceg puta od stanice x do stanice y.
  Zadatak rjesavamo tako da za sve moguce stanice s provjerimo da li gornji
  uvjet zadovoljen. Kako je garantirano da uvijek postoji rjesenje, potrebno je
  samo provjeriti da li najkraci put od prve zadane stanice do s moze voditi
  kroz zadnju zadanu stanicu.
  Najkraci put od neke stanice do svih ostalih stanica racunamo pretrazivanjem u
  sirinu (bfs).
*/

#include <iostream>
#include <cstring>
#include <list>
#include <queue>
#include <vector>
#include <map>

using namespace std;

const int MAXN=200;
const int MAXK=200;
const int MAXM=100;
const int MAXBROJ=MAXN*MAXK;

typedef list<int> L;
typedef L::iterator Li;

int n;
int k[MAXN];
int l[MAXN][MAXK];

int m;
int g[MAXM];

int broj=0;
L susjed[MAXBROJ];

map<int, int> I;
map<int, int> R;

int d[MAXM][MAXBROJ];

int rjesenje[MAXBROJ];

void citaj_ulaz (void)
{
        cin >> n;
        for (int i=0; i<n; i++)
        {
                cin >> k[i];
                for (int j=0; j<k[i]; j++)
                        cin >> l[i][j];
        }
        cin >> m;
        for (int i=0; i<m; i++)
                cin >> g[i];
}

int indeks (int a)
{
        if (I.count(a)) return I[a];
        I[a]=broj;
        R[broj]=a;
        return broj++;
}

void napravi_graf (void)
{
        for (int i=0; i<n; i++)
                for (int j=0; j<k[i]-1; j++)
                {
                        susjed[indeks(l[i][j])].push_back(indeks(l[i][j+1]));
                        susjed[indeks(l[i][j+1])].push_back(indeks(l[i][j]));
                }
}

void bfs (int a)
{
        queue<int> q;
        memset(d[a], -1, sizeof d[a]);
        q.push(indeks(g[a]));
        d[a][indeks(g[a])]=0;
        while (!q.empty())
        {
                int x=q.front();
                q.pop();
                for (Li i=susjed[x].begin(); i!=susjed[x].end(); i++)
                        if (d[a][*i]==-1)
                        {
                                d[a][*i]=d[a][x]+1;
                                q.push(*i);
                        }
        }
}

void rijesi (void)
{
        bfs(0);
        bfs(m-1);
        int a=indeks(g[m-1]);
        memset(rjesenje, -1, sizeof rjesenje);
        for (int c=0; c<broj; c++)
        {
                if (d[0][a]==-1) rjesenje[c]=0;
                if (d[m-1][c]==-1) rjesenje[c]=0;
                if (d[0][c]==-1) rjesenje[c]=0;
                if (d[0][a]+d[m-1][c]!=d[0][c]) rjesenje[c]=0;
        }
}

void ispisi_rjesenje (void)
{
        vector<int> r;
        for (int i=0; i<broj; i++)
                if (rjesenje[i]) r.push_back(R[i]);
        sort(r.begin(), r.end());
        for (int i=0; i<r.size(); i++)
                cout << r[i] << endl;
}

int main (void)
{
        citaj_ulaz();
        napravi_graf();
        rijesi();
        ispisi_rjesenje();
        return 0;
}
