
/*
  Natjecanje studenata informaticara hrvatskih sveucilista 2005
  Zadatak LUD

  Opis algoritma:
  Zadatak rjesavamo rekurzivno, razmatrajuci dva slucaja: 1. trazena znamenka
  L(n) je "nasljedjena" iz L(n-1), 2. trazena znamenka je jedna od znamenki
  broja n, tj. dodana je u zadnjem koraku.
  Da bi znali o kojem se slucaju radi potrebno je odrediti broj znamenaka broja
  n te provjeriti da li je trazena pozicija k djeljiva s tim brojem.
*/

#include <stdio.h>
#include <math.h>
#include <stdlib.h>

int znamenka(int broj,int indeks)
{
  char niz[20];

  itoa(broj,niz,10);
  return (niz[indeks - 1] - '0');
}

int rijesi(int n,int k)
{
  int broj_znamenaka;

  if (n == 1 || k == 1)
    return 1;

  broj_znamenaka = ((int) log10((double) n+0.1)) + 1;

  if (k % (broj_znamenaka + 1) == 1)
    return rijesi(n - 1,k / (broj_znamenaka + 1) + 1);

  return znamenka(n,(k - 1) % (broj_znamenaka + 1));
}

int main(void)
{
  int n,k;

  scanf("%d%d",&n,&k);
  printf("%d\n",rijesi(n,k));

  return 0;
}
