#include <cstdio>
#include <algorithm>
#include <set>
using namespace std;

const int max_n = 100000;

struct point {
  int x, y;
  
  point(int x_, int y_):x(x_), y(y_) {}
};

inline bool operator < (const point &a, const point &b) {
  return a.x < b.x && a.y > b.y;
}

inline long long eval(const point &a, const point &b, const point &c) {
  return (long long)(b.x - a.x) * (b.y - c.y);
}
inline bool under(const point &a, const point &b) {
  return a.x <= b.x && a.y <= b.y;
}

struct point3 {
  int x, y, z;
};

inline bool operator < (const point3 &a, const point3 &b) {
  return a.z > b.z;
}

typedef multiset<point>::iterator Siter;

inline const point &my_prev(Siter i) {
  --i;
  return *i;
}

point3 ar[max_n];

int main() {
  for (;;) {
    int n, m;
    scanf("%d%d", &n, &m);
    if (n == 0 && m == 0) return 0;
    for (int i = 0; i < n; ++i) scanf("%d%d%d", &ar[i].x, &ar[i].y, &ar[i].z);
    sort(ar, ar + n);
    multiset<point> S;
    S.insert(point(0, m + 1));
    S.insert(point(m + 1, 0));
    int last_z = m + 1;
    long long sum = 0, result = (long long)m * m * m;
    for (int k = 0; k < n; ++k) {
      int z = ar[k].z;
      result -= sum * (last_z - z);
      last_z = z;
      point p(ar[k].x, ar[k].y);
      Siter l = S.lower_bound(p), u = S.upper_bound(p);
      point prev = my_prev(l), cur = *l;
      if (l != u && under(p, cur)) continue;
      while (l != u) {
        S.erase(l++);
        point next = *l;
        sum -= eval(prev, cur, next);
        cur = next;
      }
      sum += eval(prev, p, cur);
      S.insert(u, p);
    }
    result -= sum * last_z;
    printf("%Ld\n", result);
  }
}
