#include <cstdio>
#include <cstring>
#include <climits>

const double inf = 1.0e40;

int vnr[26][26];
int dist[26 * 26][26 * 26 + 2];
int edge[26 * 26][26 * 26];
int adj[26 * 26][26 * 26];
int adj_cnt[26 * 26];
int n;

inline void new_v(int a, int b) {
  if (vnr[a][b] != -1) return;
  vnr[a][b] = n++;
  for (int i = 0; i < n; ++i) edge[i][n - 1] = edge[n - 1][i] = 0;
  adj_cnt[n - 1] = 0;
}
inline void new_edge(int i, int j, int w) {
  if (!edge[i][j]) adj[j][adj_cnt[j]++] = i;
  edge[i][j] <?= w;
}

char str[1002];

int main() {
  for (;;) {
    int m;
    scanf("%d\n", &m);
    if (m == 0) return 0;
    for (int i = 0; i < 26; ++i)
     for (int j = 0; j < 26; ++j) vnr[i][j] = -1;
    n = 0;
    for (; m; --m) {
      gets(str);
      int len = strlen(str);
      if (len < 2) continue;
      int fa = str[0] - 'a', fb = str[1] - 'a', la = str[len - 2] - 'a', lb = str[len - 1] - 'a';
      new_v(fa, fb);
      new_v(la, lb);
      int a = vnr[fa][fb], b = vnr[la][lb];
      new_edge(a, b, -len);
    }
    if (n == 0) {
      printf("No solution.\n");
      continue;
    }
    for (int i = 0; i < n; ++i) dist[i][0] = 0;
    for (int k = 1; k <= n + 1; ++k)
     for (int i = 0; i < n; ++i) {
      dist[i][k] = INT_MAX;
      for (int ii = 0; ii < adj_cnt[i]; ++ii) {
        int j = adj[i][ii];
        if (dist[j][k - 1] != INT_MAX)
         dist[i][k] <?= dist[j][k - 1] + edge[j][i];
      }
    }
    double result = inf;
    for (int v = 0; v < n; ++v) {
      double r = -inf;
      for (int k = 0; k <= n; ++k) {
        if (dist[v][n + 1] == INT_MAX) {
          r = inf;
          break;
        }
        else if (dist[v][k] != INT_MAX)
         r >?= (double)(dist[v][n + 1] - dist[v][k]) / (n + 1 - k);
      }
      result <?= r;
    }
    if (result < inf - 0.000001) printf("%.2f\n", -result);
    else printf("No solution.\n");
  }
}
