#include <stdio.h>
#include <string.h>

#define MAX_N 1040

int n;
struct p_t{
  int i,j;
} p[2][MAX_N][MAX_N];
int pi;

char op[100][8];
char opi[100][5];
char flag[MAX_N][MAX_N];
int op_len;

int rotated;
int multiply;

int lcd(int a, int b) {
  int x=a,y=b;
  while (y) {
    int z=x % y;
    x=y;
    y=z;
  }
  return (a / x) * b;
}

#define func(name, newi, newj) \
                 void name(void) { \
                   int kam=pi^1; \
                   for (int i=0;i<n; i++) for (int j=0;j<n;j++) { \
                     int ni=newi; int nj=newj; \
                     p[kam][ni][nj].i=p[pi][i][j].i; \
                     p[kam][ni][nj].j=p[pi][i][j].j; \
                   } pi=kam; }

func(rot, n-1-j, i);
func(rotinv, j, n-1-i);
func(sym, i, n-1-j);
func(bhsym, i, (i>=n/2) ? n-1-j : j);
func(bvsym, (i>=n/2) ? n+n/2-1-i: i, j);
func(div, (i&1) ? (n/2)+(i/2): i/2, j);
func(divinv, (i>=n/2) ? (i-n/2)*2+1 : i*2, j);

func(mix, (!(i&1)) ? /*sudy radek*/ ((j<n/2) ? i : i+1) :	\
     /*lichy*/ ((j<n/2) ? i-1 : i),            			\
     (!(i&1)) ? /*sudy radek*/ ((j<n/2) ? 2*j : (j-n/2)*2) :    \
     /*lichy*/ ((j<n/2) ? 2*j+1 : (j-n/2)*2+1));

func(mixinv, (!(j&1)) ? (i/2)*2 : (i/2)*2+1,                    \
     (!(i&1)) ? /*sudy radek*/ j/2 :                            \
     /*lichy*/ (j/2 + n/2));


void apply(char *op, int inv) {
  if (!strcmp(op, "id")) return;
  if (!strcmp(op, "rot")) {if (inv) rotinv(); else rot();}
  else if (!strcmp(op, "sym")) sym();
  else if (!strcmp(op, "bhsym")) bhsym();
  else if (!strcmp(op, "bvsym")) bvsym();
  else if (!strcmp(op, "div")) {if (inv) divinv(); else div();}
  else if (!strcmp(op, "mix")) {if (inv) mixinv(); else mix();}
}

int main(void) {
//   n=8;pi=0;
//   for (int i=0;i<n;i++) {
//     for (int j=0;j<n;j++)
//       p[0][i][j].i=i*n+j;
//   }
  
//   opi[0][0]='\0';
//   scanf(" %[^ \n0-9-] %[-]", op[0], opi[0]);
//   apply(op[0], opi[0][0]!='\0');
//   for (int i=0;i<n;i++) {
//     for (int j=0;j<n;j++) printf("%2d ", p[pi][i][j].i);
//     putchar('\n');
//   }
//   return 0;

  while (scanf("%d", &n), n) {
    pi=0;
    for (int i=0;i<n;i++)
      for (int j=0;j<n;j++) {
	p[0][i][j].i=i;
	p[0][i][j].j=j;
      }

    op_len=0;
    while (opi[op_len][0]='\0', 
	   scanf(" %[^ \n0-9-] %[-]", op[op_len], opi[op_len])) op_len++;

    for (int i=op_len-1;i>=0;i--)
      apply(op[i], opi[i][0]!='\0');

    for (int i=0;i<n;i++)
      for (int j=0;j<n;j++)
	flag[i][j]=0;
    
    int nsd=1;
    for (int i=0;i<n;i++)
      for (int j=0;j<n;j++) if (!flag[i][j]) {
	int ni=i, nj=j;
	int len=0;
	do {
	  flag[ni][nj]=1;
	  int xi=p[pi][ni][nj].i;
	  int xj=p[pi][ni][nj].j;
	  ni=xi;
	  nj=xj;

	  len++;
	} while (ni!=i || nj!=j);
	nsd=lcd(nsd,len);
      }    

    printf("%d\n", nsd);
  }

  return 0;
}
