#include <stdio.h>

int n, m;
int inv[]={0,1,4,5,2,3,6};

int A[305][305];

int VAL(char *str) {
  if (*str=='M') return 0;
  if (*str=='T' && str[1]=='U') return 1;
  if (*str=='W') return 2;
  if (*str=='T' && str[1]=='H') return 3;
  if (*str=='F') return 4;
  if (*str=='S' && str[1]=='A') return 5;
  return 6;
}

int main(void) {
  n=m=0;
  while (scanf("%d %d", &n, &m), n) {
    for (int i=0;i<m;i++)
      for (int j=0;j<=n;j++)
	A[i][j]=0;
    
    for (int i=0;i<m;i++) {
      int poc;
      char d[2][8];
      scanf("%d %s %s", &poc, d[0], d[1]);
      A[i][n]=(VAL(d[1])-VAL(d[0])+7+1) % 7;
      for (int j=0;j<poc;j++) {
	int t;
	scanf("%d", &t);
	A[i][t-1]=(A[i][t-1]+1)%7;
      }
    }
    int radek=0;
    int j;
    for (j=0;j<n;j++) {
      //prvni radek s nenul. koef
      int i=radek;
      while (i<m && A[i][j]==0) i++;
      if (i>=m) continue;

      //prohodit za radek-ty
      if (i>radek) {
	int tmp;
	for (int k=0;k<=n;k++) {
	  tmp=A[i][k]; A[i][k]=A[radek][k]; A[radek][k]=tmp;
	}
      }

      //vynormovat
      if (A[radek][j]!=1) {
	int mul=inv[A[radek][j]];
	for (int l=j; l<=n; l++) A[radek][l]=(A[radek][l]*mul)%7;
      }

      //ostatni zeliminovat
      for (int i=0;i<m;i++) if (i!=radek && A[i][j]!=0) {
	int coef=A[i][j];
	
	for (int l=0;l<=n;l++) {
	  A[i][l]=(A[i][l]-coef*A[radek][l]+49) % 7;
	}
      }
      //hura
      radek++;
    }

//     printf("\nP %d N %d\n", radek, n);
//     for (int i=0;i<m;i++) {
//       for (int j=0;j<=n;j++) printf("%d ", A[i][j]);
//       putchar('\n');
//     }

    int multiple=radek<n;
    int bad=0;

    for (j=radek; j<m;j++) {
      if (A[j][n]!=0) bad=1;
    }

    if (bad) puts("Inconsistent data.");
    else if (multiple) puts("Multiple solutions.");
    else {
      printf ("%d", (A[0][n] < 3) ? A[0][n] + 7 : A[0][n]);
      for (int i=1;i<n;i++) printf(" %d", (A[i][n] < 3) ? A[i][n]+7 : A[i][n]);
      putchar('\n');
    }
  }

  return 0;
}
