#include <cstdio>
#include <algorithm>
#include <iterator>
#include <string>
#include <vector>
#include <map>

using namespace std;

typedef long long LL;
typedef pair<int,int> PII;
typedef vector<int> VI;

#define MP make_pair
#define FOR(i,a,b) for(int i=a; i<=b; ++i)
#define FORD(i,a,b) for(int i=a; i>=b; --i)
#define REP(i,n) for(int i=0;i<n; ++i)
#define VAR(v,i) __typeof(i) v=(i)
#define FOREACH(i,c) for(VAR(i,(c).begin()); i!=(c).end(); ++i)
#define PB push_back
#define ST frirst
#define ND second
#define ALL(c) c.begin(),c.end()
#define SIZE(x) (int)x.size()

#define WSP 200
int n,m,ks,kl;
const double eps = 1E-9;
typedef struct{
  int x,y;
} plant;
plant ps[100],pl[100];
double fs[10000],fl[10000];
const int rs = 58*WSP/100, rl = 131*WSP/100;
bool por(plant a, plant b){
  return a.x == b.x ? a.y < b.y : a.x < b.x; 
}
typedef struct{
  double a,b;
} odcinek;
odcinek odc[200];
int odccnt;
void dodajodc(double a,double b){
  odc[odccnt].a = max(a,0.0);
  odc[odccnt].b = min(b,(double)(m*WSP));
  odccnt++;
}
inline bool iszero(double x) { return x >= -eps && x <= eps; }
bool poro(odcinek a,odcinek b){
  return iszero(a.a-b.a) ? a.b < b.b : a.a < b.a;
}
double liczodc(void){
  if (odccnt == 0) return 0.0;
  sort(odc,odc + odccnt, poro);
  double y = -100000.0;
  double fy = -100000.0;
  double s = 0.0;
  REP(i,odccnt){
    if (odc[i].a <= fy)
      fy >?= odc[i].b;
    else{
      s+= fy - y;
      y = odc[i].a;
      fy = odc[i].b;
    }
  }
  s += fy - y;
  return s;
}

int main(){  
  REP(i,1001){
    if (i <= rs)
      fs[1000-i] = fs[i+1000] = sqrt((double)(rs*rs) - (double)(i*i));
    else
      fs[1000-i] = fs[i+1000] = 0.0;
    if (i <= rl)
      fl[1000-i] = fl[i+1000] = sqrt((double)(rl*rl) - (double)(i*i));
    else
      fl[1000-i] = fl[i+1000] = 0.0;
  }
  while(1){
    scanf("%d%d%d%d",&n,&m,&ks,&kl);
    if (!( n+m+ks+kl)) break;
    REP(i,ks) { scanf("%d%d",&(ps[i].x),&(ps[i].y)); ps[i].x *= WSP; ps[i].y *= WSP; }
    REP(i,kl) { scanf("%d%d",&(pl[i].x),&(pl[i].y)); pl[i].x *= WSP; pl[i].y *=WSP; }
    sort(ps,ps+ks,por);
    sort(pl,pl+kl,por);
    int x = 0;
    double s = 0;
    int pozsm=0,pozm=0,pozsl=0,pozl=0;
    while (x < WSP * n){ x|=1;
      while (pozsm < ks && ps[pozsm].x <= x-rs) ++pozsm;
      while (pozsl < kl && pl[pozsl].x <= x-rl) ++pozsl;
      while (pozm < ks && ps[pozm].x < x+rs) ++pozm;
      while (pozl < kl && pl[pozl].x < x+rl) ++pozl;
      if (pozsm == pozm && pozsl == pozl){
        x = min ((pozsm < ks ? (ps[pozsm].x - rs +1) : (WSP*n+1)),
                 (pozsl < kl ? (pl[pozsl].x - rl +1) : (WSP*n+1)));
        continue;
      }
      odccnt = 0;
      FOR(i,pozsm,pozm-1) dodajodc( (double)ps[i].y - fs[1000 + ps[i].x - x], (double)ps[i].y + fs[1000 + ps[i].x - x]);
      FOR(i,pozsl,pozl-1) dodajodc( (double)pl[i].y - fl[1000 + pl[i].x - x], (double)pl[i].y + fl[1000 + pl[i].x - x]);
/*      if (x==WSP*n || x==0)
        s+= liczodc() / 2.0;
      else*/
        s += liczodc();
      ++x;
    }
    printf("%.04lf\n",((double)(n*m))-2.0*s/((double)(WSP * WSP)));
  }
  return 0;
}
