{---------------------------------------------------------------}
{ ACM ICPC 2005-2006, NEERC                                     }
{ Northern Subregional Contest                                  }
{ St Petersburg, October 29, 2005                               }
{---------------------------------------------------------------}
{ Problem A. Astronomy                                          }
{                                                               }
{ Original idea         Pavel Mavrin                            }
{ Problem statement     Pavel Mavrin                            }
{ Testset               Pavel Mavrin                            }
{---------------------------------------------------------------}
{ Solution with test checker                                    }
{                                                               }
{ Author                Georiy Korneev                          }
{---------------------------------------------------------------}

{$q-,r-}
uses
    math, sysutils;

const
    max_t = 10000;
    max_n = 1000;
    max_l = 4 * max_n;

type
    tlong = array [1..max_l] of longint;

procedure mul(var a: tlong; b: longint);
var
    i: longint;
    p: longint;
begin
    p := 0;
    for i := 1 to max_l do begin
        p := p div 10 + a[i] * b;
        a[i] := p mod 10;
    end;
    assert(p = 0);
end;

procedure o(var a: tlong);
var
    i: longint;
    f: boolean;
begin
    f := false;
    for i := max_l downto 1 do begin
        f := f or (a[i] <> 0);
        if f then write(a[i]);
    end;
end;

var
    i, j, n: longint;
    u: array [1..2 * max_t] of boolean;
    p: array [1..max_t] of longint;
    t: array [1..max_n] of longint;
    cp: longint;
    ans: array [1..max_t] of longint;
    f: longint;
    nom, den: tlong;
    v1, v2, v3: longint;
    flag: boolean;
begin
    assign(input, 'astronomy.in'); reset(input);
    assign(output, 'astronomy.out'); rewrite(output);

    cp := 0;

    for i := 2 to 2 * max_t do begin
        if not u[i] then begin
            inc(cp);
            p[cp] := i;

            j := 2 * i;
            while j <= 2 * max_t do begin
                u[j] := true;
                j := j + i;
            end;
        end;
    end;

    read(n);

    assert((2 <= n) and (n <= max_n));
    flag := false;
    for i := 1 to n do begin
        read(t[i]);
        assert((1 <= t[i]) and (t[i] <= max_t));
        if (i > 1) and (t[i] <> t[i - 1]) then flag := true;
    end;
    assert(flag);

    flag := false;
    for i := 2 to n do begin
        if t[i] <> t[1] then begin
            v1 := 2 * abs(t[i] - t[1]);
            v2 := t[i];
            v3 := t[1];

            for j := 1 to cp do begin
                f := 0;
                while v1 mod p[j] = 0 do begin
                    dec(f);
                    v1 := v1 div p[j];
                end;
                while v2 mod p[j] = 0 do begin
                    inc(f);
                    v2 := v2 div p[j];
                end;
                while v3 mod p[j] = 0 do begin
                    inc(f);
                    v3 := v3 div p[j];
                end;

                if flag then begin
                    ans[j] := max(ans[j], f);
                end else begin
                    ans[j] := f;
                end;
            end;
            flag := true;
        end;
    end;

    den[1] := 1;
    nom[1] := 1;
    for i := 1 to cp do begin
        for j := 1 to ans[i] do begin
            mul(nom, p[i]);
        end;
        for j := ans[i] to -1 do begin
            mul(den, p[i]);
        end;
    end;

    o(nom);
    write(' ');
    o(den);

    close(input);
    close(output);
end.