/*-------------------------------------------------------------*/
/* ACM ICPC 2005-2006, NEERC                                   */
/* Northern Subregional Contest                                */
/* St Petersburg, October 29, 2005                             */
/*-------------------------------------------------------------*/
/* Problem B. Bee Garden                                       */
/*                                                             */
/* Original idea         Georgiy Korneev                       */
/* Problem statement     Andrew Stankevich                     */
/* Testset               Georgiy Korneev                       */
/*-------------------------------------------------------------*/
/* Model solution (Java)                                       */
/*                                                             */
/* Author:               Georgiy Korneev                       */
/*-------------------------------------------------------------*/

import java.io.*;
import java.util.*;

class bee_gk {
    private static StreamTokenizer t;
    private static boolean[] u;
    private static double[][] a;
    private static List<List<Integer>> edges;
    private static int[] x;
    private static int[] y;
    private static int n;

    private static int nextInt() throws IOException {
        t.nextToken();
        return (int) t.nval;
    }

    private static double hypot(int dx, int dy) {
        return Math.sqrt(dx * dx + dy * dy);
    }

    private static void dfs(int i, int j, double l) {
        u[j] = true;
        a[i][j] = l;
        for (int k : edges.get(j)) {
            if (!u[k]) {
                dfs(i, k, l + hypot(x[j] - x[k], y[j] - y[k]));
            }
        }
    }

    private static boolean between(int a, int x, int b) {
        return (a <= x) && (x <= b) || (b <= x) && (x <= a);
    }

    public static void main(String args[]) throws IOException {
        Locale.setDefault(Locale.US);

        t = new StreamTokenizer(new BufferedReader(new FileReader("bee.in")));
        PrintWriter writer = new PrintWriter(new FileOutputStream("bee.out"));

        n = nextInt();
        x = new int[n + 1];
        y = new int[n + 1];

        for (int i = 1; i <= n; i++) {
            x[i] = nextInt();
            y[i] = nextInt();
        }

        edges = new ArrayList<List<Integer>>();
        for (int i = 0; i <= n; i++) {
            edges.add(new ArrayList<Integer>());
        }

        for (int i = 0; i < n; i++) {
            int v1 = nextInt();
            int v2 = nextInt();
            edges.get(v1).add(v2);
            edges.get(v2).add(v1);
        }

        a = new double[n + 1][n + 1];

        for (int i = 0; i <= n; i++) {
            u = new boolean[n + 1];
            dfs(i, i, 0);
        }

        double best = 0;
        int besti = 0;
        int bestj = 0;
        for (int i = 0; i <= n; i++) {
            for (int j = i + 1; j <= n; j++) {
                int la = y[i] - y[j];
                int lb = x[j] - x[i];
                int lc = la * x[i] + lb * y[i];

                boolean f = false;
                for (int k = 0; k <= n; k++) if (k != i && k != j) {
                    if (x[k] * la + y[k] * lb == lc) {
                        if (between(x[i], x[k], x[j]) && between(y[i], y[k], y[j])) {
                            f = true;
                        }
                    }
                }
               
                if (!f) {
                    if (a[i][j] - hypot(x[i] - x[j], y[i] - y[j]) > best) {
                        best = a[i][j] - hypot(x[i] - x[j], y[i] - y[j]);
                        besti = i;
                        bestj = j;
                    }
                }
            }
        }

        if (best > 1e-8) {
            writer.println(besti + " " + bestj);
        } else {
            writer.println(-1);
        }
        
        writer.close();
    }
}
