/*-------------------------------------------------------------*/
/* ACM ICPC 2005-2006, NEERC                                   */
/* Northern Subregional Contest                                */
/* St Petersburg, October 29, 2005                             */
/*-------------------------------------------------------------*/
/* Problem B. Bee Garden                                       */
/*                                                             */
/* Original idea         Georgiy Korneev                       */
/* Problem statement     Andrew Stankevich                     */
/* Testset               Georgiy Korneev                       */
/*-------------------------------------------------------------*/
/* Solution                                                    */
/*                                                             */
/* Author:               Pavel Mavrin                          */
/*-------------------------------------------------------------*/

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintWriter;
import java.util.Scanner;

public class bee_pm {

    private static final double EPS = 1e-8;

    public static void main(String[] args) throws FileNotFoundException {
        Scanner scanner = new Scanner(new File("bee.in"));

        int n = scanner.nextInt();
        n++;

        int[] x = new int[n];
        int[] y = new int[n];

        for (int i = 1; i < n; i++) {
            x[i] = scanner.nextInt();
            y[i] = scanner.nextInt();
        }

        double[][] d = new double[n][n];
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                d[i][j] = 1e100;
            }
        }

        for (int i = 1; i < n; i++) {
            int a = scanner.nextInt();
            int b = scanner.nextInt();
            d[a][b] = Math.hypot(x[a] - x[b], y[a] - y[b]);
            d[b][a] = d[a][b];
        }

        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                for (int k = 0; k < n; k++) {
                    d[j][k] = Math.min(d[j][k], d[j][i] + d[i][k]);
                }
            }
        }

        int mini = 0;
        int minj = 0;
        double max = 0;

        for (int i = 0; i < n; i++) {
            for (int j = i + 1; j < n; j++) {
                boolean good = true;
                for (int k = 0; k < n; k++) if (k != i && k != j) {
                    if ((x[k] - x[i]) * (y[j] - y[i]) == (x[j] - x[i]) * (y[k] - y[i]) &&
                            x[k] >= Math.min(x[i], x[j]) && x[k] <= Math.max(x[i], x[j]) &&
                            y[k] >= Math.min(y[i], y[j]) && y[k] <= Math.max(y[i], y[j])) {
                        good = false;
                        break;
                    }
                }
                if (good) {
                    double dd = d[i][j] - Math.hypot(x[i] - x[j], y[i] - y[j]);
                    if (dd > max) {
                        max = dd;
                        mini = i;
                        minj = j;
                    }
                }
            }
        }

        PrintWriter writer = new PrintWriter(new FileOutputStream("bee.out"));
        if (max < EPS)
            writer.print(-1);
        else
            writer.print("" + mini + ' ' + minj);

        writer.close();
    }


}
