/*-------------------------------------------------------------*/
/* ACM ICPC 2005-2006, NEERC                                   */
/* Northern Subregional Contest                                */
/* St Petersburg, October 29, 2005                             */
/*-------------------------------------------------------------*/
/* Problem D. Drying                                           */
/*                                                             */
/* Original idea         Pavel Mavrin                          */
/* Problem statement     Andrew Lopatin                        */
/* Testset               Andrew Lopatin                        */
/*-------------------------------------------------------------*/
/* Solution                                                    */
/*                                                             */
/* Author                Andrew Stankevich                     */
/*-------------------------------------------------------------*/

import java.util.Scanner;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;

public class drying_as {
    public void run() throws FileNotFoundException {
        Scanner in = new Scanner(new File("drying.in"));
        int n = in.nextInt();
        int[] a = new int[n];
        int l = 0;
        int r = 0;
        for (int i = 0; i < n; i++) {
            a[i] = in.nextInt();
            if (a[i] > r) {
                r = a[i];
            }
        }
        int k = in.nextInt();
        in.close();

        if (k != 1) {
            while (r - l > 1) {
                int m = (l + r) / 2;
                long t = 0;
                for (int i = 0; i < n; i++) {
                    if (a[i] > m) {
                        t += (a[i] - m + (k - 2)) / (k - 1);
                    }
                }
                if (t > m) {
                    l = m;
                } else {
                    r = m;
                }
            }
        }

        PrintWriter out = new PrintWriter(new File("drying.out"));
        out.println(r);
        out.close();
    }

    public static void main(String[] args) throws FileNotFoundException {
        new drying_as().run();
    }
}
