/*-------------------------------------------------------------*/
/* ACM ICPC 2005-2006, NEERC                                   */
/* Northern Subregional Contest                                */
/* St Petersburg, October 29, 2005                             */
/*-------------------------------------------------------------*/
/* Problem E. Expectation                                      */
/*                                                             */
/* Original idea         Andrew Stankevich                     */
/* Problem statement     Andrew Lopatin                        */
/* Testset               Andrew Lopatin                        */
/*-------------------------------------------------------------*/
/* Solution                                                    */
/*                                                             */
/* Author                Andrew Stankevich                     */
/*-------------------------------------------------------------*/

import java.util.Scanner;
import java.util.Locale;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;

public class expectation_as {
    public int count1(int n, int l) {
        int m = n / (2 * l) * l;
        if (n - 2 * m < l) {
            return m;
        } else {
            return n - m - l;
        }
    }

    public double expected(int n) {
        double r = 0;
        int l = 1;
        for (int i = 0; i < 31; i++) {
            double p1 = count1(n, l) * 1.0 / n;
            r += 2 * p1 * (1 - p1) * l;
            l = l * 2;
        }
        return r;
    }

    public void run() throws FileNotFoundException {
        Scanner in = new Scanner(new File("expectation.in"));
        PrintWriter out = new PrintWriter(new File("expectation.out"));

        int tn = in.nextInt();
        for (int test = 0; test < tn; test++) {
            int n = in.nextInt();
            out.printf("%.2f\n", expected(n));
        }

        in.close();
        out.close();
    }

    public static void main(String[] args) throws FileNotFoundException {
        Locale.setDefault(Locale.US);
        new expectation_as().run();
    }
}
