/*-------------------------------------------------------------*/
/* ACM ICPC 2005-2006, NEERC                                   */
/* Northern Subregional Contest                                */
/* St Petersburg, October 29, 2005                             */
/*-------------------------------------------------------------*/
/* Problem E. Expectation                                      */
/*                                                             */
/* Original idea         Andrew Stankevich                     */
/* Problem statement     Andrew Lopatin                        */
/* Testset               Andrew Lopatin                        */
/*-------------------------------------------------------------*/
/* Model solution (Java)                                       */
/*                                                             */
/* Author                Georgiy Korneev                       */
/*-------------------------------------------------------------*/

import java.io.*;
import java.util.*;

class expectation_gk {
    private static double p(int n, int s) {
        return (n / s / 2 * s + (((n & s) == 0) ? n % s : s)) / (double) n;
    }
        
    private static double e(int n) {
        double r = 0;
        for (int i = 0; i < 32; i++) {
            int s = 1 << i;
            double p = p(n, s);
            r += 2 * p * (1 - p) * s;
        }
        return r;
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);

        Scanner scanner = new Scanner(new File("expectation.in"));
        PrintWriter writer = new PrintWriter(new FileOutputStream("expectation.out"));

        int k = scanner.nextInt();
        for (int i = 0; i < k; i++) {
            writer.println(e(scanner.nextInt()));
        }

        writer.close();
    }
}