{---------------------------------------------------------------}
{ ACM ICPC 2005-2006, NEERC                                     }
{ Northern Subregional Contest                                  }
{ St Petersburg, October 29, 2005                               }
{---------------------------------------------------------------}
{ Problem E. Expectation                                        }
{                                                               }
{ Original idea         Andrew Stankevich                       }
{ Problem statement     Andrew Lopatin                          }
{ Testset               Andrew Lopatin                          }
{---------------------------------------------------------------}
{ Solution with test checker                                    }
{                                                               }
{ Author                Georgiy Korneev                         }
{---------------------------------------------------------------}

{$q-,r-,o+}
const
    max_k = 1000;
    max_n = 1000000000;

function pr(n, s: longint): double;
var
    b: longint;
begin
    if (n and s) = 0 then begin
        b := n mod s;
    end else begin
        b := s;
    end;
    pr := (b + (n div s) div 2 * s) / n;
end;

function e(n: longint): double;
var
    i: longint;
    r: double;
    s: longint;
    p: double;
begin
    r := 0;
    for i := 0 to 31 do begin
        s := 1 shl i;
        p := pr(n, s);
        r := r + 2 * p * (1 - p) * s;
    end;
    e := r;
end;

var
    i, k, n: longint;
begin
    assign(input, 'expectation.in'); reset(input);
    assign(output, 'expectation.out'); rewrite(output);

    read(k);
    assert((1 <= k) and (k <= max_k));

    for i := 1 to k do begin
        read(n);
        assert((1 <= n) and (n <= max_n));
        writeln(e(n):0:2);
    end;

    close(input);
    close(output);
end.