/*-------------------------------------------------------------*/
/* ACM ICPC 2005-2006, NEERC                                   */
/* Northern Subregional Contest                                */
/* St Petersburg, October 29, 2005                             */
/*-------------------------------------------------------------*/
/* Problem F. Flip and Turn                                    */
/*                                                             */
/* Original idea         Georgiy Korneev                       */
/* Problem statement     Georgiy Korneev                       */
/* Testset               Georgiy Korneev                       */
/*-------------------------------------------------------------*/
/* Model solution (Java)                                       */
/*                                                             */
/* Author                Georgiy Korneev                       */
/*-------------------------------------------------------------*/

import java.io.*;
import java.util.*;

class flip_gk {
    private static final int MAX_S = 100000;
    private static int top = 0;
    private static char[] s = new char[MAX_S * 8];

    private static void add(char ch) {
        if (top == 0 || s[top - 1] != ch) {
            s[top++] = ch;
        } else {
            top--;
        }
    }

    private static void add(String s) {
        for (char ch : s.toCharArray()) {
            add(ch);
        }
    }
    
    private static int readNumber(Reader reader) throws IOException {
        int ch = reader.read();
        switch (ch) {
            case '9': {
                reader.read();
                return 1;
            }
            case '1': {
                reader.read();
                reader.read();
                return 2;
            }
            case '2': {
                reader.read();
                reader.read();
                return 3;
            }
            default: {
                throw new RuntimeException("" + (char) ch);
            }
        }
    }

    private static char[][] t(char[][] a) {
        char[][] b = new char[a[0].length][a.length];
        for (int i = 0; i < a.length; i++) {
            for (int j = 0; j < a[i].length; j++) {
                b[j][i] = a[i][j];
            }
        }
        return b;
    }

    private static char[][] f(char[][] a) {
        char[][] b = new char[a.length][a[0].length];
        for (int i = 0; i < a.length; i++) {
            for (int j = 0; j < a[i].length; j++) {
                b[a.length - i - 1][j] = a[i][j];
            }
        }
        return b;
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);

        LineNumberReader reader = new LineNumberReader(new FileReader("flip.in"));
        PrintWriter writer = new PrintWriter(new FileOutputStream("flip.out"));

        StringTokenizer tokenizer = new StringTokenizer(reader.readLine());

        int n = Integer.parseInt(tokenizer.nextToken());
        int m = Integer.parseInt(tokenizer.nextToken());

        char[][] a = new char[n][m];

        for (int i = 0; i < a.length; i++) {
            for (int j = 0; j < a[i].length; j++) {
                a[i][j] = (char) reader.read();
            }
            reader.readLine();
        }

        int ch;
        while ((ch = reader.read()) != -1) {
            switch(ch) {
                case '1': 
                    add("t");
                    break;
                case '2': 
                    add("ftf");
                    break;
                case 'V': 
                    add("tft");
                    break;
                case 'H': 
                    add("f");
                    break;
                case 'A':
                case 'Z':
                    add("ft");
                    break;
                case 'B':
                case 'Y':
                    add("ftft");
                    break;
                case 'C':
                case 'X':
                    add("ftftft");
                    break;
            }
        }

        for (int i = 0; i < top % 8; i++) {
            if (s[i] == 't') {
                a = t(a);
            } else {
                a = f(a);
            }
        }

        writer.println(a.length + " " + a[0].length);
        for (int i = 0; i < a.length; i++) {
            for (int j = 0; j < a[i].length; j++) {
                writer.print(a[i][j]);
            }
            writer.println();
        }

        writer.close();
    }
}