/*-------------------------------------------------------------*/
/* ACM ICPC 2005-2006, NEERC                                   */
/* Northern Subregional Contest                                */
/* St Petersburg, October 29, 2005                             */
/*-------------------------------------------------------------*/
/* Problem F. Flip and Turn                                    */
/*                                                             */
/* Original idea         Georgiy Korneev                       */
/* Problem statement     Georgiy Korneev                       */
/* Testset               Georgiy Korneev                       */
/*-------------------------------------------------------------*/
/* Solution                                                    */
/*                                                             */
/* Author                Pavel Mavrin                          */
/*-------------------------------------------------------------*/

import java.util.Scanner;
import java.io.*;

public class flip_pm {

    static int[][] tt;

    public static void main(String[] args) throws IOException {
        Scanner scanner = new Scanner(new File("flip.in"));
        int n = scanner.nextInt();
        int m = scanner.nextInt();
        scanner.nextLine();

        String[] tab = new String[n];
        for (int i = 0; i < n; i++) {
            tab[i] = scanner.nextLine();
        };

        tt = new int[2][2];
        tt[0][0] = 1;
        tt[0][1] = 2;
        tt[1][0] = 3;
        tt[1][1] = 4;

        String oper = scanner.nextLine();

        int t;
        for (int i = 0; i < oper.length(); i++) {
            switch (oper.charAt(i)) {
                case '1':
                    swap(0, 1, 1, 0);
                    break;
                case '2':
                    swap(0, 0, 1, 1);
                    break;
                case 'H':
                    swap(0, 0, 1, 0);
                    swap(0, 1, 1, 1);
                    break;
                case 'V':
                    swap(0, 0, 0, 1);
                    swap(1, 0, 1, 1);
                    break;
                case 'A': case 'Z':
                    swap(0, 0, 1, 0);
                    swap(1, 0, 1, 1);
                    swap(1, 1, 0, 1);
                    break;
                case 'B': case 'Y':
                    swap(0, 0, 1, 1);
                    swap(0, 1, 1, 0);
                    break;
                case 'C': case 'X':
                    swap(0, 0, 0, 1);
                    swap(0, 1, 1, 1);
                    swap(1, 1, 1, 0);
                    break;
            }
        }
        if (tt[0][0] < 3 && tt[1][0] < 3 || tt[0][1] < 3 && tt[1][1] < 3) {
            for (int i = 0; i < 2; i++) {
                for (int j = 0; j < 2; j++) {
                    if (tt[i][j] == 2) tt[i][j] = 3;
                    else if (tt[i][j] == 3) tt[i][j] = 2;
                }
            }
            String[] tab2 = new String[m];
            for (int i = 0; i < m; i++) {
                StringBuffer sb = new StringBuffer();
                for (int j = 0; j < n; j++) {
                    sb.append(tab[j].charAt(i));
                }
                tab2[i] = sb.toString();
            }
            t = n;
            n = m;
            m = t;
            tab = tab2;
        }

        PrintWriter writer = new PrintWriter(new FileOutputStream("flip.out"));

        writer.println("" + n + " " + m);

        if (tt[0][0] == 1) {
            for (int i = 0; i < n; i++) {
                for (int j = 0; j < m; j++) {
                    writer.print(tab[i].charAt(j));
                }
                writer.println();
            }
        }
        if (tt[0][1] == 1) {
            for (int i = 0; i < n; i++) {
                for (int j = m - 1; j >= 0; j--) {
                    writer.print(tab[i].charAt(j));
                }
                writer.println();
            }
        }
        if (tt[1][0] == 1) {
            for (int i = n - 1; i >= 0; i--) {
                for (int j = 0; j < m; j++) {
                    writer.print(tab[i].charAt(j));
                }
                writer.println();
            }
        }
        if (tt[1][1] == 1) {
            for (int i = n - 1; i >= 0; i--) {
                for (int j = m - 1; j >= 0; j--) {
                    writer.print(tab[i].charAt(j));
                }
                writer.println();
            }
        }
        writer.close();
    }

    private static void swap(int i1, int j1, int i2, int j2) {
        int t = tt[i2][j2];
        tt[i2][j2] = tt[i1][j1];
        tt[i1][j1] = t;
    }
}
