/*-------------------------------------------------------------*/
/* ACM ICPC 2005-2006, NEERC                                   */
/* Northern Subregional Contest                                */
/* St Petersburg, October 29, 2005                             */
/*-------------------------------------------------------------*/
/* Problem G. Godfather                                        */
/*                                                             */
/* Original idea         Dmitry Pavlov                         */
/* Problem statement     Andrew Stankevich                     */
/* Testset               Andrew Stankevich                     */
/*-------------------------------------------------------------*/
/* Solution                                                    */
/*                                                             */
/* Author                Andrew Stankevich                     */
/*-------------------------------------------------------------*/

import java.util.*;
import java.io.*;

public class godfather_as implements Runnable {
    class Edge {
        int d;
        int n;
        int r;
        int s;

        public Edge(int d) {
            this.d = d;
        }
    }

    int n;
    int[] head;
    Edge[] edges;

    public void run() {
        Scanner in = null;
        try {
            in = new Scanner(new File("godfather.in"));
        } catch (FileNotFoundException e) {
        }

        n = in.nextInt();
        head = new int[n];
        Arrays.fill(head, -1);
        edges = new Edge[2 * n - 2];
        int m = 0;
        for (int i = 0; i < n - 1; i++) {
            int a = in.nextInt() - 1;
            int b = in.nextInt() - 1;

            edges[m] = new Edge(b);
            edges[m].n = head[a];
            edges[m].r = m + 1;
            head[a] = m++;
            edges[m] = new Edge(a);
            edges[m].n = head[b];
            edges[m].r = m - 1;
            head[b] = m++;
        }
        in.close();

        dfs(1, -1);

        Set<Integer> a = new TreeSet<Integer>();
        int best = n;
        for (int v = 0; v < n; v++) {
            int max = 0;
            for (int i = head[v]; i != -1; i = edges[i].n) {
                if (edges[i].s > max) {
                    max = edges[i].s;
                }
            }
            if (max < best) {
                best = max;
                a.clear();
                a.add(v);
            } else if (max == best) {
                a.add(v);
            }
        }

        PrintWriter out = null;
        try {
            out = new PrintWriter(new File("godfather.out"));
        } catch (FileNotFoundException e) {
        }
        for (Iterator<Integer> it = a.iterator(); it.hasNext();) {
            Integer i =  it.next() + 1;
            out.print(i);
            if (it.hasNext()) {
                out.print(" ");
            }
        }
        out.close();
    }

    int dfs(int v, int p) {
        int r = 1;
        for (int i = head[v]; i != -1; i = edges[i].n) {
            if (edges[i].d != p) {
                edges[i].s = dfs(edges[i].d, v);
                r += edges[i].s;
                edges[edges[i].r].s = n - edges[i].s;
            }
        }
        return r;
    }

    public static void main(String[] args) {
        Thread t = new Thread(new godfather_as());
        t.start();
    }
}
