{---------------------------------------------------------------}
{ ACM ICPC 2005-2006, NEERC                                     }
{ Northern Subregional Contest                                  }
{ St Petersburg, October 29, 2005                               }
{---------------------------------------------------------------}
{ Problem G. Godfather                                          }
{                                                               }
{ Original idea         Dmitry Pavlov                           }
{ Problem statement     Andrew Stankevich                       }
{ Testset               Andrew Stankevich                       }
{---------------------------------------------------------------}
{ Model solution (Delphi)                                       }
{                                                               }
{ Author                Georgiy Korneev                         }
{---------------------------------------------------------------}

{$minstacksize 20000000}
uses
    math;

const
    max_n = 200000;
type
    plist = ^tlist;
    tlist = record
        next: plist;
        val: longint;
    end;

procedure add(var list: plist; val: longint);
var
    p: plist;
begin
    new(p);
    p.next := list;
    p.val := val;
    list := p;
end;

var
    i, n: longint;
    a, b: longint;
    e: array [1..max_n] of plist;
    u: array [1..max_n] of boolean;
    ans, ans1: longint;

function dfs(i: longint): longint;
var
    p: plist;
begin
    u[i] := true;

    result := 1;

    p := e[i];
    while p <> nil do begin
        if (not u[p.val]) then begin
            result := result + dfs(p.val);
        end;
        p := p.next;
    end;

    if (ans = 0) and (result >= n div 2 + 1) then begin
        ans := i;
    end;

    if (result * 2 = n) then begin
        ans1 := i;
    end;
end;

begin
    assign(input, 'godfather.in'); reset(input);
    assign(output, 'godfather.out'); rewrite(output);
    
    read(n);
    for i := 1 to n - 1 do begin
        read(a, b);
        add(e[a], b);
        add(e[b], a);
    end;

    ans1 := 0;
    ans := 0;
    dfs(1);

    if ans1 <> 0 then begin
        writeln(min(ans, ans1), ' ', max(ans, ans1));
    end else begin
        writeln(ans);
    end;

    close(input);
    close(output);
end.