/*-------------------------------------------------------------*/
/* ACM ICPC 2005-2006, NEERC                                   */
/* Northern Subregional Contest                                */
/* St Petersburg, October 29, 2005                             */
/*-------------------------------------------------------------*/
/* Problem G. Godfather                                        */
/*                                                             */
/* Original idea         Dmitry Pavlov                         */
/* Problem statement     Andrew Stankevich                     */
/* Testset               Andrew Stankevich                     */
/*-------------------------------------------------------------*/
/* Model solution (Java)                                       */
/*                                                             */
/* Author                Georgiy Korneev                       */
/*-------------------------------------------------------------*/

import java.io.*;
import java.math.*;
import java.util.*;

class godfather_gk implements Runnable {
    private StreamTokenizer t;

    private int nextInt() throws IOException {
        t.nextToken();
        return (int) t.nval;
    }

    private List<Integer>[] edges;
    private boolean[] u;
    private int ans1;
    private int ans;
    private int n;

    private int dfs(int i) {
        u[i] = true;

        int result = 1;

        for (int j: edges[i]) {
            if (!u[j]) {
                result += dfs(j);
            }
        }

        if (ans == 0 && result >= n / 2 + 1) {
            ans = i + 1;
        }

        if (result * 2 == n) {
            ans1 = i + 1;
        }

        return result;
    }

    public void run() {
        try {
           Locale.setDefault(Locale.US);

           t = new StreamTokenizer(new BufferedReader(new FileReader("godfather.in")));
           PrintWriter writer = new PrintWriter(new FileOutputStream("godfather.out"));

           n = nextInt();
           edges = new List[n];
           for (int i = 0; i < n; i++) {
               edges[i] = new ArrayList<Integer>(5);
           }
           for (int i = 1; i < n; i++) {
                int a = nextInt() - 1;
                int b = nextInt() - 1;
                edges[a].add(Integer.valueOf(b));
                edges[b].add(Integer.valueOf(a));
           }

           u = new boolean[n];
           dfs(0);

           if (ans1 != 0) {
               writer.println(Math.min(ans, ans1) + " " + Math.max(ans, ans1));
           } else {
               writer.println(ans);
           }

           writer.close();
        } catch (IOException e){
        }
    }

    public static void main(String[] args) throws IOException {
        new Thread(new godfather_gk()).start();
    }
}
