/*-------------------------------------------------------------*/
/* ACM ICPC 2005-2006, NEERC                                   */
/* Northern Subregional Contest                                */
/* St Petersburg, October 29, 2005                             */
/*-------------------------------------------------------------*/
/* Problem G. Godfather                                        */
/*                                                             */
/* Original idea         Dmitry Pavlov                         */
/* Problem statement     Andrew Stankevich                     */
/* Testset               Andrew Stankevich                     */
/*-------------------------------------------------------------*/
/* Solution                                                    */
/*                                                             */
/* Author                Pavel Pavrin                          */
/*-------------------------------------------------------------*/

import java.io.*;
import java.math.*;
import java.util.*;

class godfather_pm {

    public static void main(String[] args) throws IOException {
        Scanner scanner = new Scanner(new File("godfather.in"));
        PrintWriter writer = new PrintWriter(new FileOutputStream("godfather.out"));

        int n = scanner.nextInt();

        int[] q = new int[n];
        int[] s = new int[n];
        int[] d = new int[n];
        
        for (int i = 0; i < n - 1; i++) {
            int a = scanner.nextInt();
            int b = scanner.nextInt();
            a--;
            b--;
            d[a]++;
            d[b]++;
            s[a] ^= b;
            s[b] ^= a;
        }

        List<Integer>[] l = new List[n];
        for (int i = 0; i < n; i++) {
          l[i] = new LinkedList<Integer>();           
        }

        for (int i = 0; i < n; i++) {
            q[i] = 1;
            if (d[i] == 1) {
                l[0].add(i);
            }
        }

        int nn = n;
        int max = 1;

        for (int i = 0; i < n; i++) {
            if (nn <= 2) {
                for (int j = 0; j < n; j++) {
                    if (q[j] == max) {
                        writer.println(j + 1);
                    }
                }
                break;
            }
            for (int j: l[i]) {
                d[s[j]]--;
                q[s[j]] += q[j];
                s[s[j]] ^= j;
                if (q[s[j]] > max) {
                    max = q[s[j]];
                }
                if (d[s[j]] == 1) {
                    l[q[s[j]] - 1].add(s[j]);
                }
                nn--;
            }
        }
        writer.close();
    }
}