{---------------------------------------------------------------}
{ ACM ICPC 2005-2006, NEERC                                     }
{ Northern Subregional Contest                                  }
{ St Petersburg, October 29, 2005                               }
{---------------------------------------------------------------}
{ Problem H. Horn Clauses                                       }
{                                                               }
{ Original idea         Dmitri Pavlov                           }
{ Problem statement     Dmitriy Shtukenberg                     }
{ Testset               Andrew Lopatin                          }
{---------------------------------------------------------------}
{ Solution                                                      }
{                                                               }
{ Author                Andrew Lopatin                          }
{---------------------------------------------------------------}

{$O-,Q+,R+}
uses SysUtils;
const MaxC=20000;

var v:array [1..MaxC] of string;
    vc:integer;


function varid (const id:string):integer;
var i:integer;
begin
  for i:=1 to vc do 
    if id=v[i] then begin Result:=i; exit end;
  inc (vc); Result:=vc; v[vc]:=id;
end;


var s, cl:integer;
    t:array [1..MaxC] of boolean;
    lc:array [1..MaxC] of integer;

procedure startcase;
begin
  s:=0; vc:=0; cl:=0;
  fillchar (t, sizeof (t), 0);
  fillchar (lc, sizeof (lc), 0);
end;


var l:array [1..MaxC] of array of integer;
    r:array [1..MaxC] of integer;

procedure solve;
var last, cur, i, j, k, p:integer;
begin
  last:=1; cur:=1;
  repeat
    if lc[cur]=0 then begin
      if r[cur]=-1 then begin writeln ('unsatisfiable'); exit end;
      if not t[r[cur]] then begin
        t[r[cur]]:=true;
        last:=cur;
        for j:=1 to cl do begin
          p:=0;
          for k:=0 to lc[j]-1 do
            if l[j, k]<>r[cur] then begin l[j, p]:=l[j, k]; inc (p) end;
          lc[j]:=p
        end;
      end;
    end;
    inc (cur); if cur>cl then cur:=1;
  until cur=last;
  for i:=1 to vc do begin
    if i>1 then write (',');
    write (v[i], '=');
    if t[i] then write ('true') else write ('false')
  end;
  writeln;
end;
    
var curchar:char;
    b:integer;


procedure init;
begin
  read (curchar); b:=1;
end;


function nextchar:char;
begin
  Result:=curchar; read (curchar); inc (b);
  assert ((curchar=#26) or (b<=MaxC));
end;


function eatvar:string;
begin
  Result:='';
  while curchar in ['A'..'Z'] do Result:=Result+nextchar;
end;


var x:string;

begin
  reset (input, 'horn.in'); rewrite (output, 'horn.out');
  init;
  startcase;
  repeat
    case s of
      0: begin
           assert (nextchar='(');
           inc (cl); setlength (l[cl], 64);
           s:=1;
         end;
      1: begin
           if (curchar='=') and (lc[cl]=0) then s:=2 else begin
             x:=eatvar; assert (length (x)>0);
             l[cl][lc[cl]]:=varid (x); inc (lc[cl]);
             if lc[cl]>=length (l[cl]) {and 63 = 0} then setlength (l[cl], {lc[cl]+64}length (l[cl])*2);
             if (curchar='=') then s:=2 else assert (nextchar='&');
           end;
         end;
      2: begin
           setlength (l[cl], lc[cl]); 
           assert (nextchar='='); assert (nextchar='>');
           x:=eatvar;
           if length (x)=0 then begin
             assert (lc[cl]>0); r[cl]:=-1 
           end else r[cl]:=varid (x);
           assert (nextchar=')');
           if curchar='&' then begin
             nextchar; s:=0;
           end else begin
             assert (cl>0); solve;
             assert (nextchar=#13); assert (nextchar=#10);
             if (curchar=#26) then break;
             startcase;
           end;
         end;
    end;
  until false;
end.