{---------------------------------------------------------------}
{ ACM ICPC 2005-2006, NEERC                                     }
{ Northern Subregional Contest                                  }
{ St Petersburg, October 29, 2005                               }
{---------------------------------------------------------------}
{ Problem I. Inner Vertices                                     }
{                                                               }
{ Original idea         Sergey Orshanskiy                       }
{ Problem statement     Georgiy Korneev                         }
{ Testset               Georgiy Korneev                         }
{---------------------------------------------------------------}
{ Model solution (Deplhi)                                       }
{                                                               }
{ Author                Georgiy Korneev                         }
{---------------------------------------------------------------}

uses
    math;
const
    max_n = 100000;
    base  = 131072;

type
    tarr = array [1..max_n] of longint;
var
    i, j, n: longint;
    x, y: tarr;
    minv, maxv, minh, maxh, minvi, maxvi: tarr;
    cx, ix, cy, iy: tarr;
    c1, c2: int64;
    q: array [1..max_n + base] of longint;

procedure qsort(l, r: longint; var c, p: tarr);
var
    i, j: longint;
    x, t: longint;        
begin
    x := c[(l * 13 + r * 17) div 30];
    i := l;
    j := r;

    while (i <= j) do begin
        while (c[i] < x) do inc(i);
        while (c[j] > x) do dec(j);
        if (i <= j) then begin
            t := c[i]; c[i] := c[j]; c[j] := t;
            t := p[i]; p[i] := p[j]; p[j] := t;
            inc(i);
            dec(j);
        end;
    end;

    if (l < j) then qsort(l, j, c, p);
    if (i < r) then qsort(i, r, c, p);
end;

function inner(x, y: longint): boolean;
begin
    inner := (minv[x] < y) and (y < maxv[x]) and (minh[y] < x) and (x < maxh[y]);
end;

procedure add(i, v: longint);
begin
    i := i + base;
    while (i > 0) do begin
        inc(q[i], v);
        i := i div 2;
    end;
end;

function get(l, r: longint): longint;
begin
    l := l + base - 1;
    r := r + base + 1;
    result := 0;
    while l < r - 1 do begin
        if (l mod 2 = 0) then begin
            result := result + q[l + 1];
        end;
        if (r mod 2 = 1) then begin
            result := result + q[r - 1];
        end;
        l := l div 2;
        r := r div 2;
    end;
end;

var
    imin, imax: longint;
begin
    assign(input, 'inner.in'); reset(input);
    assign(output, 'inner.out'); rewrite(output);

    read(n);
    for i := 1 to n do begin
        read(x[i], y[i]);
    end;

    for i := 1 to n do begin
        cx[i] := x[i];
        ix[i] := i;
        cy[i] := y[i];
        iy[i] := i;
    end;

    qsort(1, n, cx, ix);
    qsort(1, n, cy, iy);

    j := 0;
    for i := 1 to n do begin
        if (i = 1) or (cx[i - 1] < cx[i]) then begin
            inc(j);
        end;
        x[ix[i]] := j;
    end;

    j := 0;
    for i := 1 to n do begin
        if (i = 1) or (cy[i - 1] < cy[i]) then begin
            inc(j);
        end;
        y[iy[i]] := j;
    end;

    for i := 1 to n do begin
        minv[i] := n + 1;
        minh[i] := n + 1;
        maxv[i] := 0;
        maxh[i] := 0;
    end;

    for i := 1 to n do begin
        minv[x[i]] := min(minv[x[i]], y[i]);
        maxv[x[i]] := max(maxv[x[i]], y[i]);
        minh[y[i]] := min(minh[y[i]], x[i]);
        maxh[y[i]] := max(maxh[y[i]], x[i]);
    end;

    c2 := 0;
    for i := 1 to n do begin
        if inner(x[i], y[i]) then begin
            inc(c2);
        end;
    end;

    for i := 1 to n do begin
        if maxv[i] = minv[i] then begin
            maxv[i] := 0;
            minv[i] := n + 1;
        end;
    end;

    for i := 1 to n do begin
        minvi[i] := i;
        maxvi[i] := i;
    end;

    qsort(1, n, minv, minvi);
    qsort(1, n, maxv, maxvi);

    c1 := 0;

    imin := 1;
    imax := 1;
    while (imax <= n) and (maxv[imax] = 0) do inc(imax);
    for i := 1 to n do begin
        while (imax <= n) and (maxv[imax] = i) do begin
            add(maxvi[imax], -1);
            inc(imax);
        end;
        c1 := c1 + get(minh[i] + 1, maxh[i] - 1);
        while (imin <= n) and (minv[imin] = i) do begin
            add(minvi[imin], 1);
            inc(imin);
        end;
    end;

    writeln(c1 + n - c2);

    close(input);
    close(output);
end.