{---------------------------------------------------------------}
{ ACM ICPC 2005-2006, NEERC                                     }
{ Northern Subregional Contest                                  }
{ St Petersburg, October 29, 2005                               }
{---------------------------------------------------------------}
{ Problem J. Jenny's First Exams                                }
{                                                               }
{ Original idea         Pavel Mavrin                            }
{ Problem statement     Pavel Mavrin                            }
{ Testset               Pavel Mavrin                            }
{---------------------------------------------------------------}
{ Model solution                                                }
{                                                               }
{ Author                Pavel Mavrin                            }
{---------------------------------------------------------------}

uses
  SysUtils, Classes, DateUtils;

const
  MAX_N = 100000;

type
  TExam = record
    subject: string;
    date: TDateTime;
    t: integer;
    deadLine: TDateTime;
    preparationDate: TDateTime;
  end;
  PExam = ^TExam;

function compareExams(a, b: pointer): integer;
begin
  result := round(PExam(a).date - PExam(b).date);
end;

function comparePreparations(a, b: pointer): integer;
begin
  result := round(PExam(a).preparationDate - PExam(b).preparationDate);
end;

var
  hn: integer;
  h: array[1..MAX_N] of PExam;

procedure add(exam: PExam);
var
  i, ii: integer;
  t: PExam;
begin
  inc(hn);
  h[hn] := exam;
  i := hn;
  while i > 1 do begin
    ii := i shr 1;
    if h[ii].deadLine > h[i].deadLine then exit;
    t := h[ii];
    h[ii] := h[i];
    h[i] := t;
    i := ii;
  end;
end;

function extractMax(): Pexam;
var
  i, ii, iii: integer;
  t: PExam;
begin
  result := h[1];
  h[1] := h[hn];
  dec(hn);
  i := 1;
  while (2*i <= hn) do begin
    iii := i;
    ii := 2*i;
    if (h[ii].deadLine > h[iii].deadLine) then iii := ii;
    ii := 2*i + 1;
    if (ii <= hn) and (h[ii].deadLine > h[iii].deadLine) then iii := ii;
    if iii = i then exit;
    t := h[i];
    h[i] := h[iii];
    h[iii] := t;
    i := iii;
  end;
end;

var
  n, i: integer;
  s: string;
  exams: TList;
  exam: PExam;
  firstDate: TDateTime;
  lastDate: TDateTime;
  today: TDateTime;

begin
  reset(input, 'jenny.in');
  rewrite(output, 'jenny.out');

  dateSeparator := '.';
  shortDateFormat := 'dd/mm/yyyy';
  firstDate := StrToDate('01.01.1900');
  lastDate := StrToDate('31.12.2100');

  readln(n);
  exams := TList.create();
  for i := 1 to n do begin
    new(exam);
    readln(exam.subject);
    readln(s);
    exam.date := strToDate(s);
    readln(exam.t);
    exam.deadLine := exam.date - exam.t;
    exams.add(exam);
  end;

  exams.Sort(compareExams);

  today := lastDate;

  i := n - 1;

  while (i >= 0) or (hn > 0) do begin
    if (i >= 0) and (today = PExam(exams.Items[i]).date) then begin
      add(PExam(exams.Items[i]));
      i := i - 1;
    end else begin
      if hn > 0 then begin
        exam := extractMax();
        exam.preparationDate := today;
        if today < exam.deadLine then begin
          writeln('Impossible');
          exit;
        end;
      end;
    end;
    today := IncDay(today, -1);
  end;

  writeln(DateToStr(today + 1));

end.
