/*-------------------------------------------------------------*/
/* ACM ICPC 2005-2006, NEERC                                   */
/* Northern Subregional Contest                                */
/* St Petersburg, October 29, 2005                             */
/*-------------------------------------------------------------*/
/* Problem K. K Best                                           */
/*                                                             */
/* Original idea         Dmitri Pavlov                         */
/* Problem statement     Andrew Stankevich                     */
/* Testset               Andrew Stankevich                     */
/*-------------------------------------------------------------*/
/* Solution                                                    */
/*                                                             */
/* Author                Georgiy Korneev                       */
/*-------------------------------------------------------------*/

import java.io.*;
import java.util.*;

public class k_gk {
    private static final double EPS = 1e-16;

    private StreamTokenizer t;
    private double[] a;
    private int[] p;
    private int[] q;

    private int nextInt() throws IOException {
        t.nextToken();
        return (int) t.nval;
    }

    private void kth(int l, int r, int k) {
        double x = a[(l * 13 + r * 17) / 30];
        int i = l;
        int j = r;
        while (i <= j) {
            while (a[i] > x) i++;
            while (a[j] < x) j--;
            if (i <= j) {
                double t = a[i]; a[i] = a[j]; a[j] = t;
                int q = p[i]; p[i] = p[j]; p[j] = q;
                i++;
                j--;
            }
        }
        if (k <= j) kth(l, j, k);
        if (i <= k) kth(i, r, k);
    }

    public void run() throws IOException {
        Locale.setDefault(Locale.US);

        t = new StreamTokenizer(new BufferedReader(new FileReader("k.in")));
        PrintWriter writer = new PrintWriter(new FileOutputStream("k.out"));

        int n = nextInt();
        int k = nextInt();
        int[] v = new int[n];
        int[] w = new int[n];

        for (int i = 0; i < n; i++) {
            v[i] = nextInt();
            w[i] = nextInt();
        }

        a = new double[n];
        p = new int[n];
        q = new int[n];

        double l = -1;
        double r = 1e10;
        while (true) {
            double m = (l + r) / 2;
            if (l == m || r == m || Math.abs(l) + Math.abs(r) < EPS) break;

            for (int i = 0; i < n; i++) {
                p[i] = i;
                a[i] = v[i] - m * w[i];
            }

            kth(0, n - 1, k - 1);

            double s = 0;
            for (int i = 0; i < k; i++) {
                s += a[i];
            }

            if (s > 0) {
                l = m;
                System.arraycopy(p, 0, q, 0, n);
            } else {
                r = m;
            }
        }

        for (int i = 0; i < k; i++) {
            writer.println(q[i] + 1);
        }

        writer.close();
    }

    public static void main(String[] args) throws IOException {
        new k_gk().run();
    }
}