/*-------------------------------------------------------------*/
/* ACM ICPC 2005-2006, NEERC                                   */
/* Northern Subregional Contest                                */
/* St Petersburg, October 29, 2005                             */
/*-------------------------------------------------------------*/
/* Problem K. K Best                                           */
/*                                                             */
/* Original idea         Dmitri Pavlov                         */
/* Problem statement     Andrew Stankevich                     */
/* Testset               Andrew Stankevich                     */
/*-------------------------------------------------------------*/
/* Solution                                                    */
/*                                                             */
/* Author                Mavrin Pavel                          */
/*-------------------------------------------------------------*/

import java.util.*;
import java.io.*;

public class k_pm {

    private static float EPS = 0.000001f;

    static class Pair {
        public int i;
        public float v;

        public Pair(int i, float v) {
            this.i = i;
            this.v = v;
        }
    }

    static float[] a;
    static int[] ind;
    static int n;
    static int k;
    static int[] v;
    static int[] w;

    static StreamTokenizer t;

    static private int nextInt() throws IOException {
        t.nextToken();
        return (int) t.nval;
    }



    public static void main(String[] args) throws IOException {
        t = new StreamTokenizer(new BufferedReader(new FileReader("k.in")));
        PrintWriter writer = new PrintWriter(new FileOutputStream("k.out"));

        n = nextInt();
        k = nextInt();
        v = new int[n];
        w = new int[n];

        for (int i = 0; i < n; i++) {
            v[i] = nextInt();
            w[i] = nextInt();
        }

        float l = 0;
        float r = 1000000;
        float m = (l + r) / 2;

        a = new float[n];
        ind = new int[n];

        for (int j = 0; j < 50; j++) {
            if (can(m)) {
                float sv = 0;
                float sw = 0;
                for (int i = 0; i < k; i++) {
                    sv += v[ind[i]];
                    sw += w[ind[i]];
                }
                l = sv / sw;
                if (!can(l + EPS)) break;
            } else {
                r = m;
            }
            m = (l + r) / 2;
        }

        can(l);
        for (int i = 0; i < k; i++) {
            writer.print("" + (ind[i] + 1) + ' ');
        }
        writer.close();
    }

    private static boolean can(float m) {
        for (int i = 0; i < n; i++) {
            a[i] = w[i] * m - v[i];
            ind[i] = i;
        }
        beat(a, ind, k);
        float s = 0;
        for (int i = 0; i < k; i++) {
            s += a[i];
        }
        return s <= 0;
    }

    private static void beat(float[] a, int[] ind, int k) {
        int l = 0;
        int r = a.length - 1;
        while (l < r) {
            float x = a[l + (int)(Math.random() * (r - l + 1))];
            int i = l;
            int j = r;
            while (i <= j) {
                while (a[i] < x) i++;
                while (a[j] > x) j--;
                if (i <= j) {
                    float t = a[i];
                    a[i] = a[j];
                    a[j] = t;
                    int tt = ind[i];
                    ind[i] = ind[j];
                    ind[j] = tt;
                    i++;
                    j--;
                }
            }
            if (k > i) {
                l = i;
            } else if (k <= j) {
                r = j;
            } else return;
        }
    }
}
