#include <stdio.h>
#include <string.h>

#define maxc 30333
#define baza 100
#define fwd 3
#define format "%02d"

typedef int BigNum[maxc];

int compare(BigNum, BigNum);
void add(BigNum, BigNum, BigNum);
void sub(BigNum, BigNum, BigNum);
void mult(int, BigNum, BigNum);
void multbig(BigNum, BigNum, BigNum);
void divx(int, BigNum, BigNum, int*);
void divbig(BigNum, BigNum, BigNum, BigNum);

#define NMAX 200010

int cnt[NMAX];
int i, j, N;

BigNum total, result, doi, naux1, naux2, n1, n2;

void getdoi(int p)
{
	int x;

	memset(doi, 0, sizeof(doi));

	for (x = 20; x >= 0; x--)
		if (p & (1 << x))
			break;

	doi[0] = 1; doi[1] = 2;

	while ((--x) >= 0)
	{
		multbig(doi, doi, naux1);

		if (p & (1 << x))
			mult(2, naux1, doi);
		else
			memmove(doi, naux1, sizeof(BigNum));
	}
}

int gcd(int a, int b)
{
	if (b % a == 0)
		return a;
	else
		return gcd(b % a, a);
}

int main()
{
	scanf("%d", &N);

	memset(cnt, 0, sizeof(cnt));

	for (i = 1; i <= N; i++)
		cnt[gcd(i, N)]++;

	memset(total, 0, sizeof(total));
	total[0] = 1;

	for (i = 1; i <= N; i++)
		if (cnt[i])
		{
			getdoi(i);

			mult(cnt[i], doi, naux1);
			add(naux1, total, naux2);
			memmove(total, naux2, sizeof(BigNum));

			//fprintf(stderr, "%d\n", i);
		}

	divx(N, total, result, &j);

	printf("%d", result[result[0]]);

	for (i = result[0] - 1; i >= 1; i--)
		printf(format, result[i]);

	return 0;
}

/* 1 if n1 > n2 ; -1 if n1 < n2 ; 0 if n1 == n2 */
int compare(BigNum n1, BigNum n2)
{
int i, res;

if (n1[0] > n2[0]) return 1;
if (n1[0] < n2[0]) return -1;

for (res = 0, i = n1[0]; i >= 1; i--)
  if (n1[i] > n2[i])
    {
      res=1;
      break;
    }
  else
  if (n1[i] < n2[i])
    {
      res=-1;
      break;
    }

return res;
}

void add(BigNum n1, BigNum n2, BigNum rez)
{
int i, ndigits = n1[0];

if (n2[0] > ndigits)
  ndigits = n2[0];

memset(rez, 0, sizeof(BigNum));
for (i = 1; i <= ndigits; i++)
  rez[i] = n1[i]+n2[i];

for (i = 1 ;i <= (ndigits+fwd); i++)
  if (rez[i] >= baza)
    {
      rez[i+1] += (rez[i]/baza);
      rez[i] %= baza;
    }

for (i = (ndigits+fwd); i >= 1; i--)
  if (rez[i] > 0)
    {
      rez[0] = i;
      break;
    }
}

void sub(BigNum n1, BigNum n2, BigNum res)
{
int i, ndigits = n1[0];

memset(res, 0, sizeof(BigNum));
for (i = 1; i <= ndigits; i++)
  res[i] = n1[i] - n2[i];

for (i = 1; i <= ndigits; i++)
  while (res[i] < 0)
    {
      res[i] += baza;
      res[i+1]--;
    }

for (res[0] = 1, i = ndigits; i >= 1; i--)
  if (res[i])
    {
      res[0] = i;
      break;
    }
}

void mult(int x, BigNum num, BigNum rez)
{
int i, ndigits = num[0];

memset(rez, 0, sizeof(BigNum));
for (i = 1; i <= ndigits; i++)
  rez[i] = num[i]*x;

for (i = 1; i <= (ndigits+fwd); i++)
  if (rez[i] >= baza)

    {
    rez[i+1] += (rez[i]/baza);
    rez[i] %= baza;
    }

for (i = (ndigits+fwd); i >= 1; i--)
  if (rez[i] > 0)
    {
    rez[0] = i;
    break;
    }
}

void multbig(BigNum n1, BigNum n2, BigNum rez)
{
int i, j, ndigits = n1[0]+n2[0]-1;

memset(rez, 0, sizeof(BigNum));
for (i = 1; i <= n1[0]; i++)
  for (j = 1; j <= n2[0]; j++)
    rez[i+j-1] += (n1[i]*n2[j]);

for (i = 1; i <= (ndigits+fwd); i++)
  if (rez[i] >= baza)
    {
      rez[i+1] += (rez[i]/baza);
      rez[i] %= baza;
    }

for (i = (ndigits+fwd); i >= 1; i--)
  if (rez[i] > 0)
    {
      rez[0] = i;
      break;
    }
}

void divx(int x, BigNum n, BigNum cat, int* rest)
{
int i, j, ndigits = 0, v;

memset(cat, 0, sizeof(BigNum));
v = 0, i = n[0];
while (v < x && i)
  {
    v = v*baza+n[i];
    i--;
  }

ndigits = 1, cat[1] = v/x, v=v%x;

for (; i; i--)
  {
    v = v*baza+n[i];
    cat[++ndigits] = v/x;
    v %= x;
  }
*rest = v;

for (v = ndigits>>1, i = 1; i <= v; i++)
  {
    j = cat[i];
    cat[i] = cat[ndigits-i+1];
    cat[ndigits-i+1]=j;
  }

cat[0] = ndigits;
}

void divbig(BigNum p, BigNum q, BigNum cat, BigNum rest)
{
int i, j, ndigits, li, ls, m, ok;

if (compare(p, q) == -1)
  {
    memset(cat, 0, sizeof(BigNum));
    cat[0] = 1;
    memmove(rest, p, sizeof(BigNum));
    return;
  }

memset(rest, 0, sizeof(rest));
for (i = q[0]; i; i--)
  rest[i] = p[p[0]-q[0]+i];
rest[0] = ndigits = q[0];

if (compare(rest, q) == -1)
  {
    for (i = q[0]+1; i; i--)
      rest[i] = p[p[0]-q[0]+i-1];
    rest[0] = ndigits = q[0]+1;
  }

memset(cat, 0, sizeof(BigNum));
for (i = p[0]-ndigits+1; i; i--)
  {
    if (compare(rest, q) == -1)
      {
        cat[0]++;
        cat[cat[0]] = 0;
      }
    else
      {
        li = 1, ls = baza-1, ok = 0;
        while (li <= ls)
          {
            m = (li+ls)>>1;
    
            mult(m, q, naux1);
    
            if (compare(naux1, rest) <= 0)
              ok = m, li = m+1;
            else
              ls = m-1;
          }
  
        mult(ok, q, naux1);
        sub(rest, naux1, naux2);
        memmove(rest, naux2, sizeof(BigNum));
  
        cat[0]++;
        cat[cat[0]] = ok;
      }

    if (i-1)
      {
        if (rest[0] == 1 && rest[1] == 0)
          rest[0]--;

        for (j = rest[0]; j; j--)
          rest[j+1] = rest[j];

        rest[1] = p[i-1];
        rest[0]++;
      }
  }

/* swap cat */
for (i = 1; i <= cat[0]>>1; i++)
  ok = cat[i], cat[i] = cat[cat[0]-i+1], cat[cat[0]-i+1] = ok;
}
