/* Deep Blue */

/* Incremental Convex Hull : O(N * logN) */

#include <stdio.h>
#include <string.h>
#include <math.h>

#include <set>
#include <map>
#include <algorithm>

#define NMAX 100100
#define eps 1e-5

using namespace std;

#define coordtype __int64
#define format "%I64d"

coordtype x[NMAX], y[NMAX], a, acur = 0;
double u[NMAX], xm, ym;

set<double> s;
map<double, int> m;
set<double>::iterator i1, i2, ine, ib, ie;
int i, j, k, N, smn, p1, p2;

coordtype atri(int p1, int p2, int p3)
{
    coordtype a;

    a = x[p1] * y[p2] - x[p2] * y[p1] +
        x[p2] * y[p3] - x[p3] * y[p2] +
        x[p3] * y[p1] - x[p1] * y[p3];

    return a;
}

int main()
{
    //freopen("a.in", "r", stdin);

    for (i = 1; i <= 3; i++)
	{
		scanf(format, &x[i]);
		scanf(format, &y[i]);
	}

    acur = atri(1, 2, 3);
	if (acur < 0)
		acur = -acur;

    xm = (double)(x[1] + x[2] + x[3]) / 3.0;
    ym = (double)(y[1] + y[2] + y[3]) / 3.0;

    for (i = 1; i <= 3; i++)
    {
        u[i] = atan2((double)y[i] - ym, (double)x[i] - xm);

        s.insert(u[i]);
        m[u[i]] = i;
    }

    scanf("%d", &N);
    
    for (i = 4; i <= N + 3; i++)
    {
        scanf(format, &x[i]);
		scanf(format, &y[i]);

        if (fabs((double)x[i] - xm) > eps || fabs((double)y[i] - ym) > eps)
        {
            u[i] = atan2((double)y[i] - ym, (double)x[i] - xm);

            ib = s.begin();
            ie = s.end();
            ie--;
            
            if (u[i] < *ib || u[i] > *ie)
            {
                p2 = m[*(i2 = s.begin())];
                p1 = m[*(i1 = (--s.end()))];
            }
            else
            {
                p1 = m[*(i1 = (--s.lower_bound(u[i])))];
                p2 = m[*(i2 = (s.lower_bound(u[i])))];
            }

            a = atri(p1, p2, i);
            if (a < 0)  /* in exterior */
            {
				acur -= a;

                /* muta i1 */
                ine = i1;
                if (i1 == s.begin())
                   i1 = (--s.end());
                else
                    i1--;

                while (atri(m[*i1], m[*ine], i) < 0)
                {
                    acur -= (atri(m[*i1], m[*ine], i));

                    ine = i1;
                    if (i1 == s.begin())
                       i1 = (--s.end());
                    else
                        i1--;
                }

                i1 = ine;

                /* muta i2 */
                ine = i2;
                if (i2 == (--s.end()))
                   i2 = s.begin();
                else
                    i2++;

                while (atri(m[*ine], m[*i2], i) < 0)
                {
                    acur -= (atri(m[*ine], m[*i2], i));

                    ine = i2;
                    if (i2 == (--s.end()))
                       i2 = s.begin();
                    else
                        i2++;
                }

                i2 = ine;

				i1++;
				if (i1 == s.end())
					i1 = s.begin();

                for (ine = i1; ine != i2; ine = i1)
                {
					i1++;
                    if (i1 == s.end())
                       i1 = s.begin();

                    s.erase(*ine);
                }

                s.insert(u[i]);
                m[u[i]] = i;
            }
        }

        printf(format, acur);
		printf("\n");
    }

    return 0;
}
