{ XV ᨩ᪠  誮쭨  ଠ⨪    }
{  "筨"                                      }
{ : ᠭ ॢ                              }
{ 襭:  客                                 }
{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 16384,0,0}
const
  MaxN      = 2010;
  MaxDifpts = (2*MaxN + 2);
type
  coord_t = integer;
  sq_t    = longint;
  pointc_t = array [0..1] of coord_t;
var
  maxx, maxy: coord_t;
  n, k, npts: integer;
  pts: array [1..MaxDifpts] of pointc_t;
  pr: array [1..MaxN, 0..1] of integer;
  rlen, ulen: array [1..MaxDifpts] of coord_t;
  ur: array [1..MaxDifpts] of integer;
  rai, rbi, rk: integer;
  rs: sq_t;

function pmore(const a, b: pointc_t): boolean;
begin
  pmore := ( (a[0] > b[0]) or ( (a[0] = b[0]) and (a[1] > b[1])) );
end;

function getp(const x, y: coord_t): integer;
var
  i: integer;
begin
  for i := 1 to npts do
    if ((pts[i][0] = x) and (pts[i][1] = y)) then begin
      getp := i;
      exit;
    end;

  inc(npts);
  pts[npts][0] := x;
  pts[npts][1] := y;
  getp := npts;
end;

function getp_bs(const x, y: coord_t): integer;
var
  l, r, m: integer;
begin
  l := 1;
  r := npts;

  while (r-l>4) do begin
    m := (l+r) shr 1;

    if ( (pts[m][0] > x) or ( (pts[m][0] = x) and (pts[m][1] > y)) ) then begin
      r := m-1;
    end else begin
      l := m;
    end;
  end;

  while (l<=r) do begin
    if (pts[l][0] = x) and (pts[l][1] = y) then begin
      getp_bs := l;
      exit;
    end;
    inc(l);
  end;

  getp_bs := 0;
end;

procedure ReadAll;
var
  i: integer;
  x1, y1, x2, y2: coord_t;
begin
  Assign(Input, 'sandbox.in'); Reset(Input);

  Read(maxx, maxy);
  Read(n, k);

  npts := 0;
  for i := 1 to n do begin
    Read(x1, y1, x2, y2);
    pr[i, 0] := getp(x1, y1);
    pr[i, 1] := getp(x2, y2);
    getp(x1, y2);
    getp(x2, y1);
  end;

  Close(Input);
end;

var
  pi, rpi: array [1..MaxDifpts] of integer;

procedure swpp(i, j: integer);
var
  h: integer;
  hh: coord_t;
begin
  hh := pts[i][0]; pts[i][0] := pts[j][0]; pts[j][0] := hh;
  hh := pts[i][1]; pts[i][1] := pts[j][1]; pts[j][1] := hh;

  h := pi[i]; pi[i] := pi[j]; pi[j] := h;
end;

procedure SortP(l, r: integer);
var
  m: pointc_t;
  i, j: integer;
begin
  m[0] := pts[(l+r) shr 1][0];
  m[1] := pts[(l+r) shr 1][1];
  i := l;
  j := r;

  repeat
    while (pmore(m, pts[i])) do inc(i);
    while (pmore(pts[j], m)) do dec(j);

    if (i<=j) then begin
      swpp(i, j);
      inc(i);
      dec(j);
    end;
  until (i>j);

  if (l < j) then SortP(l, j);
  if (i < r) then SortP(i, r);
end;

procedure SortPts;
var
  i: integer;
begin
  for i := 1 to npts do
    pi[i] := i;

  SortP(1, npts);

  for i := 1 to npts do
    rpi[pi[i]] := i;

  for i := 1 to n do begin
    pr[i][0] := rpi[pr[i][0]];
    pr[i][1] := rpi[pr[i][1]];
  end;
end;

procedure MakeT;
var
  i, j, rnx, unx: integer;
  x1, x2, y1, y2: coord_t;
begin
  fillchar(rlen, sizeof(rlen), 0);
  fillchar(ulen, sizeof(ulen), 0);
  fillchar(ur, sizeof(ur), 0);

  unx := npts;

  for i := npts downto 1 do begin
    rlen[i] := pts[i][0];
    ulen[i] := pts[i][1];

    if (i<npts) then begin
      unx := i+1;
      if (pts[unx][0] <> pts[i][0]) then unx := 0;
    end else unx := 0;

    rnx := 0;
    for j := i+1 to npts do begin
      if (pts[j][1] = pts[i][1]) then begin
        rnx := j;
        break;
      end;
    end;

    for j := 1 to n do begin
      x1 := pts[pr[j][0]][0];
      x2 := pts[pr[j][1]][0];
      y1 := pts[pr[j][0]][1];
      y2 := pts[pr[j][1]][1];

      if (x1 >= pts[i][0]) and (y1 >= pts[i][1]) then inc(ur[i]);

      if (unx > 0) then
      if (x1 = pts[i][0]) or (x2 = pts[i][0]) then begin
        if (ulen[i] >= y1) and (pts[unx][1] <= y2) then ulen[i] := ulen[unx];
      end;

      if (rnx > 0) then
      if (y1 = pts[i][1]) or (y2 = pts[i][1]) then begin
        if (rlen[i] >= x1) and (pts[rnx][0] <= x2) then rlen[i] := rlen[rnx];
      end;
    end;
  end;
end;

procedure Solve;
var
  p1, p2, i, j, kk: integer;
  s, aa, bb: sq_t;
  x1, x2, y1, y2: coord_t;

begin
  rs := 0;
  for i := 1 to npts do
  begin
    x1 := pts[i][0];
    y1 := pts[i][1];

    aa := rlen[i] - x1;
    bb := ulen[i] - y1;
    s := aa * bb;
    if s > rs then begin
    for j := npts downto i+1 do begin
       x2 := pts[j][0];
       y2 := pts[j][1];

       if ((x2 > x1) and (y2 > y1) and
          ((rlen[i] >= x2) and (ulen[i] >= y2))) then begin

       p1 := getp_bs(x1, y2);
       p2 := getp_bs(x2, y1);

       if (p1>0) and (p2>0) then begin
         if (rlen[p1] >= x2) and (ulen[p2] >= y2) then begin
           kk := ur[i] + ur[j] - ur[p1] - ur[p2];
           if (kk <= k) then begin
             aa := pts[j][0] - pts[i][0];
             bb := pts[j][1] - pts[i][1];
             s := aa * bb;

             if (s > rs) then begin
               rs := s;
               rai := i;
               rbi := j;
               rk := kk;
             end;
           end;
         end;
       end;
       end;
    end; {for j}
    end;
  end;
end;

procedure Out;
begin
  Assign(Output, 'sandbox.out'); ReWrite(Output);

  WriteLn(pts[rai][0], ' ', pts[rai][1], ' ', pts[rbi][0], ' ', pts[rbi][1]);
{  WriteLn(rs);
  WriteLn(rk);}

  Close(Output);
end;

begin
  ReadAll;
  SortPts;
  MakeT;
  Solve;
  Out;
end.
