{ XV ᨩ᪠  誮쭨  ଠ⨪       }
{  "筨"                         }
{ : ᠭ ॢ                 }
{ 襭: ᨬ                     }

{$R-, Q-}

uses Math;

const
  maxN = 2001;
  maxC = 10001;
  inf = maxlongint;

type
  integer = longint;

  TRect = record
    x1, y1, x2, y2 : integer;
  end;

var
  xs, ys : integer;
  n, k : integer;
  r : array[1..maxN] of TRect;
  cnt : array[1..maxN,1..4] of integer;
  xmax, ymax : array[1..maxN] of integer;
  xmin, ymin : array[1..maxN] of integer;
  ans : TRect;
  maxarea : integer;

  nx, ny : integer;
  xlist, ylist : array[1..maxN] of integer;
  xref, yref : array[0..maxC] of integer;

function GetX (const r : TRect; k : integer) : integer;
begin
  case k of
    1, 3: GetX := r.x1;
    2, 4: GetX := r.x2;
  end;
end;

function GetY (const r : TRect; k : integer) : integer;
begin
  case k of
    1, 2: GetY := r.y1;
    3, 4: GetY := r.y2;
  end;
end;

procedure BuildXList;
var
  f : array[0..maxC] of boolean;
  i : integer;

begin
  fillchar (f, sizeof (f), false);
  for i := 1 to n do begin
    f[r[i].x1] := true;
    f[r[i].x2] := true;
  end;

  nx := 0;
  fillchar (xref, sizeof (xref), 0);
  for i := 0 to xs do
    if f[i] then begin
      inc (nx);
      xlist[nx] := i;
      xref[i] := nx;
    end;
end;

procedure BuildYList;
var
  f : array[0..maxC] of boolean;
  i : integer;

begin
  fillchar (f, sizeof (f), false);
  for i := 1 to n do begin
    f[r[i].y1] := true;
    f[r[i].y2] := true;
  end;

  ny := 0;
  fillchar (yref, sizeof (yref), 0);
  for i := 0 to ys do
    if f[i] then begin
      inc (ny);
      ylist[ny] := i;
      yref[i] := ny;
    end;
end;

procedure BuildRightDownCounters;
var
  i, j : integer;

  function CalcFor (x, y : integer) : integer;
  var
    j : integer;
    result : integer;

  begin
    result := 0;
    for j := 1 to n do
      if (r[j].x1 >= x) and (r[j].y1 >= y) then
        inc (result);
    CalcFor := result;
  end;

begin
  for i := 1 to n do
    for j := 1 to 4 do
      cnt[i,j] := CalcFor (GetX (r[i], j), GetY (r[i], j));
end;

function GetNumRect (upleft, upright, downleft, downright : integer) : integer;
begin
  GetNumRect := cnt[upleft,1] - cnt[upright,2] - cnt[downleft,3] + cnt[downright,4];
end;

procedure GetXExtents (x0, y0 : integer; var xmin, xmax : integer);
var
  i : integer;

begin
  xmin := 0;
  xmax := xs;
  for i := 1 to n do
    if (y0 > r[i].y1) and (y0 < r[i].y2) then begin
      if r[i].x1 >= x0 then
        xmax := min (xmax, r[i].x1);
      if r[i].x2 <= x0 then
        xmin := max (xmin, r[i].x2);
    end;
end;

procedure GetYExtents (x0, y0 : integer; var ymin, ymax : integer);
var
  i : integer;

begin
  ymin := 0;
  ymax := ys;
  for i := 1 to n do
    if (x0 > r[i].x1) and (x0 < r[i].x2) then begin
      if r[i].y1 >= y0 then
        ymax := min (ymax, r[i].y1);
      if r[i].y2 <= y0 then
        ymin := max (ymin, r[i].y2);
    end;
end;

procedure BuildExtents;
var
  i : integer;
  tmp : integer;

begin
  for i := 1 to n do begin
    GetXExtents (GetX (r[i], 1), GetY (r[i], 1), tmp, xmax[i]);
    GetXExtents (GetX (r[i], 4), GetY (r[i], 4), xmin[i], tmp);

    GetYExtents (GetX (r[i], 1), GetY (r[i], 1), tmp, ymax[i]);
    GetYExtents (GetX (r[i], 4), GetY (r[i], 4), ymin[i], tmp);
  end;
end;

function IsGoodRect (i, j : integer) : boolean;
begin
  IsGoodRect :=
    (GetX (r[i], 1) < GetX (r[j], 4)) and (GetY (r[i], 1) < GetY (r[j], 4)) and
    (xmax[i] >= GetX (r[j], 4)) and (ymax[i] >= GetY (r[j], 4)) and
    (xmin[j] <= GetX (r[i], 1)) and (ymin[j] <= GetY (r[i], 1));
end;

procedure FindMax;
var
  curarea : integer;
  xidx, yidx : array[1..maxC] of integer;
  i, j : integer;
  p, q : integer;

  procedure BuildXIndices (y0 : integer);
  var
    i : integer;

  begin
    fillchar (xidx, sizeof (integer) * nx, 0);
    for i := 1 to n do
      if GetY (r[i], 2) = y0 then
        xidx[xref[GetX (r[i], 2)]] := i;
  end;

  procedure BuildYIndices (x0 : integer);
  var
    i : integer;

  begin
    fillchar (yidx, sizeof (integer) * ny, 0);
    for i := 1 to n do
      if GetX (r[i], 3) = x0 then
        yidx[yref[GetY (r[i], 3)]] := i;
  end;

begin
  maxarea := 0;
  for i := 1 to n do begin
    BuildXIndices (r[i].y1);
    BuildYIndices (r[i].x1);
    for j := 1 to n do
      if IsGoodRect (i, j) then begin
        p := xidx[xref[GetX (r[j], 4)]];
        q := yidx[yref[GetY (r[j], 4)]];
//        writeln (i, ' ', p, ' ', q, ' ', j, ' -> ', GetNumRect (i, p, q, j));
        if GetNumRect (i, p, q, j) <= k then begin
          curarea := (GetX (r[j], 4) - GetX (r[i], 1)) * (GetY (r[j], 4) - GetY (r[i], 1));
          if curarea > maxarea then begin
            ans.x1 := GetX (r[i], 1);
            ans.y1 := GetY (r[i], 1);
            ans.x2 := GetX (r[j], 4);
            ans.y2 := GetY (r[j], 4);
            maxarea := curarea;
          end;
        end;
      end;
  end;
end;

procedure Solve;
begin
  BuildXList;
  BuildYList;
  BuildRightDownCounters;
  BuildExtents;
  FindMax;
end;

procedure ReadInput;
var
  i : integer;

begin
  assign (input, 'sandbox.in');
  reset (input);

  read (xs, ys);
  read (n, k);
  for i := 1 to n do
    read (r[i].x1, r[i].y1, r[i].x2, r[i].y2);

  close (input);
end;

procedure WriteOutput;
begin
  assign (output, 'sandbox.out');
  rewrite (output);
  writeln (ans.x1, ' ', ans.y1, ' ', ans.x2, ' ', ans.y2);
  close (output);
end;

begin
  ReadInput;
  Solve;
  WriteOutput;
end.
