{$A+,B-,D-,E+,F+,G-,I-,L-,N+,O-,P-,Q-,R-,S+,T+,V+,X+,Y+}
{$M 65520,0,655360}
Program Problem;
Const
     InFile = 'fishes.in';
     OutFile = 'fishes.out';
     NMax = 1000;
     NStepsMax = 50;
Type
    TGroup = Record
     Position : LongInt;
     Length : LongInt;
    End;
    TArrGroups = Array [0..NMax] Of TGroup;
    TSteps = Array [0..NStepsMax] Of Record
     LSwaps : LongInt;
     Swaps : Array [0..NMax] Of LongInt;
    End;
Var
   N : LongInt;
   K : LongInt;
   BG,WG : TArrGroups;
   BGLen,WGLen : LongInt;
   BestSteps : TSteps;
   BestNSteps : LongInt;

 Procedure ReadData;
  Var I : LongInt;
      Color,PrevColor : LongInt;

   Procedure Add (Color,PrevColor : LongInt; Var G : TArrGroups; Var Len : LongInt);
    Begin
      If PrevColor <> Color Then Begin
       Inc (Len);
       G[Len].Position:= I;
       G[Len].Length:= 1;
      End
      Else Inc (G[Len].Length);
    End;

   Begin
     Assign (Input,InFile); ReSet (Input);
     Read (N,K);
     BGLen:= 0; WGLen:= 0;
     PrevColor:= -1;
     For I:= 1 To N Do Begin
       Read (Color);
       Case Color Of
        0 : Add (Color,PrevColor,BG,BGLen);
        1 : Add (Color,PrevColor,WG,WGLen);
        End;
       PrevColor:= Color;
     End;
     Close (Input);
   End;

 Procedure Steps (BG,WG : TArrGroups; BGLen,WGLen : LongInt);
  Var
     Steps : TSteps;
     NSteps : LongInt;

     I,J : LongInt;
     LSwaps : LongInt;

   Procedure Swap (Var I,J : LongInt);
    Var
       I1,J1 : LongInt;
     Begin
       Inc (Steps[NSteps].LSwaps);
       Steps[NSteps].Swaps[Steps[NSteps].LSwaps]:= WG[J].Position;

       BG[I].Position:= WG[J].Position;
       WG[J].Position:= BG[I].Position + BG[I].Length;
       If I > 1 Then Begin
        BG[I-1].Length:= BG[I-1].Length + BG[I].Length;
        For I1:= I To BGLen - 1 Do BG[I1]:= BG[I1+1];
        FillChar (BG[BGLen],SizeOf(BG[BGLen]),0);
        Dec (BGLen);
       End;
       Inc (I);
       If J < WGLen Then Begin
        WG[J+1].Length:= WG[J+1].Length + WG[J].Length;
        WG[J+1].Position:= WG[J].Position;
        For J1:= J To WGLen - 1 Do WG[J1]:= WG[J1+1];
        FillChar (WG[WGLen],SizeOf(WG[WGLen]),0);
        Dec (WGLen);
       End;
       Inc (J);
     End;

   Begin
     NSteps:= 0;
     While (BGLen > 1) Or (WGLen > 1) Do Begin
       Inc (NSteps);
       If NSteps > BestNSteps Then Exit;
       If BG[1].Position <> 1 Then I:= 1 Else I:= 2;
       J:= 1;
       Steps[NSteps].LSwaps:= 0;
       While (Steps[NSteps].LSwaps < K) And
              (I<=BGLen) And (J<=WGLen) Do Begin
        Swap (I,J);
       End;

     End;
     If NSteps < BestNSteps Then Begin
      BestNSteps:= NSteps;
      BestSteps:= Steps;
     End;
   End;

 Procedure Solve;
  Begin
    BestNSteps:= MaxLongInt;
    Steps (BG,WG,BGLen,WGLen);
    Steps (WG,BG,WGLen,BGLen);
  End;

 Procedure WriteData;
  Var
     I,J : LongInt;
   Begin
     Assign (Output,OutFile); ReWrite (Output);
     If BestNSteps > 0 Then
      For I:= 1 To BestNSteps Do Begin
        Write (BestSteps[I].LSwaps,' ');
        For J:= 1 To BestSteps[I].LSwaps Do Write (BestSteps[I].Swaps[J],' ');
        WriteLn;
      End;
     Write (0);
     Close (Output);
   End;

 BEGIN
   ReadData;
   Solve;
   WriteData;
 END.
