{
                 XV ᨩ᪠   ଠ⨪
    : 6
    襭: ࠭殢 ३ <andreyvit@nvkz.net>
}
{! $DEFINE DEBUG}
{$UNDEF DEBUG}
{$IFDEF DEBUG}{$R+,Q+,I+,S+}{$ELSE}{$R-,Q-,I-,S-}{$ENDIF}
program S0705_6;
uses
	SysUtils, Math;
const
    infile = 'chain.in';
    outfile = 'chain.out';
type
    integer = longint;
    natural = cardinal;

const
    MAX = 1000;
    INF = 32767;
(*
    MAXBT = MAX div 8;
type
    Bits = object
        procedure init;
        function getbit (b, i : integer) : boolean;
        procedure put (i : integer; v : boolean);
        procedure put (b, i : integer; v : boolean);
        function getbyte (b : integer) : byte;
    private
        data : array [0..MAXBT{-1}] of byte;
    end;

procedure Bits.init;
begin
    fillbyte (data, sizeof (data), 0);
end;

function Bits.getbyte (b : integer) : byte;
begin
    getbyte := data [b];
end;

function Bits.getbit (b, i : integer) : boolean;
begin
    getbit := ((data [b] shr i) and 1) = 1;
end;

procedure Bits.put (b, i : integer; v : boolean);
begin
	if v then
        data [b] := data [b] or (1 shl i)
    else
        data [b] := data [b] and not (1 shl i);
end;

procedure Bits.put (i : integer; v : boolean);
begin
    put (i shr 3, i - (i shr 3), v);
end;
*)

type
    _Cand = record
        w, idx, len : smallint;
    end;
   	letter_t = 'a'..'z';
var
    Motto : string[255];
    N : longint;
    Words : array [1..MAX] of string[11];
    candidates : array [1..255] of record
        count : integer;
        data : array [1..MAX] of _Cand;
    end;
    letter_dist : array [letter_t, letter_t] of integer;
    letter_min_word : array [letter_t, letter_t] of integer;
    letter_pred : array [letter_t, letter_t] of char;
    letter_best : array [0..255, letter_t] of integer;
    letter_best_len : array [0..255, letter_t] of integer;

function min (a, b : integer) : integer;
begin
    if a < b then min := a else min := b;
end;

procedure setminex (var minv : integer; cur : integer;
                var minsupp : char; cursupp : char);
begin
    if cur < minv then begin
        minv := cur;
        minsupp := cursupp;
    end;
end;

procedure setminexi (var minv : integer; cur : integer;
                var minsupp : integer; cursupp : integer);
begin
    if cur < minv then begin
        minv := cur;
        minsupp := cursupp;
    end;
end;

procedure findLetterConnections;
var
    i, j, k : char;
    len : integer;
    w : integer;
    s : string;
begin
    for i := low (letter_t) to high (letter_t) do
        for j := low (letter_t) to high (letter_t) do
            if i = j then begin
                letter_dist [i, j] := 0;
                letter_pred [i, j] := #0;
            end
            else begin
                letter_dist [i, j] := INF;
                letter_pred [i, j] := i {or #0?};
            end;

    for w := 1 to N do begin
        len := length (words [w]);
        setminexi (letter_dist [words [w][1], words [w][len]],
            len-1,
            letter_min_word [words [w][1], words [w][len]],
            w);
    end;

    for k := low (letter_t) to high (letter_t) do
        for i := low (letter_t) to high (letter_t) do
            for j := low (letter_t) to high (letter_t) do
                setminex (letter_dist [i, j],
                        letter_dist [i, k] + letter_dist [k, j],
                        letter_pred [i, j], k);

    {
    for i := low (letter_t) to high (letter_t) do
        for j := low (letter_t) to high (letter_t) do
            if (letter_dist [i, j] < 32000) and
            	(letter_dist [i, j] <> 0) then
                writeln (i, '--', j, ' = ', letter_dist [i, j]);
    }
end;

function indexOf (st : integer; s : string; ch : char) : integer;
begin
	{SPECIAL: last character of S is NOT considered here!}
    while st < length (s) do
        if s [st] <> ch then
            inc (st)
        else begin
            indexOf := st;
            exit;
        end;
    indexOf := -1;
end;

procedure getBestCandidate (w : string; shift : integer; var cand : _Cand);
var
    cur : _Cand;
    startIdx, idx, curShift : integer;
begin
    cand.len := 0;
    startIdx := indexOf (1, w, Motto [shift]);
    if startIdx < 0 then exit;
    curShift := shift + 1;
    idx := startIdx;
    while curShift <= length (Motto) do begin
        idx := indexOf (idx+1, w, Motto [curShift]);
        if idx < 0 then break;
        inc (curShift);
    end;
    cand.len := curShift - shift;
    cand.idx := startIdx;
end;

procedure writeCand (le, wo : integeR);
begin
	with candidates [le] do
        write (words [data [wo].w], '<', data[wo].idx, ',',
            copy(motto,le,data[wo].len),'> ');
end;

procedure findCandidates;
var
    cand : _Cand;
	le, wo : integer;
begin
    for le := 1 to length (Motto) do
        for wo := 1 to N do begin
            getBestCandidate (Words [wo], le, cand);
            if cand.len > 0 then begin
            	cand.w := wo;
                with candidates [le] do begin
                    inc (count);
                    data [count] := cand;
                end;
            end;
        end;

    {$IFDEF XDEBUG}
    for le := 1 to length (Motto) do begin
        write (Motto [le], ' => ');
        with candidates [le] do
            for wo := 1 to count do
            	writeCand (le, wo);
        writeln;
    end;
    writeln;
    {$ENDIF}
end;

function nextShift (le : integer; ca : integer) : integer;
var
    test : integer;
    w : string;
begin
    test := le + candidates [le].data [ca].len;
    if test > length (motto) then
        nextShift := 0
    else if test < length (motto) then
        nextShift := test
    else begin
        w := words [candidates [le].data [ca].w];
        if w [length (w)] = motto [length (motto)] then
            nextShift := 0
        else
            nextShift := test;
    end;
end;

procedure findBestForLetter (le : integer);
var
    ca : integer;
    ch : char;
    base_len, cur_len : integer;
    w : string;
begin
    for ch := low (letter_t) to high (letter_t) do begin
        letter_best_len [le, ch] := INF;
        letter_best [le, ch] := 0;
    end;

    with candidates [le] do
        for ca := 1 to count do begin
            w := words [data [ca].w];
            base_len := length (w) - 1 +
                letter_best_len [nextShift (le, ca), w [length(w)]];
            for ch := low (letter_t) to high (letter_t) do begin
                cur_len := base_len + letter_dist [ch, w [1]];
                if cur_len < letter_best_len [le, ch] then begin
                    letter_best_len [le, ch] := cur_len;
                    letter_best [le, ch] := ca;
                end;
            end;
        end;
end;

procedure printGlue (a, b : char);
var
    w : string;
    p : char;
begin
    p := letter_pred [a, b];
    if p = #0 then exit;
    if p <> a then
        printGlue (a, p);
    //writeln (p, ' ', b);
    writeln (words [letter_min_word [p, b]]);
end;

procedure printCandGlue (prev_le, le, a, b : integer);
var
	w1, w2 : string;
begin
	w1 := words [candidates [prev_le].data [a].w];
    w2 := words [candidates [le].data [b].w];
    printGlue (w1 [length (w1)], w2 [1]);
end;

procedure printMotto (start_ch : char);
var
    ch : char;
    le, prev_le : integer;
    prev_cand, cur_cand : integer;
    w : string;
begin
    ch := start_ch;
    le := 1;
    prev_cand := 0;
    while le > 0 do begin
        cur_cand := letter_best [le, ch];
        if prev_cand <> 0 then
        	printCandGlue (prev_le, le, prev_cand, cur_cand);
        w := words [candidates [le].data [cur_cand].w];
        {$IFDEF DEBUG}
        writeCand (le, cur_cand);
        write (' = ', letter_best_len [le, ch], ' using ', ch);
        writeln;
        {$ELSE}
        writeln (w);
        {$ENDIF}
        ch := w [length (w)];
        prev_cand := cur_cand;
        prev_le := le;
        le := nextShift (le, cur_cand);
    end;
end;

procedure processMotto;
var
    le : integer;
    ch, best_ch : char;
    best_len : integer;
begin
    for ch := low (letter_t) to high (letter_t) do
        letter_best_len [0, ch] := 0;

    for le := length (Motto) downto 1 do
        findBestForLetter (le);

    best_ch := low (letter_t);
    best_len := letter_best_len [1, best_ch];
    for ch := succ (low (letter_t)) to high (letter_t) do
        if letter_best_len [1, ch] < best_len then begin
            best_ch := ch;
            best_len := letter_best_len [1, best_ch];
        end;

    {$IFDEF DEBUG}
    writeln (best_len, ' (really ', best_len+1, ')');
    {$ENDIF}
    if best_len >= INF then
        write ('?')
    else
	    printMotto (best_ch);
end;

var
	i : longint;
begin
	assign (input, infile); reset (input);
    {$IFNDEF DEBUG}assign (output, outfile); rewrite (output);{$ENDIF}

    {$IFDEF DEBUG}writeln;writeln;writeln;{$ENDIF}

    readln (Motto);
    readln (N);
    for i := 1 to N do
        readln (words [i]);

    findLetterConnections;
    findCandidates;
    processMotto;

    close (input);
    close (output);
end.
