{.$define debug}

{$R-,Q-,S-,I-}

program template;
const
 h = 2100;
 no = 'NO';
 infinity = 100000;
 {$ifdef debug}
 cinfile = 'input.txt';
 coutfile = 'output.txt';
 {$else}
 cinfile = 'glass.in';
 coutfile = 'glass.out';
 {$endif}
type
 int = longint;
 real = extended;
 tpoint = record
  x,y :int;
 end;
var
 n :int;
 p :array [1..h,1..4] of tpoint;
 a,b :array [1..h] of tpoint;
 mv :array [1..h] of tpoint;
 vect :tpoint;
 data :array [1..h,1..3] of tpoint;
 fr :tpoint;
 vp :tpoint;

procedure init;
begin
 fillchar (p,sizeof(p),0);
 fillchar (a,sizeof(a),0);
 fillchar (b,sizeof(b),0);
 fillchar (vect,sizeof(vect),0);
 fillchar (vp,sizeof(vp),0);
 fillchar (mv,sizeof(mv),0);
 fillchar (data,sizeof(data),0);
end;

procedure readdata;
var i,j :int;
begin
 assign (input,cinfile);
 reset (input);
 readln (n);
 for i := 1 to n do
  for j := 1 to 3 do
   begin
    read (p[i,j].x,p[i,j].y);
    p[i,4] := p[i,1];
   end;
 close (input);
end;

procedure outdata;
var i,j :int;
begin
 assign (output,coutfile);
 rewrite (output);
 for i := 1 to n do
  for j := 1 to 3 do
   begin
    write (data[i,j].x,' ',data[i,j].y,' ');
    if j = 3 then
     writeln;
   end;
 close (output);
end;

procedure outno;
begin
 assign (output,coutfile);
 rewrite (output);
 writeln (no);
 close (output);
 halt;
end;

procedure swap (var a,b :tpoint);
var tmp :tpoint;
begin
 tmp := a;
 a := b;
 b := tmp;
end;

function product (a,b :tpoint):int;
begin
 product := a.x*b.y - a.y*b.x;
end;

function vector (a,b,c :tpoint):int;
begin
 vector := (b.x - a.x)*(c.y - a.y) -
            (b.y - a.y)*(c.x - a.x);
end;

procedure calcpoints (v :int; var a,b :tpoint);
var i,j :int;
    _p :array [1..4] of tpoint;
    t :tpoint;
    d :array [1..2] of tpoint;
    k :int;
    good :int;
    a_,b_ :int;
begin
 fillchar (_p,sizeof(_p),0);
 good := 0;
 for i := 1 to 3 do
  begin
   t.x := p[v,i].x;
   t.y := p[v,i].y;
   for j := 1 to 4 do
    begin
     _p[j].x := p[v,j].x - t.x;
     _p[j].y := p[v,j].y - t.y;
    end;
   k := 0;
   for j := 1 to 3 do
    if not (j = i) then
     begin
      inc(k);
      d[k] := _p[j];
     end;
   a_ := d[1].y - d[2].y;
   b_ := d[2].x - d[1].x;
   if (a_ = 0) or (b_ = 0) then
    begin
     inc(good);
     a := d[1];
     b := d[2];
     mv[v] := t;
    end;
  end;
 if product(a,b) < 0 then
  swap(a,b);
 if (good = 0) then
  outno;
end;

procedure solve;
var i,j :int;
    minx,miny :int;
    cur :int;
begin
 for i := 1 to n do
  calcpoints (i,a[i],b[i]);
 for i := 1 to n do
  begin
   vect.x := vect.x + a[i].x - b[i].x;
   vect.y := vect.y + a[i].y - b[i].y;
   if a[i].x = b[i].x then
    vp.y := vp.y + b[i].y - a[i].y
   else
    vp.x := vp.x + b[i].x - a[i].x;
  end;
 if not ((vect.x = 0) and (vect.y = 0)) then
  outno;
 if not ((vp.x = 0) and (vp.y = 0)) then
  outno;
 fr.x := 0;
 fr.y := 0;
 for i := 1 to n do
  for j := 1 to 3 do
   begin
    data[i,j].x := p[i,j].x - mv[i].x;
    data[i,j].y := p[i,j].y - mv[i].y;
    if data[i,j].x < fr.x then
     fr.x := data[i,j].x;
    if data[i,j].y < fr.y then
     fr.y := data[i,j].y;
   end;
 for i := 1 to n do
  for j := 1 to 3 do
   begin
    data[i,j].x := data[i,j].x - fr.x;
    data[i,j].y := data[i,j].y - fr.y;
   end;
 miny := infinity;
 for i := 1 to n do
  if a[i].y < miny then
   miny := a[i].y;
 minx := infinity;
 cur := 0;
 for i := 1 to n do
  if a[i].y = miny then
   if a[i].x < minx then
    begin
     minx := a[i].x;
     cur := i;
    end;
 swap(a[1],a[cur]);
 swap(b[1],b[cur]);
 for i := 2 to n-1 do
  for j := i+1 to n do
   if vector (fr,a[i],a[j]) < 0 then
    begin
     swap (a[i],a[j]);
     swap (b[i],b[j]);
    end;
 a[n+1] := a[1];
 b[n+1] := b[1];
 for i := 1 to n do
  if not ((b[i].x = a[i+1].x) and (b[i].y = a[i+1].y)) then
   outno;
end;

begin
 init;
 readdata;
 solve;
 outdata;
end.