const
  eps=1e-4;
  infile='glass.in';
  outfile='glass.out';

type
  tpoint = record
    x,y:integer;
    end;
  triangle = array[1..3]of tpoint;

var
  t:array[1..2000]of triangle;
  use:array[1..2000]of boolean;
  n:integer;

procedure openfiles;
begin
  assign(input,infile);
  assign(output,outfile);
  reset(input);
  rewrite(output);
end;

procedure closefiles;
begin
  close(input);
  close(output);
end;

function polarangle(k:tpoint):extended;
var
  x,y,k1:extended;

begin
  if (k.x=0)and(k.y=0)then
  begin
    polarangle:=0;
    exit;
  end;
  if k.x=0 then
  begin
    if k.y<0 then
      polarangle:=pi*1.5
    else
      polarangle:=pi*0.5;
    exit;
  end;
  x:=k.x;
  y:=k.y;
  k1:=arctan(y/x);
  if (x<0) then
    k1:=k1+pi;
  if (y<0)and(x>0) then
    k1:=2*pi+k1;
  polarangle:=k1;
end;

procedure outsolve;
var
  k:tpoint;
  i,i1:integer;

begin
  k.x:=t[1][1].x;
  k.y:=t[1][1].y;
  for i:=1 to n do
   for i1:=1 to 3 do
     if (t[i][i1].x<k.x)or((t[i][i1].x=k.x)and(t[i][i1].y<k.y))then
       k:=t[i][i1];
  for i:=1 to n do
   for i1:=1 to 3 do
   begin
     t[i][i1].x:=t[i][i1].x-k.x;
     t[i][i1].y:=t[i][i1].y-k.y;
   end;
  for i:=1 to n do
  begin
   for i1:=1 to 3 do
     write(t[i][i1].x,' ',t[i][i1].y,' ');
   writeln;
  end;
end;

function check:boolean;
var
  xmin,xmax,ymin,ymax,xymin,xymax,yxmin,yxmax:integer;
  sum,s,kmax,kmin:extended;
  i,i1,i2:integer;
  l,l1,l2:boolean;

begin
  s:=0;
  l:=true;
  for i:=1 to n do
  begin
    kmin:=10;
    kmax:=-10;
    for i1:=1 to 3 do
    if (t[i][i1].x<>0)or(t[i][i1].y<>0) then
    begin
      if polarangle(t[i][i1])>kmax then
        kmax:=polarangle(t[i][i1]);
      if polarangle(t[i][i1])<kmin then
        kmin:=polarangle(t[i][i1]);
    end;
    if (kmax-kmin)>pi then
      l1:=true
    else
      l1:=false;
    for i1:=1 to n do
    begin
      l2:=true;
      if i<>i1 then
      for i2:=1 to 3 do
      if (t[i1][i2].x<>0)or(t[i1][i2].y<>0) then
      begin
        if l1 then
          l2:=(l2)and(polarangle(t[i1][i2])<=kmax)and(polarangle(t[i1][i2])>=kmin)
        else
          l2:=(l2)and((polarangle(t[i1][i2])>=kmax)or(polarangle(t[i1][i2])<=kmin));
      end;
      l:=(l)and(l2);
    end;
  end;
  for i:=1 to n do
  begin
    sum:=0;
    for i1:=1 to 3 do
      if abs(sum)<eps then
        sum:=sum+polarangle(t[i][i1])
      else
        sum:=sum-polarangle(t[i][i1]);
    sum:=abs(sum);
    if (sum-eps)>pi then
      sum:=sum-pi;
    s:=s+sum;
  end;
  l:=(l)and(abs(s-2*pi)<eps);
  xmin:=t[1][1].x;
  xmax:=t[1][1].x;
  yxmax:=t[1][1].y;
  yxmin:=t[1][1].y;
  for i:=1 to n do
    for i1:=1 to 3 do
    begin
      if (t[i][i1].x>xmax)or((t[i][i1].x=xmax)and(t[i][i1].y>yxmax)) then
      begin
        xmax:=t[i][i1].x;
        yxmax:=t[i][i1].y;
      end;
      if (t[i][i1].x<xmin)or((t[i][i1].x=xmin)and(t[i][i1].y<yxmax)) then
      begin
        xmin:=t[i][i1].x;
        yxmin:=t[i][i1].y;
      end;
    end;
  ymin:=t[1][1].y;
  ymax:=t[1][1].y;
  xymax:=t[1][1].x;
  xymin:=t[1][1].x;
  for i:=1 to n do
    for i1:=1 to 3 do
    begin
      if (t[i][i1].y>ymax)or((t[i][i1].y=ymax)and(t[i][i1].x>xymax)) then
      begin
        ymax:=t[i][i1].y;
        xymax:=t[i][i1].x;
      end;
      if (t[i][i1].y<ymin)or((t[i][i1].y=ymin)and(t[i][i1].x<xymin)) then
      begin
        ymin:=t[i][i1].y;
        xymin:=t[i][i1].x;
      end;
    end;
  check:=(l)and(ymax=yxmax)and(ymin=yxmin)and(xmax=xymax)and(xmin=xymin);
end;

procedure add(q:integer);
var
  k,k1,i,i1,x,y:integer;

begin
  if ((t[q][1].x=t[q][2].x)and(t[q][1].y=t[q][3].y))or
     ((t[q][1].x=t[q][3].x)and(t[q][1].y=t[q][2].y)) then
       k:=1;
  if ((t[q][2].x=t[q][1].x)and(t[q][2].y=t[q][3].y))or
     ((t[q][2].x=t[q][3].x)and(t[q][2].y=t[q][1].y)) then
       k:=2;
  if ((t[q][3].x=t[q][2].x)and(t[q][3].y=t[q][1].y))or
     ((t[q][3].x=t[q][1].x)and(t[q][3].y=t[q][2].y)) then
       k:=3;
  use[q]:=true;
  k1:=0;
  for i1:=1 to n do
    if not use[i1] then
      k1:=i1;
  for i:=1 to 3 do
    if i<>k then
      begin
        x:=t[q][i].x;
        y:=t[q][i].y;
        for i1:=1 to 3 do
        begin
          t[q][i1].x:=t[q][i1].x-x;
          t[q][i1].y:=t[q][i1].y-y;
        end;
        if k1=0 then
          if check then
          begin
            outsolve;
            closefiles;
            halt;
          end;
        if k1<>0 then
          add(k1);
      end;
  use[q]:=false;
end;

procedure solve;
var
  i,i1,sum:integer;
  k:tpoint;

begin
  read(n);
  for i:=1 to n do
    for i1:=1 to 3 do
      read(t[i][i1].x,t[i][i1].y);
  fillchar(use,sizeof(use),false);
  for i:=1 to n do
  begin
    sum:=0;
    if (t[i][3].x=t[i][1].x)or(t[i][3].y=t[i][1].y) then
    begin
      inc(sum);
      k:=t[i][2];
    end;
    if (t[i][2].x=t[i][1].x)or(t[i][2].y=t[i][1].y) then
    begin
      inc(sum);
      k:=t[i][3];
    end;
    if (t[i][3].x=t[i][2].x)or(t[i][3].y=t[i][2].y) then
    begin
      inc(sum);
      k:=t[i][1];
    end;
    if sum=1 then
    begin
      use[i]:=true;
      for i1:=1 to 3 do
      begin
        t[i][i1].x:=t[i][i1].x-k.x;
        t[i][i1].y:=t[i][i1].y-k.y;
      end;
    end;
    if (sum>2) or (sum<1) then
    begin
      write('NO');
      exit;
    end;
  end;
  for i:=1 to n do
    if not use[i] then
    begin
      add(i);
      break;
    end;
  if not(check) then
  begin
    write('NO');
    exit;
  end;
  outsolve;
end;

begin
  openfiles;
  solve;
  closefiles;
end.
