#include <stdio.h>

FILE*fi,*fo;

struct TPoint {
  int x,y;
};
struct TTriang {
  TPoint A,B,C;
  TPoint*a,*b,*c;
  TPoint p,q;
  void redetect(void);
  void relocate(TPoint);
  void move(TPoint);
  int operator==(TTriang&);
};

int n,m;
TTriang*s;
int*t;
char*r;

int main(void) {
  int i;
  fi=fopen("glass.in","rt");
  fscanf(fi,"%d",&n);
  s=new TTriang[n];
  for (i=0; i<n; i++) {
    fscanf(fi,"%d%d%d%d%d%d",
    &s[i].A.x,&s[i].A.y,&s[i].B.x,&s[i].B.y,&s[i].C.x,&s[i].C.y);
    s[i].redetect();
  }
  fclose(fi);
  t=new int[n];
  int j,k;
  r=new char[n];
  for (i=0; i<n; i++) r[i]=1;
  t[0]=k=0; r[k]--;
  for (i=1; i<n; i++) {
    for (j=0; j<n; j++) if (r[j]) if (s[k]==s[j]) break;
    if (j>=n) break;
    s[j].relocate(*s[k].b);
    t[i]=k=j; r[k]--;
  } m=(i>=n);
  delete[]r;
  if (m) {
    TPoint z;
    z.x=s[0].a->x; z.y=s[0].a->y;
    for (i=0; i<n; i++) {
      if (s[i].a->x<z.x) z.x=s[i].a->x;
      if (s[i].a->y<z.y) z.y=s[i].a->y;
      if (s[i].b->x<z.x) z.x=s[i].b->x;
      if (s[i].b->y<z.y) z.y=s[i].b->y;
    }
    for (i=0; i<n; i++) s[i].move(z);
  }
  fo=fopen("glass.out","wt");
  if (m) {
    for (i=0; i<n; i++) fprintf(fo,"%d %d %d %d %d %d\n",
    s[i].A.x,s[i].A.y,s[i].B.x,s[i].B.y,s[i].C.x,s[i].C.y);
  } else fprintf(fo,"NO");
  fclose(fo);
  delete[]t;
  delete[]s;
  return(0);
}


void TTriang::redetect(void) {
  TPoint*d,e; long z;
  a=&A; b=&B; c=&C;
  if ((a->x==c->x)||(a->y==c->y)) { d=b; b=c; c=d; }
  if ((b->x==c->x)||(b->y==c->y)) { d=a; a=c; c=d; }
  p.x=a->x-c->x; p.y=a->y-c->y;
  q.x=b->x-c->x; q.y=b->y-c->y;
  z=long(p.x)*long(q.y)-long(p.y)*long(q.x);
  if (z<0) { d=a; a=b; b=d;  e=p; p=q; q=e; }
}
void TTriang::relocate(TPoint d) {
  d.x-=a->x; d.y-=a->y;
  a->x+=d.x; a->y+=d.y;
  b->x+=d.x; b->y+=d.y;
  c->x+=d.x; c->y+=d.y;
}
void TTriang::move(TPoint d) {
  a->x-=d.x; a->y-=d.y;
  b->x-=d.x; b->y-=d.y;
  c->x-=d.x; c->y-=d.y;
}
int TTriang::operator==(TTriang&z) {
  return((q.x==z.p.x)&&(q.y==z.p.y));
}

