#include <stdio.h>
#include <stdlib.h>
enum treugtype {LEFT,RIGHT,TOP,BOTTOM};
class treug {
  public:
  int x[3];
  int y[3];

  int par[2];
  int other;
  int delta;
  int h;
  treugtype type;
  treug() {
    type = LEFT;
    delta = 0;
    h = 0;
    par[0] = 0;
    par[1] = 0;
    other = 0;
  }

  int calc();
  int recalcleft(int nx, int ny);
  int recalcright(int nx, int ny);
  int recalctop(int nx, int ny);
  int recalcbottom(int nx, int ny);
};
int n;
treug* t[2000];
int left[2000];
int nl;
int X,Y;
int top[2000];
int nt;
int right[2000];
int nr;
int bottom[2000];
int nb;
FILE* input;
FILE* output;
int i,j,k;
int tx,ty;
int treug_error;

int qsort(int a[], int l, int r) {
  int i,j,k;
  int x;
  i = l;
  j = r;
  x = t[a[(l+r)/2]]->delta;
  while (i<=j) {
    while (t[a[i]]->delta > x) i++;
    while (t[a[j]]->delta < x) j--;
    if (i<=j) {
      k = a[i];
      a[i] = a[j];
      a[j] = k;
      i++;
      j--;
    }
  }
  if (i<r) qsort(a,i,r);
  if (j>l) qsort(a,l,j);
  return 0;
}


int min(int a, int b) {
  if (a<b) return a;
    else return b;
}
int max(int a, int b) {
  if (a>b) return a;
    else return b;
}

int equals() {
  int i,j,k;
  int a,b;
  int d1x,d1y,d2x,d2y;
  a = bottom[0];
  b = left[nl-1];
  d1x = abs(t[a]->x[t[a]->other] - min(t[a]->x[t[a]->par[0]],t[a]->x[t[a]->par[1]]));
  d1y = abs(t[a]->h);
  d2x = abs(t[b]->h);
  d2y = abs(t[b]->y[t[b]->other] - min(t[b]->y[t[b]->par[0]],t[b]->y[t[b]->par[1]]));
  if ((d1x!=d2x)||(d1y!=d2y)) {
    return 0;
  }
  a = bottom[nb-1];
  b = right[nr-1];
  d1x = abs(t[a]->x[t[a]->other] - max(t[a]->x[t[a]->par[0]],t[a]->x[t[a]->par[1]]));
  d1y = abs(t[a]->h);
  d2x = abs(t[b]->h);
  d2y = abs(t[b]->y[t[b]->other] - min(t[b]->y[t[b]->par[0]],t[b]->y[t[b]->par[1]]));
  if ((d1x!=d2x)||(d1y!=d2y)) {
    return 0;
  }
  a = top[0];
  b = left[0];
  d1x = abs(t[a]->x[t[a]->other] - min(t[a]->x[t[a]->par[0]],t[a]->x[t[a]->par[1]]));
  d1y = abs(t[a]->h);
  d2x = abs(t[b]->h);
  d2y = abs(t[b]->y[t[b]->other] - max(t[b]->y[t[b]->par[0]],t[b]->y[t[b]->par[1]]));
  if ((d1x!=d2x)||(d1y!=d2y)) {
    return 0;
  }
  a = top[nt-1];
  b = right[0];
  d1x = abs(t[a]->x[t[a]->other] - max(t[a]->x[t[a]->par[0]],t[a]->x[t[a]->par[1]]));
  d1y = abs(t[a]->h);
  d2x = abs(t[b]->h);
  d2y = abs(t[b]->y[t[b]->other] - max(t[b]->y[t[b]->par[0]],t[b]->y[t[b]->par[1]]));
  if ((d1x!=d2x)||(d1y!=d2y)) {
    return 0;
  }




  return 1;
}

int treug::calc() {

  if (x[0] == x[1]) {
    par[0] = 0;
    par[1] = 1;
    other = 2;
    if (x[2] > x[0]) type = LEFT;
      else type = RIGHT;
  }
  if (x[0] == x[2]) {
    par[0] = 0;
    par[1] = 2;
    other = 1;
    if (x[1] > x[0]) type = LEFT;
      else type = RIGHT;
  }
  if (x[1] == x[2]) {
    par[0] = 1;
    par[1] = 2;
    other = 0;
    if (x[0] > x[1]) type = LEFT;
      else type = RIGHT;
  }

  if (y[0] == y[1]) {
    par[0] = 0;
    par[1] = 1;
    other = 2;
    if (y[2] > y[0]) type = BOTTOM;
      else type = TOP;
  }
  if (y[0] == y[2]) {
    par[0] = 0;
    par[1] = 2;
    other = 1;
    if (y[1] > y[0]) type = BOTTOM;
      else type = TOP;
  }
  if (y[1] == y[2]) {
    par[0] = 1;
    par[1] = 2;
    other = 0;
    if (y[0] > y[1]) type = BOTTOM;
      else type = TOP;
  }

  if (par[0] == par[1]) treug_error = 1;

  if ((type == LEFT)||(type == RIGHT)) {
    delta = max(y[par[0]],y[par[1]])-y[other];
    h = abs(x[par[0]]-x[other]);
  }
  if ((type == TOP)||(type == BOTTOM)) {
    delta = max(x[par[0]],x[par[1]])-x[other];
    h = abs(y[par[0]]-y[other]);
  }

  return 0;
}

int treug::recalcbottom(int nx, int ny) {
  int i,j,k,v1,v2,v3;
  for (i=0; i<3; i++) {
    if (x[i] == min(x[par[0]],x[par[1]])) {
      v1 = i;
      break;
    }
  }
  v2 = other;
  for (i=0; i<3; i++) {
    if (x[i] == max(x[par[0]],x[par[1]])) {
      v3 = i;
      break;
    }
  }
  x[v2] = x[v2] - x[v1];
  y[v2] = y[v2] - y[v1];
  x[v3] = x[v3] - x[v1];
  y[v3] = y[v3] - y[v1];
  x[v1] = nx;
  y[v1] = ny;
  x[v2] = x[v2] + x[v1];
  y[v2] = y[v2] + y[v1];
  x[v3] = x[v3] + x[v1];
  y[v3] = y[v3] + y[v1];
}
int treug::recalctop(int nx, int ny) {
  int i,j,k,v1,v2,v3;
  for (i=0; i<3; i++) {
    if (x[i] == min(x[par[0]],x[par[1]])) {
      v1 = i;
      break;
    }
  }
  v2 = other;
  for (i=0; i<3; i++) {
    if (x[i] == max(x[par[0]],x[par[1]])) {
      v3 = i;
      break;
    }
  }
  x[v2] = x[v2] - x[v1];
  y[v2] = y[v2] - y[v1];
  x[v3] = x[v3] - x[v1];
  y[v3] = y[v3] - y[v1];
  x[v1] = nx;
  y[v1] = ny;
  x[v2] = x[v2] + x[v1];
  y[v2] = y[v2] + y[v1];
  x[v3] = x[v3] + x[v1];
  y[v3] = y[v3] + y[v1];
}

int treug::recalcleft(int nx, int ny) {
  int i,j,k,v1,v2,v3;
  for (i=0; i<3; i++) {
    if (y[i] == max(y[par[0]],y[par[1]])) {
      v1 = i;
      break;
    }
  }
  v2 = other;
  for (i=0; i<3; i++) {
    if (y[i] == min(y[par[0]],y[par[1]])) {
      v3 = i;
      break;
    }
  }
  x[v2] = x[v2] - x[v1];
  y[v2] = y[v2] - y[v1];
  x[v3] = x[v3] - x[v1];
  y[v3] = y[v3] - y[v1];
  x[v1] = nx;
  y[v1] = ny;
  x[v2] = x[v2] + x[v1];
  y[v2] = y[v2] + y[v1];
  x[v3] = x[v3] + x[v1];
  y[v3] = y[v3] + y[v1];
}

int treug::recalcright(int nx, int ny) {
  int i,j,k,v1,v2,v3;
  for (i=0; i<3; i++) {
    if (y[i] == max(y[par[0]],y[par[1]])) {
      v1 = i;
      break;
    }
  }
  v2 = other;
  for (i=0; i<3; i++) {
    if (y[i] == min(y[par[0]],y[par[1]])) {
      v3 = i;
      break;
    }
  }
  x[v2] = x[v2] - x[v1];
  y[v2] = y[v2] - y[v1];
  x[v3] = x[v3] - x[v1];
  y[v3] = y[v3] - y[v1];
  x[v1] = nx;
  y[v1] = ny;
  x[v2] = x[v2] + x[v1];
  y[v2] = y[v2] + y[v1];
  x[v3] = x[v3] + x[v1];
  y[v3] = y[v3] + y[v1];
}

int wrong() {
  output = fopen("glass.out","wt");
  fprintf(output,"NO\n");
  fclose(output);
  return 0;
}

int main() {
  input = fopen("glass.in","rt");
  fscanf(input,"%d\n",&n);
  for (i=0; i<n; i++) {
    t[i] = new treug();
    fscanf(input,"%d %d %d %d %d %d\n",&t[i]->x[0],&t[i]->y[0],&t[i]->x[1],&t[i]->y[1],&t[i]->x[2],&t[i]->y[2]);
    t[i]->calc();
    if (t[i]->type == LEFT) {
      left[nl] = i;
      nl++;
    }
    if (t[i]->type == RIGHT) {
      right[nr] = i;
      nr++;
    }
    if (t[i]->type == TOP) {
      top[nt] = i;
      nt++;
    }
    if (t[i]->type == BOTTOM) {
      bottom[nb] = i;
      nb++;
    }
  }
  fclose(input);

  if (treug_error) {
    wrong();
    return 0;
  }

  if (nb*nt*nl*nr == 0) {
    wrong();
    return 0;
  }

  for (i=0; i<nl; i++) {
    if (t[left[i]]->h != t[left[0]]->h) {
      wrong();
      return 0;
    }
  }
  for (i=0; i<nr; i++) {
    if (t[right[i]]->h != t[right[0]]->h) {
      wrong();
      return 0;
    }
  }
  for (i=0; i<nt; i++) {
    if (t[top[i]]->h != t[top[0]]->h) {
      wrong();
      return 0;
    }
  }
  for (i=0; i<nb; i++) {
    if (t[bottom[i]]->h != t[bottom[0]]->h) {
      wrong();
      return 0;
    }
  }

  qsort(left,0,nl-1);
  qsort(right,0,nr-1);
  qsort(top,0,nt-1);
  qsort(bottom,0,nb-1);

  if (!equals()) {
    wrong();
    return 0;
  }

  X = 0;
  Y = 0;

  tx = X;
  ty = Y;
  for (i=0; i<nb; i++) {
    t[bottom[i]]->recalcbottom(tx,ty);
    tx = max(t[bottom[i]]->x[t[bottom[i]]->par[0]],t[bottom[i]]->x[t[bottom[i]]->par[1]]);
  }
  tx = X;
  ty = t[top[0]]->h+t[bottom[0]]->h;
  for (i=0; i<nt; i++) {
    t[top[i]]->recalctop(tx,ty);
    tx = max(t[top[i]]->x[t[top[i]]->par[0]],t[top[i]]->x[t[top[i]]->par[1]]);
  }
  tx = X;
  ty = t[top[0]]->h+t[bottom[0]]->h;
  for (i=0; i<nl; i++) {
    t[left[i]]->recalcleft(tx,ty);
    ty = min(t[left[i]]->x[t[left[i]]->par[0]],t[left[i]]->x[t[left[i]]->par[1]]);
  }
  tx = t[left[0]]->h+t[right[0]]->h;
  ty = t[top[0]]->h+t[bottom[0]]->h;
  for (i=0; i<nr; i++) {
    t[right[i]]->recalcright(tx,ty);
    ty = min(t[right[i]]->x[t[right[i]]->par[0]],t[right[i]]->x[t[right[i]]->par[1]]);
  }

  output = fopen("glass.out","wt");
  for (i=0; i<n; i++) {
    fprintf(output,"%d %d %d %d %d %d\n",t[i]->x[0],t[i]->y[0],t[i]->x[1],t[i]->y[1],t[i]->x[2],t[i]->y[2]);
  }
  fclose(output);








  return 0;
}