#include <fstream.h>
#include <stdlib.h>
#include <math.h>

ifstream ifile ("glass.in");
ofstream ofile("glass.out");

struct tri
{
	int x[3], y[3];
	char good;
	char corn;
	int num;
	float a_min;
	float a_max;
} tris[2000];

tri* tr_ps[2000];

tri* badtris[8];
int numbadtris;

int s_a_min (const void* t1, const void* t2)
{
	tri* tr1 = *((tri**)t1);
	tri* tr2 = *((tri**)t2);
	if (tr1->a_min > tr2->a_min) return -1;
	if (tr1->a_min < tr2->a_min) return 1;
	if (tr1->a_min == tr2->a_min) return 0;
}
int s_num (const void* t1, const void* t2)
{
	tri* tr1 = (tri*)t1;
	tri* tr2 = (tri*)t2;
	if (tr1->num > tr2->num) return 1;
	if (tr1->num < tr2->num) return -1;
	if (tr1->num == tr2->num) return 0;
}

int N;

int main ()
{
	numbadtris = 0;
	ifile >> N;
	for (int i=0;i<N;i++)
	{
		ifile >> tris[i].x[0] >> tris[i].y[0] >> tris[i].x[1] >> tris[i].y[1] >> tris[i].x[2] >> tris[i].y[2];
		tris[i].num = i;
                tr_ps[i] = &(tris[i]);
		tris[i].good = 0;
		for (int v = 0; v < 3; v++)
		{
			if (tris[i].x[v] == tris[i].x[(v+1)%3])
			{
				tris[i].corn = (v+2)%3;
				tris[i].good++;
			}
			if (tris[i].y[v] == tris[i].y[(v+1)%3])
			{
				tris[i].corn = (v+2)%3;
				tris[i].good++;
			}
		}
		if (tris[i].good==0)
		{
			ofile << "NO";
			ofile.close();
			exit(0);
		}
		if (tris[i].good==1)
		{
			int sx = tris[i].x[tris[i].corn];
			int sy = tris[i].y[tris[i].corn];
			for (int v=0;v<3;v++)
			{
				tris[i].x[v] -= sx;
				tris[i].y[v] -= sy;
			}
		}
		if (tris[i].good>=2)
		{
			for (int v=0;v<3;v++)
			 if (
				(tris[i].x[v]==tris[i].x[(v+1)%3] || tris[i].x[v]==tris[i].x[(v+2)%3]) &&
				(tris[i].y[v]==tris[i].y[(v+1)%3] || tris[i].y[v]==tris[i].y[(v+2)%3])
			    )
			    {
				tris[i].good = 10+v;
			    }
			badtris[numbadtris++] = &(tris[i]);
		}
	}


	for (int checker = 0; checker < pow (2,numbadtris); checker++)
	{
		for (int i = 0; i < numbadtris; i++)
		{
			int corn = (badtris[i]->good-10+1+((checker>>i)&1))%3;
			badtris[i]->corn = corn;
			int sx = badtris[i]->x[corn];
			int sy = badtris[i]->y[corn];
			for (int v=0;v<3;v++)
			{
				badtris[i]->x[v] -=sx;
				badtris[i]->y[v] -= sy;
			}
		 }
		 /*Now all of our tris must be moved*/

		 for (int t = 0; t <N; t++)
		 {
			double a1, a2;
			a1 = atan2 (tris[t].y[(tris[t].corn+1)%3], tris[t].x[(tris[t].corn+1)%3]);
			a2 = atan2 (tris[t].y[(tris[t].corn+2)%3], tris[t].x[(tris[t].corn+2)%3]);

			if (a1<0) a1+=2*M_PI;
			if (a2 <0) a2 += 2*M_PI;
			if (a2 > a1)
			{
				if (a2-a1 < M_PI)
				{
					tris[t].a_min = a2;
					tris[t].a_max = a1;
				}
				else
				{
					tris[t].a_min = a1;
					tris[t].a_max = a2;
				}
			}
			else
			{
				if (a1-a2 < M_PI)
				{
					tris[t].a_min = a1;
					tris[t].a_max = a2;
				}
				else
				{
					tris[t].a_min = a2;
					tris[t].a_max = a1;
				}
			}

		 }

		 qsort (tr_ps, N, sizeof(tri*), s_a_min);
		 int good = 1;
		 int s_x=0, s_y=0;
		 for (t = 0; t < N; t++)
		 {
			if (fabs(tr_ps[(t+1)%N]->a_min - tr_ps[t]->a_max)>0.00001)
			{
				good = 0;
				break;
			}
			if (tr_ps[t]->x[(tr_ps[t]->corn+1)%3] < s_x) s_x = tr_ps[t]->x[(tr_ps[t]->corn+1)%3];
			if (tr_ps[t]->y[(tr_ps[t]->corn+1)%3] < s_y) s_y = tr_ps[t]->y[(tr_ps[t]->corn+1)%3];
		 }

		 if (!good) continue;
		 if (good)
		 {
	       //		qsort (tris, N, sizeof(tri), s_num);
			for (int i = 0; i < N; i++)
			{
				for (int v=0;v<3;v++)
				{
					ofile << (tris[i].x[v]-s_x) << " ";
					ofile << (tris[i].y[v]-s_y) << " ";
				}
				ofile << "\n";
			}
			ofile.close();
			exit(0);
		 }
	}
	ofile << "NO";

	/*.main.*/
	return 0;
}







