{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}

program Glass;
type triangle=record
  x,y:array[1..3]of longint;
  k,t:integer;
end;
const MAXN=2000;
      eps=1e-7;
var n,HpSz:longint;
    tr:array[1..MAXN]of triangle;
    Ang:array[0..MAXN+1]of real;
    pos:array[0..MAXN+1]of integer;
    found:boolean;

procedure Swap(var a,b:real);
var t:real;
begin
  t:=a; a:=b; b:=t;
end;

procedure Exch(var a,b:integer);
var t:integer;
begin
  t:=a; a:=b; b:=t;
end;

procedure Heapify(var Ar:array of real;i:integer);
var l,r,largest:integer;
begin
  l:=2*i; r:=2*i+1;
  if (l<=HpSz)and(Ar[l]>Ar[i]) then largest:=l else largest:=i;
  if (r<=HpSz)and(Ar[r]>Ar[largest]) then largest:=r;
  if largest<>i then
  begin
    Swap(Ar[i],Ar[largest]);
    Exch(pos[i],pos[largest]);
    Heapify(Ar,largest);
  end;
end;

procedure HeapSort(var Ar:array of real);
var i:integer;
begin
  HpSz:=n;
  for i:=n div 2 downto 1 do Heapify(Ar,i);
  for i:=n downto 2 do
  begin
    Swap(Ar[1],Ar[i]);
    Exch(pos[1],pos[i]);
    dec(HpSz);
    Heapify(Ar,1);
  end;
end;

procedure inp;
var i:integer;
begin
  assign(input,'glass.in');
  assign(output,'glass.out');
  reset(input);
  rewrite(output);
  read(n);
  for i:=1 to n do read(tr[i].x[1],tr[i].y[1],tr[i].x[2],tr[i].y[2],tr[i].x[3],tr[i].y[3]);
end;

function PolarAngle(x,y:real):real;
var r:real;
begin
  if abs(x)<=eps then begin PolarAngle:=pi/2+pi*ord(y<0); end;
  r:=arctan(y/x)+pi;
  if x>0 then
    if y>0 then r:=r-pi else r:=r+pi;
  PolarAngle:=r;
end;

procedure run;
var i,j,k,l:longint;
    x1,y1,x2,y2:longint;
begin
  if n<4 then begin found:=false; exit; end;
  for i:=1 to n do
  begin
    found:=false;
    for j:=1 to 3 do
    begin
      for k:=1 to 3 do
      begin
        if k=j then continue;
        if (tr[i].x[j]=tr[i].x[k])or(tr[i].y[j]=tr[i].y[k]) then
        begin
          tr[i].k:=6-j-k; found:=true; break;
        end;
      end;
      if found then break;
    end;
    if not found then exit;
  end;
  for i:=1 to n do
  begin
    k:=tr[1].x[tr[1].k]-tr[i].x[tr[i].k];
    HpSz:=tr[1].y[tr[1].k]-tr[i].y[tr[i].k];
    for j:=1 to 3 do
    begin
      tr[i].x[j]:=tr[i].x[j]+k;
      tr[i].y[j]:=tr[i].y[j]+HpSz;
    end;
  end;
  for i:=1 to n do
  begin
    for j:=1 to 3 do
    begin
      if j=tr[i].k then continue;
      k:=6-j-tr[i].k;
      HpSz:=(tr[i].y[k]-tr[i].y[tr[i].k])*(tr[i].x[j]-tr[i].x[tr[i].k]);
      l:=(tr[i].x[k]-tr[i].x[tr[i].k])*(tr[i].y[j]-tr[i].y[tr[i].k]);
      if HpSz-l>0 then tr[i].t:=j;
    end;
  end;
  for i:=1 to n do
  begin pos[i]:=i; Ang[i]:=PolarAngle(tr[i].x[tr[i].t]-tr[1].x[tr[1].k],tr[i].y[tr[i].t]-tr[1].y[tr[1].k]) end;
  HeapSort(Ang);
  for i:=1 to n-1 do
  begin
    x1:=tr[pos[i]].x[6-tr[pos[i]].k-tr[pos[i]].t];
    y1:=tr[pos[i]].y[6-tr[pos[i]].k-tr[pos[i]].t];
    x2:=tr[pos[i+1]].x[tr[pos[i+1]].t];
    y2:=tr[pos[i+1]].y[tr[pos[i+1]].t];
    if (x1<>x2)or(y1<>y2) then begin found:=false; exit; end;
  end;
  x1:=tr[pos[n]].x[6-tr[pos[n]].k-tr[pos[n]].t];
  y1:=tr[pos[n]].y[6-tr[pos[n]].k-tr[pos[n]].t];
  x2:=tr[pos[1]].x[tr[pos[1]].t];
  y2:=tr[pos[1]].y[tr[pos[1]].t];
  if (x1<>x2)or(y1<>y2) then begin found:=false; exit; end;
  l:=0;
  for i:=1 to n-1 do
  begin
    x1:=tr[pos[i]].x[6-tr[pos[i]].k-tr[pos[i]].t]-tr[pos[i]].x[tr[pos[i]].t];
    y1:=tr[pos[i]].y[6-tr[pos[i]].k-tr[pos[i]].t]-tr[pos[i]].y[tr[pos[i]].t];
    x2:=tr[pos[i+1]].x[6-tr[pos[i+1]].k-tr[pos[i+1]].t]-tr[pos[i+1]].x[tr[pos[i+1]].t];
    y2:=tr[pos[i+1]].y[6-tr[pos[i+1]].k-tr[pos[i+1]].t]-tr[pos[i+1]].y[tr[pos[i+1]].t];
    if (x1*x2+y1*y2<>0)and(y2*x1-x2*y1<>0) then begin found:=false; exit; end;
    if (x1*x2+y1*y2=0)then inc(l);
  end;
  x1:=tr[pos[n]].x[6-tr[pos[n]].k-tr[pos[n]].t]-tr[pos[n]].x[tr[pos[n]].t];
  y1:=tr[pos[n]].y[6-tr[pos[n]].k-tr[pos[n]].t]-tr[pos[n]].y[tr[pos[n]].t];
  x2:=tr[pos[1]].x[6-tr[pos[1]].k-tr[pos[1]].t]-tr[pos[1]].x[tr[pos[1]].t];
  y2:=tr[pos[1]].y[6-tr[pos[1]].k-tr[pos[1]].t]-tr[pos[1]].y[tr[pos[1]].t];
  if (x1*x2+y1*y2<>0)and(y2*x1-x2*y1<>0) then begin found:=false; exit; end;
  if (x1*x2+y1*y2=0)then inc(l);
  if l<>4 then begin found:=false; exit; end;
  found:=true;
end;

procedure outp;
var i:integer;
begin
  if not found then write('NO')
  else
    for i:=1 to n do
    begin
      write(tr[i].x[1],' ',tr[i].y[1],' ',tr[i].x[2],' ',tr[i].y[2],' ',tr[i].x[3],' ',tr[i].y[3]);
      writeln;
    end;
  close(input);
  close(output);
end;

begin
  inp;
  run;
  outp;
end.