{$I-,Q-,R-,S-}
const
     FileIn='fishes.in';
     FileOut='fishes.out';
     MaxN=100000;
     MaxK=10000;
type
    TFishes=array [1..MaxN] of Byte;
var
   N, K: LongInt;
   Fishes: TFishes;

procedure ReadData;
var
   F: Text;
   NFish: LongInt;
begin
     Assign (F, FileIn);
     Reset (F);
     Readln (F, N, K);
     for NFish:=1 to N
         do Read (F, Fishes [NFish]);
     Close (F);
end;

procedure Solve;
var
   F: Text;
   GroupsCount: LongInt;

function GetGroupsCount (const aFishes: TFishes): LongInt;
var
   NFish: LongInt;
begin
     GroupsCount:=1;
     for NFish:=2 to N
         do if Fishes [NFish-1]<>Fishes [NFish]
               then Inc (GroupsCount);
     GetGroupsCount:=GroupsCount;
end;

function EOG (aFirstFish: LongInt): LongInt;
var
   NFish: LongInt;
begin
     NFish:=aFirstFish+1;
     while (NFish<=N) and (Fishes [NFish]=Fishes [NFish-1])
           do Inc (NFish);
     EOG:=NFish;
end;

procedure SwapGroups (var aFishes: TFishes; aFirstFish: LongInt);
var
   NFish: LongInt;

procedure InvertGroup;
var
   FirstWas: Byte;
begin
     FirstWas:=aFishes [NFish];
     while (NFish<=N) and (aFishes [NFish]=FirstWas)
           do begin
              aFishes [NFish]:=aFishes [NFish] xor 1;
              Inc (NFish);
           end;
end;

var
   NextFirst: LongInt;
begin
     NFish:=aFirstFish;
     NextFirst:=EOG (EOG (aFirstFish)+1)-EOG (aFirstFish)+aFirstFish;
     InvertGroup;
     NFish:=NextFirst;
     InvertGroup;
end;

function FirstOfPreLast (const aFishes: TFishes): LongInt;
var
   NFish: LongInt;

procedure SkipGroup;
begin
     while (NFish>1) and (Fishes [NFish-1]=Fishes [NFish])
           do Dec (NFish);
end;

begin
     NFish:=N;
     SkipGroup;
     Dec (NFish);
     SkipGroup;
     FirstOfPreLast:=NFish;
end;

procedure DoNextStep;
var
   Last: LongInt;
   NFish, NewNFish: LongInt;
   L: LongInt;
   Swaps: array [1..MaxK] of LongInt;
   NSwap: LongInt;
begin
     Last:=FirstOfPreLast (Fishes);
     L:=0;
     for NFish:=1 to Last
         do if (NFish=1) or (Fishes [NFish-1]<>Fishes [NFish])
               then begin
                    NewNFish:=EOG (EOG (NFish)+1)+1;
                    SwapGroups (Fishes, NFish);
                    Inc (L);
                    Swaps [L]:=NFish;
                    NFish:=NewNFish;
               end;
     Write (F, L);
     for NSwap:=1 to L
         do Write (F, #32, Swaps [NSwap]);
     Writeln (F);
end;

begin
     Assign (F, FileOut);
     Rewrite (F);
     while GetGroupsCount (Fishes)>2
           do DoNextStep;
     Writeln (F, 0);
     Close (F);
end;

procedure Main;
begin
     ReadData;
     Solve;
end;

begin
     Main;
end.
