{$I-,Q-,R-,S-}
const
     FileIn='glass.in';
     FileOut='glass.out';
     MaxN=2000;
     MaxNodes=MaxN*3;
type
    TTriangle=record
                    X1, Y1, X2, Y2, X3, Y3: LongInt;
                    First, Second: Boolean;
              end;
    TTriangles=array [1..MaxN] of TTriangle;
    TNode=record
                X, Y, Count: LongInt;
          end;
var
   N: LongInt;
   Tr: TTriangles;
   Nodes: array [1..MaxNodes] of TNode;
   NodesCount: LongInt;
   PutNo: Boolean;

procedure Swap (var aA, aB: LongInt);
var
   T: LongInt;
begin
     T:=aA;
     aA:=aB;
     aB:=T;
end;

function Min (aA, aB: LongInt): LongInt;
begin
     if aA<aB
        then Min:=aA
        else Min:=aB;
end;

procedure ReadData;
var
   F: Text;
   NItem: LongInt;
   X1, Y1, X2, Y2, X3, Y3: LongInt;
begin
     Assign (F, FileIn);
     Reset (F);
     Readln (F, N);
     for NItem:=1 to N
         do begin
            Readln (F, X1, Y1, X2, Y2, X3, Y3);
            if (X1=X3) or (Y1=Y3)
               then begin
                    Swap (X2, X3);
                    Swap (Y2, Y3);
                    Tr [NItem].First:=true;
               end
               else Tr [NItem].First:=false;
            if (X2=X3) or (Y2=Y3)
               then begin
                    Swap (X1, X3);
                    Swap (Y1, Y3);
                    Tr [NItem].Second:=true;
               end
               else Tr [NItem].Second:=false;
            Tr [NItem].X1:=X1;
            Tr [NItem].Y1:=Y1;
            Tr [NItem].X2:=X2;
            Tr [NItem].Y2:=Y2;
            Tr [NItem].X3:=X3;
            Tr [NItem].Y3:=Y3;
         end;
     Close (F);
end;

procedure WriteData;
var
   F: Text;
   NItem: LongInt;
begin
     Assign (F, FileOut);
     Rewrite (F);
     case PutNo of
          false: for NItem:=1 to N
                     do with Tr [NItem]
                        do begin
                           if Second
                              then begin
                                   Swap (X1, X3);
                                   Swap (Y1, Y3);
                              end;
                           if First
                              then begin
                                   Swap (X2, X3);
                                   Swap (Y2, Y3);
                              end;
                           Writeln (F, X1, #32, Y1, #32, X2, #32, Y2, #32, X3, #32, Y3);
                        end;
          true: Writeln (F, 'NO');
     end;
     Close (F);
end;

procedure Shift3ToZero;
var
   NItem: LongInt;
begin
     for NItem:=1 to N
         do with Tr [NItem]
                 do begin
                    X1:=X1-X3;
                    Y1:=Y1-Y3;
                    X2:=X2-X3;
                    Y2:=Y2-Y3;
                    X3:=0;
                    Y3:=0;
                 end;
end;

procedure Normalize;
var
   NItem: LongInt;
   MinX, MinY: LongInt;
begin
     MinX:=MaxLongInt;
     MinY:=MaxLongInt;
     for NItem:=1 to N
         do with Tr [NItem]
                 do begin
                    MinX:=Min (Min (MinX, X1), Min (X2, X3));
                    MinY:=Min (Min (MinY, Y1), Min (Y2, Y3));
                 end;
     for NItem:=1 to N
         do with Tr [NItem]
                 do begin
                    Dec (X1, MinX);
                    Dec (Y1, MinY);
                    Dec (X2, MinX);
                    Dec (Y2, MinY);
                    Dec (X3, MinX);
                    Dec (Y3, MinY);
                 end;
end;

function CheckNodes: Boolean;

procedure CheckPoint (aX, aY: LongInt);
var
   NPoint: LongInt;
begin
     for NPoint:=1 to NodesCount
         do if (Nodes [NPoint].X=aX) and (Nodes [NPoint].Y=aY)
               then begin
                    Inc (Nodes [NPoint].Count);
                    Exit;
               end;
     Inc (NodesCount);
     Nodes [NodesCount].X:=aX;
     Nodes [NodesCount].Y:=aY;
     Nodes [NodesCount].Count:=1;
end;

var
   NItem: LongInt;
begin
     NodesCount:=0;
     for NItem:=1 to N
         do with Tr [NItem]
                 do begin
                    CheckPoint (X1, Y1);
                    CheckPoint (X2, Y2);
                 end;
     for NItem:=1 to NodesCount
         do if Nodes [NItem].Count<>2
               then begin
                    CheckNodes:=false;
                    Exit;
               end;
     CheckNodes:=true;
end;

procedure Solve;
begin
     Shift3ToZero;
     Normalize;
     CheckNodes;
     PutNo:=not CheckNodes;
end;

procedure Main;
begin
     ReadData;
     Solve;
     WriteData;
end;

begin
     Main;
end.
