{Define TL}
const
     FileIn='chain.in';
     FileOut='chain.out';
     MaxN=1000;
     TimeLimit=1.8;
     MaxDepth=MaxN*4;
var
   Losung: string;
   N: LongInt;
   Words: array [1..MaxN] of string [10];
   Impossible: Boolean;
   {$IfDef TL}
   Timer: LongInt absolute $0:$46c;
   StartTimer: LongInt;
   {$EndIf}
   PrevResult: array [1..MaxN] of LongInt;
   ResultRepeated: array [1..MaxN] of Boolean;
   Order, BestOrder: array [1..MaxDepth] of LongInt;
   BestDepth: LongInt;
   BestLength: LongInt;

procedure ReadData;
var
   F: Text;
   NWord: LongInt;
begin
     Assign (F, FileIn);
     Reset (F);
     Readln (F, Losung);
     Readln (F, N);
     for NWord:=1 to N
         do Readln (F, Words [NWord]);
     Close (F);
end;

procedure WriteData;
var
   F: Text;
   NItem: LongInt;
begin
     Assign (F, FIleOut);
     Rewrite (F);
     if Impossible
        then Writeln (F, '?')
        else for NItem:=1 to BestDepth
                 do Writeln (F, Words [BestOrder [NItem]]);
     Close (F);
end;

{$IfDef TL}
function HaveTimeLimit: Boolean;
begin
     HaveTimeLimit:=(Timer-StartTimer)/18.2>TimeLimit;
end;
{$EndIf}

function QuickImpossible: Boolean;
var
   AvailChars: set of Char;
   NWord: LongInt;
   NChar: Byte;
begin
     AvailChars:=[];
     for NWord:=1 to N
         do for NChar:=1 to Length (Words [NWord])
                do AvailChars:=AvailChars+[Words [NWord] [NChar]];
     for NChar:=1 to Length (Losung)
         do if not (Losung [NChar] in AvailChars)
               then begin
                    QuickImpossible:=true;
                    Exit;
               end;
     QuickImpossible:=false;
end;

function LosungDecreasing (aNWord: LongInt; aCompletedLen: LongInt): LongInt;
var
   NCharWord, NCharLos: LongInt;
begin
     NCharLos:=aCompletedLen+1;
     for NCharWord:=1 to Length (Words [aNWord])
         do if Words [aNWord] [NCharWord]=Losung [NCharLos]
               then begin
                    Inc (NCharLos);
                    if NCharLos>Length (Losung)
                       then Break;
               end;
     LosungDecreasing:=NCharLos-aCompletedLen-1;
end;

function Rec (aLastCh: Char; aCompletedLen: LongInt; aDepth: LongInt; aLength: LongInt): Boolean;
var
   NWord: LongInt;
   Decreasing: LongInt;
begin
     for NWord:=1 to N
         do if aLastCh=Words [NWord] [1]
               then begin
                    {$IfDef TL}
                    if HaveTimeLimit
                       then Break;
                    {$EndIf}
                    Order [aDepth]:=NWord;
                    Decreasing:=LosungDecreasing (NWord, aCompletedLen);
                    if Decreasing+aCompletedLen=Length (Losung)
                       then begin
                            Rec:=true;
                            if aLength+Length (Words [NWord])-1<BestLength
                               then begin
                                    Move (Order, BestOrder, SizeOf (BestOrder));
                                    BestDepth:=aDepth;
                                    BestLength:=aLength+Length (Words [NWord])-1;
                               end;
                            Exit;
                       end
                       else if (PrevResult [NWord]<=Decreasing+aCompletedLen)
                               then begin
                                    if (PrevResult [NWord]=Decreasing+aCompletedLen)
                                       then case ResultRepeated [NWord] of
                                                 false: ResultRepeated [NWord]:=true;
                                                 true: Continue;
                                       end
                                       else ResultRepeated [NWord]:=false;
                                    PrevResult [NWord]:=Decreasing+aCompletedLen;
                                    if Rec (Words [NWord] [Length (Words [NWord])],
                                            aCompletedLen+Decreasing, aDepth+1, aLength+Length (Words [NWord])-1)
                                       then begin
                                            Rec:=true;
                                            Exit;
                                       end;
                               end;
               end;
     Rec:=false;
end;

procedure Solve;
var
   NWord: LongInt;
   Decreasing: LongInt;
begin
     Impossible:=QuickImpossible;
     if not Impossible
        then begin
             BestLength:=MaxLongInt;
             Impossible:=true;
             FillChar (PrevResult, SizeOf (PrevResult), 0);
             FillChar (ResultRepeated, SizeOf (ResultRepeated), false);
             for NWord:=1 to N
                 do begin
                    Decreasing:=LosungDecreasing (NWord, 0);
                    Order [1]:=NWord;
                    if Decreasing=Length (Losung)
                       then begin
                            Impossible:=false;
                            Exit;
                       end
                       else if Rec (Words [NWord] [Length (Words [NWord])], Decreasing, 2, Length (Words [NWord]))
                               then Impossible:=false;
                 end;
        end;
end;

procedure Main;
begin
     {$IfDef TL}
     StartTimer:=Timer;
     {$EndIf}
     ReadData;
     Solve;
     WriteData;
end;

begin
     Main;
end.
