#include <stdio.h>
#include <stdlib.h>

typedef struct {
  long int x, y;
} point;

typedef struct {
  point A, B, C;
} treug;

int **matrix;
int n;
treug *mass;
int vis[1000];
int flag = 0;

int height(int num, int from, int step) {
  int last[1000];
  int i, j;
  int cur;
  int res = 0;
  int nn = 0;

  if (vis[num] == 1) {
    if (flag == 1) {
      return -1;
    } else {
      flag = 1;
    }
  }

  vis[num]++;

  for (i = 0; i < n; i++) {
    if ((matrix[num][i] > 0) && (i != num)) {
      if ((matrix[num][i]/10 == from) || (from == 0)) {
	for (j = 0; j < n; j++) {
	  last[j] = vis[j];
	}
	cur = height(i, matrix[num][i]%10, step+1);
	nn = 1;
	if (cur == -1) return -1;
	if (cur > res) {
	  res = cur;
	}
	for (j = 0; j < n; j++) {
	  vis[j] = last[j];
	}
      }
    }
  }

  if (nn == 0) return step;

  return res;
}


int sq(point A, point B, point C) {
  int res = abs(A.x*B.y - B.x*A.y +
	     B.x*C.y - C.x*B.y +
	     C.x*A.y - A.x*C.y);

  return res;
}

int inT(treug ABC, point o) {
  if (sq(ABC.A, ABC.B, ABC.C) == sq(ABC.A, ABC.B, o) +
				   sq(ABC.A, ABC.C, o) +
				   sq(ABC.C, ABC.B, o)) {
				     return 1;
				   } else {
				     return 0;
				   }

}

int pere(point A, point B, point C, point D) {
  long int x1, x2, x3, x4, y1, y2, y3, y4;
  float a1, a2, b1, b2, c1, c2;
//  float hlp;
  float xA, yA;

  x1 = A.x;
  x2 = B.x;
  x3 = C.x;
  x4 = D.x;

  y1 = A.y;
  y2 = B.y;
  y3 = C.y;
  y4 = D.y;

  a1 = y2 - y1;
  b1 = x1 - x2;
  c1 = x1*y2 - x2*y1;

  a2 = y4 - y3;
  b2 = x3 - x4;
  c2 = x3*y4 - x4*y3;

/*  hlp = sqrt(a1*a1+b1*b1);

  a1/=hlp;
  b1/=hlp;
  c1/=hlp;*/

  if (a1*b2 - b1*a2 == 0) return 0;

  xA = ((c1*b2-b1*c2)*1.0) / (1.0*a1*b2-b1*a2);
  yA = ((c2*a1-c1*a2)*1.0) / (1.0*a1*b2-b1*a2);

  if ((((xA-x1)*(xA-x2) <= 0.00001) && ((yA-y1)*(yA-y2) <= 0.00001)) &&
     (((xA-x3)*(xA-x4) <= 0.00001) && ((yA-y3)*(yA-y4) <= 0.00001))) {
    return 1;
  }

  return 0;
}

int main() {
  int i, j;
  int res = 0;
  int cur = 0;
  FILE *in, *out;

  in = fopen("travel.in", "r");
  out = fopen("travel.out", "w");

  fscanf(in, "%d", &n);

  matrix = (int**) malloc (n * sizeof(int*));
  for (i = 0; i < n; i++) {
    matrix[i] = (int*) malloc (n * sizeof(int));
  }
  mass = (treug*) malloc (n * sizeof(treug));

  for (i = 0; i < n; i++) {
    fscanf(in, "%ld %ld %ld %ld %ld %ld", &mass[i].A.x, &mass[i].A.y, &mass[i].B.x, &mass[i].B.y, &mass[i].C.x, &mass[i].C.y);
  }

  for (i = 0; i < n; i++) {
    for (j = 0; j < n; j++) {
      matrix[i][j] = 0;
    }
  }

  for (i = 0; i < n; i++) {
    for (j = 0; j < n; j++) {
	matrix[i][j] = 0;

	if (inT(mass[i], mass[j].A) == 1) {
	  if ((pere(mass[i].B, mass[i].C, mass[j].A, mass[j].B) == 1) &&
	      (pere(mass[i].B, mass[i].C, mass[j].A, mass[j].C) == 1)) {
		matrix[i][j] = 11;
	      } else {
		  if ((pere(mass[i].A, mass[i].B, mass[j].A, mass[j].B) == 1) &&
		      (pere(mass[i].A, mass[i].B, mass[j].A, mass[j].C) == 1)) {
			matrix[i][j] = 31;
		      } else {
			  if ((pere(mass[i].A, mass[i].C, mass[j].A, mass[j].B) == 1) &&
			      (pere(mass[i].A, mass[i].C, mass[j].A, mass[j].C) == 1)) {
				matrix[i][j] = 21;
			      }
		      }
	      }
	} else {

	if (inT(mass[i], mass[j].B) == 1) {
	  if ((pere(mass[i].B, mass[i].C, mass[j].B, mass[j].A) == 1) &&
	      (pere(mass[i].B, mass[i].C, mass[j].B, mass[j].C) == 1)) {
		matrix[i][j] = 12;
	      } else {
		  if ((pere(mass[i].A, mass[i].B, mass[j].B, mass[j].A) == 1) &&
		      (pere(mass[i].A, mass[i].B, mass[j].B, mass[j].C) == 1)) {
			matrix[i][j] = 32;
		      } else {
			  if ((pere(mass[i].A, mass[i].C, mass[j].B, mass[j].A) == 1) &&
			      (pere(mass[i].A, mass[i].C, mass[j].B, mass[j].C) == 1)) {
				matrix[i][j] = 22;
			      }
		      }
	      }


	} else {

	if (inT(mass[i], mass[j].C) == 1) {
	  if ((pere(mass[i].B, mass[i].C, mass[j].C, mass[j].B) == 1) &&
	      (pere(mass[i].B, mass[i].C, mass[j].C, mass[j].A) == 1)) {
		matrix[i][j] = 13;
	      } else {
		  if ((pere(mass[i].A, mass[i].B, mass[j].C, mass[j].B) == 1) &&
		      (pere(mass[i].A, mass[i].B, mass[j].C, mass[j].A) == 1)) {
			matrix[i][j] = 33;
		      } else {
			  if ((pere(mass[i].A, mass[i].C, mass[j].C, mass[j].B) == 1) &&
			      (pere(mass[i].A, mass[i].C, mass[j].C, mass[j].A) == 1)) {
				matrix[i][j] = 23;
			      }
		      }
	      }


	}
	}
	}

    }
  }

  for (i = 0; i < n; i++) {
    for (j = 0; j < n; j++) vis[j] = 0;
    cur = height(i, 0, 0);
//    printf("%d: %d\n", i, cur);
    if (cur == -1) {
      res = -1;
      break;
    }
    if (cur > res) {
      res = cur;
    }
  }

  fprintf(out, "%d\n", res);

  fclose(in);
  fclose(out);
  return 0;
}