/***
 * PROGRAMMER: Ryablkin Michael;
 ***/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <ctype.h>

#define F_EQ(x, y) (fabs((x) - (y)) < 0.00001)

typedef void VOID;
typedef int INT;
typedef unsigned int UINT;
typedef long LONG;
typedef unsigned long ULONG;
typedef double DBL;
typedef char CHAR;
typedef char BYTE;
typedef int BOOL;

FILE *In, *Out;

/* The main function */
INT main( VOID )
{
  LONG N, K, L, Q, QHL, QHR, QL, S, i, F;
  DBL Ost;

  In = fopen("squares.in", "rt");
  if (In == NULL)
    return -1;
  Out = fopen("squares.out", "wt");
  if (Out == NULL)
  {
    fclose(In);
    return -1;
  }

  fscanf(In, "%ld%ld", &N, &K);

  L = (LONG)sqrt(K);
  Q = K - L * L;

  if (Q == 0)
  {
    S = 4 + 4 * L;
    F = N - S;
    if (N < S || F % 2)
    {
      fprintf(Out, "NO");
      fclose(In);
      fclose(Out);
      return 0;
    }
    /* Printing path */
    fprintf(Out, "YES\n0 0\n");
    for (i = 0; i <= L; i++)
      fprintf(Out, "0 %ld\n", i + 1);
    for (i = 0; i <= L; i++)
      fprintf(Out, "%ld %ld\n", i + 1, L + 1);
    for (i = L; i >= 0; i--)
      fprintf(Out, "%ld %ld\n", L + 1, i + 1);
    for (i = L; i >= 0; i--)
      fprintf(Out, "%ld %ld\n", i + 1, (LONG)0);
  }
  else
  {
    Ost = (DBL)Q / L;
    if (F_EQ(Q / L, Ost))
    {
      QHL = Q / L;
      QHR = Q / L;
      QL = L;
      S = 4 + 4 * L + QHL + QHL;
    }
    else
    {
      QHR = Q / L;
      QHL = Q / L + 1;
      QL = QHL * L - Q;
      S = 5 + 4 * L + QHR + QHL;
    }

    F = N - S;
    if (N < S || F % 2)
    {
      fprintf(Out, "NO");
      fclose(In);
      fclose(Out);
      return 0;
    }
    if (QHL != QHR)
    {
      /* Printing path */
      fprintf(Out, "YES\n0 0\n");

      for (i = 0; i <= L + QHL; i++)
	fprintf(Out, "0 %ld\n", i + 1);
      for (i = 0; i <= L; i++)
	fprintf(Out, "%ld %ld\n", i + 1, L + QHL + 1);
      for (i = L + QHL - 1; i >= QHL - QHR; i--)
	fprintf(Out, "%ld %ld\n", L + 1, i + 1);
      for (i = L + 1; i > QL; i--)
	fprintf(Out, "%ld %ld\n", i, QHL - QHR);
      /*
      for (i = QHL - QHR; i > 0; i--)
	fprintf(Out, "%ld %ld\n", QL + 1, i);
      */
      for (i = QL; i >= 0; i--)
	fprintf(Out, "%ld %ld\n", i + 1, (LONG)0);
    }
    else
    {
      /* Printing path */
      fprintf(Out, "YES\n0 0\n");
      for (i = 0; i <= L + QHL; i++)
	fprintf(Out, "0 %ld\n", i + 1);
      for (i = 0; i <= L; i++)
	fprintf(Out, "%ld %ld\n", i + 1, L + QHL + 1);
      for (i = L + QHL - 1; i >= 0; i--)
	fprintf(Out, "%ld %ld\n", L + 1, i + 1);
      for (i = L; i >= 0; i--)
	fprintf(Out, "%ld %ld\n", i + 1, (LONG)0);
    }
  }
  F = F / 2;
  for (i = 0; i < F; i++)
    fprintf(Out, "%ld %ld\n", (LONG)1, -i - 1);
  for (i = F - 1; i >= 0; i--)
    fprintf(Out, "%ld %ld\n", (LONG)0, -i - 1);

  fclose(In);
  fclose(Out);
  return 0;
} /* End of 'main' function */
