{$N+,Q+,R+}

(*

Contest: X St. Petersburg - V Kirov shcool olympiad
Problem C: chimney-sweep
Solution`s author: Cherepanov E.

*)
const
  maxn = 15000;
type
 int = longint;
var
  n:int;
  hh:array[0..maxn]of longint;
  lsize,rsize:int;
  best:comp;
  rowtype, lr, rr, lt, rt:int;




procedure qsort(l,r: integer);
var
  i,j,x,y: int;
begin
  while l<r do
    begin
      i:=l;
      j:=r;
      x:=hh[(l+r) DIV 2];
      repeat
        while hh[i]<x do i:=i+1;
        while x<hh[j] do j:=j-1;
        if i<=j then
        begin
          y    :=hh[i];
          hh[i]:=hh[j];
          hh[j]:=y;
          i:=i+1;
          j:=j-1;
        end;
      until i>j;
      if (j-l > r-i) then
        begin
           qsort(i,r);
           r:=j;
        end else
        begin
           qsort(l,j);
           l:=i;
        end
    end;
end;

function min(a,b:int):int;
begin
 if a < b then min:=a else min:=b;
end;


function max(a,b:int):int;
begin
 if a < b then max:=b else max:=a;
end;


function delta(i1,i2:integer):comp;
begin
  delta := hh[max(i1,i2)]-hh[min(i1,i2)]+ min(abs(hh[0]-hh[i1]), abs(hh[0]-hh[i2]));
end;


procedure save(rtype:int; l,r:int);
var
  c1,c2:comp;
  i1, i2:int;
begin
  if l>2 then i1:=2 else i1 := r+1;
  if r<n then i2:=n else i2 := l-1;
  c1 := delta(l,r);
  c2 := delta(i1,i2);
  if best <= c1+c2 then exit;
  best := c1+c2;
  rowtype := rtype;
  lr := l;
  rr := r;
  if rtype = 0 then  { row on left size}
    begin
      lt := 1;
      if abs(hh[l]-hh[0]) < abs (hh[r]-hh[0]) then lt :=0;
      rt := 0;
      if abs(hh[i1]-hh[0]) < abs (hh[i2]-hh[0]) then rt :=1;
    end else
    begin
      lt := 1;
      if abs(hh[i1]-hh[0]) < abs (hh[i2]-hh[0]) then lt :=0;
      rt := 0;
      if abs(hh[l]-hh[0]) < abs (hh[r]-hh[0]) then rt :=1;
    end;


end;

procedure solve;
var
 i:integer;
begin
  qsort(2,n);
  best:=1e10;
  if (lsize=0) then
    begin
      best := delta(2,n);
      if n=1 then best :=0;
      rowtype := 1;
      rt := 0;
      if abs(hh[0]-hh[2]) < abs(hh[0]-hh[n]) then rt :=1;
      lr :=2;
      rr :=n;
      exit;
    end;

  if (rsize=0) then
    begin
      best := delta(2,n);
      rowtype := 0;
      lt := 1;
      if abs(hh[0]-hh[2]) < abs(hh[0]-hh[n]) then lt :=0;
      lr :=2;
      rr :=n;
      exit;
    end;

  for i:=2 to n-lsize do
    save(0,i,i+lsize-1);
  for i:=2 to n-rsize do
    save(1,i,i+rsize-1);
end;

procedure ReadData;
var
 i,k:int;
begin
  assign(input,'e.in');
  reset(input);
  read(n);
  for i:=1 to n do
    read(hh[i]);
  read(k);
  lsize := k-1;
  rsize := n-k;
  hh[0]:=hh[k];
  hh[k]:=hh[1];
  close(input);
end;

procedure WriteData;
var
 i:integer;
begin
  assign(output,'e.out');
  rewrite(output);
  if rowtype = 0 then {left case}
    begin
     if lt = 1 then
       for i:=lr to rr do write(hh[i], ' ')
     else
       for i:=rr downto lr do write(hh[i], ' ');
     write(hh[0],' ');
     if rt = 1 then
      begin
       for i:=2 to n do if (i < lr) or (i > rr) then write(hh[i], ' ')
      end
     else
       for i:=n downto 2 do if (i < lr) or (i > rr) then write(hh[i], ' ');
     writeln;
    end else
    begin   { right case }
     if lt = 1 then
      begin
       for i:=2 to n do if (i < lr) or (i > rr) then write(hh[i], ' ')
      end
     else
       for i:=n downto 2 do if (i < lr) or (i > rr) then write(hh[i], ' ');
     write(hh[0],' ');
     if rt = 1 then
       for i:=lr to rr do write(hh[i], ' ')
     else
       for i:=rr downto lr do write(hh[i], ' ');
     writeln;
    end;
  close(output);
end;


begin
  ReadData;
  Solve;
  WriteData;
end.