{$apptype CONSOLE}
{$R+}

const
	inFile = 'roads.in';
	outFile = 'roads.out';

	maxN = 50;
	maxM = maxN * maxN div 2;
	inf = maxint div 2;

type
	TEdge = record
		u, v, w : integer;
	end;

var
	n, m : integer;
	e : array[1..maxM] of TEdge;
	st : array[1..maxN,1..maxN] of integer;
	w : array[1..maxN,1..maxM] of integer;
	pxy : array[1..maxN] of integer;
	pyx : array[1..maxM] of integer;
    d : array[-1..maxN + maxM] of integer;

	nx, ny : integer;


procedure ReadData;
var
	i : integer;

begin
	assign(input, inFile);
	reset(input);

	fillchar(st, sizeof(st), 0);

	read(n, m);
	for i := 1 to m do begin
		read(e[i].u, e[i].v, e[i].w);
		st[e[i].u, e[i].v] := i;
		st[e[i].v, e[i].u] := i;
	end;	

	close(input);
end;

procedure WriteData;
var
    i : integer;
begin
	assign(output, outFile);
	rewrite(output);
	writeln(n, ' ', m);
    for i := 1 to m do
    	writeln(e[i].u, ' ', e[i].v, ' ', e[i].w + d[i]);
	close(output);
end;

procedure BuildGraph;
var
	i : integer;
	used : array[1..maxN] of boolean;
	stack : array[1..maxN] of integer;
	sp : integer;

	procedure DFS(ei, i, tg : integer);
	var
		j : integer;

	begin
		used[i] := true;
		if i = tg then begin
			for j := 1 to sp do
				if e[stack[j]].w > e[ei].w then
					w[stack[j], ei - nx] := e[ei].w - e[stack[j]].w;
			exit;
		end;

		for j := 1 to n do
			if not used[j] and (st[i,j] > 0) and (st[i,j] <= nx) then begin
				inc(sp);
				stack[sp] := st[i,j];
				DFS(ei, j, tg);
				dec(sp);
			end;
	end;

var j : integer;

begin
	nx := n - 1;
	ny := m - n + 1;

	fillchar(w, sizeof(w), 0);

	for i := 1 to ny do begin
		fillchar(used, sizeof(used), false);
		sp := 0;
		DFS(i + nx, e[i + n - 1].u, e[i + n - 1].v);
	end;

	{
	for i := 1 to nx do begin
		for j := 1 to ny do write(w[i,j]:6);
		writeln;
	end;
	}
end;

procedure Solve;
var
	i, j : integer;

begin
	BuildGraph;

	fillchar(d, sizeof(d), 0);
	for i := 1 to nx do
	begin
		d[i] := 0;
		for j := 1 to ny do
			if w[i][j] < d[i] then
				d[i] := w[i][j];
	end;
end;

begin
	ReadData;
	Solve;
	WriteData;
end.
