{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O-,P+,Q+,R+,S+,T-,U-,V+,W-,X+,Y+,Z1}
{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $00100000}
{$IMAGEBASE $00400000}
{$APPTYPE CONSOLE}

{

  Sample solution for the task "Fence painting"
  Copyright(c) by Michael Mirzayanov

  Last revision date : 23.06.2003

}

program Shablon;

  const
    inFile = 'paint.in';
    outFile = 'paint.out';
    nmax = 300;

  type
    int = longint;

  var
    n : int;
    ans : int;

    s : string;
    lf, rg : array [1..nmax] of int;
    log : array [1..nmax, 1..nmax] of int;
    col : array [1..nmax] of char;

  function Rec(lo, hi : int) : int;
    var
      mid : int;
  begin
    if lo > hi then begin
      Result := 0;
      exit;
    end;
    if log[lo, hi] > 0 then begin
      Result := log[lo, hi];
      exit;
    end;
    if lo = hi then begin
      Result := 1;
    end else begin
      if s[lo] = s[hi] then begin
        Result := Rec(lo + 1, hi);
        if Result > Rec(lo, hi - 1) then Result := Rec(lo, hi - 1); 
      end
      else
        Result := hi - lo + 1;
      for mid := lo to hi - 1 do
        if Rec(lo, mid) + Rec(mid + 1, hi) < Result then
          Result := Rec(lo, mid) + Rec(mid + 1, hi);
      log[lo, hi] := Result;      
    end;
  end;

  function WriteRec(lo, hi : int; dir : int) : int;
    var
      mid : int;
      pans : int;
  begin
    if lo > hi then begin
      Result := 0;
      exit;
    end;
    if lo = hi then begin
      inc(ans);
      lf[ans] := lo;
      rg[ans] := hi;
      col[ans] := s[lo];
    end else begin
      if s[lo] = s[hi] then begin
        if Rec(lo + 1, hi) < Rec(lo, hi - 1) then begin
          pans := ans + 1;
          WriteRec(lo + 1, hi, 2);
          lf[pans] := lo;
        end else begin
          pans := ans + 1;
          WriteRec(lo, hi - 1, 1);
          rg[pans] := hi;
        end;
      end
      else begin
        Result := Rec(lo, hi);
        for mid := lo to hi - 1 do
          if Rec(lo, mid) + Rec(mid + 1, hi) = Result then begin
            if dir = 1 then begin
              WriteRec(lo, mid, 1);
              WriteRec(mid + 1, hi, 2);
            end else begin
              WriteRec(mid + 1, hi, 2);
              WriteRec(lo, mid, 1);
            end;
            break;
          end;
      end;
    end;
  end;
  
  procedure OutData;
    var
      i, j : int;
  begin
    assign(output,outFile);
    rewrite(output);

    writeln(ans);
    ans := 0;

    WriteRec(1, length(s), 1);

    for i := 1 to ans do
      writeln(lf[i], ' ', rg[i], ' ', col[i]);

    close(output);
  end;

  procedure Solve;
    var
      i, j : int;
  begin
    fillchar(log, SizeOf(log), 0);
    ans := Rec(1, length(s));
  end;

  procedure ReadData;
    var
      i, j : int;
  begin
    assign(input,inFile);
    reset(input);

    readln(n);
    readln(s);

    close(input);
  end;

begin
  ReadData;
  Solve;
  OutData;
end.
