{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O-,P+,Q+,R+,S+,T-,U-,V+,W-,X+,Y+,Z1}
{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $00100000}
{$IMAGEBASE $00400000}
{$APPTYPE CONSOLE}

{

  Sample solution for the task "... flow"
  Copyright(c) by Michael Mirzayanov

  Last revision date : 24.06.2003

}

program iterations;

  uses
    sysutils;

  const
    inFile = 'flow.in';
    outFile = 'flow.out';
    nmax = 100;

    eps = 1E-9;

    MAX = 30000000;

  type
    int = longint;
    real = extended;
    TList = ^TNode;
    TNode = record
              a, b : int;
              inf : int;
              w : int;
              next : TList;
            end;

  var
    n : int;
    ans : real;
    m : int;
    gr : array [1..nmax] of TList;
    koef : real;
    r, rr : array [1..nmax] of real;

  function find_answer : real;
    var
      used : array [1..nmax] of real;
    procedure rec(ind : int; sum : real);
      var
        x : TList;
    begin
      if used[ind] > -0.5 then exit;
      used[ind] := sum;
      x := gr[ind];
      while x <> nil do begin
        rec(x^.inf, sum + r[x^.inf] - r[ind]);
        x := x^.next;
      end;
    end;
    var
      i : int;
  begin
    for i := 1 to n do used[i] := -1;
    rec(1, 0);
    if used[n] > -0.5 then result := used[n] else result := 0;
  end;

  procedure OutData;
    var
      i, j : int;
      aa, bb : int;
      w : int;
      x : TList;
  begin
    assign(output,outFile);
    rewrite(output);

    if { abs(find_answer) < eps } false then begin
      writeln(0.0 : 0 : 10);
    end else begin
      x := gr[1];
      ans := 0;
      while x <> nil do begin
        ans := ans + (r[x^.inf] - r[1]) * koef;
        x := x^.next;
      end;
      writeln(ans : 0 : 10);
      if abs(ans) < eps * 100 then koef := 0;  
    end;

    assign(input,inFile);
    reset(input);

    read(n);
    read(m);

    for i := 1 to m do begin
      read(aa, bb, w);
      writeln((r[bb] - r[aa]) * koef : 0 : 10);
    end;

    close(input);
    close(output);
  end;

  procedure Solve;
    var
      i, j : int;
      min : real;
      x : TList;
      d : real;
      it : int;
      sum : real;
      deg : int;
  begin
    if m > 100 then
      it := MAX div (m * 2)
    else
      it := MAX div (m * 200);

    for i := 2  to n - 1 do
      r[i] := 0.5;
    r[1] := 0;
    r[n] := 1;

    for i := 1 to it do begin
      for j := 2 to n - 1 do begin
        sum := 0;
        x := gr[j];
        deg := 0;
        while x <> nil do begin
          sum := sum + r[x^.inf];
          x := x^.next;
          inc(deg);
        end;
        if deg > 0 then
          rr[j] := sum / deg
        else
          rr[j] := r[j];
      end;
      r := rr;
      r[1] := 0;
      r[n] := 1;
    end;

    min := 1E20;
    for i := 1 to n do begin
      x := gr[i];
      while x <> nil do begin
        d := r[x^.a] - r[x^.b];
        if abs(d) > eps then
          if min > abs(x^.w / d) then begin
            min := abs(x^.w / d);
          end;
        x := x^.next;
      end;
    end;
    koef := min;
  end;

  procedure ReadData;
    var
      i, j : int;
      a, b : int;
      w : int;
      x : TList;
  begin
    assign(input,inFile);
    reset(input);

    read(n);
    read(m);

    for i := 1 to n do gr[i] := nil;

    for i := 1 to m do begin
      read(a, b, w);

//      if a = b then runerror;

      new(x);
      x^.a := a;
      x^.b := b;
      x^.w := w;
      x^.inf := b;
      x^.next := gr[a];
      gr[a] := x;

      new(x);
      x^.a := a;
      x^.b := b;
      x^.w := w;
      x^.inf := a;
      x^.next := gr[b];
      gr[b] := x;
    end;

    close(input);
  end;

begin
  ReadData;
  Solve;
  OutData;
end.
