const
    max_n = 20000;

type ttown = record
    x, y, i, nx, ny, c: longint;
end;

var
    t: array [1..max_n] of ttown;

procedure qsort1(l, r: longint);
var
    i, j, x: longint;
    z: ttown;
begin
    i := l;
    j := r;
    x := t[l + random(r - l)].x;
    while (i <= j) do begin
        while (x > t[i].x) do inc(i);
        while (x < t[j].x) do dec(j);
        if (i <= j) then begin
            z := t[i];
            t[i] := t[j];
            t[j] := z;
            inc(i);
            dec(j);
        end;
    end;
    if (l < j) then qsort1(l, j);
    if (r > i) then qsort1(i, r);
end;

procedure qsort2(l, r: longint);
var
    i, j, x: longint;
    z: ttown;
begin
    i := l;
    j := r;
    x := t[l + random(r - l)].y;
    while (i <= j) do begin
        while (x > t[i].y) do inc(i);
        while (x < t[j].y) do dec(j);
        if (i <= j) then begin
            z := t[i];
            t[i] := t[j];
            t[j] := z;
            inc(i);
            dec(j);
        end;
    end;
    if (l < j) then qsort2(l, j);
    if (r > i) then qsort2(i, r);
end;

procedure qsort3(l, r: longint);
var
    i, j, x: longint;
    z: ttown;
begin
    i := l;
    j := r;
    x := t[l + random(r - l)].i;
    while (i <= j) do begin
        while (x > t[i].i) do inc(i);
        while (x < t[j].i) do dec(j);
        if (i <= j) then begin
            z := t[i];
            t[i] := t[j];
            t[j] := z;
            inc(i);
            dec(j);
        end;
    end;
    if (l < j) then qsort3(l, j);
    if (r > i) then qsort3(i, r);
end;

var
    i, n, v, cx, cy: longint;
    x, y, ccx, ccy: array [1..max_n] of longint;

procedure findy(v: longint); forward;

procedure findx(v: longint);
begin    
    while (x[v] <> 0) and (t[x[v]].c <> 0) do begin
        x[v] := t[x[v]].nx;
    end;
    if x[v] <> 0 then begin
        t[x[v]].c := 1;
        dec(ccx[v]);
        dec(ccy[t[x[v]].y]);
        findy(t[x[v]].y);
    end;
end;

procedure findy(v: longint);
begin    
    while (y[v] <> 0) and (t[y[v]].c <> 0) do begin
        y[v] := t[y[v]].ny;
    end;
    if y[v] <> 0 then begin
        t[y[v]].c := 2;
        dec(ccy[v]);
        dec(ccx[t[y[v]].x]);
        findx(t[y[v]].x);
    end;    
end;

begin
    assign(input, 'mayors.in'); reset(input);
    assign(output, 'mayors.out'); rewrite(output);

    read(n);

    for i := 1 to n do begin
        read(t[i].x, t[i].y);
        t[i].i := i;
        t[i].c := 0;
    end;

    qsort1(1, n);
    cx := 0;
    v := -maxlongint;
    for i := 1 to n do begin
        if v <> t[i].x then begin
            v := t[i].x;
            inc(cx);
            x[cx] := 0;
        end;
        t[i].x := cx;
        t[i].nx := x[cx];
        x[cx] := t[i].i;
        inc(ccx[cx]);        
    end;

    qsort2(1, n);
    v := -maxlongint;
    cy := 0;
    for i := 1 to n do begin
        if v <> t[i].y then begin
            v := t[i].y;
            inc(cy);
            y[cy] := 0;
        end;
        t[i].y := cy;
        t[i].ny := y[cy];
        y[cy] := t[i].i;
        inc(ccy[cy]);
    end;

    qsort3(1, n);
    {
    for i := 1 to n do begin
        writeln(t[i].i, ' ', t[i].x, ' ', t[i].y);
    end;
    }

    for i := 1 to cx do begin
        if ccx[i] mod 2 = 1 then begin
            findx(i);
        end;
    end;

    for i := 1 to cy do begin
        if ccy[i] mod 2 = 1 then begin
            findy(i);
        end;
    end;

    for i := 1 to cx do begin
        while (x[i] <> 0) do begin
            findx(i);
        end;
    end;

    for i := 1 to cy do begin
        if y[i] <> 0 then begin
            findy(i);
        end;
    end;

    for i := 1 to n do begin
        writeln(t[i].c - 1, ' ');
    end;

    close(input);
    close(output);
end.