{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O-,P+,Q+,R+,S+,T-,U-,V+,W-,X+,Y+,Z1}
{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $00100000}
{$IMAGEBASE $00400000}
{$APPTYPE CONSOLE}

{

  Sample solution for the task "Parking"
  Copyright(c) by Michael Mirzayanov

  Last revision date : 25.06.2003

}

program solution;

  const
    inFile = 'parking.in';
    outFile = 'parking.out';
    nmax = 100000;

  type
    int = longint;
    TTree = ^TNode;
    TNode = record
              inf : int;
              l, r : TTree;
            end;
    TAction = record
                type_ : int;
                cur : int;
                time : int;
                car : int;
              end;

  var
    n : int;
    m : int;
    ans : int;
    tree : TTree;
    p, pos : array [1..nmax] of int;
    ps : int;
    act : array [1..2 * nmax] of TAction;
    tact : int;
    answer : array [1..nmax] of int;

  function Build(a, b : int) : TTree;
  begin
    new(Result);
    Result^.inf := b - a + 1;
    if a = b then begin
      Result^.l := nil;
      Result^.r := nil;
    end else begin
      Result^.l := Build(a, (a + b) shr 1);
      Result^.r := Build((a + b) shr 1 + 1, b);
    end;
  end;

  function Insert(a, b, ind : int; t : TTree) : boolean;
    var
      lval : int;
      mid : int;
      nxt : int;
  begin
    Insert := True;
    if (a = b) then begin
      if (t^.inf = 1) and (ind = 1) then begin
        p[a] := ps;
        pos[ps] := a;
        t^.inf := 0;
      end else Insert := False;
    end else begin
      mid := (a + b) shr 1 - a + 1;
      if (ind <= mid) and (t^.l^.inf > 0) then begin
        if Insert(a, (a + b) shr 1, ind, t^.l) then dec(t^.inf) else begin
          nxt := ind - mid;
          if nxt < 1 then nxt := 1;
          if Insert((a + b) shr 1 + 1, b, nxt, t^.r) then dec(t^.inf) else Insert := False;
        end;
      end else begin
        nxt := ind - mid;
        if nxt < 1 then nxt := 1;
        if Insert((a + b) shr 1 + 1, b, nxt, t^.r) then dec(t^.inf) else Insert := False;
      end;
    end;
  end;

  procedure Delete(a, b : int; ind : int; t : TTree);
    var
      mid : int;
      nxt : int;
  begin
    if (a = b) then begin
      if (t^.inf = 0) and (ind = 1) then begin
        p[a] := 0;
        pos[ps] := 0;
        t^.inf := 1;
      end else begin
        writeln('ERROR!!');
      end;
    end else begin
      mid := (a + b) shr 1 - a + 1;
      if (ind <= mid) then begin
        Delete(a, (a + b) shr 1, ind, t^.l);
        inc(t^.inf);
      end else begin
        nxt := ind - mid;
        if nxt < 1 then nxt := 1;
        Delete((a + b) shr 1 + 1, b, nxt, t^.r);
        inc(t^.inf);
      end;
    end;
  end;

  procedure OutData;
    var
      i, j : int;
  begin
    assign(output,outFile);
    rewrite(output);
    for i := 1 to m do writeln(answer[i]);
    close(output);
  end;

  procedure HeapSort;
    var
      p, q : int;
      x : TAction;

    procedure sift;
      var
        i, j : int;
    begin
      i := p;
      j := p shl 1;
      x := act[i];
      if (j < q) and (act[j].time <= act[j + 1].time) then inc(j);
      while (j <= q) and (act[j].time > x.time) do begin
        act[i] := act[j];
        i := j;
        j := j shl 1;
        if (j < q) and (act[j].time <= act[j + 1].time) then inc(j);
      end;
      act[i] := x;
    end;

  begin
    q := tact;
    for p := tact downto 1 do sift;
    p := 1;
    while q > 1 do begin
      x := act[p];
      act[p] := act[q];
      act[q] := x;
      dec(q);
      sift;
    end;
  end;

  procedure Solve;
    var
      i, j : int;
  begin
    HeapSort;
    for i := 1 to tact do begin
      ps := act[i].car;
      if act[i].type_ = 1 then begin
        if not Insert(1, n, act[i].cur, tree) then Insert(1, n, 1, tree);
        answer[act[i].car] := pos[act[i].car];
      end else begin
        Delete(1, n, pos[act[i].car], tree);
      end;
    end;
  end;

  procedure ReadData;
    var
      i, j : int;
      cur : int;
      t1, t2 : int;
      c : int;
  begin
    assign(input,inFile);
    reset(input);
    read(n, m);
    tree := Build(1, n);
    fillchar(p, SizeOf(p), 0);

    for i := 1 to m do begin
      read(t1, t2, c);
      inc(tact);
      act[tact].type_ := 1;
      act[tact].time := t1;
      act[tact].cur := c;
      act[tact].car := i;
      inc(tact);
      act[tact].type_ := 2;
      act[tact].time := t2;
      act[tact].car := i;
    end;

    close(input);
  end;

begin
  ReadData;
  Solve;
  OutData;
end.
