{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J-,K-,L+,M-,N+,O-,P+,Q+,R+,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $00100000}
{$IMAGEBASE $00400000}
{$APPTYPE GUI}
const
    max_n = 2097152;

function min(a, b: longint): longint;
begin
    if a < b then min := a else min := b;
end;

function max(a, b: longint): longint;
begin
    if a < b then max := b else max := a;
end;

function d2(x: longint): longint;
begin
    if x < 0 then begin
        d2 := x div 2 - 1;
    end else begin
        d2 := x div 2;
    end;
end;

procedure get(var x, y: longint);
var
    t: longint;
begin
    read(x, y);
    t := d2(x + y);
    y := d2(x - y);
    x := t;
end;

type et = (_out, _vert, _in);

type event = record
    t: et;
    x, y1, y2: longint;
end;

var
    e: array [1..max_n * 2] of event;
    ce: longint;

procedure qsort(l, r: longint);
var
    i, j, x: longint;
    z: event;
begin
    i := l;
    j := r;
    x := e[l + random(r - l)].x;
    while (i <= j) do begin
        while (x > e[i].x) do inc(i);
        while (x < e[j].x) do dec(j);
        if (i <= j) then begin
            z := e[i];
            e[i] := e[j];
            e[j] := z;
            inc(i);
            dec(j);
        end;
    end;
    if (l < j) then qsort(l, j);
    if (r > i) then qsort(i, r);
end;

var
    t: array [1..2 * max_n] of longint;

procedure add(p: longint);
begin
    while p <> 0 do begin
        inc(t[p]);
        p := p div 2;
    end;
end;

procedure del(p: longint);
begin
    while p <> 0 do begin
        dec(t[p]);
        p := p div 2;
    end;
end;

function getCount(l, r: longint): longint;
var
    lf, rf: boolean;
    q: longint;
begin
    lf := false;
    rf := false;
    q := 0;
    while l <> r do begin
        if lf then begin
            q := q + t[l * 2 + 1];
        end;
        if rf then begin
            q := q + t[r * 2];
        end;
        lf := l mod 2 = 0;
        rf := r mod 2 = 1;
        l := l div 2;
        r := r div 2;
    end;
    getCount := q;
end;

var
    i, n: longint;
    s, px, py, x, y: longint;
begin
    assign(input, 'poly.in'); reset(input);
    assign(output, 'poly.out'); rewrite(output);

    read(n);

    ce := 0;
    get(px, py);
    for i := 1 to n - 1 do begin
        get(x, y);
        if x = px then begin
            inc(ce);
            e[ce].t := _vert;
            e[ce].x := x;
            e[ce].y1 := min(y, py);
            e[ce].y2 := max(y, py);
        end else begin
            inc(ce);
            e[ce].t := _in;
            e[ce].x := min(x, px);
            e[ce].y1 := y;
            inc(ce);
            e[ce].t := _out;
            e[ce].x := max(x, px);
            e[ce].y1 := y;
        end;
        px := x;
        py := y;
    end;

    qsort(1, ce);
    s := 0;
    for i := 1 to ce do begin
        if e[i].t = _in then begin
            add(e[i].y1 + 1000000 + max_n);
        end else if e[i].t = _out then begin
            del(e[i].y1 + 1000000 + max_n);
        end else begin
            s := s + getCount(e[i].y1 + 1000000 + max_n, e[i].y2 + 1000000 + max_n);
        end;
    end;

    writeln(s);

    close(input);
    close(output);
end.