{$APPTYPE CONSOLE}

{$R-,Q-}

const
	inFile	= 'brackets.in';
	outFile	= 'brackets.out';

	MaxN	= 1000;
	MaxL	= 1000;
	modulo	= 10000;
	modulosq = ( modulo * modulo );
	modulod	= 4;
type
	tlong = record
		l: integer;
		d: array [1..MaxL] of longint;
	end;

procedure Fatal(const msg: string);
begin
	WriteLn(msg);
	halt(1);
end;

procedure ladd(var a: tlong; const b: tlong);
var
	x, z, cp: longint;
begin
	cp := 1; z := 0;
	while (cp <= b.l) or (z > 0) do begin
		if (cp > MaxL) then
			Fatal('overflow in ladd');
		x := z;
		if (cp <= a.l) then
			Inc(x, a.d[cp]);
		if (cp <= b.l) then
			Inc(x, b.d[cp]);
		if x >= modulo then begin
			a.d[cp] := x - modulo;
			z := 1;
		end else begin
			a.d[cp] := x;
			z := 0;
		end;
		inc(cp);
	end;
	if (cp > a.l) then begin
		while (cp>0) and (a.d[cp] = 0) do
			dec(cp);
		a.l := cp;
	end;	
end;

function min(a, b: longint): longint;
begin
	if a < b then
		min := a
	else
		min := b;
end;
function max(a, b: longint): longint;
begin
	if a > b then
		max := a
	else
		max := b;
end;

procedure lmul(var r: tlong; const a, b: tlong);
var
  i, aa, bb, x, z, cp: longint;
begin
	z := 0;
	for cp := 1 to a.l + b.l do begin
		x := z;
		z := 0;
		aa := max(1, cp+1-b.l);
		bb := min(cp, a.l);
		for i := aa to bb do begin
			Inc(x, a.d[i] * b.d[cp+1-i]);
			if (x >= modulosq) then begin
				Dec(x, modulosq);
				Inc(z, modulo);
			end;
		end;

		if (cp > MaxL) then
			Fatal('overflow in lmul');
		r.d[cp] := x mod modulo;
		Inc(z, x div modulo);
	end;
	cp := a.l + b.l;
	while (cp>0) and (r.d[cp] = 0) do
		dec (cp);

	r.l := cp;
end;

procedure lset(var a: tlong; x: longint);
begin
	fillchar(a, sizeof(a), 0);
	while x>0 do begin
		inc(a.l);
		a.d[a.l] := x mod modulo;
		x := x div modulo;
	end;
end;

procedure lprint(const a: tlong);
var
	i, j, t: integer;
	x, m: longint;
begin
	t := a.l;
	for i := t downto 1 do begin
		x := a.d[i];
		if (i < a.l) then begin
			m := 10;
			for j := 2 to modulod do begin
				if x < m then
					Write(0);
				m := m * 10;
			end;
		end;
		Write(x);
	end;
	WriteLn;
end;

var
	A, G: array [1..MaxN] of tlong;
	tmp: tlong;
	i, k, n, nn: integer;
begin
	fillchar(A, sizeof(A), 0);
	fillchar(G, sizeof(G), 0);

	Assign(Input, inFile); reset(Input);
	Read(n);
	Close(Input);

	lset(A[1], 2);
	lset(G[1], 3);
{
	for i := 2 to n do begin
		nn := (i-1) shr 1;

		for k := 1 to nn do begin
			lmul(tmp, A[k], A[i-k]);
			ladd(A[i], tmp);
			ladd(A[i], tmp);
		end;
		if not odd(i) then begin
			lmul(tmp, A[i shr 1], A[i shr 1]);
			ladd(A[i], tmp);
		end;
		ladd(A[i], A[i-1]);
		ladd(A[i], A[i-1]);

		for k := 1 to nn do begin
			lmul(tmp, G[k], G[i-k]);
			ladd(G[i], tmp);
			ladd(G[i], tmp);
		end;
		if not odd(i) then begin
			lmul(tmp, G[i shr 1], G[i shr 1]);
			ladd(G[i], tmp);
		end;
		ladd(G[i], G[i-1]);
		ladd(G[i], G[i-1]);
		ladd(G[i], A[i-1]);
	end;
}
	for i := 2 to n do begin
		lmul(tmp, A[1], A[i-1]);
		ladd(A[i], tmp);
		for k := 2 to i-1 do begin
			lmul(tmp, A[k-1], A[i-k]);
			ladd(A[i], tmp);
			ladd(A[i], tmp);
		end;
		ladd(A[i], A[i-1]);
		ladd(A[i], A[i-1]);

		lmul(tmp, G[1], G[i-1]);
		ladd(G[i], tmp);
		for k := 2 to i-1 do begin
			lmul(tmp, G[k-1], G[i-k]);
			ladd(G[i], tmp);
			ladd(G[i], tmp);
			lmul(tmp, A[k-1], G[i-k]);
			ladd(G[i], tmp);
		end;
		ladd(G[i], G[i-1]);
		ladd(G[i], G[i-1]);
		ladd(G[i], A[i-1]);
	end;                                     	
	Assign(Output, outFile); ReWrite(Output);
	lprint(G[n]);
	Close(Output);
end.
