#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <ctype.h>
#include <string.h>

#define NN 110

struct REB {
  REB *p;
  REB *prv;
  int a;
};

struct REB_I {
  REB_I *p;
  int a;
  int n;
};

struct IN_REB {
  int x, y;
  int w;
};

struct PP {
  int t;
  int x;
};

int _stklen = 4194304;

FILE *fi, *fo;
IN_REB roads[NN*NN];
//REB *gx[NN];
//REB *gy[NN*NN];
REB *gg[NN*NN];
//int pwx[NN];
//int pwy[NN*NN];
int pw[NN];
int h[NN*NN];
int n,m;
REB_I *g[NN];
int d[NN][NN];
int w[NN*NN];
bool used[NN];

void AddRebI(REB_I **g, int x, int y, int n)
{
  REB_I *t;
  t=new REB_I;
  t->n=n;
  t->a=y;
  t->p=g[x];
  g[x]=t;
}

void AddReb(REB **g, int x, int y)
{
  REB *t;
  t=new REB;
  t->a=y;
  t->p=g[x];
  t->prv=NULL;
  if(t->p!=NULL)
    t->p->prv=t;
  g[x]=t;
}

void DelReb(REB *t, int x, REB **g)
{
  if(t->p!=NULL)
    t->p->prv=t->prv;
  if(t->prv!=NULL)
    t->prv->p=t->p;
  else
    g[x]=t->p;
  pw[x]--;
  pw[t->a]--;
//  delete(t);
}

void dfs(int x, int v,int w)
{
  REB_I *t;
  used[v]=true;
  d[x][v]=w;
  for(t=g[v];t!=NULL;t=t->p)
    if(!used[t->a])
      dfs(x,t->a,v);
}

int GetRebNum(REB_I **g,int x, int y)
{
  REB_I *t;
  for(t=g[x];t!=NULL;t=t->p)
    if(t->a==y)
      return t->n;
}

void sift(int *h, int p, int q)
{
  int i,j;
  int x;
  i=p;
  j=2*i+1;
  x=h[i];
  if(j<q-1) if(pw[h[j]]<pw[h[j+1]]) j++;
  if(j<q) if(pw[h[j]]<pw[x]) j=q+1;
  while(j<q)
  {
    h[i]=h[j];
    i=j;
    j=2*j+1;
    if(j<q-1) if(pw[h[j]]<pw[h[j+1]]) j++;
    if(j<q) if(pw[h[j]]<pw[x]) j=q+1;
  }
  h[i]=x;
}

int main()
{
  int i,j;
  int x,y;
  int cur;
  int xx,yy;
  REB *t;
  fi=fopen("roads.in","rt");
  fo=fopen("roads.out","wt");

  fscanf(fi,"%i%i",&n,&m);
  for(i=0;i<n;i++)
  {
    g[i]=NULL;
//    gx[i]=NULL;
  }
  for(i=0;i<m;i++)
  {
    gg[i]=NULL;
//    gy[i]=NULL;
  }
  for(i=0;i<m;i++)
  {
    fscanf(fi,"%i%i%i",&roads[i].x,&roads[i].y,&roads[i].w);
    if(i<n-1)
    {
      AddRebI(g,roads[i].x-1,roads[i].y-1,i);
      AddRebI(g,roads[i].y-1,roads[i].x-1,i);
    }
    w[i]=roads[i].w;
  }

  for(i=0;i<n;i++)
  {
    for(j=0;j<n;j++)
      used[j]=false;
    dfs(i,i,-1);
  }

  for(i=n-1;i<m;i++)
  {
    x=roads[i].x-1;
    y=roads[i].y-1;
    cur=y;
    while(cur>=0)
    {
      xx=GetRebNum(g,d[x][cur],cur);
      if(w[xx]>w[i])
      {
        AddReb(gg,xx,i);
        AddReb(gg,i,xx);
        pw[xx]++;
        pw[i]++;
      }
      cur=d[x][cur];
    }
  }

//  for(i=0;i<m;i++)
//    h[i]=i;
//  for(i=m/2+1;i>=0;i--)
//    sift(h,i,m);

  x=m-1;
  for(i=m-2;i>=0;i--)
    if(pw[i]>pw[x])
      x=i;
  while(pw[x]>0)
  {
    if(x<n-1)
    {
      y=0;
      for(t=gg[x];t!=NULL;t=t->p)
        if(w[t->a]>y)
          y=w[t->a];
      w[x]=y;
      for(t=gg[x];t!=NULL;t=t->p)
        if(w[t->a]==y)
          DelReb(t,x,gg);
    }
    else
    {
      y=100000;
      for(t=gg[x];t!=NULL;t=t->p)
        if(w[t->a]<y)
          y=w[t->a];
      w[x]=y;
      for(t=gg[x];t!=NULL;t=t->p)
        if(w[t->a]==y)
          DelReb(t,x,gg);
    }
//    for(i=m/2+1;i>=0;i--)
//      sift(h,i,m);
    x=m-1;
    for(i=m-2;i>=0;i--)
      if(pw[i]>pw[x])
        x=i;
  }

  fprintf(fo,"%i %i\n",n,m);
  for(i=0;i<m;i++)
  {
    roads[i].w=w[i];
    fprintf(fo,"%i %i %i\n",roads[i].x,roads[i].y,roads[i].w);
  }

  fclose(fi);
  fclose(fo);
  return 0;
}


