#include <stdio.h>
#include <math.h>

FILE*fi,*fo;

#define EPS ((double)1e-7)

struct TPoint {
  long x,y;
  short k;
};

class TForest {
  private:
    short n,m,N,c,C;
    TPoint*a,*b,*d,*q,*Q;
    long s,S;
    int sign(double);
    int sign(long);
    int cmpa(TPoint*,TPoint*,TPoint*);
    int cmpad(TPoint*,TPoint*,TPoint*);
    int cmp(TPoint*,TPoint*,TPoint*);
    void heapify(TPoint*,short,short,TPoint*);
    void sort(TPoint*,short,TPoint*);
    void trythisa(short);
    void trythisb(void);
  public:
    TForest(void);
    ~TForest();
    void Delete(void);
    void scan(FILE*);
    void print(FILE*);
    void find(void);
};

TForest g;

int main(void) {
  fi=fopen("birds.in","rt");
  g.scan(fi);
  fclose(fi);
  g.find();
  fo=fopen("birds.out","wt");
  g.print(fo);
  fclose(fo);
  return(0);
}


void TForest::trythisb(void) {
  if (N<=2) return;
  short i,j; TPoint z;
  z=d[0]; j=0;
  for (i=1; i<N; i++) if (( d[i].y<z.y )||( (d[i].y==z.y)&&(d[i].x<z.x) ))
  { z=d[i]; j=i; }
  d[j]=d[0]; d[0]=z;
  sort(&d[1],N-1,&d[0]);
  q[0]=d[0]; c=1;
  for (i=1; i<N; i++) if (c>=2) {
    if (cmp(&q[c-1],&d[i],&q[c-2])>0) q[c++]=d[i];
    else { c--; i--; }
  } else q[c++]=d[i];
  s=0;
  for (j=c-1,i=0; i<c; j=i++) s+=(q[j].x-q[i].x)*(q[i].y+q[j].y);


  if (s>S) {
    TPoint*z;
    C=c; S=s;
    z=Q; Q=q; q=z;
  }
}
void TForest::trythisa(short k) {
  short i,j;
  if (m>0) {
    sort(b,m,&a[k]);
    N=1; d[0]=a[k];
    for (i=0; i<n; i++)
      if (( cmpa(&b[0],&a[i],&a[k])<0 )||( cmpa(&b[m-1],&a[i],&a[k])>0 ))
      d[N++]=a[i];
    trythisb();
    for (j=1; j<m; j++) {
      N=1; d[0]=a[k];
      for (i=0; i<n; i++)
        if (( cmpa(&b[j-1],&a[i],&a[k])>0 )&&( cmpa(&b[j],&a[i],&a[k])<0 ))
        d[N++]=a[i];
      trythisb();
    }
  } else {
    N=1; d[0]=a[k];
    for (i=0; i<n; i++) if (i!=k) d[N++]=a[i];
    trythisb();
  }
}
void TForest::find(void) {
  short i;
  C=0; S=0;
  for (i=0; i<n; i++) trythisa(i);
}

TForest::TForest(void) {
  a=0; b=0; d=0;
  q=0; Q=0;
}
TForest::~TForest() {
  Delete();
}
void TForest::Delete(void) {
  if (a) delete[]a; if (b) delete[]b; if (d) delete[]d;
  if (q) delete[]q; if (Q) delete[]Q;
}
void TForest::scan(FILE*f) {
  Delete();
  short i;
  fscanf(f,"%hd",&n);
  a=new TPoint[n];
  for (i=0; i<n; i++) {
    fscanf(f,"%ld%ld",&a[i].x,&a[i].y);
    a[i].k=i;
  }
  fscanf(f,"%hd",&m);
  b=new TPoint[m];
  for (i=0; i<m; i++) {
    fscanf(f,"%ld%ld",&b[i].x,&b[i].y);
    b[i].k=i;
  }
  d=new TPoint[n];
  q=new TPoint[n]; Q=new TPoint[n];
}
void TForest::print(FILE*f) {
  short i;
  fprintf(f,"%hd\n",C);
  for (i=0; i<C; i++) {
    if (i) fprintf(f," ");
    fprintf(f,"%hd",Q[i].k+1);
  }
}

void TForest::heapify(TPoint*e,short v,short w,TPoint*o) {
  short i,j; TPoint z;
  i=v; j=(v<<1)+1;
  if ((j<w)&&(cmpad(&e[j],&e[j+1],o)>0)) j++;
  z=e[i];
  while ((j<=w)&&(cmpad(&z,&e[j],o)>0)) {
    e[i]=e[j];
    i=j; j=(j<<1)+1;
    if ((j<w)&&(cmpad(&e[j],&e[j+1],o)>0)) j++;
  }
  e[i]=z;
}
void TForest::sort(TPoint*e,short k,TPoint*o) {
  short i,j; TPoint z;
  for (i=k>>1,j=k-1; i>0; i--) heapify(e,i,j,o);
  for (; j>0; j--) {
    heapify(e,i,j,o);
    z=e[i]; e[i]=e[j]; e[j]=z;
  }
}

int TForest::cmpa(TPoint*v,TPoint*w,TPoint*o) {
  double x0,y0,x1,y1,z0,z1; int z;
  x0=(double)(v->x-o->x); y0=(double)(v->y-o->y);
  if ((x0==0)&&(y0==0)) return(0);
  x1=(double)(w->x-o->x); y1=(double)(w->y-o->y);
  if ((x1==0)&&(y1==0)) return(0);
  z0=atan2(y0,x0); z1=atan2(y1,x1);
  z=sign(z1-z0);
  return(z);
}
int TForest::cmpad(TPoint*v,TPoint*w,TPoint*o) {
  double x0,y0,x1,y1,z0,z1; int z;
  x0=(double)(v->x-o->x); y0=(double)(v->y-o->y);
  if ((x0==0)&&(y0==0)) return(0);
  x1=(double)(w->x-o->x); y1=(double)(w->y-o->y);
  if ((x1==0)&&(y1==0)) return(0);
  z0=atan2(y0,x0); z1=atan2(y1,x1);
  z=sign(z1-z0);
  if (z) return(z);
  z0=x0*x0+y0*y0; z1=x1*x1+y1*y1;
  z=sign(z1-z0);
  return(z);
}
int TForest::cmp(TPoint*v,TPoint*w,TPoint*o) {
  long x0,y0,x1,y1,z0,z1; int z;
  x0=v->x-o->x; y0=v->y-o->y;
  x1=w->x-o->x; y1=w->y-o->y;
  z=sign(x0*y1-x1*y0);
  return(z);
}
int TForest::sign(double z) {
  if (z<-EPS) return(-1);
  if (z>+EPS) return(+1);
  return(0);
}
int TForest::sign(long z) {
  if (z<0) return(-1);
  if (z>0) return(+1);
  return(0);
}

