{$D-,L-,Q-,R-,S-,I-}
Program pr_b;
const
  inpfile='roads.in';
  outfile='roads.out';
  nm=125;
  mm=nm*nm;
type
  Rebr=record
    x,y : Integer;
  end;
var
  a,b : array [1..nm,1..nm] of Integer;
  num : array [1..nm,1..nm] of Integer;
  col : array [1..nm] of Integer;
  reb,gr : array [1..mm] of Rebr;
  deg1 : array [1..nm] of Integer;
  deg2 : array [1..mm] of Integer;
  err : array [1..nm*nm*nm] of Rebr;
  cer : array [1..nm*nm*nm] of Integer;
  n,m,grn,errn : LongInt;
{}
Procedure Inp;
var
  i,x,y : LongInt;
begin
  assign(input,inpfile);
  reset(input);
  read(n,m);
  for i:=1 to n-1 do begin
    read(x,y); read(a[x,y]);
    num[x,y]:=i; a[y,x]:=a[x,y];
    reb[i].x:=x; reb[i].y:=y;
  end;

  grn:=0;
  for i:=1 to m-n+1 do begin
    read(x,y); read(b[x,y]);
    num[x,y]:=i+n-1; b[y,x]:=b[x,y];
    gr[i].x:=x; gr[i].y:=y; inc(grn);
  end;
end;
{}
Procedure Out;
var
  i : LongInt;
begin
  assign(output,outfile);
  rewrite(output);
  writeln(n,' ',m);
  for i:=1 to n-1 do begin
    writeln(reb[i].x,' ',reb[i].y,' ',a[reb[i].x,reb[i].y]);
  end;
  for i:=1 to grn do begin
    writeln(gr[i].x,' ',gr[i].y,' ',b[gr[i].x,gr[i].y]);
  end;
  close(output);
  halt;
end;
{}
Procedure Init;
begin
  fillchar(a,sizeof(a),0);
  fillchar(b,sizeof(b),0);
  fillchar(num,sizeof(num),0);
  fillchar(col,sizeof(col),0);
  fillchar(reb,sizeof(reb),0);
  fillchar(gr,sizeof(gr),0);
  fillchar(deg1,sizeof(deg1),0);
  fillchar(deg2,sizeof(deg2),0);
  fillchar(err,sizeof(err),0);
  fillchar(cer,sizeof(cer),0);
end;
{}
Procedure Dfs(x,cl : Integer);
var
  i : Integer;
begin
  col[x]:=cl;
  for i:=1 to n do
    if (a[x,i]>0) and (col[i]=0) then Dfs(i,cl);
end;
{}
Procedure Swap(var q,w : Rebr);
var
  bak : Rebr;
begin
  bak:=q;
  q:=w;
  w:=bak;
end;
{}
Procedure SwapI(var q,w : Integer);
var
  bak : Integer;
begin
  bak:=q;
  q:=w;
  w:=bak;
end;
{}
Procedure Sort(l,r: Integer);
var
  i,j,x : Integer;
begin
  i:=l; j:=r; x:=cer[(l+r) div 2];
  repeat
    while cer[i]<x do inc(i);
    while x<cer[j] do dec(j);
    if not(i>j) then begin
      Swap(err[i],err[j]);
      SwapI(cer[i],cer[j]);
      inc(i); dec(j);
    end;
  until i>j;
  if l<j then Sort(l,j);
  if i<r then Sort(i,r);
end;
{}
Procedure Solve;
var
  i,j,d,xn,yn : LongInt;
begin
  for i:=1 to n-1 do begin
    fillchar(col,sizeof(col),0);
    d:=a[reb[i].x,reb[i].y];
    a[reb[i].x,reb[i].y]:=0;
    a[reb[i].y,reb[i].x]:=0;
    Dfs(reb[i].x,1); Dfs(reb[i].y,2);
    a[reb[i].x,reb[i].y]:=d;
    a[reb[i].y,reb[i].x]:=d;
    for j:=1 to grn do begin
      if (col[gr[j].x]<>col[gr[j].y])
      and (b[gr[j].x,gr[j].y]<d) then begin
        inc(deg1[i]); inc(deg2[j]);
        inc(errn);
        err[errn].y:=j; err[errn].x:=i;
        cer[errn]:=d-b[gr[j].x,gr[j].y];
      end;
    end;
  end;

  Sort(1,errn);

  for i:=1 to errn do begin
    xn:=err[i].x; yn:=err[i].y;
    if a[reb[xn].x,reb[xn].y]>b[gr[yn].x,gr[yn].y] then begin
      if deg1[xn]>=deg2[yn] then begin
        a[reb[xn].x,reb[xn].y]:=b[gr[yn].x,gr[yn].y];
      end else begin
        b[gr[yn].x,gr[yn].y]:=a[reb[xn].x,reb[xn].y];
      end;
    end;
    dec(deg1[xn]); dec(deg2[yn]);
  end;
end;
{}
Begin
  Init;
  Inp;
  Solve;
  Out;
End.
