{
  Dmitry Orlov
    SARATOV
    id = 33
}


{.$define debug}

{$R-,Q-,S-,I-,N+}


program template;
const
 nmax = 110;
 eps = 1e-9;
 cinfile = 'birds.in';
 coutfile= 'birds.out';
type
 int = longint;
 real = extended;
 tpoint = record
  x,y :real;
 end;
var
 p,g :array [1..nmax] of tpoint;
 result :array [1..nmax] of int;
 ans :real;
 numres :int;
 n,m :int;

procedure init;
begin
 randseed := 1242;
 ans := 0;
end;

procedure readdata;
var i,j :int;
begin
 assign (input,cinfile);
 reset (input);
 read (n);
 for i := 1 to n do
  read (p[i].x,p[i].y);
 read (m);
 for i := 1 to m do
  read (g[i].x,g[i].y);
 close (input);
end;

procedure outdata;
var i,j :int;
begin
 assign (output,coutfile);
 rewrite (output);
 writeln (numres);
 for i := 1 to numres do
  write (result[i],' ');
 close (output);
end;

function len (var a,b :tpoint):real;
begin
 len := sqrt(sqr(a.x - b.x) + sqr(a.y - b.y));
end;


function good (center :tpoint; r :real):boolean;
var i,j :int;
    t :real;
begin
 good := false;
 for i := 1 to m do
  begin
   t := len (g[i],center);
   if t < r + eps then
    exit;
  end;
 good := true;
end;

procedure tryit (center :tpoint; r :real; need :boolean);
var i :int;
    pp :array [1..nmax] of tpoint;
    num :array [1..nmax] of int;
    s :array [1..nmax] of int;
    d :int; cur :int; k :int;
    min1,min2,t :real;
    sq :real;

procedure swap (var a,b :tpoint);
var tmp :tpoint;
begin
 tmp := a;
 a := b;
 b := tmp;
end;

function less (var a,b :tpoint):boolean;
var product :real;
begin
 product := (a.x - pp[1].x)*(b.y - pp[1].y) -
             (a.y - pp[1].y)*(b.x - pp[1].x);
 if abs(product) < eps then
  less := len(pp[1],a) < len(pp[1],b)
 else
  less := product < 0;
end;

procedure swapint (var a,b :int);
var tmp :int;
begin
 tmp := a;
 a := b;
 b := tmp;
end;

procedure sort (l,r :int);
var i,j :int;
    x :tpoint;
begin
 i := l;
 j := r;
 x := pp[l + random(r-l+1)];
 repeat
  while less (pp[i],x) do
   inc(i);
  while less (x,pp[j]) do
   dec(j);
  if i <= j then
   begin
    swap (pp[i],pp[j]);
    swapint (num[i],num[j]);
    inc(i);
    dec(J);
   end;
 until i > j;
 if i < r then
  sort (i,r);
 if l < j then
  sort (l,j);
end;

function vector (a,b,c :tpoint):real;
var x1,y1,x2,y2 :real;
begin
 x1 := b.x - a.x;
 y1 := b.y - a.y;
 x2 := c.x - b.x;
 y2 := c.y - b.y;
 vector := x1*y2 - x2*y1;
end;

function test:boolean;
var i,j :int;
    r :array [0..1] of int;
    prd :real;
    x1,y1,x2,y2 :real;
begin
 test := false;
{ for j := 1 to m do
  begin
   fillchar (r,sizeof(r),0);
   for i := 1 to d do
    begin
     x1 := -g[j].x + pp[s[i]].x;
     y1 := -g[j].y + pp[s[i]].y;
     x2 := -g[j].x + pp[s[i+1]].x;
     y2 := -g[j].y + pp[s[i+1]].y;
     prd := x1*y2 - x2*y1;
     if prd < 0 then
      inc(r[0]);
     if prd > 0 then
      inc(r[1]);
    end;
   if (r[0] > 0) and (r[1] > 0) then
    exit;
  end;
 test := true;}
end;


begin
 k := 0;
 for i := 1 to n do
  begin
   t := len (p[i],center);
   if t < r + eps then
    begin
     inc(k);
     pp[k] := p[i];
     num[k] := i;
    end;
  end;
 if k <= 2 then
  exit;
 min1 := 1e50;
 for i := 1 to k do
  if pp[i].y < min1 then
   min1 := pp[i].y;
 cur := 0;
 min2 := 1e50;
 for i := 1 to k do
  if pp[i].y - min1 < eps then
   if pp[i].x < min2 then
    begin
     min2 := pp[i].x;
     cur := i;
    end;
 swap (pp[1],pp[cur]);
 swapint (num[1],num[cur]);
 sort (2,k);
 fillchar (s,sizeof(s),0);
 d := 3;
 s[1] := 1;
 s[2] := 2;
 s[3] := 3;
 for i := 4 to k do
  begin
   while (d > 1) and
    (vector (pp[s[d-1]],pp[s[d]],pp[i]) > -eps) do
     dec(d);
   inc(d);
   s[d] := i;
  end;
 sq := 0;
 s[d+1] := s[1];
 for i := 1 to d do
  sq := sq + (pp[s[i]].x - pp[s[i+1]].x)*(pp[s[i]].y + pp[s[i+1]].y);
 sq := abs(sq);
 if need then
  if not test then
   exit;
 if sq > ans then
  begin
   ans := sq;
   numres := d;
   for i := 1 to d do
    result[i] := num[s[i]];
  end;
end;

procedure solve;
var i,j :int;
    t :tpoint;
    r :real;
begin
 t.x := 0;
 t.y := 0;
 r := 1e10;
 tryit (t,r,true);
 for i := 1 to n-1 do
  for j := i+1 to n do
   begin
    t.x := (p[i].x + p[j].x)/2;
    t.y := (p[i].y + p[j].y)/2;
    r := len (p[i],p[j])/2;
    if good (t,r) then
     tryit (t,r,false);
   end;
end;

begin
 init;
 readdata;
 solve;
 outdata;
end.