program Palindromes_Suffix_Arrays_RULEZZZ;
{$N+}
const
  MAXN = 100002; {100002}

type
  RMQ = object
    h : array [1..8*MAXN] of longint;
    size : longint;
    procedure init;
    procedure update(index, value : longint);
    function getmin(left, right : longint) : longint;
  end;
  SuffixArray = object
    poss, inv, col, start, tposs, tinv, tcol, pstart : array [1..2*MAXN] of longint;
    colno, tcolno : longint;
    cur : RMQ;
    procedure swap(a, b : longint);
    function lcp(a, b : longint) : longint;
    procedure build;
  end;

var
  n : longint;
  answer : comp;
  s : array [0..2*MAXN] of char;
  A : SuffixArray;

procedure RMQ.init;
begin
  size := n;
  fillchar(h,sizeof(h),255);
end;

procedure RMQ.update(index, value : longint);
var
  t : longint;
begin
  t := index + size - 1;
  while t>0 do
  begin
    if (h[t]=-1) or (h[t]>value) then
      h[t] := value;
    t := t div 2;
  end;
end;

function RMQ.getmin(left, right : longint) : longint;
var
  l, r, answer : longint;
begin
  l := left + size - 1;
  r := right + size - 1;
  answer := -1;
  while l<=r do
  begin
    if (h[l]<>-1) and ((answer=-1) or (answer>h[l])) then
      answer := h[l];
    if (h[r]<>-1) and ((answer=-1) or (answer>h[r])) then
      answer := h[r];
    if l=r then
      break;
    l := (l+1) div 2;
    r := (r-1) div 2;
  end;
  getmin := answer;
end;

procedure SuffixArray.swap(a, b : longint);
var
  t : longint;
begin
  t := poss[a];
  poss[a] := poss[b];
  poss[b] := t;
  inv[poss[a]] := a;
  inv[poss[b]] := b;
end;

function SuffixArray.lcp(a, b : longint) : longint;
begin
  if inv[a]<=inv[b] then
    lcp := cur.getmin(inv[a],inv[b]-1)
  else
    lcp := cur.getmin(inv[b],inv[a]-1);
end;

procedure SuffixArray.Build;
var
  h, t, i, j, k, ccol : longint;
  c : char;
  temp, no : array ['a'..#127] of longint;
begin
  h := 1;
  fillchar(temp,sizeof(temp),0);
  for i:=1 to n do
    inc(temp[s[i]]);
  t := 1;
  colno := 0;
  for c:='a' to #127 do
    if temp[c]>0 then
    begin
      inc(colno);
      start[colno] := t;
      pstart[colno] := t;
      no[c] := colno;
      t := t + temp[c];
    end;
  for i:=1 to n do
  begin
    c := s[i];
    col[i] := no[c];
    poss[pstart[col[i]]] := i;
    inv[i] := pstart[col[i]];
    inc(pstart[col[i]]);
  end;
  cur.init;
  for i:=1 to n-1 do
    if col[poss[i]]<>col[poss[i+1]] then
    cur.update(i,0);

  while h<=n do
  begin
    tposs := poss;
    tinv := inv;
    pstart := start;
    tcolno := colno;
    tcol := col;
    for i:=1 to n do
    begin
      j := tposs[i];
      if j>h then
      begin
        k := inv[j-h];
        swap(k,pstart[tcol[j-h]]);
        inc(pstart[tcol[j-h]]);
      end;
    end;
    ccol := tcol[poss[1]];
    col[poss[1]] := ccol;
    for i:=1 to n-1 do
    begin
      if tcol[poss[i]]<>tcol[poss[i+1]] then
        ccol := tcol[poss[i+1]]
      else
        if ((poss[i+1]=n+1-h) or (tcol[poss[i]+h]<>tcol[poss[i+1]+h])) then
        begin
          inc(colno);
          ccol := colno;
          start[colno] := i+1;
          if poss[i+1]=n+1-h then
            cur.update(i,h)
          else
            cur.update(i,h+lcp(poss[i]+h,poss[i+1]+h));
        end;
      col[poss[i+1]] := ccol;
    end;
    h := h*2;
  end;
end;

procedure Load(infile, outfile : string);
var
  i : longint;
begin
  assign(input,infile);
  reset(input);
  assign(output,outfile);
  rewrite(output);
  n := 0;
  while not eof do
  begin
    read(s[n+1]);
    if not (s[n+1] in ['a'..'z']) then
      break;
    inc(n);
  end;
  for i:=1 to n do
    s[2*n+1-i] := s[i];
  n := n*2;
end;

function min(a, b : longint) : longint;
begin
  if a>b then
    min := b
  else
    min := a;
end;

procedure Solve;
var
  i : longint;
begin
  A.Build;
  answer := 0;
  for i:=1 to n div 2 do
  begin
    answer := answer + min(A.lcp(i,n+1-i),n div 2+1-i) - 1;
    if i>1 then
      answer := answer + min(A.lcp(i,n+2-i),n div 2+1-i);
  end;
end;

procedure Save;
begin
  writeln(answer:0:0);
  close(input);
  close(output);
end;

begin
  Load('palindr.in','palindr.out');
  Solve;
  Save;
end.