#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <ctype.h>
#include <string.h>

#define NN 110000
#define MANY 2000000000

struct REB {
  int a;
  int w;
  REB *p;
};

struct PTree {
  int parent;
  REB *child;
  int deep;
};

int _stklen = 4194304;

FILE *fi, *fo;
int n;
REB *g1[NN];
PTree g[NN];
bool used[NN];
int d1[NN];
int d2[NN];
int d[NN];
int c1,c2;
int f1,f2;
int upf1, upf2;
int f12;
int NumC;
int root;

int max(int a, int b)
{
  return (a>b)?a:b;
}

int min(int a, int b)
{
  return (a<b)?a:b;
}

void AddReb(REB **g, int x, int y,int w)
{
  REB *t;
  t=new REB;
  t->a=y;
  t->w=w;
  t->p=g[x];
  g[x]=t;
}

void AddReb1(REB **g, int y,int w)
{
  REB *t;
  t=new REB;
  t->a=y;
  t->w=w;
  t->p=*g;
  *g=t;
}

void dfs(REB **g, int v, int w, int *d)
{
  REB *t;
  used[v]=true;
  d[v]=w;
  for(t=g[v];t!=NULL;t=t->p)
    if(!used[t->a])
      dfs(g,t->a,w+t->w,d);
}

int dfsb(int v)
{
  REB *t;
  int y;
  used[v]=true;
  g[v].parent=-1;
  g[v].child=NULL;
  g[v].deep=0;
  for(t=g1[v];t!=NULL;t=t->p)
  {
    if(!used[t->a])
    {
      AddReb1(&g[v].child,t->a,t->w);
      y=dfsb(t->a)+t->w;
      if(y>g[v].deep)
        g[v].deep=y;
    }
    else
    {
      g[v].parent=t->a;
    }
  }
  return g[v].deep;
}

bool MoveC(int *cc1, int *cc2)
{
  int df;
  int mf;
  int ff;
  int mdeep;
  int c1,c2;
  REB *t,*p, *tt;
  c1=*cc1;
  c2=*cc2;
  mf=max(f1,max(upf1,(f12+1)/2));
  mf=max(mf,max(upf2,f2));
  df=-1;
  for(p=g[c1].child;p!=NULL;p=p->p)
  {
    mdeep=-1;
    for(t=g[c1].child;t!=NULL;t=t->p)
    {
      if((t->a!=c2)&&(t->a!=p->a))
      {
        if(mdeep<0)
        {
          mdeep=t->a;
          tt=t;
        }
        else
        {
          if(g[mdeep].deep<g[t->a].deep)
          {
            mdeep=t->a;
            tt=t;
          }
        }
      }
    }
    if(c1!=c2)
    {
      ff=g[mdeep].deep+p->w+tt->w;
      ff=max(ff,upf1+p->w);
      ff=max(ff,max(upf2,(f12+p->w+1)/2));
      ff=max(ff,f2);
    }
    else
    {
      ff=max(g[mdeep].deep+tt->w,g[p->a].deep);
    }
//    ff=max(ff,f12+p->w);
    if(ff<=mf)
    {
      mf=ff;
      df=p->a;
    }
  }
  if(df<0)
    return false;
  for(p=g[c1].child;p!=NULL;p=p->p)
    if(p->a==df)
      tt=p;
  p=tt;
  mdeep=-1;
  for(t=g[c1].child;t!=NULL;t=t->p)
  {
    if((t->a!=c2)&&(t->a!=p->a))
    {
      if(mdeep<0)
      {
        mdeep=t->a;
        tt=t;
      }
      else
      {
        if(g[mdeep].deep<g[t->a].deep)
        {
          mdeep=t->a;
          tt=t;
        }
      }
    }
  }
  if(c1!=c2)
  {
    upf1=max(upf1+p->w,g[mdeep].deep+tt->w+p->w);
    upf2=max(upf2,f12+tt->w+g[mdeep].deep);
  }
  else
  {
    f2=g[mdeep].deep+tt->w;
  }
  f12+=p->w;
  *cc1=df;
  f1=g[p->a].deep;
  return true;
}

int main()
{
  int i,j;
  int x,y;
  int w;
  bool flag;
  fi=fopen("cows.in","rt");
  fo=fopen("cows.out","wt");

  fscanf(fi,"%i",&n);
  if(n==2)
  {
    fprintf(fo,"1 2\n");
    fclose(fi);
    fclose(fo);
    return 0;
  }
  for(i=0;i<n;i++)
    g1[i]=NULL;
  for(i=0;i<n-1;i++)
  {
    fscanf(fi,"%i%i%i",&x,&y,&w);
    x--;
    y--;
    AddReb(g1,x,y,w);
    AddReb(g1,y,x,w);
  }

  for(i=0;i<n;i++)
    used[i]=false;
  dfs(g1,0,0,d1);
  x=d1[0];
  y=0;
  for(i=1;i<n;i++)
  {
    if(d1[i]>x)
    {
      x=d1[i];
      y=i;
    }
  }
  for(i=0;i<n;i++)
    used[i]=false;
  dfs(g1,y,0,d2);
  x=d2[0];
  y=0;
  for(i=1;i<n;i++)
  {
    if(d2[i]>x)
    {
      x=d2[i];
      y=i;
    }
  }
  for(i=0;i<n;i++)
    used[i]=false;
  dfs(g1,y,0,d1);
  for(i=0;i<n;i++)
    d[i]=max(d1[i],d2[i]);

  x=d[0];
  for(i=1;i<n;i++)
    if(d[i]<x)
      x=d[i];

  NumC=0;
  for(i=0;i<n;i++)
  {
    if(x==d[i])
    {
      if(NumC==0)
      {
        c1=i;
        NumC=1;
      }
      else
      {
        c2=i;
        NumC=2;
      }
    }
  }
  if(NumC==1)
    c2=c1;

  for(i=0;i<n;i++)
    used[i]=false;
  dfsb(c1);
  root=c1;
  f1=g[c2].deep;
  f2=g[c2].deep;
  f12=g[c1].deep-g[c2].deep;
  upf1=0;
  upf2=0;

  flag=true;
  while(flag)
  {
    if(max(f1,upf1)>=max(f2,upf2))
      flag=MoveC(&c1,&c2);
    else
      flag=MoveC(&c2,&c1);
  }

  fprintf(fo,"%i %i\n",c1+1,c2+1);
  
  fclose(fi);
  fclose(fo);
  return 0;
}


