#include <stdio.h>
#include <string.h>

FILE*fi,*fo;

#define INF ((long)0x7FFFFF00)

struct TEdge {
  long u,x;
  TEdge*z;
};
class TGraph {
  private:
    long n,M,m,a[2];
    TEdge*G,**g;
    long*q,*r0,*r1;
    void search(long,long*);
  public:
    TGraph(void);
    ~TGraph();
    void Delete(void);
    void scan(FILE*);
    void print(FILE*);
    void decide(void);
};

TGraph g;

int main(void) {
  fi=fopen("cows.in","rt");
  g.scan(fi);
  fclose(fi);
  g.decide();
  fo=fopen("cows.out","wt");
  g.print(fo);
  fclose(fo);
  return(0);
}


void TGraph::search(long u,long*r) {
  long l,i,v,w; TEdge*y;
  memset(r,-1,n*sizeof(long));
  q[0]=u; r[u]=0; l=1;
  for (i=0; i<l; i++) {
    v=q[i];
    for (y=g[v]; y; y=y->z) {
      w=y->u;
      if (r[w]>=0) continue;
      q[l]=w; r[w]=r[v]+y->x; l++;
    }
  }
}
void TGraph::decide(void) {
  long i,v,w;
  search(0,r1);
  v=0; for (i=0; i<n; i++) if (r1[i]>r1[v]) v=i;
  search(v,r0);
  w=v; for (i=0; i<n; i++) if (r0[i]>r0[w]) w=i;
  search(w,r1);
  for (i=0; i<n; i++) if (r1[i]>r0[i]) r0[i]=r1[i];
  a[0]=v; for (i=0; i<n; i++) if (r0[i]<r0[a[0]]) a[0]=i; r0[a[0]]=INF;
  a[1]=w; for (i=0; i<n; i++) if (r0[i]<r0[a[1]]) a[1]=i; r0[a[1]]=INF;
  if (a[0]>a[1]) { i=a[0]; a[0]=a[1]; a[1]=i; }
}

TGraph::TGraph(void) {
  G=0; g=0;
  q=0; r0=0; r1=0;
}
TGraph::~TGraph() {
  Delete();
}
void TGraph::Delete(void) {
  if (G) delete[]G; if (g) delete[]g;
  if (q) delete[]q; if (r0) delete[]r0; if (r1) delete[]r1;
}
void TGraph::scan(FILE*f) {
  Delete();
  fscanf(f,"%ld",&n);
  M=n<<1;
  long i,v,w,x;
  G=new TEdge[M]; g=new TEdge*[n];
  memset(g,0,n*sizeof(TEdge*)); m=0;
  for (i=1; i<n; i++) {
    fscanf(f,"%ld%ld%ld",&v,&w,&x); v--; w--;
    G[m].u=w; G[m].x=x; G[m].z=g[v]; g[v]=&G[m++];
    G[m].u=v; G[m].x=x; G[m].z=g[w]; g[w]=&G[m++];
  }
  q=new long[n+2]; r0=new long[n]; r1=new long[n];
}
void TGraph::print(FILE*f) {
  fprintf(f,"%ld %ld",a[0]+1,a[1]+1);
}

