{$D-,L-,Q-,R-,S-,I-}
Program pr_b;
Uses SysUtils;
const
  inpfile='cows.in';
  outfile='cows.out';
  sec=24*60*60;
  tl=1.7;
  inf=1e40;
  eps=1e-6;
  nm=300005;
type
  Rebr=record
    x,y : LongInt;
    c : Extended;
  end;
var
  a : array [0..nm] of Rebr;
  p : array [0..nm] of LongInt;
  d1,d2 : array [1..nm] of Extended;
  u1,u2 : array [1..nm] of Boolean;
  n,m,ur,vr : LongInt;
  start : Extended;
{}
Procedure Inp;
var
  i : LongInt;
begin
  assign(input,inpfile);
  reset(input);
  read(n); m:=n-1;
  for i:=1 to m do begin
    read(a[i].x,a[i].y,a[i].c);
    a[i+m].y:=a[i].x;
    a[i+m].x:=a[i].y;
    a[i+m].c:=a[i].c;
  end;
end;
{}
Procedure Out;
begin
  assign(output,outfile);
  rewrite(output);
  writeln(ur,' ',vr);
  close(output);
  halt;
end;
{}
Procedure Init;
begin
  fillchar(a,sizeof(a),0);
  fillchar(p,sizeof(p),0);
  fillchar(u1,sizeof(u1),0);
  fillchar(u2,sizeof(u2),0);
  fillchar(d1,sizeof(d1),0);
  fillchar(d2,sizeof(d2),0);
end;
{}
Procedure CountP;
var
  i,j : LongInt;
begin
  for i:=1 to 2*m do begin
    p[a[i].x]:=i;
    if a[i].x<>a[i-1].x then
      for j:=a[i-1].x+1 to a[i].x-1 do p[j]:=i-1;
  end;
end;
{}
Procedure Swap(var q,w : Rebr);
var
  bak : Rebr;
begin
  bak:=q;
  q:=w;
  w:=bak;
end;
{}
Procedure Sort(l,r: LongInt);
var
  i,j,x : LongInt;
begin
  i:=l; j:=r; x:=a[(l+r) div 2].x;
  repeat
    while a[i].x<x do inc(i);
    while x<a[j].x do dec(j);
    if not(i>j) then begin
      Swap(a[i],a[j]);
      inc(i); j:=j-1;
    end;
  until i>j;
  if l<j then Sort(l,j);
  if i<r then Sort(i,r);
end;
{}
Procedure Dfs1(x : LongInt; h : Extended);
var
  i : LongInt;
begin
  u1[x]:=true; d1[x]:=h;
  for i:=p[x-1]+1 to p[x] do
    if not u1[a[i].y] then Dfs1(a[i].y,h+a[i].c);
end;
{}
Procedure Dfs2(x : LongInt; h : Extended);
var
  i : LongInt;
begin
  u2[x]:=true; d2[x]:=h;
  for i:=p[x-1]+1 to p[x] do
    if not u2[a[i].y] then Dfs2(a[i].y,h+a[i].c);
end;
{}
Function Min(q,w : Extended) : Extended;
begin
  if w-q>eps then min:=q else min:=w;
end;
{}
Function Max(q,w : Extended) : Extended;
begin
  if q-w>eps then max:=q else max:=w;
end;
{}
Procedure Solve;
var
  i,j,k : LongInt;
  res,rn : Extended;
begin
  res:=inf; ur:=1; vr:=2;

  Sort(1,2*m); CountP;
  for i:=2 to n do
    for j:=1 to i-1 do begin
      if (now-start)*sec>=tl then Out;
      rn:=0;
      fillchar(u1,sizeof(u1),0);
      fillchar(u2,sizeof(u2),0);
      Dfs1(i,0); Dfs2(j,0);
      for k:=1 to n do
        d1[k]:=min(d1[k],d2[k]);
      for k:=1 to n do
        rn:=max(rn,d1[k]);
      if rn<res then begin
        res:=rn; vr:=i; ur:=j;
      end;
    end;
end;
{}
Begin
  start:=now;
  Init;
  Inp;
  Solve;
  Out;
End.
