{
  Dmitry Orlov
    SARATOV
    id = 33
}


{.$define debug}

{$R-,Q-,S-,I-,N+}
{$M 30000000, 30000000}


program CowTree;
const
 nmax = 101000;
 inf = 1500000000;
 {$ifdef debug}
 cinfile = 'input.txt';
 coutfile = 'output.txt';
 {$else}
 cinfile = 'cows.in';
 coutfile= 'cows.out';
 {$endif}
type
 int = longint;
 real = extended;
 tptr = ^tlist;
 tlist = record
  inf :int;
  w :int;
  next :tptr;
 end;
 tarray = array [1..nmax] of int;
var
 n :int;
 gr :array [1..nmax] of tptr;
 cow :array [1..2] of int;
 result :array [1..2] of int;
 excellent :boolean;
 paint :array [1..nmax] of boolean;
 state :array [1..nmax] of int;
 center :int;

procedure init;
begin
 fillchar (gr,sizeof(gr),0);
 result[1] := 1;
 result[2] := 2;
 excellent := false;
 fillchar (paint,sizeof(paint),0);
 fillchar (state,sizeof(state),0);
end;

procedure add (var list :tptr; value :int; w :int);
var x :tptr;
begin
 new(x);
 x^.inf := value;
 x^.w := w;
 x^.next := list;
 list := x;
end;

procedure readdata;
var i,j :int;
    u,v,z :int;
begin
 assign (input,cinfile);
 reset (input);
 read (n);
 for i := 1 to n-1 do
  begin
   read (u,v,z);
   add (gr[u],v,z);
   add (gr[v],u,z);
  end;
 close (input);
end;

procedure outdata;
var i,j :int;
begin
 assign (output,coutfile);
 rewrite (output);
 if result[1] > result[2] then
  begin
   result[1] := result[1] xor result[2];
   result[2] := result[1] xor result[2];
   result[1] := result[1] xor result[2];
  end;
 writeln (result[1],' ',result[2]);
 close (output);
end;

function dfs (v :int; from :int):int;
var x :tptr;
    res,t :int;
begin
 if paint[v] then
  begin
   dfs := state[v];
   exit;
  end;
 paint[v] := true;
 res := 0;
 x := gr[v];
 while not (x = nil) do
  begin
   if not (x^.inf = from) then
    begin
     t := x^.w + dfs(x^.inf,v);
     if t > res then
      res := t;
    end;
   x := x^.next;
  end;
 state[v] := res;
 dfs := res;
end;

procedure bfs (start :int; var d :tarray);
var used :array [1..nmax] of boolean;
    q :array [1..nmax] of int;
    cur :int; w,t :int; x :tptr;

procedure add (v :int; from :int; w :int);
begin
 if used[v] then
  exit;
 used[v] := true;
 inc(t);
 q[t] := v;
 d[v] := d[from] + w;
end;

begin
 fillchar (used,sizeof(used),0);
 fillchar (d,sizeof(d),0);
 q[1] := start;
 t := 1;
 w := 1;
 used[start] := true;
 while w <= t do
  begin
   cur := q[w];
   inc(w);
   x := gr[cur];
   while not (x = nil) do
    begin
     add (x^.inf,cur,x^.w);
     x := x^.next;
    end;
  end;
end;

function put (start :int; dst :int; rib :int):int;
var q :array [1..nmax] of int;
    used :array [1..nmax] of boolean;
    prev :array [1..nmax] of int;
    w,t :int; cur :int; x :tptr;
    d :array [1..nmax] of int;
    max :int; i,j :int;

procedure add (v :int; from :int; w :int);
begin
 used[v] := true;
 prev[v] := from;
 d[v] := d[from] + w;
 inc(t);
 q[t] := v;
end;


begin
 fillchar (used,sizeof(used),0);
 fillchar (prev,sizeof(prev),0);
 fillchar (d,sizeof(d),0);
 q[1] := start;
 used[start] := true;
 w := 1;
 t := 1;
 while w <= t do
  begin
   cur := q[w];
   inc(w);
   x := gr[cur];
   while not (x = nil) do
    begin
     if not (x^.inf = center) and not used[x^.inf] then
      add (x^.inf,cur,x^.w);
     x := x^.next;
    end;
  end;
 cur := start;
 max := 0;
 for i := 1 to n do
  if d[i] > max then
   begin
    max := d[i];
    cur := i;
   end;
 while max - d[cur] < dst do
  begin
   if cur = start then
    break;
   t := cur;
   cur := prev[cur];
   if max - d[cur] > dst then
    begin
     cur := t;
     break;
    end;
  end;
 if (cur = start) and (max + rib <= dst) then
  cur := center;
 put := cur;
end;

procedure solve;
var i,j :int;
    d,d_ :tarray;
    max :int; cur :int;
    t :int;
    r :array [1..2] of int;
    vl :array [1..2] of int;
    wr :array [1..2] of int;
    lo,hi,mid :int;
    x :tptr;

function good (x :int):boolean;
var d :array [1..2] of tarray;
    i,j,t,max :int;
begin
 cow[1] := put(r[1],x,wr[1]);
 cow[2] := put(r[2],x,wr[2]);
 bfs (cow[1],d[1]);
 bfs (cow[2],d[2]);
 max := 0;
 for i := 1 to n do
  begin
   if d[1][i] < d[2][i] then
    t := d[1][i]
   else
    t := d[2][i];
   if t > max then
    max := t;
  end;
 if max <= x then
  begin
   good := true;
   move (cow,result,sizeof(result));
   excellent := true;
  end
 else
  good := false;
end;


begin
 if n = 2 then
  exit;
 bfs (1,d);
 max := 0;
 cur := 0;
 for i := 1 to n do
  if d[i] > max then
   begin
    max := d[i];
    cur := i;
   end;
 bfs (cur,d);
 max := 0;
 cur := 0;
 for i := 1 to n do
  if d[i] > max then
   begin
    max := d[i];
    cur := i;
   end;
 bfs (cur,d_);
 max := inf;
 cur := 0;
 for i := 1 to n do
  begin
   if d[i] > d_[i] then
    t := d[i]
   else
    t := d_[i];
   if t < max then
    begin
     max := t;
     cur := i;
    end;
  end;
 center := cur;
{ writeln (center);}
 fillchar (r,sizeof(r),0);
 fillchar (wr,sizeof(wr),0);
 vl[1] := -1;
 vl[2] := -1;
 dfs (center,0);
 x := gr[center];
 while not (x = nil) do
  begin
   if state[x^.inf] > vl[1] then
    begin
     if vl[1] > vl[2] then
      begin
       vl[2] := vl[1];
       r[2] := r[1];
       wr[2] := wr[1];
      end;
     vl[1] := state[x^.inf];
     r[1] := x^.inf;
     wr[1] := x^.w;
    end
   else
    if state[x^.inf] > vl[2] then
     begin
      vl[2] := state[x^.inf];
      r[2] := x^.inf;
      wr[2] := x^.w;
     end;
   x := x^.next;
  end;
 lo := 1;
 hi := max;
{ writeln (r[1],' ',r[2],' ',lo,' ',hi);}
 while hi-lo > 1 do
  begin
   mid := (lo+hi) shr 1;
   if good (mid) then
    hi := mid
   else
    lo := mid;
  end;
 if not excellent then
  begin
   good(hi);
   good(lo);
   if not excellent then
    result[1] := center;
  end;
 if result[1] = result[2] then
  result[2] := result[2] mod n + 1;
end;

begin
 init;
 readdata;
 solve;
 outdata;
end.