{.$define debug}

{$R-,Q-,S-,I-,N+}


program template;
const
 nmax = 101000;
 cl :array [1..3] of char = ('R','G','B');
 {$ifdef debug}
 cinfile = 'input.txt';
 coutfile = 'output.txt';
 {$else}
 cinfile = 'perm.in';
 coutfile= 'perm.out';
 {$endif}
type
 int = longint;
 real = extended;
 tp = array [1..nmax] of int;
 tptr = ^tnode;
 tnode = record
  inf :int;
  l,r :tptr;
 end;
var
 n :int;
 a,b :tp;
 a_1 :tp;
 c :tp;
 tree :tptr;
 color :tp;
 result :tp;

procedure init;
begin
 fillchar (a,sizeof(a),0);
 fillchar (b,sizeof(b),0);
 fillchar (c,sizeof(c),0);
 fillchar (a_1,sizeof(a_1),0);
 fillchar (color,sizeof(color),0);
 fillchar (result,sizeof(result),0);
 tree := nil;
end;

procedure readdata;
var i,j :int;
begin
 assign (input,cinfile);
 reset (input);
 read (n);
 for i := 1 to n do
  read (a[i]);
 for i := 1 to n do
  read (b[i]);
 close (input);
end;

procedure outdata;
var i,j :int;
begin
 assign (output,coutfile);
 rewrite (output);
 for i := 1 to n do
  write (cl[result[i]]);
 close (output);
end;

procedure build (var node :tptr; lo,hi :int);
begin
 new (node);
 node^.inf := 0;
 if lo = hi then
  begin
   node^.l := nil;
   node^.r := nil;
   exit;
  end;
 build (node^.l,lo,(lo+hi) shr 1);
 build (node^.r,(lo+hi) shr 1 + 1,hi);
end;

function max (a,b :int):int;
begin
 if a > b then
  max := a
 else
  max := b;
end;

function add (node :tptr; lo,hi :int; pos :int; reach :int):int;
begin
 if lo = hi then
  begin
   add := reach;
   node^.inf := reach;
   exit;
  end;
 if pos <= (lo+hi) shr 1 then
  add := add (node^.l,lo,(lo+hi) shr 1,pos,
   max(reach,node^.r^.inf+1))
  else
  add := add (node^.r,(lo+hi) shr 1 + 1,hi,pos,reach);
 node^.inf := max (node^.l^.inf,node^.r^.inf);
end;

procedure outno;
begin
 assign (output,coutfile);
 rewrite (output);
 writeln ('NO');
 close (output);
 halt;
end;

procedure solve;
var i,j :int;
begin
 for i := 1 to n do
  a_1[a[i]] := i;
 for i := 1 to n do
  c[i] := a_1[b[i]];
 build (tree,1,n);
 for i := 1 to n do
  begin
   color[i] := add (tree,1,n,c[i],1);
   if color[i] > 3 then
    outno;
  end;
 for i := 1 to n do
  result[b[i]] := color[i];
end;

begin
 init;
 readdata;
 solve;
 outdata;
end.