program Strange_Game;
{$N+}
const
  MAXN = 100000; {100000}

var
  n, a, b, l, c, ql, qr : longint;
  e : array [0..MAXN-1,1..3] of longint;
  q, prev, d : array [0..MAXN] of longint;

procedure Load(infile, outfile : string);
begin
  assign(input,infile);
  reset(input);
  assign(output,outfile);
  rewrite(output);
  read(n,a,b);
end;

function Mul(x, y : longint) : longint;
var
  z : comp;
begin
  z := x;
  z := z * y;
  z := z - 1.0 * n * trunc(z/n);
  Mul := trunc(z);
end;

procedure relax(a : longint);
begin
  if d[a]=-1 then
  begin
    d[a] := l+1;
    prev[a] := c;
    inc(qr);
    q[qr] := a;
  end;
end;

procedure Solve;
var
  i : longint;
begin
  for i:=0 to n-1 do
  begin
    e[i,1] := (i+1) mod n;
    e[i,2] := (mul(i,i)+1) mod n;
    e[i,3] := (mul(i,mul(i,i))+1) mod n;
  end;

  ql := 1;
  qr := 1;
  q[1] := a;
  fillchar(prev,sizeof(prev),255);
  fillchar(d,sizeof(d),255);
  d[a] := 0;
  while qr>=ql do
  begin
    c := q[ql];
    inc(ql);
    l := d[c];
    relax(e[c,1]);
    relax(e[c,2]);
    relax(e[c,3]);
  end;
end;

procedure Save;
var
  w : array [1..MAXN] of longint;
  i : longint;
begin
  if d[b]=-1 then
    writeln(-1)
  else
  begin
    writeln(d[b]);
    w[d[b]+1] := b;
    for i:=d[b] downto 1 do
      w[i] := prev[w[i+1]];
    for i:=1 to d[b]+1 do
      write(w[i],' ');
    writeln;
  end;
  close(input);
  close(output);
end;

begin
  Load('game.in','game.out');
  Solve;
  Save;
end.