#include <stdio.h>
#include <string.h>

FILE*fi,*fo;

struct TEdge {
  int u;
  TEdge*z;
};

class TGraph {
  private:
    int n,N,m,c;
    TEdge*G,**g;
    int*q,*r0,*r1;
    void search(int,int*);
  public:
    TGraph(void);
    ~TGraph();
    void Delete(void);
    void scan(FILE*);
    void print(FILE*);
    void find(void);
};

TGraph g;

int main(void) {
  fi=fopen("tree.in","rt");
  g.scan(fi);
  fclose(fi);
  g.find();
  fo=fopen("tree.out","wt");
  g.print(fo);
  fclose(fo);
  return(0);
}


void TGraph::search(int u,int*r) {
  int l,i,v,w; TEdge*x;
  memset(r,-1,n*sizeof(int));
  q[0]=u; r[u]=0; l=1;
  for (i=0; i<l; i++) {
    v=q[i];
    for (x=g[v]; x; x=x->z) {
      w=x->u;
      if (r[w]<0) { q[l]=w; r[w]=r[v]+1; l++; }
    }
  }
}
void TGraph::find(void) {
  int u,v,w,x;
  search(0,r1);
  v=-1; x=-1; for (u=0; u<n; u++) if (x<r1[u]) { v=u; x=r1[u]; }
  search(v,r0);
  w=-1; x=-1; for (u=0; u<n; u++) if (x<r0[u]) { w=u; x=r0[u]; }
  search(w,r1);
  for (u=0; u<n; u++) if (r0[u]<r1[u]) r0[u]=r1[u];
  x=n+1; for (u=0; u<n; u++) if (x>r0[u]) x=r0[u];
  c=0; for (u=0; u<n; u++) if (r0[u]<=x) q[c++]=u;
}

TGraph::TGraph(void) {
  G=0; g=0;
  q=0; r0=0; r1=0;
}
TGraph::~TGraph() {
  Delete();
}
void TGraph::Delete(void) {
  if (G) delete[]G; if (g) delete[]g;
  if (q) delete[]q; if (r0) delete[]r0; if (r1) delete[]r1;
}
void TGraph::scan(FILE*f) {
  Delete();
  int i,v,w;
  fscanf(f,"%d",&n);
  N=n<<1;
  G=new TEdge[N]; g=new TEdge*[n];
  memset(g,0,n*sizeof(TEdge*)); m=0;
  for (i=1; i<n; i++) {
    fscanf(f,"%d%d",&v,&w); v--; w--;
    G[m].u=w; G[m].z=g[v]; g[v]=&G[m]; m++;
    G[m].u=v; G[m].z=g[w]; g[w]=&G[m]; m++;
  }
  q=new int[n+2]; r0=new int[n]; r1=new int[n];
}
void TGraph::print(FILE*f) {
  int i;
  fprintf(f,"%d\n",c);
  for (i=0; i<c; i++) {
    if (i) fprintf(f," ");
    fprintf(f,"%d",q[i]+1);
  }
}


