#include <stdio.h>

FILE*fi,*fo;

#define INF ((int)15360)

class TGraph {
  private:
    int n,N;
    long m;
    int*G,**g;
    void add(int,int,int);
    int get(int,int);
  public:
    TGraph(void);
    ~TGraph();
    void Delete(void);
    void scan(FILE*);
    void process(FILE*,FILE*);
};

TGraph g;

int main(void) {
  fi=fopen("graph.in","rt");
  g.scan(fi);
  fo=fopen("graph.out","wt");
  g.process(fi,fo);
  fclose(fo);
  fclose(fi);
  return(0);
}


void TGraph::add(int v,int w,int x) {
  if (g[v][w]<=x) return;
  int i,j;
  g[v][w]=x;
  for (i=0; i<n; i++)
    if (g[i][v]+g[v][w]<g[i][w]) g[i][w]=g[i][v]+g[v][w];
  for (i=0; i<n; i++)
    if (g[v][w]+g[w][i]<g[v][i]) g[v][i]=g[v][w]+g[w][i];
  for (i=0; i<n; i++) for (j=0; j<n; j++)
    if (g[i][w]+g[w][j]<g[i][j]) g[i][j]=g[i][w]+g[w][j];
}
int TGraph::get(int v,int w) {
  return(g[v][w]);
}

TGraph::TGraph(void) {
  G=0; g=0;
}
TGraph::~TGraph() {
  Delete();
}
void TGraph::Delete(void) {
  if (G) delete[]G; if (g) delete[]g;
}
void TGraph::scan(FILE*f) {
  Delete();
  int i,j;
  fscanf(f,"%d%ld",&n,&m);
  N=n*n;
  G=new int[N]; g=new int*[n];
  for (i=0,j=0; i<n; i++,j+=n) g[i]=&G[j];
  for (i=0; i<n; i++) for (j=0; j<n; j++) g[i][j]=INF;
  for (i=0; i<n; i++) g[i][i]=0;
}
void TGraph::process(FILE*finp,FILE*fout) {
  long k;
  int t,v,w,x;
  for (k=0; k<m; k++) {
    fscanf(finp,"%d%d%d",&t,&v,&w); t--; v--; w--;
    if (!t) {
      fscanf(finp,"%d",&x);
      add(v,w,x);
    } else {
      x=get(v,w);
      if (x<INF) fprintf(fout,"%d\n",x);
      else fprintf(fout,"-1\n");
    }
  }
}

