#include <stdio.h>
#include <string.h>

FILE*fi,*fo;

struct TEdge {
  int u;
  TEdge*z;
};

class TGraph {
  private:
    int n;
    long N,m,e;
    TEdge*G,**g;
    long*H,**h;
    long*c;
    int*q,*s;
  public:
    TGraph(void);
    ~TGraph();
    void Delete(void);
    void scan(FILE*);
    void print(FILE*);
    void travel(void);
};

TGraph g;

int main(void) {
  fi=fopen("input.txt","rt");
  g.scan(fi);
  fclose(fi);
  g.travel();
  fo=fopen("output.txt","wt");
  g.print(fo);
  fclose(fo);
  return(0);
}


void TGraph::travel(void) {
  int v,w; long l;
  for (v=0; v<n; v++) if (c[v]&1) break;
  e=0;
  if (v>=n) v=0;
  q[0]=v; l=0;
  while (l>=0) {
    v=q[l];
    while ((g[v])&&(h[v][g[v]->u]<=0)) g[v]=g[v]->z;
    if (g[v]) {
      w=g[v]->u;
      q[++l]=w;
      h[v][w]--; h[w][v]--;
      g[v]=g[v]->z;
    } else {
      s[e++]=v;
      l--;
    }
  }
}

TGraph::TGraph(void) {
  G=0; g=0;
  H=0; h=0;
  c=0;
  q=0; s=0;
}
TGraph::~TGraph() {
  Delete();
}
void TGraph::Delete(void) {
  if (G) delete[]G; if (g) delete[]g;
  if (H) delete[]H; if (h) delete[]h;
  if (c) delete[]c;
  if (q) delete[]q; if (s) delete[]s;
}
void TGraph::scan(FILE*f) {
  Delete();
  int i,j;
  long k,l,z;
  fscanf(f,"%d",&n);
  N=(((long)n)*((long)n));
  G=new TEdge[N<<1]; g=new TEdge*[n];
  H=new long[N]; h=new long*[n];
  for (i=0,l=0; i<n; i++,l+=(long)n) h[i]=&H[l];
  c=new long[n];
  memset(g,0,n*sizeof(TEdge*));
  memset(H,0,N*sizeof(long));
  memset(c,0,n*sizeof(long));
  m=0;
  for (i=0; i<n; i++) {
    fscanf(f,"%ld",&k);
    for (l=0; l<k; l++) {
      fscanf(f,"%d%ld",&j,&z); j--;
      G[m].u=j; G[m].z=g[i]; g[i]=&G[m]; m++;
      h[i][j]++;
      c[i]++;
    }
  }
  q=new int[m+2]; s=new int[m+2];
}
void TGraph::print(FILE*f) {
  long i;
  fprintf(f,"%ld\n",e-1);
  for (i=0; i<e; i++) {
    if (i) fprintf(f," ");
    fprintf(f,"%d",s[i]+1);
  }
}

