{$D-,L-,Q-,R-,S-,I-,N+}
Program pr_f;
const
  inpfile='convexh.in';
  outfile='convexh.out';
  eps=1e-6;
  nm=1205;
  mm=nm*nm div 2;
type
  Point=record
    x,y : Real;
  end;
var
  a,b : array [1..nm] of Point;
  c,r : array [0..mm] of Point;
  v,d : array [0..mm] of Real;
  res : Extended;
  cn,rn : LongInt;
  n : LongInt;
{}
Procedure Inp;
var
  i : LongInt;
begin
  assign(input,inpfile);
  reset(input);
  read(n);
  for i:=1 to n do
    read(a[i].x,a[i].y,b[i].x,b[i].y);
end;
{}
Procedure Out;
begin
  assign(output,outfile);
  rewrite(output);
  writeln(res:0:10);
  close(output);
  halt;
end;
{}
Procedure Init;
begin
  fillchar(a,sizeof(a),0);
  fillchar(b,sizeof(b),0);
  fillchar(c,sizeof(c),0);
  fillchar(r,sizeof(r),0);
end;
{}
Function Vc(a,b,c,d : Point) : Real;
begin
  Vc:=(b.x-a.x)*(d.y-c.y)-(b.y-a.y)*(d.x-c.x);
end;
{}
Procedure MoveToVect(var p : Point; p0 : Point; dx,dy : Real);
begin
  p.x:=p0.x+dx;
  p.y:=p0.y+dy;
end;
{}
Function Len(q,w : Point) : Real;
begin
  Len:=sqrt(sqr(q.x-w.x)+sqr(q.y-w.y));
end;
{}
Procedure Cross(var m : Point; q,w : LongInt);
var
  ab,am : Real;
begin
  ab:=Len(a[q],b[q]);
  am:=Vc(a[w],a[q],a[w],b[w])/Vc(b[q],a[q],a[w],b[w])*ab;
  MoveToVect(m,a[q],am*(b[q].x-a[q].x)/ab,am*(b[q].y-a[q].y)/ab);
end;
{}
Procedure SwapP(var q,w : Point);
var
  bak : Point;
begin
  bak:=q;
  q:=w;
  w:=bak;
end;
{}
Procedure SwapE(var q,w : Real);
var
  bak : Real;
begin
  bak:=q;
  q:=w;
  w:=bak;
end;
{}
Procedure Sort(l,r: LongInt);
var
  i,j,m : LongInt;
  x : Real;
begin
  i:=l; j:=r; m:=(l+r) div 2; x:=v[m];
  repeat
    while (v[i]+eps<x) or (abs(v[i]-x)<eps) and (d[i]+eps<d[m]) do inc(i);
    while (x+eps<v[j]) or (abs(v[j]-x)<eps) and (d[m]+eps<d[j]) do dec(j);
    if not (i>j) then begin
      SwapP(c[i],c[j]);
      SwapE(v[i],v[j]);
      SwapE(d[i],d[j]);
      inc(i); j:=j-1;
    end;
  until i>j;
  if l<j then Sort(l,j);
  if i<r then Sort(i,r);
end;
{}
{}
Procedure Solve;
var
  i,j,ni : LongInt;
  nl,ed : Point;
  dx,dy : Real;
begin
  for i:=1 to n do begin
    dx:=(a[i].x-b[i].x)*100; dy:=(a[i].y-b[i].y)*100;
    MoveToVect(a[i],a[i],dx,dy);
    MoveToVect(b[i],b[i],-dx,-dy);
  end;

  for i:=1 to n-1 do
    for j:=i+1 to n do begin
      inc(cn); Cross(c[cn],i,j);
    end;

  nl.x:=-1e10; nl.y:=1e10;
  for i:=1 to cn do begin
    if (c[i].y+eps<nl.y) or (abs(c[i].y-nl.y)<eps) and (c[i].x-eps>nl.x) then begin
      nl:=c[i]; ni:=i;
    end;
  end;

  ed.x:=nl.x+1; ed.y:=nl.y;
  for i:=1 to cn do begin
    d[i]:=Len(nl,c[i]);
    if i<>ni then v[i]:=Vc(nl,c[i],nl,ed)/d[i];
  end;
  v[ni]:=1e5;
  Sort(1,cn);

  rn:=1; r[0]:=nl; j:=2;
  while (abs(v[1]-v[j])<eps) do begin
    inc(j); if j>n then break;
  end;
  r[1]:=c[j-1];
  for i:=j to cn do begin
    while Vc(r[rn-1],r[rn],r[rn],c[i])<eps do dec(rn);
    inc(rn); r[rn]:=c[i];
  end;
  res:=0;
  for i:=1 to rn do
    res:=res+(r[i-1].x*r[i].y-r[i-1].y*r[i].x);
  res:=res/2;
end;
{}
Begin
  Init;
  Inp;
  Solve;
  Out;
End.
