program Smooth_Flow;
{$N+}

const
  MAXN = 100; {100}
  MAXM = 5000; {5000}
  EPS = 1e-10;

var
  n, m : integer;
  mat : array [0..MAXN,1..MAXN+1] of extended;
  c : array [1..MAXN,1..MAXN] of longint;
  aa, bb : array [1..MAXM] of integer;
  x : array [1..MAXN] of extended;
  v : array [1..MAXN] of boolean;

procedure Load(infile, outfile : string);
var
  i, j, a, b, c1 : longint;
begin
  assign(input,infile);
  reset(input);
  assign(output,outfile);
  rewrite(output);
  fillchar(c,sizeof(c),255);
  read(n,m);
  for i:=1 to n-2 do
    for j:=1 to n-1 do
      mat[i,j] := 0;
  for i:=1 to m do
  begin
    read(a,b,c1);
    aa[i] := a;
    bb[i] := b;
    if (a>1) and (a<n) then
    begin
      mat[a-1,a-1] := mat[a-1,a-1] + 1;
      if b>1 then
        mat[a-1,b-1] := mat[a-1,b-1] - 1;
    end;
    if (b>1) and (b<n) then
    begin
      mat[b-1,b-1] := mat[b-1,b-1] + 1;
      if a>1 then
        mat[b-1,a-1] := mat[b-1,a-1] - 1;
    end;
    if (c[a,b]=-1) or (c[a,b]>c1) then
    begin
      c[a,b] := c1;
      c[b,a] := c1;
    end;
  end;
  for i:=1 to n-2 do
    mat[i,n-1] := -mat[i,n-1];
end;

procedure dfs(a : integer);
var
  b : integer;
begin
  v[a] := true;
  for b:=1 to n do
    if (c[a,b]<>-1) and not v[b] then
      dfs(b);
end;

procedure Solve;
var
  i, j, k, t :  integer;
begin
  fillchar(x,sizeof(x),0);
  fillchar(v,sizeof(v),0);
  dfs(1);
  if not v[n] then
    exit;
  for i:=1 to n-2 do                            {Gauss}
  if v[i+1] then
  begin
    t := i;
    for j:=i+1 to n-2 do
      if v[j+1] and (abs(mat[j,i])>abs(mat[t,i])) then
        t := j;
    if abs(mat[t,i])<eps then
      exit;
    mat[0] := mat[i];
    mat[i] := mat[t];
    mat[t] := mat[0];
    for j:=i+1 to n-2 do
      for k:=n-1 downto i do
        mat[j,k] := mat[j,k] - mat[j,i] * mat[i,k] / mat[i,i];
  end;
  x[n] := 1;
  x[1] := 0;
  if (n>2) and v[n-1] then
    x[n-1] := mat[n-2,n-1]/mat[n-2,n-2];
  for i:=n-3 downto 1 do
    if v[i+1] then
    begin
      x[i+1] := mat[i,n-1];
      for j:=n-2 downto i+1 do
        if v[j+1] then
          x[i+1] := x[i+1] - x[j+1] * mat[i,j];
      x[i+1] := x[i+1] / mat[i,i];
    end;
end;

procedure Save;
var
  i, j : integer;
  t : extended;
begin
  if not v[n] then
  begin
    writeln(0);
    for i:=1 to m do
      writeln(0);
  end
  else
  begin
    t := -1;
    for i:=1 to n do
      for j:=1 to n do
        if v[i] and v[j] and (c[i,j]>=0) and (x[i]-x[j]>eps) and ((t<0) or ((x[i]-x[j])*t>eps+c[i,j])) then
          t := c[i,j]/(x[i]-x[j]);
    if t<0 then
      t := 0;
    for i:=1 to n do
      x[i] := x[i] * t;
    t := 0;
    for i:=1 to m do
      if aa[i]=1 then
        t := t + x[bb[i]];
    for i:=1 to m do
      if bb[i]=1 then
        t := t + x[aa[i]];
    writeln(t:0:4);
    for i:=1 to m do
      writeln((x[bb[i]]-x[aa[i]]):0:4);
  end;
  close(input);
  close(output);
end;

begin
  Load('flow.in','flow.out');
  Solve;
  Save;
end.
