program Parking_Lot;

const
  MAXN = 100000; {100000}

var
  n, m, hs : longint;
  s, c : array [1..MAXN] of longint;
  h : array [1..MAXN*2] of longint;
  t : array [-MAXN..MAXN] of longint;
  ans : array [1..MAXN] of longint;

procedure swap(a, b : longint);
var
  temp : longint;
begin
  temp := h[a];
  h[a] := h[b];
  h[b] := temp;
end;

procedure heapify(a : longint);
var
  l : longint;
begin
  l := a;
  if (2*a<=hs) and (t[h[2*a]]>t[h[l]]) then
    l := 2*a;
  if (2*a+1<=hs) and (t[h[2*a+1]]>t[h[l]]) then
    l := 2*a+1;
  if l<>a then
  begin
    swap(l,a);
    heapify(l);
  end;
end;

procedure Load(infile, outfile : string);
var
  i : longint;
begin
  assign(input,infile);
  reset(input);
  assign(output,outfile);
  rewrite(output);
  read(n,m);
  for i:=1 to m do
  begin
    read(t[i],t[-i],c[i]);
    h[2*i-1] := i;
    h[2*i] := -i;
  end;
  hs := 2*m;
  for i:=hs downto 1 do
    heapify(i);
  while hs>1 do
  begin
    swap(1,hs);
    dec(hs);
    heapify(1);
  end;
end;

function cum(a : longint) : longint;
var
  t : longint;
begin
  t := 0;
  while (a>0) do
  begin
    t := t + s[a];
    a := a and (a-1);
  end;
  cum := t;
end;

function sum(a, b : longint) : longint;
begin
  sum := cum(b)-cum(a-1);
end;

procedure add(a, d : longint);
begin
  while a<=n do
  begin
    s[a] := s[a] + d;
    a := a + ((a xor (a-1)) and a);
  end;
end;

procedure Solve;
var
  i, l, r, med : longint;
begin
  for i:=1 to n do
    s[i] := (i xor (i-1)) and i;
  for i:=1 to 2*m do
    if h[i]>0 then
    begin
      if sum(c[h[i]],n)=0 then
      begin
        l := 1;
        r := c[h[i]]-1;
      end
      else
      begin
        l := c[h[i]];
        r := n;
      end;
      if sum(l,l)>0 then
        ans[h[i]] := l
      else
      begin
        while r-l>1 do
        begin
          med := (l+r) div 2;
          if sum(l,med)=0 then
            l := med
          else
            r := med;
        end;
        ans[h[i]] := r;
      end;
      add(ans[h[i]],-1);
    end
    else
    begin
      add(ans[-h[i]],1);
    end;
end;

procedure Save;
var
  i : longint;
begin
  for i:=1 to m do
    writeln(ans[i]);
  close(input);
  close(output);
end;

begin
  Load('parking.in','parking.out');
  Solve;
  Save;
end.
                  