program PolyLine;

const
  MAXN = 100; {100000}

var
  n, m1, m2 : longint;
  x, y, h1, h2 : array [1..MAXN] of longint;

procedure Load(infile, outfile : string);
var
  i, x1, y1 : longint;
begin
  assign(input,infile);
  reset(input);
  assign(output,outfile);
  rewrite(output);
  read(n);
  for i:=1 to n do
  begin
    read(x1,y1);
    x[i] := x1+y1;
    y[i] := y1-x1;
  end;
end;

procedure swap1(a, b : longint);
var
  t : longint;
begin
  t := h1[a];
  h1[a] := h1[b];
  h1[b] := t;
end;

function greater1(a, b : longint) : boolean;
begin
  greater1 := (y[a]>y[b]) or ((y[a]=y[b]) and (x[a]>x[b]));
end;

procedure heapify1(a : longint);
var
  l : longint;
begin
  l := a;
  if (2*a<=m1) and greater1(h1[2*a],h1[l]) then
    l := 2*a;
  if (2*a+1<=m1) and greater1(h1[2*a+1],h1[l]) then
    l := 2*a+1;
  if l<>a then
  begin
    swap1(l,a);
    heapify1(l);
  end;
end;

procedure heapsort1;
var
  i : longint;
begin
  m1 := n;
  for i:=1 to m1 do
    h1[i] := i;
  for i:=m1 downto 1 do
    heapify1(i);
  while m1>1 do
  begin
    swap1(1,m1);
    dec(m1);
    heapify1(1);
  end;
end;

procedure swap2(a, b : longint);
var
  t : longint;
begin
  t := h2[a];
  h2[a] := h2[b];
  h2[b] := t;
end;

function greater2(a, b : longint) : boolean;
begin
  greater2 := (x[a]>x[b]) or ((x[a]=x[b]) and (y[a]>y[b]));
end;

procedure heapify2(a : longint);
var
  l : longint;
begin
  l := a;
  if (2*a<=m2) and greater2(h2[2*a],h2[l]) then
    l := 2*a;
  if (2*a+1<=m2) and greater2(h2[2*a+1],h2[l]) then
    l := 2*a+1;
  if l<>a then
  begin
    swap2(l,a);
    heapify2(l);
  end;
end;
                                                                                                                 `
procedure heapsort2;
var
  i : longint;
begin
  m2 := n;
  for i:=1 to m2 do
    h2[i] := i;
  for i:=m2 downto 1 do
    heapify2(i);
  while m2>1 do
  begin
    swap2(1,m2);
    dec(m2);
    heapify2(1);
  end;
end;

procedure Solve;
var
  i : longint;
begin
{  heapsort1;
  heapsort2;}
writeln(0);
end;

procedure Save;
begin
  close(input);
  close(output);
end;

begin
  Load('poly.in','poly.out');
  Solve;
  Save;
end.