#include <stdio.h>
#include <string.h>

FILE*fi,*fo;

struct TAction {
  int t;
  long h,x,k;
};
class TPlace {
  private:
    long n,N,m,mn;
    long*a;
    long findy(long,long);
    long findz(long,long);
  public:
    TPlace(void);
    ~TPlace();
    void Delete(void);
    void init(long);
    void set(long);
    void dec(long);
    void inc(long);
    long getz(long);
};

class TActions {
  private:
    long n,m,c;
    TAction*a;
    long*b;
    TPlace h;
    void heapifya(long,long);
    void sorta(void);
  public:
    TActions(void);
    ~TActions();
    void Delete(void);
    void scan(FILE*);
    void print(FILE*);
    void prepare(void);
    void process(void);
};

TActions g;

int main(void) {
  fi=fopen("parking.in","rt");
  g.scan(fi);
  fclose(fi);
  g.prepare();
  g.process();
  fo=fopen("parking.out","wt");
  g.print(fo);
  fclose(fo);
  return(0);
}


void TActions::prepare(void) {
  sorta();
  h.set(1);
}
void TActions::process(void) {
  long i,k;
  for (i=0; i<c; i++) {
    k=a[i].k;
    if (!a[i].t) {
      b[k]=h.getz(a[i].x);
      h.dec(b[k]);
    } else {
      h.inc(b[k]);
    }
  }
}

TActions::TActions(void) {
  a=0; b=0;
}
TActions::~TActions() {
  Delete();
}
void TActions::Delete(void) {
  if (a) delete[]a;
  if (b) delete[]b;
}
void TActions::scan(FILE*f) {
  Delete();
  long i,j,k,x,y,z;
  fscanf(f,"%ld%ld",&n,&m);
  c=m<<1;
  a=new TAction[c];
  for (k=0,i=0,j=1; k<m; k++,i+=2,j+=2) {
    fscanf(f,"%ld%ld%ld",&x,&y,&z); z--;
    a[i].t=0; a[i].h=x; a[i].x=z; a[i].k=k;
    a[j].t=1; a[j].h=y; a[j].x=z; a[j].k=k;
  }
  b=new long[m];
  h.init(n);
}
void TActions::print(FILE*f) {
  long i;
  for (i=0; i<m; i++) fprintf(f,"%ld\n",b[i]+1);
}
void TActions::heapifya(long v,long w) {
  long i,j; TAction z;
  i=v; j=(v<<1)+1;
  if ((j<w)&&(a[j].h<a[j+1].h)) j++;
  z=a[i];
  while ((j<=w)&&(z.h<a[j].h)) {
    a[i]=a[j];
    i=j; j=(j<<1)+1;
    if ((j<w)&&(a[j].h<a[j+1].h)) j++;
  }
  a[i]=z;
}
void TActions::sorta(void) {
  long i,j; TAction z;
  for (i=c>>1,j=c-1; i>0; i--) heapifya(i,j);
  for (; j>0; j--) {
    heapifya(i,j);
    z=a[i]; a[i]=a[j]; a[j]=z;
  }
}


void TPlace::set(long z) {
  long i,j;
  for (i=m; i<m+n; i++) a[i]=z;
  for (i=m-1; i>=0; i--) {
    j=(i<<1)+1;
    a[i]=a[j]+a[j+1];
  }
}
void TPlace::dec(long k) {
  long i;
  for (i=k+m; i>=0; i=(i-1)>>1) a[i]--;
}
void TPlace::inc(long k) {
  long i;
  for (i=k+m; i>=0; i=(i-1)>>1) a[i]++;
}
long TPlace::findy(long v,long w) {
  long u;
  if (a[v]>0) u=v; else u=w;
  if (u<m) u=findy((u<<1)+1,(u<<1)+2);
  return(u);
}
long TPlace::findz(long v,long w) {
  long u=-1;
  if (v>w) return(u);
  if (a[v]>0) u=v;
  else u=findz(v>>1,(w>>1)-1);
  if (u<0) if (a[w]>0) u=w;
  if (u<0) return(u);
  if (u<m) u=findy((u<<1)+1,(u<<1)+2);
  return(u);
}
long TPlace::getz(long k) {
  long i;
  i=findz(k+m,mn-1);
  if (i<0) i=findz(m,mn-1);
  i-=m;
  return(i);
}

TPlace::TPlace(void) {
  a=0;
}
TPlace::~TPlace() {
  Delete();
}
void TPlace::Delete(void) {
  if (a) delete[]a;
}
void TPlace::init(long n_) {
  Delete();
  long i,j;
  n=n_;
  for (N=2; N<n; N<<=1);
  m=N-1; mn=m+n; N<<=1;
  a=new long[N];
  memset(a,0,N*sizeof(long));
}

