{
  Dmitry Orlov
    SARATOV
    id = 33
}


{.$define debug}

{$R-,Q-,S-,I-,N+}


program template;
const
 nmax = 101000;
 phi :extended = pi/4;
 eps = 1e-6;
 {$ifdef debug}
 cinfile = 'input.txt';
 coutfile = 'output.txt';
 {$else}
 cinfile = 'poly.in';
 coutfile= 'poly.out';
 {$endif}
type
 int = longint;
 real = extended;
 tpoint = record
  x,y :real;
 end;
 tvector = array [1..nmax] of real;
 tarray = array [1..nmax] of int;
 newpoint = record
  x,y :int;
 end;
 hor = record
  x1,x2 :int;
  y :int;
 end;
 vert = record
  y1,y2 :int;
  x :int;
 end;
var
 n :int;
 p :array [1..nmax] of tpoint;
 np :array [1..nmax] of newpoint;
 xx,yy :tvector;
 xn,yn :tarray;
 ans :int;
 h :array [1..nmax] of hor;
 v :array [1..nmax] of vert;
 xbeg :array [1..nmax] of int;
 nh,nv :int;

procedure init;
begin
 ans := 0;
 randseed := 35182;
 fillchar (np,sizeof(np),0);
 fillchar (h,sizeof(h),0);
 fillchar (v,sizeof(v),0);
 fillchar (xbeg,sizeof(xbeg),0);
 nv := 0;
 nh := 0;
end;

procedure readdata;
var i,j :int;
    x,y :int;
begin
 assign (input,cinfile);
 reset (input);
 readln (n);
 for i := 1 to n do
  begin
   read (x,y);
   p[i].x := x*cos(phi) - y*sin(phi);
   p[i].y := x*sin(phi) + y*cos(phi);
  end;
 close (input);
end;

procedure outdata;
var i,j :int;
begin
 assign (output,coutfile);
 rewrite (output);
 writeln (ans);
 close (output);
end;

procedure swap (var a,b :real);
var tmp :real;
begin
 tmp := a;
 a := b;
 b := tmp;
end;

procedure quicksort (var b :tvector);

procedure sort (l,r :int);
var i,j :int;
    x :real;
begin
 i := l;
 j := r;
 x := b[l + random(r-l+1)];
 repeat
  while b[i] < x do
   inc(i);
  while b[j] > x do
   dec(j);
  if i <= j then
   begin
    swap (b[i],b[j]);
    inc(i);
    dec(j);
   end;
 until i > j;
 if i < r then
  sort (i,r);
 if j > l then
  sort (l,j);
end;

begin
 sort (1,n);
end;

procedure convert (var b :tvector; var num :tarray);
var i :int;
begin
 fillchar (num,sizeof(num),0);
 num[1] := 1;
 for i := 2 to n do
  if b[i] > b[i-1] + eps then
   num[i] := num[i-1] + 1
  else
   num[i] := num[i-1];
end;

function search (var b :tvector; value :real):int;
var l,r :int;
    mid :int;
begin
 l := 1;
 r := n;
 while r-l > 1 do
  begin
   mid := (l+r) shr 1;
   if b[mid] < value then
    l := mid
   else
    r := mid;
  end;
 if abs(b[l] - value) < eps then
  search := l
 else
  search := r;
end;

procedure swapint (var a,b :int);
begin
 a := a xor b;
 b := a xor b;
 a := a xor b;
end;

procedure swapvert (var a,b :vert);
var tmp :vert;
begin
 tmp := a;
 a := b;
 b := tmp;
end;

procedure sortit (l,r :int);
var i,j :int;
    x :int;
begin
 i := l;
 j := r;
 x := v[l + random(r-l+1)].x;
 repeat
  while v[i].x < x do
   inc(i);
  while v[j].x > x do
   dec(j);
  if i <= j then
   begin
    swapvert (v[i],v[j]);
    inc(i);
    dec(j);
   end;
 until i > j;
 if i < r then
  sortit (i,r);
 if l < j then
  sortit (l,j);
end;

procedure addhor (h :hor);
var i,j :int;
begin
 for i := xbeg[h.x1+1] to xbeg[h.x2]-1 do
  begin
   {$ifdef debug}
   if not (v[i].x > h.x1) or not (v[i].x < h.x2) then
    writeln ('kosyak');
   {$endif}
   if (v[i].y1 < h.y) and (v[i].y2 > h.y) then
    inc(ans);
  end;
end;

procedure solve;
var i,j :int;
begin
 for i := 1 to n do
  begin
   xx[i] := p[i].x;
   yy[i] := p[i].y;
  end;
 quicksort (xx);
 quicksort (yy);
 convert (xx,xn);
 convert (yy,yn);
 for i := 1 to n do
  begin
   np[i].x := xn[search (xx,p[i].x)];
   np[i].y := yn[search (yy,p[i].y)];
  end;
 for i := 1 to n-1 do
  if np[i].x = np[i+1].x then
   begin
    inc(nv);
    v[nv].x := np[i].x;
    v[nv].y1 := np[i].y;
    v[nv].y2 := np[i+1].y;
    if v[nv].y1 > v[nv].y2 then
     swapint (v[nv].y1,v[nv].y2);
   end
  else
   begin
    inc(nh);
    h[nh].y := np[i].y;
    h[nh].x1 := np[i].x;
    h[nh].x2 := np[i+1].x;
    if h[nh].x1 > h[nh].x2 then
     swapint (h[nh].x1,h[nh].x2);
   end;
 if nv = 0 then
  exit;
 sortit (1,nv);
 xbeg[v[1].x] := 1;
 for i := 2 to nv do
  if v[i].x > v[i-1].x then
   xbeg[v[i].x] := i;
 xbeg[v[nv].x+1] := nv+1;
 for i := 1 to nh do
  addhor (h[i]);
end;

begin
 init;
 readdata;
 solve;
 outdata;
end.