program CoolMerge;

const
  MAXN = 200; {200}

var
  n, ans, gn, realgn : integer;
  mat : array [1..MAXN,1..MAXN] of boolean;
  g, pred : array [1..MAXN] of integer;
  v1, v2 : array [1..MAXN] of boolean;
  ansa, ansb : array [1..MAXN*2] of integer;
  good : array [1..MAXN] of integer;

procedure Load(infile, outfile : string);
var
  i, m, a, b : longint;
begin
  assign(input,infile);
  reset(input);
  assign(output,outfile);
  rewrite(output);
  read(n,m);
  fillchar(mat,sizeof(mat),0);
  for i:=1 to m do
  begin
    read(a,b);
    mat[a,b] := true;
  end;
end;

procedure Solve;
var
  i, j, k, r, a, b : integer;
begin
  for j:=1 to n do
    for i:=1 to n do
      for k:=1 to n do
        mat[i,k] := mat[i,k] or (mat[i,j] and mat[j,k]);
  gn := 0;
  for i:=1 to n do
  begin
    for j:=1 to i do
      if mat[i,j] and mat[j,i] then
        break;
    if j=i then
    begin
      inc(gn);
      g[i] := gn;
      pred[gn] := i;
    end
    else
      g[i] := g[j];
  end;
  fillchar(v1,sizeof(v1),1);
  fillchar(v2,sizeof(v2),1);
  for i:=1 to n do
    for j:=1 to n do
      if (mat[i,j]) and (g[i]<>g[j]) then
      begin
        v1[g[j]] := false;
        v2[g[i]] := false;
      end;
  ans := 0;
  realgn := 0;
  for i:=1 to gn do
    if v1[i] or v2[i] then
      inc(realgn);
  while realgn>1 do
  begin
    r := 0;
    a := 0;
    b := 0;

    fillchar(good,sizeof(good),0);
    for i:=1 to gn do
      for j:=1 to gn do
      begin
        if (v1[i] and v2[j] and mat[pred[i],pred[j]]) then
        begin
          inc(good[i]);
          inc(good[j]);
        end;
      end;

    for i:=1 to gn do
      if v1[i] then
        for j:=1 to gn do
          if v2[j] and (i<>j) then
          begin
            if mat[pred[i],pred[j]] then
            begin
              if (good[i]>1) and (good[j]>1) and (r<2) then
              begin
                r := 2;
                a := i;
                b := j;
              end
              else
                if r<1 then
                begin
                  r := 1;
                  a := i;
                  b := j;
                end;
            end
            else
            begin
              if (good[i]>0) and (good[j]>0) and (r<2) then
              begin
                r := 2;
                a := i;
                b := j;
              end
              else
                if r<1 then
                begin
                  r := 1;
                  a := i;
                  b := j;
                end;
            end;
          end;
    dec(realgn,r);
    inc(ans);
    ansa[ans] := pred[a];
    ansb[ans] := pred[b];
    if mat[pred[a],pred[b]] then
    begin
      dec(good[a]);
      dec(good[b]);
    end;
    mat[pred[a],pred[b]] := true;
    mat[pred[b],pred[a]] := true;
    for i:=1 to n do
      for j:=1 to n do
        mat[i,j] := mat[i,j] or (mat[i,pred[a]] and mat[pred[b],j]);
    for i:=1 to n do
      for j:=1 to n do
        mat[i,j] := mat[i,j] or (mat[i,pred[b]] and mat[pred[a],j]);
    v1[a] := good[b]<=0;
    v2[a] := good[a]<=0;
    if pred[a]>pred[b] then
      pred[a] := pred[b];
    v1[b] := false;
    v2[b] := false;
  end;
end;

procedure Save;
var
  i : integer;
begin
  writeln(ans);
  for i:=1 to ans do
    writeln(ansa[i],' ',ansb[i]);
  close(input);
  close(output);
end;

begin
  Load('merge.in','merge.out');
  Solve;
  Save;
end.