{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V+,X+}
{$M 16384,0,655360}
Const MaxD=50;
      Osn=10;

Type TLongBase=Array[1..MaxD] of Shortint;
Type TLong=Object
  Public
    Num:^TLongBase;
    Len:Longint;
    Constructor InitIt;
    Destructor DestroyIt;
    Procedure ReadIt;
    Procedure WriteIt;
    Procedure SetLong(var A:TLong);
    Procedure SetShort(A:Longint);
    Function CompareIt(var A:TLong):Shortint;
    Procedure IncIt(var A:TLong);
    Procedure DecIt(var A:TLong);
    Procedure MulIt(var A:TLong);
    Procedure Mul10It;
end;

Constructor TLong.InitIt;
begin
New(Num);
FillChar(Num^,SizeOf(Num^),0);
Len:=0;
end;

Destructor TLong.DestroyIt;
begin
Dispose(Self.Num);
end;

Procedure TLong.ReadIt;
var c:Char;
begin
Repeat Read(c) Until c in ['0'..'9'];
While c in ['0'..'9'] Do
begin
  Self.Mul10It;
  Num^[1]:=Ord(c)-Ord('0');
  Read(c);
end;
if c=#13 then
  Read(c)
else
  Readln;
end;

Procedure TLong.WriteIt;
var i:Longint;
begin
for i:=Len downto 1 do
begin
  if (Osn>10) AND (Num^[i]>=10) then
    Write(Chr(Num^[i]-10+Ord('A')))
  else
    Write(Num^[i]);
end;
Writeln;
end;

Procedure TLong.SetLong(var A:TLong);
begin
Num^:=A.Num^;
Len:=A.Len;
end;

Procedure TLong.SetShort(A:Longint);
var i:Longint;
begin
FillChar(Num^,SizeOf(Num^),0);
Len:=0;
Repeat
  Inc(Len);
  Num^[Len]:=A mod Osn;
  A:=A div Osn;
Until A=0;
end;

Function TLong.CompareIt(var A:TLong):Shortint;
var Ans:Shortint;
    i:Longint;
begin
Ans:=0;
if Self.Len>A.Len then
  Ans:=1
else if Self.Len<A.Len then
  Ans:=-1
else
begin
  for i:=Self.Len downto 1 do
    if Self.Num^[i]>A.Num^[i] then
    begin
      Ans:=1;
      Break;
    end
    else if Self.Num^[i]<A.Num^[i] then
    begin
      Ans:=-1;
      Break;
    end;

end;
CompareIt:=Ans;
end;

Procedure TLong.IncIt(var A:TLong);
var i,t:Longint;
    L:Longint;
begin
if A.Len>Self.Len then
  L:=A.Len
else
  L:=Self.Len;
for i:=1 to L do
begin
  t:=Self.Num^[i]+A.Num^[i];
  Self.Num^[i]:=t mod Osn;
  Inc(Self.Num^[i+1], t div Osn);
end;

While Self.Num^[Self.Len+1]>0 Do Inc(Self.Len);
end;

Procedure TLong.DecIt(var A:TLong);
var i:Longint;
begin

for i:=1 to A.Len do
begin
  Dec(Self.Num^[i],A.Num^[i]);
  if Self.Num^[i]<0 then
  begin
    Inc(Self.Num^[i],Osn);
    Dec(Self.Num^[i+1]);
  end;
end;

for i:=1 to Self.Len do
  if Self.Num^[i]<0 then
  begin
    Inc(Self.Num^[i],Osn);
    Dec(Self.Num^[i+1]);
  end;

While (Self.Len>1) AND (Self.Num^[Self.Len]=0) Do Dec(Self.Len);
end;

Procedure TLong.MulIt(var A:TLong);
var i,j,t:Longint;
    Res:TLong;
begin
Res.InitIt;
for i:=1 to Self.Len do
for j:=1 to A.Len do
begin
  t:=Self.Num^[i]*A.Num^[j]+Res.Num^[i+j-1];
  Res.Num^[i+j-1]:=t mod Osn;
  Inc(Res.Num^[i+j],t div Osn);
end;
Res.Len:=Self.Len+A.Len;
While (Res.Len>1) AND (Res.Num^[Res.Len]=0) Do Dec(Res.Len);
Self.SetLong(Res);
Res.DestroyIt;
end;

Procedure TLong.Mul10It;
var i:Longint;
begin
for i:=Len downto 1 do
  Num^[i+1]:=Num^[i];
Num^[1]:=0;
Inc(Len);
end;

Const INPUTFILE='mountain.in';
      OUTPUTFILE='mountain.out';

Const Max=10;
Type Real=Double;

var c:Array[1..Max] of Integer;
    a,b:Array[0..Max,0..Max,0..Max] of TLong;
    H,L,K:Longint;
    i,j,g:Longint;

Procedure FRead;
begin
Assign(Input,INPUTFILE);
Reset(Input);
Read(H,L,K);
for i:=1 to K do
  Read(c[i]);
Close(Input);
if (K>0) AND (c[K]=1) then Dec(K);
c[K+1]:=-1;
for i:=0 to Max do
for j:=0 to Max do
for g:=0 to Max do
begin
  a[i,j,g].InitIt;
  b[i,j,g].InitIt;
end;
end;

Procedure FWrite(var Answer:TLong);
begin
Assign(Output,OUTPUTFILE);
Rewrite(Output);
Answer.WriteIt;
Close(Output);

Answer.DestroyIt;
for i:=0 to L do
for j:=0 to H do
for g:=0 to K do
begin
  a[i,j,g].DestroyIt;
  b[i,j,g].DestroyIt;
end;

Halt;
end;

Procedure Solve;
var CH,CHm,CL:Longint;
    Ans:TLong;
begin
Ans.InitIt;
if L<2*H then
  Ans.SetShort(0)
else
begin
  a[0,0,0].SetShort(1);

  for g:=0 to 0 do
  for i:=1 to L-1 do
  for j:=1 to H do
  begin
    a[i,j,g].IncIt(a[i-1,j,g]);
    a[i,j,g].IncIt(a[i-1,j-1,g]);
    a[i,j,g].IncIt(a[i-1,j+1,g]);

    if c[g+1]=j then
      a[i,j,g+1].SetLong(a[i,j,g]);


    if j=H then
      b[i,j,g].SetLong(a[i,j,g])
    else
    begin
      b[i,j,g].IncIt(b[i-1,j,g]);
      b[i,j,g].IncIt(b[i-1,j-1,g]);
      b[i,j,g].IncIt(b[i-1,j+1,g]);
    end;
    if c[g+1]=j then
      b[i,j,g+1].SetLong(b[i,j,g]);

  end;

{  for g:=1 to K do
  for i:=1 to L-1 do
  for j:=1 to H do
  begin
{    a[i,j,g].IncIt(a[i-1,j,g]);
    a[i,j,g].IncIt(a[i-1,j-1,g]);
    a[i,j,g].IncIt(a[i-1,j+1,g]);


    if c[g+1]=j then
      a[i,j,g+1].SetLong(a[i,j,g]);


    if j=H then
      b[i,j,g].SetLong(a[i,j,g])
    else
    begin
      b[i,j,g].IncIt(b[i-1,j,g]);
      b[i,j,g].IncIt(b[i-1,j-1,g]);
      b[i,j,g].IncIt(b[i-1,j+1,g]);
    end;
    if c[g+1]=j then
      b[i,j,g+1].SetLong(b[i,j,g]);

  end;}

  Ans.SetLong(b[L-1,1,0]);

end;
FWrite(Ans);
end;

begin
FRead;
Solve;
end.
