#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <ctype.h>
#include <string.h>

#define LL 100
#define BASE 1000
#define NN 110

int _stklen = 4194304;

typedef struct LLONG {
  int l;
  long a[LL];
};

FILE *fi, *fo;
LLONG f[NN];
int n;

int max(int a, int b)
{
  return (a<b)?b:a;
}

int min(int a, int b)
{
  return (a>b)?b:a;
}

void init(LLONG *a)
{
  int i;
  for(i=0;i<LL;i++)
    a->a[i]=0;
  a->l=0;
}

void cpy(LLONG *a, LLONG *b)
{
  int i;
  a->l=b->l;
  for(i=LL-b->l;i<LL;i++)
    a->a[i]=b->a[i];
}

void umn(LLONG *a, long b)
{
  long r;
  int i;
  r=0;
  for(i=LL-1;i>=LL-a->l;i--)
  {
    a->a[i]=a->a[i]*b+r;
    r=a->a[i]/BASE;
    a->a[i]%=BASE;
  }
  while(r>0)
  {
    a->l++;
    a->a[LL-a->l]=r%BASE;
    r/=BASE;
  }
}

void sum(LLONG *a, LLONG *b)
{
  long r;
  int i;
  r=0;
  a->l=max(a->l,b->l);
  for(i=LL-1;i>=LL-a->l;i--)
  {
    a->a[i]=a->a[i]+b->a[i]+r;
    r=a->a[i]/BASE;
    a->a[i]%=BASE;
  }
  while(r>0)
  {
    a->l++;
    a->a[LL-a->l]=r%BASE;
    r/=BASE;
  }
}

void umn1(LLONG *a, long b, int shift)
{
  long r;
  int i;
  r=0;
  for(i=LL-1;i>=LL-a->l;i--)
  {
    a->a[i]=a->a[i]*b+r;
    r=a->a[i]/BASE;
    a->a[i]%=BASE;
  }
  for(i=LL-a->l;i<LL;i++)
    a->a[i-shift]=a->a[i];
  for(i=LL-shift;i<LL;i++)
    a->a[i]=0;
  a->l+=shift;
  while(r>0)
  {
    a->l++;
    a->a[LL-a->l]=r%BASE;
    r/=BASE;
  }
}

void umnl(LLONG *a, LLONG *b)
{
  int i;
  LLONG res;
  LLONG bb;
  init(&res);
  for(i=LL-b->l;i<LL;i++)
  {
    init(&bb);
    cpy(&bb,a);
    umn1(&bb,b->a[i],LL-i-1);
    sum(&res,&bb);
  }
  cpy(a,&res);
}

void del(LLONG *a, long b)
{
  int i;
  long r;
  r=0;
  for(i=LL-a->l;i<LL;i++)
  {
    a->a[i]+=r*BASE;
    r=a->a[i]%b;
    a->a[i]/=b;
  }
  while((a->a[LL-a->l]==0)&&(a->l>0))
    a->l--;
}

void cc(LLONG *a, int n, int k)
{
  int i;
  for(i=n-k+1;i<=n;i++)
    umn(a,i);
  for(i=2;i<=k;i++)
    del(a,i);
}

void wr(FILE *fo, LLONG *a)
{
  int i;
  long r;
  i=LL-a->l;
  fprintf(fo,"%li",a->a[i]);
  i++;
  for(;i<LL;i++)
  {
    for(r=BASE/10;r>1;r/=10)
    {
      if(a->a[i]<r)
        fprintf(fo,"0");
    }
    fprintf(fo,"%li",a->a[i]);
  }
  fprintf(fo,"\n");
}

int main()
{
  int i,j,k;
  LLONG b;
  fi=fopen("brackets.in","rt");
  fo=fopen("brackets.out","wt");

  fscanf(fi,"%i",&n);
  f[0].l=1;
  f[0].a[LL-1]=1;
  f[1].l=1;
  f[1].a[LL-1]=3;
  for(i=2;i<=n;i++)
  {
    init(&f[i]);
    for(k=0;k<i;k++)
    {
      init(&b);
      cpy(&b,&f[i-k-1]);
      for(j=0;j<k-9;j+=10)
        umn(&b,1024);
      for(;j<k-5;j+=5)
        umn(&b,32);
      for(;j<k;j++)
        umn(&b,2);
      cc(&b,2*k,k);
      del(&b,k+1);
      sum(&f[i],&b);
      init(&b);
      cpy(&b,&f[i-k-1]);
      umnl(&b,&f[k]);
      umn(&b,2);
      sum(&f[i],&b);
    }
  }

  wr(fo,&f[n]);

  fclose(fi);
  fclose(fo);
  return 0;
}


