program Fence_Game;

uses
  game;

const
  MAXN = 40;

var
  n, k, w : integer;
  f : tfence;
  a, b : array [1..MAXN] of longint;
  answer : array [0..1000000] of byte;

function paint(f1 : tfence; var f2 : tfence; i, j, w : integer) : boolean;
var
  k : integer;
begin
  if i>j then
  begin
    k := i;
    i := j;
    j := k;
  end;
  paint := false;
  if (f1[i-1]<>f1[j-1]) or (j-i+1>w) then
    exit;
  f2 := f1;
  for k:=i to j do
    if f2[k-1]<>f1[i-1] then
    begin
      paint := true;
      f2[k-1] := f1[i-1];
    end;
end;

procedure PreCount;
var
  l, i : integer;
  t : tfence;
  w0 : integer;
begin
  fillchar(a,sizeof(a),0);
  fillchar(b,sizeof(b),0);
  for l:=n downto 1 do
  begin
    if (l=1) or (f[l-1]<>f[l-2]) then
    begin
      if (f[n-1]=f[l-1]) and paint(f,t,l,n,n) then
        inc(b[l]);
      for i:=l to n-1 do
        if (f[i-1]=f[l-1]) and (f[i]<>f[l-1]) and paint(f,t,l,i,n) then
          b[l] := b[l] + a[i+1];
    end;
    a[l] := 1;
    for i:=l to n do
      a[l] := a[l] + b[i];
  end;
end;

function Fence2Number(x : tfence; l : integer) : longint;
var
  i, j, k : integer;
  t : longint;
  y : tfence;
begin
  t := 0;
  for i:=l to n do
    if f[i-1]<>x[i-1] then
      break;
  if f[i-1]=x[i-1] then
  begin
    Fence2Number := a[l];
    exit;
  end;
  repeat
    dec(i);
  until (i=1) or (x[i-1]<>x[i-2]);
  for j:=i-1 downto 1 do
    t := t + b[j];
  for j:=i to n do
    if (j=n) or (x[j]<>x[i-1]) then
      break;
  if j=n then
  begin
    Fence2Number := t + b[i];
    exit;
  end;
  for k:=j-1 downto i do
  begin
    if (f[k-1]=f[i-1]) and (f[k]<>f[i-1]) and paint(f,y,l,i,n) then
      t := t + a[k+1];
    Fence2Number := t + Fence2Number(x,j+1);
  end;
end;

function dfs(a : tfence) : integer;
var
  i, j, k, t : longint;
  l : boolean;
  b : tfence;
begin
  t := Fence2Number(a,1);
  if answer[t]<>0 then
  begin
    dfs := answer[t];
    exit;
  end;
  answer[t] := 2;
  for i:=1 to n do
    for j:=i+1 to n do
      if paint(a,b,i,j,w) and (dfs(b)=2) then
        answer[t] := 1;
  dfs := answer[t];
end;

procedure DoInit;
var
  i : integer;
begin
  init(n,k,w,f);
  PreCount;
  fillchar(answer,sizeof(answer),0);
end;

procedure Cycle(var q : tfence);
var
  i, j, i1, j1, t : integer;
  q1 : tfence;
begin
  t := dfs(q);
  i1 := 0;
  for i:=1 to n do
    for j:=i+1 to n do
      if (i1=0) and paint(q,q1,i,j,w) and ((dfs(q1)=2) or (t=2)) then
      begin
        i1 := i;
        j1 := j;
        break;
      end;
  q := q1;
  move(i1-1,j1-1,i,j);
  paint(q,q1,i+1,j+1,w);
  q := q1;
end;

var
  q : tfence;

begin
  DoInit;
  q := f;
  while true do
    Cycle(q);
end.
