{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P+,Q+,R+,S+,T-,V+,X+,Y+}
{$M 65500,0,655360}
const infile = 'input.txt'; outfile = 'output.txt';
      max = 11; eps = 0.0000001;
type pt = record x,y: extended; end;
     line = record a,b,c: extended; end;
var p1,p2: pt;
    n: longint;
    a: array [1..max,1..2] of pt;
    nnew,t: array [1..max] of byte;
    lns: array [1..max] of line;
    ok: boolean;
    ans: extended;

procedure init;
var i: longint;
begin
     assign(input,infile);
     reset(input);
     read(n);
     read(p1.x,p1.y);
     read(p2.x,p2.y);
     for i:=1 to n do
         read(a[i,1].x,a[i,1].y,a[i,2].x,a[i,2].y);
     close(input);
end;

function square(t1,t2,t3: pt): extended;
begin
     square:=(t1.x*t2.y-t2.x*t1.y+t2.x*t3.y-t3.x*t2.y+t3.x*t1.y-t1.x*t3.y);
end;

function can(p: pt; t1,t2: pt): boolean;
var e: extended;
begin
     e:=square(t1,t2,p);
     can:=(square(t1,t2,p) > eps)or(abs(square(t1,t2,p)) < eps);
end;

procedure otr(p: pt; num: longint; var nw: pt);
var qa,qb,qc: extended;
begin
     qa:=lns[num].a; qb:=lns[num].b; qc:=lns[num].c;
     nw.x:=p.x-(qa*p.x+qb*p.y+qc)*(2*qa)/(qa*qa+qb*qb);
     nw.y:=p.y-(qa*p.x+qb*p.y+qc)*(2*qb)/(qa*qa+qb*qb);
end;

procedure point_to_line(t1,t2: pt; var l: line);
begin
     l.a:=t2.y-t1.y;
     l.b:=t1.x-t2.x;
     l.c:=-(t1.x*l.a+t1.y*l.b);
end;

function dist(t1,t2: pt): extended;
begin
     dist:=sqrt((t1.x-t2.x)*(t1.x-t2.x)+(t1.y-t2.y)*(t1.y-t2.y));
end;

function pr(t1,t2,w: pt): boolean;
begin
     pr:=abs(dist(t1,w)+dist(w,t2)-dist(t1,t2))<eps;
end;

function peres_lines(l1,l2: line; var e: pt): boolean;
var st: extended;
begin
     st:=l1.a*l2.b-l1.b*l2.a;
     if abs(st) < eps then peres_lines:=false
        else begin
             peres_lines:=true;
             e.x:=-(l1.c*l2.b-l2.c*l1.b)/st;
             e.y:=(l2.a*l1.c-l1.a*l2.c)/st;
        end;
end;

function peres(t1,t2,t3,t4: pt; var e: pt): boolean;
var l1,l2: line;
begin
     peres:=false;
     point_to_line(t1,t2,l1); point_to_line(t3,t4,l2);
     if peres_lines(l1,l2,e) then
        if pr(t1,t2,e) and pr(t3,t4,e) then peres:=true;
end;

function prov(ch: pt): boolean;
var cur1,cur2,e,e2: pt;
    h,j: longint;
begin
     cur1:=p1; cur2:=ch; t[n+1]:=100;
     for h:=n downto 1 do begin
         if peres(cur1,cur2,a[t[h],1],a[t[h],2],e) then begin
            for j:=1 to n do if (j <> t[h])and(j <> t[h+1]) then
                if peres(cur1,cur2,a[j,1],a[j,2],e2) then
                   if can(cur1,a[j,1],a[j,2]) and (dist(cur1,e)-dist(cur1,e2)>eps) then
                      begin prov:=false; exit; end;
            cur1:=e; e:=cur2; otr(e,t[h],cur2);
         end
            else begin prov:=false; exit; end;
     end;
end;

function angle(z: pt): extended;
var nw: pt;
    ang: extended;
begin
     nw.x:=z.x-p1.x; nw.y:=z.y-p1.y;
     if abs(nw.x) < eps then ang:=pi/2+ord(nw.y<-eps)
        else begin
             ang:=arctan(nw.y/nw.x)+pi;
             if (nw.x>eps) then
                if (nw.y>eps)or(abs(nw.y)<eps) then ang:=ang-pi
                   else ang:=ang+pi;
        end;
     angle:=ang*180/pi;
end;

procedure rec(h: longint; p: pt);
var i: longint;
    tmp: pt;
begin
     if ok then exit;
     if h = n+1 then begin
        if prov(p) then begin
           ok:=true; ans:=angle(p);
        end;
        exit;
     end;
     for i:=1 to n do
         if (nnew[i] = 0)and can(p,a[i,1],a[i,2]) then begin
            nnew[i]:=1; t[h]:=i; otr(p,i,tmp); rec(h+1,tmp);
            nnew[i]:=0; end;
end;

procedure fill_lns;
var i: longint;
begin
     for i:=1 to n do
         point_to_line(a[i,1],a[i,2],lns[i]);
end;

procedure solve;
begin
     fillchar(nnew,SizeOf(nnew),0);
     fillchar(t,SizeOf(t),0);
     fill_lns;
     ok:=false;
     rec(1,p2);
end;

procedure done;
begin
     assign(output,outfile);
     rewrite(output);
     if ok then begin
        writeln('YES');
        write(ans:0:6)
     end
        else write('NO');
     close(output);
end;

begin
     init;
     solve;
     done;
end.