{$IFDEF NORMAL}
  {$I-,Q-,R-,S-}
{$ENDIF NORMAL}
{$IFDEF DEBUG}
  {$I+,Q+,R+,S-}
{$ENDIF DEBUG}
{$IFDEF RELEASE}
  {$I-,Q-,R-,S-}
{$ENDIF RELEASE}
type txy = record
       x, y: integer;
     end;

const reg: array['A'..'D'] of byte = (8, 4, 2, 1);
      chreg = ['A'..'D','a'..'d'];
      shifts: array[0..3] of txy = ((x: 0;y: -1),
                                    (x: 1;y: 0),
                                    (x: 0;y: 1),
                                    (x: -1;y: 0));

type Pstr = ^string;
     Tfld = record
       trig: byte;
       rot: Pstr; {nil - trig}
     end;

var fld: array[0..3,1..30,1..30] of word;
    a: array[1..30,1..30] of Tfld;
    k: longint;
    m,n,p,q,x0,y0,a0: integer;

var x,y,ang: integer;
    cregs: byte;
    count: longint;

function inside(x,y: integer):boolean;
begin
  if (x>=1) and (x<=m) and (y>=1) and (y<=n) then inside:=true else inside:=false;
end;

function nvis(x,y:integer;cregs,ang:byte):boolean;
var mask: word;
begin
  mask:=1 shl cregs;
  if (fld[ang,y,x] and mask)<>0 then nvis:=true else nvis:=false;
end;

function turn(var s: string; cregs:byte):boolean;
var token: (_open, _close, _not, _and, _or, _xor, _val, _end);
    value: boolean;
    curpos: byte;

  procedure GetToken;
  begin
    while s[curpos]=' ' do inc(curpos);
    if curpos>length(s) then begin token:=_end; exit; end;

    if s[curpos]='T' then begin
      token:=_val;
      value:=true;
      inc(curpos,4);
      exit;
    end;

    if s[curpos]='F' then begin
      token:=_val;
      value:=false;
      inc(curpos,5);
      exit;
    end;

    if s[curpos]='(' then begin
      token:=_open;
      inc(curpos,1);
      exit;
    end;

    if s[curpos]=')' then begin
      token:=_close;
      inc(curpos,1);
      exit;
    end;

    if s[curpos]='X' then begin
      token:=_xor;
      inc(curpos,3);
      exit;
    end;

    if s[curpos]='O' then begin
      token:=_or;
      inc(curpos,2);
      exit;
    end;

    if s[curpos]='N' then begin
      token:=_not;
      inc(curpos,3);
      exit;
    end;

    if (curpos<length(s)) and (s[curpos]='A') and (s[curpos+1]='N') then begin
      token:=_and;
      inc(curpos,3);
      exit;
    end;

    token:=_val;
    value:=(cregs and reg[s[curpos]])<>0;
    inc(curpos);
  end;


function expr:boolean; forward;

function oper:boolean;
begin
  if token=_val then begin oper:=value; end else
  if token=_not then begin
    GetToken;
    oper:=not oper;
  end else
  if token=_open then begin
    oper:=expr;
    GetToken;
  end;
  GetToken;
end;

function expr:boolean;
var res: boolean;
begin
  GetToken;
  res:=oper;
  while token in [_or, _and, _xor] do begin
   case token of
_or: res:=res or oper;
_xor: res:=res or oper;
_and: res:=res or oper;
   end;
  end;
  expr:=res;
end;

begin
  curpos:=1;
  turn:=expr;

  {if s='TRUE' then turn:=true else
    if s='FALSE' then turn:=false else
      turn:=(cregs and reg[s[1]])>0;}
end;


Function Go: byte; {0-broken 1-cycle 2-finished}
var mask: byte;
Begin
  repeat
    if inside(x,y) then begin
      cregs:=cregs xor a[y,x].trig;

      if a[y,x].rot<>nil then begin
        if turn(a[y,x].rot^,cregs) then inc(ang) else dec(ang);
        ang:=(ang+4) mod 4;
      end;

      {}
      if not nvis(x,y,cregs,ang) then begin
        mask:=1 shl cregs;
        fld[ang,y,x]:=fld[ang,y,x] or mask;

        if k<=count then begin
          Go:=2; exit;
        end;
      end else begin
        Go:=1; exit;
      end;
    end else begin
      Go:=0; exit;
    end;

    x:=x+shifts[ang].x;
    y:=y+shifts[ang].y;
    inc(count);
  until false;
End;

procedure Solve;
var f: text;
begin
  Assign(f,'output.txt');
  Rewrite(f);
  x:=x0; y:=y0; ang:=a0; cregs:=0;
  count:=0;
  case go of
0: WriteLn(f,-1);
2: WriteLn(f, x,' ',y);
1: begin
    x:=x0; y:=y0; ang:=a0; cregs:=0;
    k:=k mod count;
    count:=0;
    fillchar(fld,sizeof(fld),0);
    Go;
    WriteLn(f,x,' ',y);
   end;
  end;
  Close(f);
end;


procedure Load;
var f: text;
    i,x,y: integer;
    ch: char;
    ps: Pstr;
begin
  Assign(f,'input.txt');
  Reset(f);
  Read(f,m,n,p,q,k,x0,y0,a0);
  a0:=a0 div 90;
  For i:=1 to p do begin
    Read(f,x,y);
    Read(f,ch);
    while not (ch in chreg) do Read(f,ch);
    a[y,x].trig:=a[y,x].trig or reg[upcase(ch)];
  end;
  For i:=1 to q do begin
    new(ps);
    Read(f,x,y);
    Read(f,ch);
    while ch=' ' do read(f,ch);
    ps^:=upcase(ch);
    while not eoln(f) do begin
      read(f,ch);
      ps^:=ps^+upcase(ch);
    end;
    a[y,x].rot:=ps;
  end;
  Close(f);
end;

procedure Free;
var i,j: integer;
begin
  For i:=1 to n do
    For j:=1 to m do
      if a[i,j].rot<>nil then Dispose(a[i,j].rot);
end;

Begin
  Load;
  Solve;
  Free;
End.
