{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
type int = longint;
const eps = 1e-7;

var p: array [1..15] of int;
var n: int;
var ans: extended;
var x0, y0, x1, y1: extended;
var xb, yb, xe, ye: array [1..15] of extended;

var xx, yy: extended;
function simm(x, y: extended; u: int): boolean;
var a, b, c, d: extended;
begin
  a:=ye[u] - yb[u];
  b:=xb[u] - xe[u];
  c:=-a * xb[u] - b * yb[u];
  d:=(a * x + b * y + c) / sqrt(sqr(a) + sqr(b));
  if ((xb[u] < xe[u] - eps) and (d < -eps)) or
     ((xb[u] > xe[u] + eps) and (d > eps)) then
       begin
         simm:=false;
         exit;
       end;
  a:=-a;
  b:=-b;
  c:=sqrt(sqr(a) + sqr(b));
  a:=a / c;
  b:=b / c;
  xx:=x + 2 * a * d;
  yy:=y + 2 * b * d;
  simm:=true;
end;

function bt(a, x, y: extended): boolean;
begin
bt:=((x - eps < a) and (a < y + eps)) or ((y - eps < a) and (a < x + eps));
end;

var xt, yt: extended;
function inters(x, y, xx, yy: extended;u: int): boolean;
var d, d1, d2, a1, b1, c1, a2, b2, c2: extended;
begin
  a1:=yy - y;
  b1:=x - xx;
  c1:=-a1 * x - b1 * y;

  a2:=yb[u] - ye[u];
  b2:=xe[u] - xb[u];
  c2:=-a2 * xb[u] - b2 * yb[u];

  d:=a1 * b2 - a2 * b1;
  d1:=b1 * c2 - b2 * c1;
  d2:=-a1 * c2 + a2 * c1;
  if abs(d) < eps then
    begin
      inters:=false;
      exit;
    end;
  xt:=d1 / d;
  yt:=d2 / d;
  if bt(xt, x, xx) and bt(yt, y, yy) and
     bt(xt, xb[u], xe[u]) and bt(yt, yb[u], ye[u]) then
       begin
         inters:=true;
         exit;
       end;
  inters:=false;
end;

function check: boolean;
var i: int;
var x, y: array [0..15] of extended;
begin
  check:=false;
  x[0]:=x0;
  y[0]:=y0;

  for i:=1 to n do
    begin
      if not simm(x[i - 1], y[i - 1], p[i]) then
        begin
          check:=false;
          exit;
        end;
      x[i]:=xx;
      y[i]:=yy;
    end;
  for i:=n downto 1 do
    begin
      if not inters(x[i], y[i], x1, y1, p[i]) then
        begin
          check:=false;
          exit;
        end;
      x1:=xt;
      y1:=yt;
    end;
  check:=true;
  if abs(xt - x0) < eps then
    ans:=90
  else
    begin
      ans:=(yt - y0) / (xt - x0);
      ans:=arctan(ans);
      if ans < -eps then ans:=ans + 2 * pi;
      ans:=ans * 180 / pi;
    end;
end;

var found: boolean;
var mark: array [1..15] of boolean;
procedure gen(u: int);
var i: int;
begin
  if found then exit;
  if u = n then
    begin
      if check then
        found:=true;
      exit;
    end;
  for i:=1 to n do
    if (not mark[i]) then
      begin
        p[u + 1]:=i;
        mark[i]:=true;
        gen(u + 1);
        mark[i]:=false;
      end;
end;

var i: int;
begin
  assign(input, 'input.txt');
  assign(output, 'output.txt');
  reset(input);
  rewrite(output);
  read(n);
  read(x0, y0);
  read(x1, y1);
  for i:=1 to n do
    read(xb[i], yb[i], xe[i], ye[i]);
  found:=false;
  gen(0);
  if found then
    begin
      writeln('YES');
      writeln(ans: 0: 6);
      close(input);
      close(output);
      exit;
    end;
  writeln('NO');
  close(input);
  close(output);
end.
