#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <ctype.h>

#define NN 100
#define BASE 1000

FILE *fi, *fo;

struct LLONG {
  int l;
  long a[NN];
};

struct PW2 {
  LLONG n;
  long a[33][33];
};

long pw2[6];
long mx[33][33];
PW2 w[400];
int m;
long p;
LLONG n;

void umn(LLONG *a , long q, LLONG *b)
{
  int i;
  long r;
  for(i=0;i<NN;i++)
  {
    b->a[i]=0;
  }
  b->l=a->l;
  r=0;
  for(i=NN-1;i>=NN-a->l;i--)
  {
    b->a[i]=a->a[i]*q+r;
    r=b->a[i]/BASE;
    b->a[i]%=BASE;
  }
  while(r>0)
  {
    b->l++;
    b->a[NN-b->l]=r%BASE;
    r=r/BASE;
  }
}

int eq(LLONG *a, LLONG *b)
{
  long i;
  if(a->l>b->l) return 1;
  if(a->l<b->l) return -1;
  for(i=NN-a->l;(i<NN)&&(a->a[i]==b->a[i]);i++) ;
  if(i>=NN) return 0;
  if(a->a[i]>b->a[i]) return 1;
  if(a->a[i]<b->a[i]) return -1;
  return 0;
}

void vich(LLONG *a, LLONG *b)
{
  long r;
  int i;
  r=0;
  for(i=NN-1;i>=NN-a->l;i--)
  {
    a->a[i]-=b->a[i]+r;
    r=0;
    while(a->a[i]<0)
    {
      a->a[i]+=BASE;
      r++;
    }
  }
  while((a->a[NN-a->l]==0)&&(a->l>0))
  {
    a->l--;
  }
}

void GetLong(LLONG *a)
{
  int s[200];
  int q;
  int i;
  char c;
  c=getc(fi);
  while(!isdigit(c)) c=getc(fi);
  q=0;
  while(isdigit(c))
  {
    s[q]=c-'0';
    q++;
    c=getc(fi);
  }
  for(i=0;i<NN;i++) a->a[i]=0;
  a->l=0;
  while(q>0)
  {
    if(q>=3)
    {
      a->l++;
      a->a[NN-a->l]=s[q-3]*100+s[q-2]*10+s[q-1];
      q-=3;
    }
    else
    {
      a->l++;
      for(i=0;i<q;i++) a->a[NN-a->l]=a->a[NN-a->l]*10+s[i];
      q=0;
    }
  }
}

int pos(long a, long b)
{
  long aa[6];
  long bb[6];
  int i;
  for(i=0;i<m;i++)
  {
    aa[i]=(a&pw2[i])?1:0;
    bb[i]=(b&pw2[i])?1:0;
  }
  for(i=0;i<m-1;i++)
  {
    if((aa[i]==aa[i+1])&&(aa[i]==bb[i])&&(bb[i]==bb[i+1])) return 0;
  }
  return 1;
}

void init()
{
  int i,j,k;
  pw2[0]=1;
  for(i=1;i<6;i++)  pw2[i]=pw2[i-1]*2;
  for(i=0;i<33;i++)
    for(j=0;j<33;j++)
      mx[i][j]=0;
  for(i=0;i<pw2[m];i++)
    for(j=0;j<pw2[m];j++)
      mx[i][j]=pos(i,j);
  for(k=0;k<400;k++)
    for(i=0;i<33;i++)
      for(j=0;j<33;j++)
        w[k].a[i][j]=0;
}

int main()
{
  int i,j,k,l,d;
  double fd;
  int nd;
  long a[33][33];
  long aa[33][33];
  long s;
  fi=fopen("nice.in","rt");
  fo=fopen("nice.out","wt");

  GetLong(&n);
  fscanf(fi,"%i%li",&m,&p);
  init();
  w[0].n.l=1;
  w[0].n.a[NN-1]=1;
  for(i=0;i<pw2[m];i++)
    for(j=0;j<pw2[m];j++)
      w[0].a[i][j]=(i==j)?1:0;
  fd=n.l*log(10)/log(2);
  nd=(int)fd;
  for(k=1;k<nd+2;k++)
  {
    umn(&w[k-1].n,2,&w[k].n);
    for(l=0;l<pw2[m];l++)
    {
      for(i=0;i<pw2[m];i++)
      {
        for(j=0;j<pw2[m];j++)
        {
          if(mx[i][j])
          {
            for(d=0;d<pw2[m];d++)
            {
              w[k].a[l][d]+=w[k-1].a[l][i]*w[k-1].a[j][d]%p;
              w[k].a[l][d]%=p;
            }
          }
        }
      }
    }
  }
  k=nd+1;
  while(eq(&w[k].n,&n)>0) k--;
  vich(&n,&w[k].n);
  for(i=0;i<pw2[m];i++)
    for(j=0;j<pw2[m];j++)
      a[i][j]=w[k].a[i][j];
  for(;k>=0;k--)
  {
    if(eq(&w[k].n,&n)<=0)
    {
      vich(&n,&w[k].n);
      for(i=0;i<pw2[m];i++)
        for(j=0;j<pw2[m];j++)
          aa[i][j]=0;
      for(l=0;l<pw2[m];l++)
      {
        for(i=0;i<pw2[m];i++)
        {
          for(j=0;j<pw2[m];j++)
          {
            if(mx[i][j])
            {
              for(d=0;d<pw2[m];d++)
              {
                aa[l][d]+=a[l][i]*w[k].a[j][d]%p;
                aa[l][d]%=p;
              }
            }
          }
        }
      }
      for(i=0;i<pw2[m];i++)
        for(j=0;j<pw2[m];j++)
          a[i][j]=aa[i][j];
    }
  }

  s=0;
  for(i=0;i<pw2[m];i++)
  {
    for(j=0;j<pw2[m];j++)
    {
      s+=a[i][j];
      s%=p;
    }
  }

  fprintf(fo,"%li\n",s);
  
  fclose(fi);
  fclose(fo);
  return 0;
}
