#include <stdio.h>

FILE*fi,*fo;


struct TEdge {
  long b,c;
  TEdge*z;
  TEdge(void);
  ~TEdge();
};
class TGraph {
  private:
    void _deepsrch(long);
    void _deepsrch_cond(long);
  public:
    long n,m,k,t,l,r;
    TEdge*e,**ez;
    long*c,*q,*ta,*tb;
    long*s;
    TGraph(void);
    ~TGraph();
    void read(void);
    void readbrid(void);
    void printc(void);
    void printb(void);
    void deepsrch(void);
    void condense(long);
};


TGraph*g;

int main(void) {
  g=new TGraph;
  fi=fopen("d.in","rt");
  g->read();
  fclose(fi);
  g->deepsrch();
  fo=fopen("d.out","wt");
  g->printc();
  fclose(fo);
  delete g;
  return(0);
}


void TGraph::deepsrch(void) {
  long i;
  for (i=0; i<n; i++) c[i]=-1;
  k=0;
  for (i=0; i<n; i++) if (c[i]<0) { _deepsrch(i); k++; }
}
void TGraph::condense(long a) {
  long i;
  for (i=0; i<n; i++) { c[i]=-1; ta[i]=tb[i]=-1; }
  t=0; l=0;
  _deepsrch_cond(a);
  for (i=0; i<n; i++) c[i]=-1;
  k=0;
  for (i=0; i<l; i++) if (c[q[i]]<0) { _deepsrch(i); k++; }
}
void TGraph::_deepsrch(long a) {
  TEdge*d;
  c[a]=k;
  for (d=&e[a]; d; d=d->z) if (c[d->b]<0) _deepsrch(d->b);
}
void TGraph::_deepsrch_cond(long a) {
  TEdge*d,*y;
  c[a]=0;
  ta[a]=t++; q[l++]=a;
  for (d=&e[a]; d->z; ) if (c[d->z->b]<0) {
    y=d->z; d->z=y->z;
    y->z=0;
    _deepsrch_cond(y->b);
    delete y;
  } else d=d->z;
  tb[a]=t++;
}


TGraph::TGraph(void) {
  n=m=0;
  e=0; ez=0;
  c=0; q=0; ta=0; tb=0;
  s=0;
}
TGraph::~TGraph() {
  if (e) delete[]e; if (ez) delete[]ez;
  if (c) delete[]c; if (q) delete[]q;
  if (ta) delete[]ta; if (tb) delete[]tb;
  if (s) delete[]s;
}
void TGraph::read(void) {
  if (e) delete[]e; if (ez) delete[]ez;
  if (c) delete[]c; if (q) delete[]q;
  if (ta) delete[]ta; if (tb) delete[]tb;
  if (s) delete[]s;
  long i;
  fscanf(fi,"%ld%ld",&n,&m);
  e=new TEdge[n]; ez=new TEdge*[n];
  for (i=0; i<n; i++) { e[i].b=i; e[i].c=-1; ez[i]=&e[i]; }
  long a,b;
  for (i=0; i<m; i++) {
    fscanf(fi,"%ld%ld",&a,&b);
    a--; b--;
    ez[a]->z=new TEdge; ez[a]=ez[a]->z;
    ez[a]->b=b; ez[a]->c=i;
    ez[b]->z=new TEdge; ez[b]=ez[b]->z;
    ez[b]->b=a; ez[b]->c=i;
  }
  c=new long[n]; q=new long[n];
  ta=new long[n]; tb=new long[n];
  s=new long[m];
}
void TGraph::readbrid(void) {
  long i,a,b;
  fscanf(fi,"%ld%ld",&a,&b);
  r=0;
  for (i=0; i<m; i++) {
    fscanf(fi,"%ld%ld",&a,&b);
    a--; b--;
    if (c[a]!=c[b]) s[r++]=i;
  }
}
void TGraph::printc(void) {
  long i;
  fprintf(fo,"%ld\n",k);
  for (i=0; i<n; i++) {
    if (i) fprintf(fo," ");
    fprintf(fo,"%ld",c[i]+1);
  }
}
void TGraph::printb(void) {
  long i;
  fprintf(fo,"%ld\n",r);
  for (i=0; i<r; i++) {
    if (i) fprintf(fo," ");
    fprintf(fo,"%ld",s[i]+1);
  }
}

TEdge::TEdge(void) {
  z=0;
}
TEdge::~TEdge() {
  if (z) delete z;
}

