#include <stdio.h>

FILE*fi,*fo;


struct TEdge {
  long b,c;
  TEdge*z;
  TEdge(void);
  ~TEdge();
};
class TGraphOr {
  private:
    void _deepsrch(long);
    void _deepsrch_cond(long);
  public:
    long n,m,k,t,l,r;
    TEdge*e,**ez;
    long*c,*q,*ta,*tb;
    long*s;
    TGraphOr(void);
    ~TGraphOr();
    void read(void);
    void readtrans(void);
    void readbrid(void);
    void printc(void);
    void printb(void);
    void deepsrch(void);
    void condense0(void);
    void condense1(void);
};


TGraphOr g;

int main(void) {
  fi=fopen("g.in","rt");
  g.read();
  fclose(fi);
  g.condense0();
  fi=fopen("g.in","rt");
  g.readtrans();
  fclose(fi);
  g.condense1();
  fo=fopen("g.out","wt");
  g.printc();
  fclose(fo);
  return(0);
}


void TGraphOr::deepsrch(void) {
  long i;
  for (i=0; i<n; i++) c[i]=-1;
  k=0;
  for (i=0; i<n; i++) if (c[i]<0) { _deepsrch(i); k++; }
}
void TGraphOr::condense0(void) {
  long i;
  for (i=0; i<n; i++) { c[i]=-1; ta[i]=tb[i]=-1; }
  t=0; l=0;
  for (i=0; i<n; i++) if (c[i]<0) _deepsrch_cond(i);
}
void TGraphOr::condense1(void) {
  long i;
  for (i=0; i<n; i++) c[i]=-1;
  k=0;
  for (i=l-1; i>=0; i--) if (c[q[i]]<0) { _deepsrch(q[i]); k++; }
}
void TGraphOr::_deepsrch(long a) {
  TEdge*d;
  c[a]=k;
  for (d=&e[a]; d; d=d->z) if (c[d->b]<0) _deepsrch(d->b);
}
void TGraphOr::_deepsrch_cond(long a) {
  TEdge*d;
  c[a]=0;
  ta[a]=t++;
  for (d=&e[a]; d; d=d->z) if (c[d->b]<0) _deepsrch_cond(d->b);
  tb[a]=t++; q[l++]=a;
}


TGraphOr::TGraphOr(void) {
  n=m=0;
  e=0; ez=0;
  c=0; q=0; ta=0; tb=0;
  s=0;
}
TGraphOr::~TGraphOr() {
  if (e) delete[]e; if (ez) delete[]ez;
  if (c) delete[]c; if (q) delete[]q;
  if (ta) delete[]ta; if (tb) delete[]tb;
  if (s) delete[]s;
}
void TGraphOr::read(void) {
  if (e) delete[]e; if (ez) delete[]ez;
  if (c) delete[]c; if (q) delete[]q;
  if (ta) delete[]ta; if (tb) delete[]tb;
  if (s) delete[]s;
  long i;
  fscanf(fi,"%ld%ld",&n,&m);
  e=new TEdge[n]; ez=new TEdge*[n];
  for (i=0; i<n; i++) { e[i].b=i; e[i].c=-1; ez[i]=&e[i]; }
  long a,b;
  for (i=0; i<m; i++) {
    fscanf(fi,"%ld%ld",&a,&b);
    a--; b--;
    ez[a]->z=new TEdge; ez[a]=ez[a]->z;
    ez[a]->b=b; ez[a]->c=i;
  }
  c=new long[n]; q=new long[n];
  ta=new long[n]; tb=new long[n];
  s=new long[m];
}
void TGraphOr::readtrans(void) {
  if (e) delete[]e; if (ez) delete[]ez;
  long i,a,b;
  fscanf(fi,"%ld%ld",&a,&b);
  e=new TEdge[n]; ez=new TEdge*[n];
  for (i=0; i<n; i++) { e[i].b=i; e[i].c=-1; ez[i]=&e[i]; }
  for (i=0; i<m; i++) {
    fscanf(fi,"%ld%ld",&a,&b);
    a--; b--;
    ez[b]->z=new TEdge; ez[b]=ez[b]->z;
    ez[b]->b=a; ez[b]->c=i;
  }
}
void TGraphOr::readbrid(void) {
  long i,a,b;
  fscanf(fi,"%ld%ld",&a,&b);
  r=0;
  for (i=0; i<m; i++) {
    fscanf(fi,"%ld%ld",&a,&b);
    a--; b--;
    if (c[a]!=c[b]) s[r++]=i;
  }
}
void TGraphOr::printc(void) {
  long i;
  fprintf(fo,"%ld\n",k);
  for (i=0; i<n; i++) {
    if (i) fprintf(fo," ");
    fprintf(fo,"%ld",c[i]+1);
  }
}
void TGraphOr::printb(void) {
  long i;
  fprintf(fo,"%ld\n",r);
  for (i=0; i<r; i++) {
    if (i) fprintf(fo," ");
    fprintf(fo,"%ld",s[i]+1);
  }
}

TEdge::TEdge(void) {
  z=0;
}
TEdge::~TEdge() {
  if (z) delete z;
}

