{.$define debug}

program template;
const
 h = 21000;
 {$ifdef debug}
 cinfile = 'input.txt';
 coutfile = 'output.txt';
 {$else}
 cinfile = 'd.in';
 coutfile = 'd.out';
 {$endif}
type
 int = longint;
 tptr = ^tlist;
 tlist = record
  inf :int;
  next :tptr;
 end;
var
 n,m :int;
 ans :int;
 graph :array [1..h] of tptr;
 paint :array [1..h] of int;

procedure init;
var i :int;
begin
 for i := 1 to h do
  graph[i] := nil;
 ans := 0;
 fillchar (paint,sizeof(paint),0);
end;

procedure add (var list :tptr; value :int);
var x :tptr;
begin
 new (x);
 x^.inf := value;
 x^.next := list;
 list := x;
end;

procedure readdata;
var i,j :int;
    a,b :int;
begin
 assign (input,cinfile);
 reset (input);
 readln (n,m);
 for i := 1 to m do
  begin
   readln (a,b);
   add (graph[a],b);
   add (graph[b],a);
  end;
 close (input);
end;

procedure outdata;
var i,j :int;
begin
 assign (output,coutfile);
 rewrite (output);
 writeln (ans);
 for i := 1 to n do
  write (paint[i],' ');
 close (output);
end;

procedure dfs (v :int);
var x :tptr;
begin
 if paint[v] > 0 then
  exit;
 paint[v] := ans;
 x := graph[v];
 while not (x = nil) do
  begin
   dfs (x^.inf);
   x := x^.next;
  end;
end;

procedure solve;
var i,j :int;
begin
 for i := 1 to n do
  if paint[i] = 0 then
   begin
    inc (ans);
    dfs (i);
   end;
end;

begin
 init;
 readdata;
 solve;
 outdata;
end.