{.$define debug}

program template;
const
 h = 21000;
 {$ifdef debug}
 cinfile = 'input.txt';
 coutfile = 'output.txt';
 {$else}
 cinfile = 'g.in';
 coutfile = 'g.out';
 {$endif}
type
 int = longint;
 tptr = ^tlist;
 tlist = record
  inf :int;
  next :tptr;
 end;
var
 n :int;
 m,k :int;
 ans :int;
 gr,graph,g :array [1..h] of tptr;
 paint :array [1..h] of int;
 out :array [1..h] of int;
 p :int;
 f,p_ :array [1..h] of int;
 time :int;
 num :array [1..h] of int;
 rev :array [1..h] of int;

procedure init;
var i :int;
begin
 ans := 0;
 for i := 1 to h do
  begin
   graph[i] := nil;
   gr[i] := nil;
   g[i] := nil;
  end;
 fillchar (paint,sizeof(paint),0);
 fillchar (out,sizeof(out),0);
 k := 0;
 p := 0;
 fillchar (f,sizeof(f),0);
 fillchar (p_,sizeof(p_),0);
 time := 0;
 randseed := 13;
 fillchar (rev,sizeof(rev),0);
end;

procedure add (var list :tptr; value :int);
var x :tptr;
begin
 new (x);
 x^.inf := value;
 x^.next := list;
 list := x;
end;

procedure readdata;
var i,j :int;
    a,b :int;
begin
 assign (input,cinfile);
 reset (input);
 readln (n,m);
 for i := 1 to m do
  begin
   readln (a,b);
   add (graph[a],b);
  end;
 close (input);
end;

procedure outdata;
var i,j :int;
begin
 assign (output,coutfile);
 rewrite (output);
 writeln (ans);
 for i := 1 to n do
  write (rev[paint[i]],' ');
 close (output);
end;

procedure dfs (v :int);
var x :tptr;
begin
 if paint[v] > 0 then
  exit;
 paint[v] := 1;
 x := graph[v];
 while not (x = nil) do
  begin
   dfs (x^.inf);
   x := x^.next;
  end;
 inc(k);
 out[k] := v;
end;

procedure maketransfer;
var i :int;
    x :tptr;
begin
 for i := 1 to n do
  begin
   x := graph[i];
   while not (x = nil) do
    begin
     add (gr[x^.inf],i);
     x := x^.next;
    end;
  end;
end;

procedure dfs2 (v :int);
var x :tptr;
begin
 if paint[v] > 0 then
  exit;
 paint[v] := p;
 x := gr[v];
 while not (x = nil) do
  begin
   if paint[x^.inf] <> 0 then
    begin
     if paint[x^.inf] < p then
      add (g[p],paint[x^.inf]);
    end
   else
    dfs2 (x^.inf);
   x := x^.next;
  end;
end;

procedure swap (var a,b :int);
begin
 a := a xor b;
 b := a xor b;
 a := a xor b;
end;

procedure sort (l,r :int);
var i,j :int;
    x :int;
begin
 i := l;
 j := r;
 x := f[l + random(r-l+1)];
 repeat
  while f[i] < x do
   inc(i);
  while f[j] > x do
   dec (j);
  if i <= j then
   begin
    if not (i = j) then
     begin
      swap (f[i],f[j]);
      swap (num[i],num[j]);
     end;
    inc (i);
    dec (j);
   end;
 until i > j;
 if i < r then
  sort (i,r);
 if l < j then
  sort (l,j);
end;


procedure dfs3 (v :int);
var x :tptr;
begin
 if p_[v] > 0 then
  exit;
 p_[v] := 1;
 x := g[v];
 inc (time);
 while not (x = nil) do
  begin
   dfs3(x^.inf);
   x := x^.next;
  end;
 f[v] := time;
 inc (time);
end;



procedure solve;
var i,j :int;
begin
 for i := 1 to n do
  if paint[i] = 0 then
   dfs(i);
 maketransfer;
 fillchar (paint,sizeof(paint),0);
 for i := k downto 1 do
  if paint[out[i]] = 0 then
   begin
    inc (p);
    dfs2 (out[i]);
   end;
 ans := p;
 for i := 1 to ans do
  if p_[i] = 0 then
   dfs3 (i);
 for i := 1 to ans do
  num[i] := i;
 sort (1,ans);
 for i := 1 to ans do
  rev[num[i]] := i;
end;

begin
 init;
 readdata;
 solve;
 outdata;
end.