{$I+,Q-,R-,S+}
program         Template;

type
  PEdge         = ^TEdge;
  TEdge         = record
    F, T        : Integer;
    Next        : PEdge;
  end;

var
  N, M, L       : LongInt;
  Edges         : array[1..20000] of PEdge;
  Visited       : array[1..20000] of Boolean;
  Colors        : array[1..20000] of Integer;

procedure       OpenFiles;
begin
  Assign(Input, 'd.in');
  Reset(Input);
  Assign(Output, 'd.out');
  Rewrite(Output);
end;

procedure       CloseFiles;
begin
  Close(Input);
  Close(Output);
end;

procedure       ReadData;
var
  I, F, T       : LongInt;
  Edge          : PEdge;
begin
  ReadLn(N, M); FillChar(Edges, SizeOf(Edges), 0);
  for I := 1 to M do begin
    ReadLn(F, T);

    New(Edge);
    Edge^.T := T;
    Edge^.Next := Edges[F];
    Edges[F] := Edge;

    New(Edge);
    Edge^.T := F;
    Edge^.Next := Edges[T];
    Edges[T] := Edge;
  end;
end;

procedure       DFT(V: Integer);
var
  I             : LongInt;
  E             : PEdge;
begin
  Visited[V] := True; Colors[V] := L;

  E := Edges[V];
  while E <> nil do begin
    if not Visited[E^.T] then
      DFT(E^.T);

    E := E^.Next;
  end;
end;

procedure       Solve;
var
  I             : LongInt;
  Flag          : Boolean;
begin
  FillChar(Visited, SizeOf(Visited), 0); L := 0;

  repeat
    Flag := True;
    for I := 1 to N do
      if not Visited[I] then begin
        Flag := False;
        Break;
      end;

    if not Flag then begin
      Inc(L);
      DFT(I);
    end;
  until Flag;

  WriteLn(L);
  for I := 1 to N do begin
    Write(Colors[I]);
    if I < N then
      Write(' ');
  end;
  WriteLn;
end;

begin
  OpenFiles;
  ReadData;
  Solve;
  CloseFiles;
end.
