{$I+,Q-,R-,S+}
program         Template;

type
  PEdge         = ^TEdge;
  TEdge         = record
    F, T        : Integer;
    N           : LongInt;
    Next        : PEdge;
  end;

var
  N, M, T, B    : LongInt;
  Edges         : array[1..20000] of PEdge;
  Tree          : array[1..200000] of TEdge;
  Taken         : array[1..200000] of Boolean;
  Visited, VV   : array[1..20000] of Boolean;
  U             : array[1..20000] of Boolean;
  Ent, Ext      : array[1..20000] of LongInt;
  Colors        : array[1..20000] of LongInt;

procedure       OpenFiles;
begin
  Assign(Input, 'e.in');
  Reset(Input);
  Assign(Output, 'e.out');
  Rewrite(Output);
end;

procedure       CloseFiles;
begin
  Close(Input);
  Close(Output);
end;

procedure       ReadData;
var
  I, F, T       : LongInt;
  Edge          : PEdge;
begin
  ReadLn(N, M); FillChar(Edges, SizeOf(Edges), 0);
  for I := 1 to M do begin
    ReadLn(F, T);

    New(Edge);
    Edge^.F := F;
    Edge^.T := T;
    Edge^.N := I;
    Edge^.Next := Edges[F];
    Edges[F] := Edge;

    New(Edge);
    Edge^.F := T;
    Edge^.T := F;
    Edge^.N := I;
    Edge^.Next := Edges[T];
    Edges[T] := Edge;
  end;
end;

procedure       DFT(V: Integer; var Time: LongInt);
var
  E             : PEdge;
begin
  Visited[V] := True; Inc(Time); Ent[V] := Time;

  E := Edges[V];
  while E <> nil do begin
    if not Visited[E^.T] then begin
      Inc(T);

      Tree[T].F := E^.T;
      Tree[T].T := E^.F;
      Tree[T].N := E^.N;

      Taken[E^.N] := True;

      DFT(E^.T, Time);
    end;

    E := E^.Next;
  end;

  Ext[V] := Time;
end;

procedure       DFT2(V: Integer);
var
  I             : LongInt;
  E             : PEdge;
begin
  VV[V] := True; Colors[V] := B;

  for I := 1 to T do
    if (Tree[I].F = V) and not VV[Tree[I].T] then
      DFT2(Tree[I].T);

  E := Edges[V];
  while E <> nil do begin
    if not Taken[E^.N] and not VV[E^.T] then
      DFT2(E^.T);

    E := E^.Next;
  end;
end;

procedure       Solve;
var
  Time, I, MI, C: LongInt;
begin
  T := 0; FillChar(Taken, SizeOf(Taken), 0);
  FillChar(Visited, SizeOf(Visited), 0); Time := 0; DFT(1, Time);

  B := 0; FillChar(VV, SizeOf(VV), 0); FillChar(U, SizeOf(U), 0);
  repeat
    Time := MAXLONGINT;
    for I := 1 to N do
      if (Ent[I] < Time) and not VV[I] then begin
        MI := I;
        Time := Ent[I];
      end;

    if Time <> MAXLONGINT then begin
      VV[MI] := True;
      Inc(B); DFT2(MI);
    end;
  until Time = MAXLONGINT;

  C := 0;
  for I := 1 to T do
    if Colors[Tree[I].F] <> Colors[Tree[I].T] then
      Inc(C);

  Writeln(C); MI := 0;
  for I := 1 to T do
    if Colors[Tree[I].F] <> Colors[Tree[I].T] then begin
      Inc(MI);
      Write(Tree[I].N);
      if MI < C then
        Write(' ');
    end;
  Writeln;
end;

begin
  OpenFiles;
  ReadData;
  Solve;
  CloseFiles;
end.
