const
     FileIn='2queens.in';
     FileOut='2queens.out';
     Delta=1;
var
   X1, Y1, X2, Y2, XK, YK: LongInt;
   Answer, AnswerNQueen, AnswerNewX, AnswerNewY: LongInt;

procedure ReadData;
var
   F: Text;
begin
     Assign (F, FileIn);
     Reset (F);
     Readln (F, X1, Y1, X2, Y2, XK, YK);
     Close (F);
end;

procedure WriteData;
var
   F: Text;
begin
     Assign (F, FileOut);
     Rewrite (F);
     Writeln (F, Answer);
     Writeln (F, AnswerNQueen, #32, AnswerNewX, #32, AnswerNewY);
     Close (F);
end;

function IsUnderAttack (aX, aY, aXQ, aYQ: LongInt): Boolean;
begin
     IsUnderAttack:=(Abs ((aX-aXQ))=Abs ((aY-aYQ))) or (aX=aXQ) or (aY=aYQ);
end;

function CheckMate (aX1, aY1, aX2, aY2, aXK, aYK: LongInt): Boolean;
var
   X, Y: LongInt;
begin
     for X:=aXK-1 to aXK+1
         do for Y:=aYK-1 to aYK+1
                do if not (IsUnderAttack (X, Y, aX1, aY1) or IsUnderAttack (X, Y, aX2, aY2))
                      then begin
                           CheckMate:=false;
                           Exit;
                      end;
     CheckMate:=true;
end;

function CanQueenGoFromTo (aX, aY, aNewX, aNewY, aX2, aY2: LongInt): Boolean;
begin
     CanQueenGoFromTo:=((Abs (aX-aNewX)=Abs (aY-aNewY)) or (aX=aNewX) or (aY=aNewY)) and ((Abs (aNewX-XK)>1) or (Abs (aNewY-YK)>1) or (IsUnderAttack (aNewX, aNewY, aX2, aY2)));
end;

procedure Solve;
var
   NewX, NewY: LongInt;
begin
     AnswerNQueen:=1;
     AnswerNewX:=2;
     AnswerNewY:=3;
     Answer:=1;
     for NewX:=XK-Delta to XK+Delta
         do for NewY:=XK-Delta to XK+Delta
                do begin
                   if CanQueenGoFromTo (X1, Y1, NewX, NewY, X2, Y2) and CheckMate (NewX, NewY, X2, Y2, XK, YK) and (not ((NewX=X2) and (NewY=Y2))) and (not ((NewX=XK) and (NewY=YK)))
                      then begin
                           AnswerNQueen:=1;
                           AnswerNewX:=NewX;
                           AnswerNewY:=NewY;
                           Exit;
                      end;
                   if CanQueenGoFromTo (X2, Y2, NewX, NewY, X1, Y1) and CheckMate (X1, Y1, NewX, NewY, XK, YK) and (not ((NewX=X1) and (NewY=Y1))) and (not ((NewX=XK) and (NewY=YK)))
                      then begin
                           AnswerNQueen:=2;
                           AnswerNewX:=NewX;
                           AnswerNewY:=NewY;
                           Exit;
                      end;
                end;
end;

procedure Main;
begin
     ReadData;
     Solve;
     WriteData;
end;

begin
     Main;
end.
