{$I+,Q-,R-,S-}
const
  inputfile = '2strings.in';
  outputfile = '2strings.out';
  maxn = 60001;

type
  int = longint;
  bool = boolean;
  tstring = record
    n: int;
    d: array[0..1, 0..maxn]of char;
  end;

var
  a, b: tstring;
  i, l: int;

function kmp(var t, p: tstring): bool;
var
  i, k: int;
  pr: array[0..maxn]of word;

begin
  kmp := false;
  k := 0;
  pr[0] := 0;
  pr[1] := 0;
  for i := 2 to p.n do begin
    while(k > 0)and(p.d[(k + 1)div maxn, (k + 1) mod maxn] <> p.d[i div maxn, i mod maxn])do
      k := pr[k];
    if(p.d[(k + 1)div maxn, (k + 1) mod maxn] = p.d[i div maxn, i mod maxn])then
      inc(k);
    pr[i] := k;
  end;

  k := 0;
  for i := 1 to t.n do begin
    while(k > 0)and(p.d[(k + 1)div maxn, (k + 1) mod maxn] <> t.d[i div maxn, i mod maxn])do
      k := pr[k];
    if(p.d[(k + 1)div maxn, (k + 1) mod maxn] = t.d[i div maxn, i mod maxn])then
      inc(k);
    if(k = p.n)then begin
      kmp := true;
      exit;
    end;
  end;
end;

procedure readstring(var s: tstring);
var
  c: char;
begin
  s.n := 0;
  read(c);
  while(not(ord(c) > 32))do
    read(c);
  while(ord(c) > 32)do begin
    inc(s.n);
    s.d[s.n div maxn, s.n mod maxn] := c;
    read(c);
  end;
end;

procedure add(var s: tstring);
var
  i, l: int;
begin
  l := s.n;
  for i := 1 to l do
    s.d[(s.n + i) div maxn, (s.n + i) mod maxn] := s.d[i div maxn, i mod maxn];
  s.n := s.n + l;
end;

function find(var a, b: tstring): int;
var
  i, down, up, mid: int;

function check(l: int): bool;
var
  i: int;
  s: tstring;
begin
  s.n := l;
  for i := 1 to l do
    s.d[i div maxn, i mod maxn] := b.d[i div maxn, i mod maxn];

  while(s.n <= a.n)do
    add(s);
  while(s.n <= b.n)do
    add(s);

  check := (kmp(s, a))and(kmp(s, b));
end;

begin
  down := 1;
  up := b.n;

  while(down + 1 < up)do begin
    mid := (down + up) div 2;
    if(check(mid))then
      up := mid
    else
      down := mid;
  end;
  if(check(down))then
    find := down
  else
    if(check(up))then
      find := up
    else
      find := -1;
end;

procedure writeall;
begin
  if(b.d[b.n div maxn, b.n mod maxn] = a.d[0, 1])then begin
    for i := 1 to b.n - 1 do
      write(b.d[i div maxn, i mod maxn]);
    for i := 1 to a.n do
      write(a.d[i div maxn, i mod maxn]);
  end else begin
    if(a.d[a.n div maxn, a.n mod maxn] = b.d[0, 1])then begin
      for i := 1 to a.n - 1 do
        write(a.d[i div maxn, i mod maxn]);
      for i := 1 to b.n do
        write(b.d[i div maxn, i mod maxn]);
    end else begin
      for i := 1 to a.n do
        write(a.d[i div maxn, i mod maxn]);
      for i := 1 to b.n do
        write(b.d[i div maxn, i mod maxn]);
    end;
  end;
end;

begin
  assign(input, inputfile);
  reset(input);
  assign(output, outputfile);
  rewrite(output);
  readstring(a);
  readstring(b);

  if(a.n < b.n)then begin
    l := find(b, a);
    if(l > 0)then
      for i := 1 to l do
        write(a.d[i div maxn, i mod maxn])
    else begin
      l := find(a, b);
      if(l > 0)then
        for i := 1 to l do
          write(b.d[i div maxn, i mod maxn])
      else begin
        writeall;
      end;
    end;
  end else begin
    l := find(a, b);
    if(l > 0)then
      for i := 1 to l do
        write(b.d[i div maxn, i mod maxn])
    else begin
      l := find(b, a);
      if(l > 0)then
        for i := 1 to l do
          write(a.d[i div maxn, i mod maxn])
      else begin
        writeall;
      end;
    end;
  end;
  close(output);
  close(input);
end.