const
     FileIn='2strings.in';
     FileOut='2strings.out';
     MaxN=50000;
     MaxShifts=MaxN;
type
    TLongStr=array [1..MaxN] of Char;
    TPi=array [1..MaxN] of LongInt;
    TShifts=record
                  Values: array [1..MaxShifts] of LongInt;
                  Count: LongInt;
            end;
var
   A, B, C: TLongStr;
   N, M, L: LongInt;
   ShiftsA, ShiftsB: TShifts;

procedure ReadData;
var
   F: Text;
begin
     Assign (F, FileIn);
     Reset (F);
     N:=0;
     while not EOLn (F)
           do begin
              Inc (N);
              Read (F, A [N]);
           end;
     Readln (F);
     M:=0;
     while not EOLn (F)
           do begin
              Inc (M);
              Read (F, B [M]);
           end;
     Close (F);
end;

procedure WriteData;
var
   F: Text;
   NChar: LongInt;
begin
     Assign (F, FileOut);
     Rewrite (F);
     for NChar:=1 to L
         do Write (F, C [NChar]);
     Writeln (F);
     Close (F);
end;

procedure ComputePrefixFunction (const aP: TLongStr; aM: LongInt; var aPi: TPi);
var
   q, k: LongInt;
begin
     aPi [1]:=0;
     k:=0;
     for q:=2 to aM
         do begin
            while (k>0) and (aP [k+1]<>aP [q])
                  do k:=aPi [k];
            if aP [k+1]=aP [q]
               then Inc (k);
            aPi [q]:=k;
         end;
end;

procedure KMPMatcher (const aT, aP: TLongStr; aN, aM: LongInt; var aShifts: TShifts);
var
   Pi: TPi;
   q, i: LongInt;
begin
     ComputePrefixFunction (aP, aM, Pi);
     q:=0;
     for i:=1 to aN
         do begin
            while (q>0) and (aP [q+1]<>aT [i])
                  do q:=Pi [q];
            if aP [q+1]=aT [i]
               then Inc (q);
            if q=aM
               then begin
                    Inc (aShifts.Count);
                    aShifts.Values [aShifts.Count]:=i-aM+1;
                    q:=Pi [q];
               end;
         end;
end;

function Min (aA, aB: LongInt): LongInt;
begin
     if aA<aB
        then Min:=aA
        else Min:=aB;
end;

function Max (aA, aB: LongInt): LongInt;
begin
     if aA<aB
        then Max:=aB
        else Max:=aA;
end;

function Calc (aSA, aSB: LongInt): LongInt;
begin
     Calc:=Max (ShiftsA.Values [aSA]+N, ShiftsB.Values [aSB]+M)-
           Min (ShiftsA.Values [aSA], ShiftsB.Values [aSB]);
end;

function Diff (aA, aB: TLongStr; aLen: LongInt): Boolean;
var
   NChar: LongInt;
begin
     for NChar:=1 to aLen
         do if aA [NChar]<>aB [NChar]
               then begin
                    Diff:=true;
                    Exit;
               end;
     Diff:=false;
end;

procedure Solve;
var
   SA, SB, BestSA, BestSB, Best, Cur, PartLen: LongInt;
begin
     L:=N+M;
     Move (A, C, N);
     Move (B, C [N+1], M);
     FillChar (ShiftsA, SizeOf (ShiftsA), 0);
     FillChar (ShiftsB, SizeOf (ShiftsB), 0);
     KMPMatcher (C, A, L, N, ShiftsA);
     KMPMatcher (C, B, L, M, ShiftsB);
     BestSA:=1;
     BestSB:=1;
     Best:=Calc (BestSA, BestSB);
     for SA:=1 to ShiftsA.Count
         do for SB:=1 to ShiftsB.Count
                do begin
                   Cur:=Calc (SA, SB);
                   if Cur<Best
                      then begin
                           BestSA:=SA;
                           BestSB:=SB;
                           Best:=Cur;
                      end;
                end;
     Move (C [Min (ShiftsA.Values [BestSA], ShiftsB.Values [BestSB])], C, Best);
     L:=Best;
     Move (C, A, L);
     for PartLen:=1 to L div 2
         do begin
            Move (C [PartLen+1], B, PartLen);
            if not Diff (A, B, PartLen)
               then begin
                    L:=PartLen;
                    Exit;
               end;
         end;
end;

procedure Main;
begin
     ReadData;
     Solve;
     WriteData;
end;

begin
     Main;
end.
