{Define CheckMyself}
const
     FileIn='print.in';
     FileOut='print.out';
     MaxN=5000;
     cmdLetter=1;
     cmdRepeat=2;
     HashMod=1000099;
     HashK=256;
type
    TCommand=record
                   CmdType: Byte;
                   Param: LongInt;
             end;
    TWay=record
               From: LongInt;
               Cmd: TCommand;
               StepsCount: LongInt;
         end;
var
   PrintStr: array [1..MaxN] of Char;
   PrintStrLen: LongInt;
   InvertedCommandList: array [1..MaxN] of TCommand;
   ListLen: LongInt;
   Ways: array [1..MaxN] of TWay;

procedure ReadData;
var
   F: Text;
begin
     Assign (F, FileIn);
     Reset (F);
     PrintStrLen:=0;
     while not EOLn (F)
           do begin
              Inc (PrintStrLen);
              Read (F, PrintStr [PrintStrLen]);
           end;
     Close (F);
end;

procedure WriteData;
var
   F: Text;
   NCmd: LongInt;
begin
     Assign (F, FileOut);
     Rewrite (F);
     Writeln (F, ListLen+1);
     for NCmd:=ListLen downto 1
         do case InvertedCommandList [NCmd].CmdType of
                 cmdLetter: Writeln (F, 'Letter(''', Chr (InvertedCommandList [NCmd].Param), ''');');
                 cmdRepeat: Writeln (F, 'Repeat(', InvertedCommandList [NCmd].Param, ');');
            end;
     Writeln (F, 'End.');
     Close (F);
end;

function GoodLen (aLen, aPrintedLen: LongInt): Boolean;
var
   NChar: LongInt;
begin
     for NChar:=aPrintedLen-aLen+1 to aPrintedLen
         do if PrintStr [NChar]<>PrintStr [NChar+aLen]
               then begin
                    GoodLen:=false;
                    Exit;
               end;
     GoodLen:=true;
end;

procedure ProcessWay (aPrintedLen: LongInt);
var
   Len, L, R: LongInt;
   LHash, RHash, LeftK: LongInt;
begin
     LHash:=0;
     RHash:=0;
     L:=aPrintedLen;
     R:=aPrintedLen+1;
     LeftK:=1;
     Len:=0;
     while (L>=1) and (R<=PrintStrLen)
           do begin
              LHash:=(LHash+LeftK*Ord (PrintStr [L])) mod HashMod;
              LeftK:=(LeftK*HashK) mod HashMod;
              RHash:=(RHash*HashK+Ord (PrintStr [R])) mod HashMod;
              if (LHash=RHash) and GoodLen (R-aPrintedLen, aPrintedLen)
                 then begin
                      Len:=R-aPrintedLen;
                      if (Len>1) and ((Ways [aPrintedLen].StepsCount+1<Ways [aPrintedLen+Len].StepsCount) or
                         (Ways [aPrintedLen+Len].StepsCount=0))
                         then begin
                              Ways [aPrintedLen+Len].Cmd.CmdType:=cmdRepeat;
                              Ways [aPrintedLen+Len].Cmd.Param:=Len;
                              Ways [aPrintedLen+Len].StepsCount:=Ways [aPrintedLen].StepsCount+1;
                              Ways [aPrintedLen+Len].From:=aPrintedLen;
                         end;
                 end;
              Dec (L);
              Inc (R);
           end;
     if (Ways [aPrintedLen].StepsCount+1<Ways [aPrintedLen+1].StepsCount) or
        (Ways [aPrintedLen+1].StepsCount=0)
        then begin
             Ways [aPrintedLen+1].From:=aPrintedLen;
             Ways [aPrintedLen+1].Cmd.CmdType:=cmdLetter;
             Ways [aPrintedLen+1].Cmd.Param:=Ord (PrintStr [aPrintedLen+1]);
             Ways [aPrintedLen+1].StepsCount:=Ways [aPrintedLen].StepsCount+1
        end;
end;

procedure CheckMyself;
var
   NCmd: LongInt;
   MyStr: array [1..MaxN] of Char;
   MyStrLen, NChar: LongInt;
begin
     Writeln ('Checking myself...');
     MyStrLen:=0;
     for NCmd:=ListLen downto 1
         do case InvertedCommandList [NCmd].CmdType of
                 cmdLetter: begin
                                 Inc (MyStrLen);
                                 MyStr [MyStrLen]:=Chr (InvertedCommandList [NCmd].Param);
                            end;
                 cmdRepeat: begin
                                 for NChar:=MyStrLen-InvertedCommandList [NCmd].Param+1 to MyStrLen
                                     do begin
                                        Inc (MyStrLen);
                                        MyStr [MyStrLen]:=MyStr [NChar];
                                     end;
                            end;
         end;
     if MyStrLen<>PrintStrLen
        then Writeln ('Lengths are different!')
        else for NChar:=1 to MyStrLen
                 do if MyStr [NChar]<>PrintStr [NChar]
                       then Writeln (NChar, ': "', MyStr [NChar], '"<>"', PrintStr [NChar], '"!');
     Writeln ('Done.');
end;

procedure Solve;
var
   NWay: LongInt;
begin
     FillChar (Ways, SizeOf (Ways), 0);
     Ways [1].Cmd.CmdType:=cmdLetter;
     Ways [1].Cmd.Param:=Ord (PrintStr [1]);
     Ways [1].StepsCount:=1;
     for NWay:=1 to PrintStrLen-1
         do if Ways [NWay].StepsCount>0
               then ProcessWay (NWay);
     ListLen:=1;
     NWay:=PrintStrLen;
     while NWay<>1
           do begin
              InvertedCommandList [ListLen]:=Ways [NWay].Cmd;
              NWay:=Ways [NWay].From;
              Inc (ListLen);
           end;
     InvertedCommandList [ListLen]:=Ways [NWay].Cmd;
     {$IfDef CheckMyself}
     CheckMyself;
     {$EndIf}
end;

procedure Main;
begin
     ReadData;
     Solve;
     WriteData;
end;

begin
     Main;
end.
