{$I-,Q-,R-,S-}
const
     FileIn='nice.in';
     FileOut='nice.out';
     MaxN=100;
     MaxM=100;
var
   M, N: LongInt;
   Matrix: array [1..MaxN, 1..MaxM] of LongInt;
   R, RNow: array [1..MaxM] of LongInt;
   C, CNow: array [1..MaxN] of LongInt;
   NoAnswer: Boolean;

procedure ReadData;
var
   F: Text;
   Row, Col: LongInt;
begin
     Assign (F, FileIn);
     Reset (F);
     Readln (F, M, N);
     for Row:=1 to M
         do Read (F, R [Row]);
     Readln (F);
     for Col:=1 to N
         do Read (F, C [Col]);
     Readln (F);
     for Row:=1 to M
         do begin
            for Col:=1 to N
                do Read (F, Matrix [Col, Row]);
            Readln (F);
         end;
     Close (F);
end;

procedure WriteData;
var
   F: Text;
   Row, Col: LongInt;
begin
     Assign (F, FileOut);
     Rewrite (F);
     if NoAnswer
        then Writeln (F, '-1')
        else for Row:=1 to M
                 do begin
                    for Col:=1 to N-1
                        do Write (F, Matrix [Col, Row], #32);
                    Writeln (F, Matrix [N, Row]);
                 end;
     Close (F);
end;

procedure CalcRCNow;
var
   X, Y: LongInt;
begin
     FillChar (RNow, SizeOf (RNow), 0);
     for X:=1 to N
         do for Y:=1 to M
                do if Matrix [X, Y]>=0
                      then begin
                           Inc (RNow [Y], Matrix [X, Y]);
                           Inc (CNow [X], Matrix [X, Y]);
                      end;
end;

function Min (aA, aB: LongInt): LongInt;
begin
     if aA<aB
        then Min:=aA
        else Min:=aB;
end;

procedure Solve;
var
   X, Y: Longint;
begin
     CalcRCNow;
     for Y:=1 to M
         do if RNow [Y]>R [Y]
               then begin
                    NoAnswer:=true;
                    Exit;
               end;
     for X:=1 to N
         do if CNow [X]>C [X]
               then begin
                    NoAnswer:=true;
                    Exit;
               end;
     for X:=1 to N
         do for Y:=1 to M
                do if Matrix [X, Y]<0
                      then begin
                           Matrix [X, Y]:=Min (R [Y]-RNow [Y], C [X]-CNow [X]);
                           Inc (RNow [Y], Matrix [X, Y]);
                           Inc (CNow [X], Matrix [X, Y]);
                      end;
     NoAnswer:=false;
end;

procedure Main;
begin
     ReadData;
     Solve;
     WriteData;
end;

begin
     Main;
end.
