program Circles;
{$N+}
type
  tpoint = record
    x,y : extended;
  end;
  tcirc = record
    x,y,r : longint;
  end;

const
  eps = 1e-10;

var
  c1,c2,c3 : tcirc;
  l : extended;

procedure Inp;
begin
  assign(input,'circles.in'); reset(input);
  assign(output,'circles.out'); rewrite(output);
  read(c1.x,c1.y,c1.r,c2.x,c2.y,c2.r);
  l := sqrt(sqr(c1.x-c2.x)+sqr(c1.y-c2.y));
end;

procedure Run;
var
  s,p,h,d : extended;
  p1,vech : tpoint;
begin
  if c1.r<c2.r then
  begin
    c3 := c1;
    c1 := c2;
    c2 := c3;
  end;
  if (c1.x=c2.x) and (c1.y=c2.y) then
  begin
    if c1.r=c2.r then
      writeln(-1)
    else
      writeln(0);
  end else
  if (l+c2.r+eps<c1.r) then
    writeln(-1)
  else
  if (abs(l+c2.r-c1.r)<eps) then
  begin
    writeln(1);
    writeln((1-c1.r/l)*c1.x+(c1.r/l)*c2.x:0:6,' ',(1-c1.r/l)*c1.y+(c1.r/l)*c2.y:0:6);
  end else
  if (abs(l-c2.r-c1.r)<eps) then
  begin
    writeln(1);
    writeln((1-c1.r/l)*c1.x+(c1.r/l)*c2.x:0:6,' ',(1-c1.r/l)*c1.y+(c1.r/l)*c2.y:0:6);
  end else
  begin
    p := (c1.r+c2.r+l)/2;
    s := sqrt(p*(p-c1.r)*(p-c2.r)*(p-l));
    h := 2*s/l;
    d := sqrt(sqr(c1.r)-sqr(h));
    d := d/l;
    p1.x := d*c2.x+(1-d)*c1.x;
    p1.y := d*c2.y+(1-d)*c1.y;
    writeln(2);
    vech.x := (c1.y-c2.y)*h/l;
    vech.y := (c2.x-c1.x)*h/l;
    writeln(p1.x+vech.x:0:6,' ',p1.y+vech.y:0:6);
    writeln(p1.x-vech.x:0:6,' ',p1.y-vech.y:0:6);
  end;
end;

procedure Outp;
begin
  close(input); close(output);
end;

begin
  Inp;
  Run;
  Outp;
end.