program Segment;
{$N+}
type
  tpoint = record
    x,y : extended;
  end;
  tppoint = record
    x,y : longint;
  end;
  tbounds = record
    mn,mx : tppoint;
  end;

const
  eps = 1e-10;

function squ(a,b,c : tpoint) : extended;
begin
  squ := (a.x-b.x)*(a.y+b.y) + (b.x-c.x)*(b.y+c.y) + (c.x-a.x)*(c.y+a.y);
end;

function min(a,b : longint) : longint;
begin
  if a>b then min := b else min := a;
end;

function max(a,b : longint) : longint;
begin
  if a<b then max := b else max := a;
end;

var
  s1,t1,s2,t2 : tpoint;
  s01,t01,s02,t02 : tppoint;

function sgn(a : extended) : shortint;
begin
  if a>eps then sgn := 1
  else if a<-eps then sgn := -1
  else sgn := 0;
end;

procedure Inp;
begin
  assign(input,'segment.in'); reset(input);
  assign(output,'segment.out'); rewrite(output);
  read(s01.x,s01.y,t01.x,t01.y,s02.x,s02.y,t02.x,t02.y);
  s1.x := s01.x; s1.y := s01.y;
  s2.x := s02.x; s2.y := s02.y;
  t1.x := t01.x; t1.y := t01.y;
  t2.x := t02.x; t2.y := t02.y;
end;

procedure Run;
var
  a1,a2 : shortint;
  b1,b2,b3 : tbounds;
  p : extended;
begin
  a1 := sgn(squ(s1,t1,s2));
  a2 := sgn(squ(s1,t1,t2));
  if (a1=a2) then
  begin
    if a1=0 then
    begin
      b1.mn.x := min(s01.x,t01.x);
      b1.mx.x := max(s01.x,t01.x);
      b1.mn.y := min(s01.y,t01.y);
      b1.mx.y := max(s01.y,t01.y);

      b2.mn.x := min(s02.x,t02.x);
      b2.mx.x := max(s02.x,t02.x);
      b2.mn.y := min(s02.y,t02.y);
      b2.mx.y := max(s02.y,t02.y);

      b3.mn.x := max(b1.mn.x,b2.mn.x);
      b3.mx.x := min(b1.mx.x,b2.mx.x);
      b3.mn.y := max(b1.mn.y,b2.mn.y);
      b3.mx.y := min(b1.mx.y,b2.mx.y);

      if (b3.mn.x > b3.mx.x) or (b3.mn.y > b3.mx.y) then
        writeln('Empty')
      else
      begin
        if (b3.mn.x = b3.mx.x) and (b3.mn.y = b3.mx.y) then
          writeln((b3.mn.x + b3.mx.x)/2:0:6,' ',(b3.mn.y + b3.mx.y)/2:0:6)
        else
        begin
          if ((s1.x<=t1.x) and (s1.y<=t1.y)) or ((t1.x<=s1.x) and (t1.y<=s1.y)) then
            writeln(1.0*b3.mn.x:0:6,' ',1.0*b3.mn.y:0:6,' ',1.0*b3.mx.x:0:6,' ',1.0*b3.mx.y:0:6)
          else
            writeln(1.0*b3.mn.x:0:6,' ',1.0*b3.mx.y:0:6,' ',1.0*b3.mx.x:0:6,' ',1.0*b3.mn.y:0:6);
        end;
      end;
    end
    else
      writeln('Empty');
  end
  else
  begin
    a1 := sgn(squ(s2,t2,s1));
    a2 := sgn(squ(s2,t2,t1));
    if (a1=a2) then
      writeln('Empty')
    else
    begin
      p := (s2.x-s1.x)*(s2.y-t2.y) - (s2.x-t2.x)*(s2.y-s1.y);
      p := p/((s1.x-t1.x)*(t2.y-s2.y) - (s1.y-t1.y)*(t2.x-s2.x));
      writeln(p*t1.x+(1-p)*s1.x:0:6,' ',p*t1.y+(1-p)*s1.y:0:6);
    end;
  end;
end;

procedure Outp;
begin
  close(input); close(output);
end;

begin
  Inp;
  Run;
  Outp;
end.