#include <stdio.h>
#include <math.h>

FILE*fi,*fo;

#define EPS ((double)1e-7)

struct TPoint {
  double x,y;
};
struct TLine {
  double x1,y1,x2,y2;
  double a,b,c;
};
int sign(double);
double dist(double,double,double,double);
void pp2l(TLine*,TPoint*,TPoint*);
int lXl(TPoint*,TLine*,TLine*);
int lXs(TLine*,TLine*);
int p0s(TLine*,TPoint*);


TPoint a1,a2,b1,b2,c0,c1,c2;
TLine a0,b0;
int pa,pb,cn;

int main(void) {
  fi=fopen("segment.in","rt");
  fscanf(fi,"%lf%lf",&a1.x,&a1.y); fscanf(fi,"%lf%lf",&a2.x,&a2.y);
  fscanf(fi,"%lf%lf",&b1.x,&b1.y); fscanf(fi,"%lf%lf",&b2.x,&b2.y);
  fclose(fi);
  pa=(( !sign(a1.x-a2.x) )&&( !sign(a1.y-a2.y) ));
  pb=(( !sign(b1.x-b2.x) )&&( !sign(b1.y-b2.y) ));
  pp2l(&a0,&a1,&a2); pp2l(&b0,&b1,&b2);
  if ((!pa)&&(!pb)) {
    int z1,z2;
    cn=lXl(&c0,&a0,&b0);
    z1=lXs(&b0,&a0); z2=lXs(&a0,&b0);
    if (cn) {
      if (z1&&z2) cn=1; else cn=0;
    } else {
      if (z1||z2) {
        if (( sign(a1.x-a2.x)>0 )||(( !sign(a1.x-a2.x) )&&( sign(a1.y-a2.y)>0 )))
        { c0=a1; a1=a2; a2=c0; }
        if (( sign(b1.x-b2.x)>0 )||(( !sign(b1.x-b2.x) )&&( sign(b1.y-b2.y)>0 )))
        { c0=b1; b1=b2; b2=c0; }
        if (( sign(a1.x-b1.x)>0 )||(( !sign(a1.x-b1.x) )&&( sign(a1.y-b1.y)>0 )))
        { c0=a1; a1=b1; b1=c0; c0=a2; a2=b2; b2=c0; }
        double da1,da2,db1,db2;
        da1=dist(a1.x,a1.y,a1.x,a1.y);
        da2=dist(a1.x,a1.y,a2.x,a2.y);
        db1=dist(a1.x,a1.y,b1.x,b1.y);
        db2=dist(a1.x,a1.y,b2.x,b2.y);
        if (sign(da2-db1)<0) cn=0;
        else if (!sign(da2-db1)) { cn=1; c0=b1; }
        else {
          cn=2; c1=b1;
          if (sign(da2-db2)<=0) c2=a2; else c2=b2;
        }
      } else cn=0;
    }
  } else if (!pa) {
    if (p0s(&a0,&b1)) { cn=1; c0=b1; }
    else cn=0;
  } else if (!pb) {
    if (p0s(&b0,&a1)) { cn=1; c0=a1; }
    else cn=0;
  } else {
    if (( !sign(a1.x-b1.x) )&&( !sign(a1.y-b1.y) )) { cn=1; c0=a1; }
    else cn=0;
  }
  fo=fopen("segment.out","wt");
  switch(cn) {
    case 1: fprintf(fo,"%.6lf %.6lf",c0.x,c0.y); break;
    case 2: fprintf(fo,"%.6lf %.6lf %.6lf %.6lf",c1.x,c1.y,c2.x,c2.y); break;
    default: fprintf(fo,"Empty");
  }
  fclose(fo);
  return(0);
}


int sign(double z) {
  if (z>+EPS) return(+1);
  if (z<-EPS) return(-1);
  return(0);
}
double dist(double x0,double y0,double x1,double y1) {
  x0-=x1; y0-=y1;
  double d=x0*x0+y0*y0;
  return(sqrt(d));
}
void pp2l(TLine*l,TPoint*p,TPoint*q) {
  l->x1=p->x; l->y1=p->y;
  l->x2=q->x; l->y2=q->y;
  l->a=l->y1-l->y2; l->b=l->x2-l->x1;
  l->c=l->x1*l->y2-l->x2*l->y1;
}
int lXl(TPoint*p,TLine*k,TLine*l) {
  double x,y,z;
  x=k->b*l->c-l->b*k->c;
  y=l->a*k->c-k->a*l->c;
  z=k->a*l->b-l->a*k->b;
  if (!sign(z)) return(0);
  p->x=x/z; p->y=y/z;
  return(1);
}
int lXs(TLine*s,TLine*l) {
  int a,b;
  a=sign(l->a*s->x1+l->b*s->y1+l->c);
  b=sign(l->a*s->x2+l->b*s->y2+l->c);
  if ((!a)&&(!b)) return(-1);
  if (a*b<=0) return(1);
  return(0);
}
int p0s(TLine*l,TPoint*p) {
  double d0,d1,d2;
  d0=dist(l->x1,l->y1,l->x2,l->y2);
  d1=dist(l->x1,l->y1,p->x,p->y);
  d2=dist(l->x2,l->y2,p->x,p->y);
  int z=sign(d1+d2-d0);
  return(z<=0);
}


