{$N+}
{.$define debug}

program template;
const
 eps = 1e-7;
 {$ifdef debug}
 cinfile = 'input.txt';
 coutfile = 'output.txt';
 {$else}
 cinfile = 'circles.in';
 coutfile = 'circles.out';
 {$endif}
type
 int = longint;
 real = extended;
 tpoint = record
  x,y :real;
 end;
var
 n :int;
 ans :int;
 x1,y1,r1 :real;
 x2,y2,r2 :real;
 p1,p2 :tpoint;

procedure init;
begin
 ans := 0;
end;

procedure outpoint (p :tpoint);
begin
 writeln ((p.x+x2):0:7,' ',(p.y+y2):0:7);
end;

procedure readdata;
var i,j :int;
begin
 assign (input,cinfile);
 reset (input);
 read (x1,y1,r1);
 read (x2,y2,r2);
 close (input);
end;

function q (a,b :tpoint):boolean;
begin
 q := (abs(a.x - b.x) < eps) and (abs(a.y - b.y) < eps);
end;

procedure outdata;
var i,j :int;
begin
 if ans = 2 then
  if q(p1,p2) then
   ans := 1;
 assign (output,coutfile);
 rewrite (output);
 writeln (ans);
 if ans = 1 then
  outpoint (p1)
 else if ans = 2 then
  begin
   outpoint (p1);
   outpoint (p2);
  end;
 close (output);
 halt;
end;

procedure outinfinite;
begin
 assign (output,coutfile);
 rewrite (output);
 writeln (-1);
 close (output);
 halt;
end;


procedure solve;
var i,j :int;
    a,b,c :real;
    aa,bb,cc :real;
    d :real;
begin
 x1 := x1 - x2;
 y1 := y1 - y2;
 if (abs (x1) < eps) and (abs(y1) < eps) then
  if abs (r1-r2) < eps then
   outinfinite
  else
   outdata;
 a := -2*x1;
 b := -2*y1;
 c := sqr(x1) + sqr(y1) + sqr(r2) - sqr(r1);
 if abs (a) < eps then
  begin
   p1.y := -c/b;
   p2.y := p1.y;
   if p1.y > r2 then
    exit;
   p1.x := sqrt (sqr(r2) - sqr(p1.y));
   p2.x := -sqrt (sqr(r2) - sqr(p1.y));
   ans := 2;
   outdata;
  end;
 aa := 1 + sqr(b)/sqr(a);
 bb := (2*b*c)/sqr(a);
 cc := sqr(c)/sqr(a) - sqr(r2);
 d := sqr(bb) - 4*aa*cc;
 if abs(cc) < eps then
  begin
   ans := 2;
   p1.y := 0;
   p2.y := -bb;
   p1.x := (-b*p1.y-c)/a;
   p2.x := (-b*p2.y-c)/a;
   outdata;
  end;

 if d < -eps then
  outdata;
 if abs (d) < eps then
  begin
   d := 0;
   ans := 1;
   p1.y := (-bb)/(2*aa);
   p1.x := (-b*p1.y-c)/a;
  end
 else
  begin
   ans := 2;
   p1.y := (-bb - sqrt(d))/(2*aa);
   p1.x := (-b*p1.y - c)/a;
   p2.y := (-bb + sqrt(d))/(2*aa);
   p2.x := (-b*p2.y - c)/a;
  end;
end;

begin
 init;
 readdata;
 solve;
 outdata;
end.