{$N+}
{.$define debug}

program template;
const
 eps = 1e-7;
 {$ifdef debug}
 cinfile = 'input.txt';
 coutfile = 'output.txt';
 {$else}
 cinfile = 'segment.in';
 coutfile = 'segment.out';
 {$endif}
type
 int = longint;
 real = extended;
 tpoint = record
  x,y :real;
 end;
var
 n :int;
 ans :int;
 a,b,c,d :tpoint;
 p :tpoint;
 p1,p2 :tpoint;

procedure init;
begin
 ans := 0;
end;

procedure outno;
begin
 assign (output,coutfile);
 rewrite (output);
 writeln ('Empty');
 close (output);
 halt;
end;

procedure outpoint (p :tpoint);
begin
 assign (output,coutfile);
 rewrite (output);
 writeln (p.x:0:7,' ',p.y:0:7);
 close (output);
 halt;
end;

procedure readdata;
var i,j :int;
begin
 assign (input,cinfile);
 reset (input);
 read (a.x,a.y,b.x,b.y,c.x,c.y,d.x,d.y);
 close (input);
end;

function q (a,b :tpoint):boolean;
begin
 q := (abs(a.x - b.x) < eps) and (abs(a.y - b.y) < eps);
end;

procedure outdata;
var i,j :int;
begin
 if q(p1,p2) then
  outpoint (p1);
 assign (output,coutfile);
 rewrite (output);
 writeln (p1.x:0:7,' ',p1.y:0:7,' ',p2.x:0:7,' ',p2.y:0:7);
 close (output);
 halt;
end;

function len (a,b :tpoint):real;
begin
 len := sqrt (sqr (a.x - b.x) + sqr(a.y - b.y));
end;

function into (a,b :tpoint; p :tpoint):boolean;
begin
 into := len (a,p) + len (p,b) - len (a,b) < eps;
end;

procedure parallel;
begin
 if (q(a,c) and q(b,d)) or (q(a,d) and q(b,c)) then
  begin
   p1 := a;
   p2 := b;
   outdata;
  end;
 {======}
 if into (c,d,a) and into (c,d,b) then
  begin
   p1 := a;
   p2 := b;
   outdata;
  end;
 if into (a,b,c) and into (a,b,d) then
  begin
   p1 := c;
   p2 := d;
   outdata;
  end;
 {========}
 if into (a,b,c) then
  begin
   p1 := c;
   if into (c,d,b) then
    p2 := b;
   if into (c,d,a) then
    p2 := a;
   outdata;
  end;
 if into (a,b,d) then
  begin
   p1 := d;
   if into (c,d,a) then
    p2 := a;
   if into (c,d,b) then
    p2 := b;
   outdata;
  end;
 {=======}
 if into (c,d,a) then
  begin
   p1 := a;
   if into (a,b,d) then
    p2 := d;
   if into (a,b,c) then
    p2 := c;
   outdata;
  end;
 if into (c,d,b) then
  begin
   p1 := b;
   if into (a,b,c) then
    p2 := c;
   if into (a,b,d) then
    p2 := d;
   outdata;
  end;
 outno;
end;

procedure solve;
var i,j :int;
    a1,b1,c1 :real;
    a2,b2,c2 :real;
begin
 if q (a,b) then
  if into (c,d,a) then
   outpoint (a)
  else
   outno;
 if q (c,d) then
  if into (a,b,c) then
   outpoint (c)
  else
   outno;
 {=======}
 a1 := a.y - b.y;
 b1 := b.x - a.x;
 c1 := -a1*a.x - b1*a.y;
 {====}
 a2 := c.y - d.y;
 b2 := d.x - c.x;
 c2 := -a2*c.x - b2*c.y;
 {=======}
 if (abs (a1) < eps) and (abs (a2) < eps) then
  parallel;
 if not ((abs (a1) < eps) or (abs(a2) < eps)) then
  if abs (b1/a1 - b2/a2) < eps then
   parallel;
 {=======}
 if not( ((a1*c.x + b1*c.y + c1)*(a1*d.x + b1*d.y + c1) < eps) and
         ((a2*a.x + b2*a.y + c2)*(a2*b.x + b2*b.y + c2) < eps)) then
          outno;
 if not (abs (a1) < eps) then
  begin
   p.y := (c1*a2/a1 - c2)/(b2 - b1*a2/a1);
   p.x := (-c1 - b1*p.y)/a1;
  end
 else
  begin
   p.y := (c2*a1/a2 - c1)/(b1 - b2*a1/a2);
   p.x := (-c2 - b2*p.y)/a2;
  end;
 outpoint (p);
end;

begin
 init;
 readdata;
 solve;
 outdata;
end.