{$D-,E+,I-,L-,P-,Q-,R-,S+,T+,V+,X+}
Type Real   = Extended;
     Point  = Record x,y : Real End;
     Line   = Record A,B,C : Real End;

Const Eps : Real = 1e-10;
      Inf = 1e+10;
      PInf : Point = (x:Inf; y:Inf);


var
a,b,c,d,o:point;
ab,cd:line;




Function Eq(Const a,b : Real) : Boolean;
Begin
  Eq:=Abs(a-b)<=Eps;
End;

Function Ne(Const a,b : Real) : Boolean;
Begin
  Ne:=Abs(a-b)>Eps;
End;

Function Le(Const a,b : Real) : Boolean;
Begin
  Le:=(a<=b) Or Eq(a,b);
End;

Function Lt(Const a,b : Real) : Boolean;
Begin
  Lt:=(a<b) And Ne(a,b);
End;

Function Ge(Const a,b : Real) : Boolean;
Begin
  Ge:=(a>=b) Or Eq(a,b);
End;

Function Gt(Const a,b : Real) : Boolean;
Begin
  Gt:=(a>b) And Ne(a,b);
End;

Function Btw(Const x,a,b : Real) : Boolean;
Begin
  Btw:=Le(a,x) And Le(x,b) Or Ge(a,x) And Ge(x,b);
End;

Function BtwS(Const x,a,b : Real) : Boolean;
Begin
  BtwS:=(a<=x) And (x<=b) Or (a>=x) And (x>=b);
End;

Function Det(Const a,b,c,d : Real) : Real;
Begin
  Det:=a*d-b*c;
End;


Function PBtw(Const P,P1,P2 : Point) : Boolean;
Begin
  PBtw:=Btw(P.x,P1.x,P2.x) And Btw(P.y,P1.y,P2.y);
End;

Function PBtwS(Const P,P1,P2 : Point) : Boolean;
Begin
  PBtwS:=BtwS(P.x,P1.x,P2.x) And BtwS(P.y,P1.y,P2.y);
End;

Procedure PMoveTo(Const P1,P2 : Point; Const k : Real; Var P : Point);
Begin
  P.x:=P1.x+(P2.x-P1.x)*k;
  P.y:=P1.y+(P2.y-P1.y)*k;
End;


Procedure PLine(Const A,B : Real; Const P : Point; Var L : Line);
Begin
  L.A:=A; L.B:=B;
  L.C:=-A*P.x-B*P.y;
End;

Procedure P2Line(Const P1,P2 : Point; Var L : Line);
Begin
  PLine(P1.y-P2.y,P2.x-P1.x,P1,L);
End;

Function L2Point(Const L1,L2 : Line; Var P : Point) : Boolean;
Var D : Real;
Begin
  L2Point:=False;
  D:=Det(L1.A,L2.A,L1.B,L2.B);
  If Eq(D,0) Then P:=PInf
  Else Begin
    P.x:=-Det(L1.C,L2.C,L1.B,L2.B)/D;
    P.y:=-Det(L1.A,L2.A,L1.C,L2.C)/D;
    L2Point:=True;
  End;
End;

begin
assign(input,'segment.in');
reset(input);
read(a.x,a.y);
read(b.x,b.y);
read(c.x,c.y);
read(d.x,d.y);
close(input);
assign(output,'segment.out');rewrite(output);
p2line(a,b,ab);
p2line(c,d,cd);
l2point(ab,cd,o);
if pbtw(o,a,b)and pbtw(o,c,d)then
 begin
 writeln(o.x:0:6,' ',o.y:0:6);
 end else writeln('Empty');
close(output);
End.