{$D-,E+,I-,L-,P-,Q-,R-,S+,T+,V+,X+}
type
  real = extended;
  point = record
    x, y: real;
  end;
  line = record
    a, b, c: real;
  end;
  circle = record
    c: point;
    r: real;
  end;

const
  eps: real = 1e-15;
  origin: Point = (x: 0.0; y: 0.0);
var kraters:array[1..2]of circle;
i,j:byte;
t:circle;
c1,c2:circle;
p1,p2,p3,p4:point;
l1,l2:line;
var p:array[1..4,1..2]of point;
res:byte;

function eq(a, b: real): boolean;
begin
  eq := abs(a-b) <= eps;
end;

function ne(a, b: real): boolean;
begin
  ne := abs(a-b) > eps;
end;

function gt(a, b: real): boolean;
begin
  gt := (a > b) and ne(a, b);
end;

function lt(a, b: real): boolean;
begin
  lt := (a < b) and ne(a, b);
end;

function p2sqrDist(p1, p2: point): real;
begin
  p2sqrDist := sqr(p1.x-p2.x)+sqr(p1.y-p2.y);
end;

function solveBiEquation(a, b, c: real; var x1, x2: real): byte;
var
  d: real;
begin
  d := sqr(b)-4*a*c;
  if lt(d, 0) then
    solveBiEquation := 0
  else begin
    if eq(d, 0) then
      solveBiEquation := 1
    else
      solveBiEquation := 2;
    d := sqrt(abs(d));
    x1 := (-b+d)/(2*a);
    x2 := (-b-d)/(2*a);
  end;
end;

procedure c2Intersection(c1, c2: circle; var p1, p2: point);
var
  k1, k2: real;
begin
  if eq(c1.c.y, c2.c.y) then begin
    p1.x := (sqr(c1.c.x)-sqr(c2.c.x)+sqr(c2.r)-sqr(c1.r))/(2*(c1.c.x-c2.c.x));
    p2.x := p1.x;
    solveBiEquation(1, -2*c1.c.y, sqr(p1.x-c1.c.x)+sqr(c1.c.y)-sqr(c1.r), p1.y, p2.y);
  end else begin
    {y=k1+k2*x}
    k1 := 0.5*(p2sqrDist(c1.c, origin)-p2sqrDist(c2.c, origin)+
      sqr(c2.r)-sqr(c1.r))/(c1.c.y-c2.c.y);
    k2 := (c2.c.x-c1.c.x)/(c1.c.y-c2.c.y);
    solveBiEquation(1+sqr(k2), 2*(k2*(k1-c1.c.y)-c1.c.x), sqr(c1.c.x)+sqr(k1-c1.c.y)-sqr(c1.r), p1.x, p2.x);
    p1.y := k1+k2*p1.x;
    p2.y := k1+k2*p2.x;
  end;
end;

procedure pMoveTo(p1, p2: point; k: real; var p: point);
begin
  p.x := p1.x+(p2.x-p1.x)*k;
  p.y := p1.y+(p2.y-p1.y)*k;
end;


procedure pMove(var p: point; dx, dy: real);
begin
  p.x := p.x+dx; p.y := p.y+dy;
end;


procedure p2line(p1, p2: point; var l: line);
begin
  l.a := p1.y-p2.y; l.b := p2.x-p1.x;
  l.c := -l.a*p1.x-l.b*p1.y;
end;


procedure plperp(l1: line; p: point; var l2: line);
begin
  l2.a := -l1.b; l2.b := l1.a;
  l2.c := -p.x*l2.a-p.y*l2.b;
end;


function cLineIntersection(c: circle; l: line; var p1, p2: point): byte;
var
  res:byte;
  k1, k2: real;
begin
  if eq(l.b, 0) then begin
    p1.x := -l.c/l.a; p2.x := p1.x;
    cLineIntersection := solveBiEquation(1, -2*c.c.y,
        sqr(c.c.y)+sqr(p1.x-c.c.x)-sqr(c.r), p1.y, p2.y);
  end else begin
    {y=k1+k2*x}
    k1 := -l.c/l.b;
    k2 := -l.a/l.b;
    res:= solveBiEquation(1+sqr(k2),
        2*(k2*(k1-c.c.y)-c.c.x), sqr(c.c.x)+sqr(k1-c.c.y)-sqr(c.r), p1.x, p2.x);
    if res>0 then
     begin
     p1.y := k1+k2*p1.x;
     if res=2 then p2.y := k1+k2*p2.x;
     end;
  end;
clineintersection:=res;
end;

function p2dist(p1, p2: point): real;
begin
  p2dist := sqrt(p2sqrDist(p1, p2));
end;




begin
assigN(INPUT,'tangent.in');reset(input);
read(kraters[1].c.x,kraters[1].c.y,kraters[1].r);
read(kraters[2].c.x,kraters[2].c.y,kraters[2].r);
i:=1;
j:=2;
close(input);
assign(output,'tangent.out');rewrite(output);
if eq(kraters[i].c.x,kraters[j].c.x)and eq(kraters[i].c.y,kraters[j].c.y)and
eq(kraters[i].r,kraters[j].r) then
begin
writeln(-1);
close(output);
exit;
end;

if gt(kraters[i].r, kraters[j].r) then begin
        t := kraters[i]; kraters[i] := kraters[j]; kraters[j] := t;
      end;
if kraters[j].r-p2dist(kraters[i].c,kraters[j].c)>kraters[i].r then
begin
writeln(0);
close(output);
exit;
end;

res:=2;
if kraters[j].r <> kraters[i].r then begin
        c2.c := kraters[j].c;
        c2.r := kraters[j].r-kraters[i].r;
        c1.c := kraters[i].c;
        c1.r := sqrt(p2sqrdist(kraters[i].c, kraters[j].c)-sqr(c2.r));
        c2Intersection(c1, c2, p1, p2);
        pMoveTo(c2.c, p1, kraters[j].r/c2.r, p3);
        pMoveTo(c2.c, p2, kraters[j].r/c2.r, p4);
        p[1,1]:=p3;
        p[2,1]:=p4;
        {add(p3,j);
        add(p4,j);}
        pMove(p1, c1.c.x-c2.c.x, c1.c.y-c2.c.y);
        pMove(p2, c1.c.x-c2.c.x, c1.c.y-c2.c.y);

        pMoveTo(c1.c, p1, kraters[i].r/c2.r, p3);
        pMoveTo(c1.c, p2, kraters[i].r/c2.r, p4);
        p[1,2]:=p3;
        p[2,2]:=p4;
        {add(p3,i);
        add(p4,i);}
      end else begin
        p2line(kraters[j].c, kraters[i].c, l1);
        plperp(l1, kraters[j].c, l2);
        cLineIntersection(kraters[j], l2, p1, p2);
        p[1,1]:=p1;
        p[2,1]:=p2;
        {add(p1,j);
        add(p2,j);}

        pMove(p1, kraters[i].c.x-kraters[j].c.x, kraters[i].c.y-kraters[j].c.y);
        pMove(p2, kraters[i].c.x-kraters[j].c.x, kraters[i].c.y-kraters[j].c.y);
        p[1,2]:=p1;
        p[2,2]:=p2;
        {add(p1,i);
        add(p2,i); }
      end;
if gt(p2dist(kraters[i].c, kraters[j].c),
      kraters[i].r+kraters[j].r) then begin
        res:=4;
        c2.c := kraters[j].c;
        c2.r := kraters[j].r+kraters[i].r;
        c1.c := kraters[i].c;
        c1.r := sqrt(p2sqrDist(kraters[i].c, kraters[j].c)-sqr(c2.r));
        c2Intersection(c1, c2, p1, p2);

        pMoveTo(c2.c, p1, kraters[j].r/c2.r, p3);
        pMoveTo(c2.c, p2, kraters[j].r/c2.r, p4);
        p[3,1]:=p3;
        p[4,1]:=p4;
        {add(p3,j);
        add(p4,j);}

        pMove(p1, c1.c.x-c2.c.x, c1.c.y-c2.c.y);
        pMove(p2, c1.c.x-c2.c.x, c1.c.y-c2.c.y);

        pMoveTo(c1.c, p1, -kraters[i].r/c2.r, p3);
        pMoveTo(c1.c, p2, -kraters[i].r/c2.r, p4);
        p[3,2]:=p3;
        p[4,2]:=p4;
        {add(p3,i);
        add(p4,i); }
      end;
writeln(res);
for i:=1 to res do
 begin
 p2line(p[i,1],p[i,2],l1);
 writeln(l1.a:0:8,' ',l1.b:0:8,' ',l1.c:0:8);
 end;


close(output);
end.

