{$A+,B-,D-,E+,F-,G-,I-,L-,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
Program pr_a;
const
  inpfile='circles.in';
  outfile='circles.out';
  eps=1e-7;
var
  x1,y1,r1,x2,y2,r2 : Extended;
  xr1,yr1,xr2,yr2 : Extended;
  k : LongInt;
{}
Procedure Inp;
begin
  assign(input,inpfile);
  reset(input);
  read(x1,y1,r1,x2,y2,r2);
end;
{}
Procedure Out;
begin
  assign(output,outfile);
  rewrite(output);
  if k=-1 then writeln(-1)
  else if k=0 then writeln(0)
  else if k=1 then
  begin
    writeln(1);
    writeln(xr1:0:6,' ',yr1:0:6);
  end else
  begin
    writeln(2);
    writeln(xr1:0:6,' ',yr1:0:6);
    writeln(xr2:0:6,' ',yr2:0:6);
  end;
  close(output);
  halt;
end;
{}
Procedure Init;
begin
end;
{}
Function InCirc1(x,y : Extended) : Boolean;
begin
  if sqr(x-x1) + sqr(y-y1) < sqr(r1) then InCirc1:=true else
  InCirc1:=false;
end;
{}
Function InCirc2(x,y : Extended) : Boolean;
begin
  if sqr(x-x2) + sqr(y-y2) < sqr(r2) then InCirc2:=true else
  InCirc2:=false;
end;
{}

Procedure Solve;
var
  d : Extended;
  cr1,sr1,cr2,sr2,cos1,sin1,cos2,sin2 : Extended;
begin
  if (abs(x1-x2)<eps) and (abs(y1-y2)<eps) then
  begin
    if abs(r1-r2)<eps then begin k:=-1; Out; end
    else begin k:=0; Out; end;
  end;
  d:=sqrt(sqr(x2-x1)+sqr(y2-y1));
  if (d-eps>r1+r2)
  or (d+r1<r2-eps) and InCirc2(x1,y1)
  or (d+r2<r1-eps) and InCirc1(x2,y2) then begin k:=0; Out; end;
  cos1:=(x2-x1)/d; sin1:=(y2-y1)/d;
  cos2:=(sqr(r1)+sqr(d)-sqr(r2))/(2*r1*d);
  sin2:=sqrt(1-sqr(cos2));
  cr1:=cos1*cos2-sin1*sin2;
  cr2:=cos1*cos2+sin1*sin2;
  sr1:=sin1*cos2+cos1*sin2;
  sr2:=sin1*cos2-cos1*sin2;
  xr1:=x1+r1*cr1; yr1:=y1+r1*sr1;
  xr2:=x1+r1*cr2; yr2:=y1+r1*sr2;
  if (abs(xr1-xr2)>eps) or (abs(yr1-yr2)>eps) then k:=2 else k:=1;
end;
{}
Begin
  Init;
  Inp;
  Solve;
  Out;
End.
