{$I+,Q-,R-,S+}
program         Template;

var
  P, C, M       : Integer;
  Queries       : array[1..100, 1..10] of Integer;
  B, W          : array[1..100] of Integer;
  Secret        : array[1..10] of Integer;

procedure       OpenFiles;
begin
  Assign(Input, 'bc.in');
  Reset(Input);
  Assign(Output, 'bc.out');
  Rewrite(Output);
end;

procedure       CloseFiles;
begin
  Close(Input);
  Close(Output);
end;

procedure       ReadData;
var
  I, J          : Integer;
begin
  ReadLn(P, C, M);
  for I := 1 to M do begin
    for J := 1 to P do
      Read(Queries[I, J]);
    ReadLn;

    ReadLn(B[I], W[I]);
    if B[I] = P then begin
      for J := 1 to P do begin
        Write(Queries[I, J]);
        if I < P then
          Write(' ')
        else
          WriteLn;
      end;

      CloseFiles;
      Halt;
    end;
  end;
end;

function        Check(X: Integer): Boolean;
var
  I             : Integer;
  BB, WW        : Integer;
  Counts        : array[0..100] of Integer;
  Mark          : array[1..10] of Boolean;
begin
  FillChar(Counts, SizeOf(Counts), 0);
  FillChar(Mark, SizeOf(Mark), 0);
  for I := 1 to P do
    Inc(Counts[Secret[I]]);

  BB := 0;
  for I := 1 to P do
    if Secret[I] = Queries[X, I] then begin
      Inc(BB);
      Dec(Counts[Secret[I]]);
      Mark[I] := True;
    end;

  if BB <> B[X] then begin
    Check := False;
    Exit;
  end;

  WW := 0;
  for I := 1 to P do
    if (Counts[Queries[X, I]] > 0) and not Mark[I] then begin
      Inc(WW);
      Dec(Counts[Queries[X, I]]);
    end;

  Check := WW = W[X];
end;

procedure       NextSecret;
var
  I             : Integer;
begin
  I := P;
  repeat
    Inc(Secret[I]);
    if Secret[I] > C then begin
      Secret[I] := 1;
      Dec(I);
    end else
      Break;
  until False;
end;

procedure       Solve;
var
  I             : Integer;
  Flag          : Boolean;
begin
  for I := 1 to P do
    Secret[I] := 1;

  repeat
    Flag := True;
    for I := 1 to M do
      while not Check(I) do begin
        Flag := False;
        NextSecret;
      end;
  until Flag;

  for I := 1 to P do begin
    Write(Secret[I]);
    if I < P then
      Write(' ')
    else
      WriteLn;
  end;
end;

begin
  OpenFiles;
  ReadData;
  Solve;
  CloseFiles;
end.
