{$I+,Q+,R+,S+}
program         Template;

type
  TState        = array[1..12, 1..12] of Char;

var
  N, Q, C       : Integer;
  H, V          : array[1..12] of Boolean;
  D1            : array[-12..12] of Boolean;
  D2            : array[1..24] of Boolean;
  Total         : LongInt;
  Current       : TState;
  Saved         : array[1..10000] of TState;
  Key           : array[1..10000] of LongInt;

procedure       OpenFiles;
begin
  Assign(Input, 'chess.in');
  Reset(Input);
  Assign(Output, 'chess.out');
  Rewrite(Output);
end;

procedure       CloseFiles;
begin
  Close(Input);
  Close(Output);
end;

procedure       ReadData;
begin
  ReadLn(N, Q, C);
end;

function        Code(Ch: Char): LongInt;
begin
  if Ch = 'Q' then
    Code := 1
  else if Ch = 'C' then
    Code := 2
  else
    Code := 0;
end;

function        GetKey: LongInt;
var
  Key           : LongInt;
  I, J          : Integer;
begin
  Key := 0;
  for I := 1 to N do
    for J := 1 to N do
      Key := (Key shl 1) xor (Key shr 7) xor Code(Current[I, J]);

  GetKey := Key;
end;

procedure       Rec(Q, C: Integer);
var
  I, J, K       : Integer;
  OK            : Boolean;
  CurKey        : LongInt;
begin
  if (Q = 0) and (C = 0) then begin
    OK := Total = 0; CurKey := GetKey;
    if Total > 0 then
      for K := 1 to Total do begin
        OK := False;

        if Key[K] = CurKey then begin
          for I := 1 to N do begin
            for J := 1 to N do
              if Saved[K][I, J] <> Current[I, J] then begin
                OK := True;
                Break;
              end;

            if OK then
              Break;
          end;
        end else
          OK := True;

        if not OK then
          Break;
      end;

    if OK then begin
      Inc(Total);
      Move(Current, Saved[Total], SizeOf(TState));
      Key[Total] := CurKey;
    end;

    Exit;
  end;

  for I := 1 to N do
    for J := 1 to N do
      if not H[I] then
        if not V[J] then
          if not D1[J - I] then
            if not D2[I + J] then begin
              H[I] := True;
              V[J] := True;

              if Q > 0 then begin
                D1[J - I] := True;
                D2[I + J] := True;

                Current[I, J] := 'Q';
                Rec(Q - 1, C);
                Current[I, J] := ' ';

                D1[J - I] := False;
                D2[I + J] := False;
              end else begin
                Current[I, J] := 'C';
                Rec(Q, C - 1);
                Current[I, J] := ' ';
              end;

              H[I] := False;
              V[J] := False;
            end;
end;

procedure       Solve;
begin
  FillChar(H, SizeOf(H), 0); FillChar(D1, SizeOf(D1), 0);
  FillChar(V, SizeOf(V), 0); FillChar(D2, SizeOf(D2), 0);
  FillChar(Current, SizeOf(Current), #32);

  Total := 0; Rec(Q, C); WriteLn(Total);
end;

begin
  OpenFiles;
  ReadData;
  Solve;
  CloseFiles;
end.
