const
  eps=1e-8;
var
  x1,y1,x2,y2,r1,r2:longint;
  d,a,b,c,xr1,xr2,yr1,yr2:extended;

procedure OpenFiles;
begin
  assign(input,'circles.in');
  assign(output,'circles.out');
  reset(input);
  rewrite(output);
end;

procedure CloseFiles;
begin
  close(input);
  close(output);
end;

procedure Solve;
begin
  read(x1,y1,r1);
  read(x2,y2,r2);
  if (x1=x2)and(y1=y2)and(r1=r2) then
  begin
    write(-1);
    exit;
  end;
  d:=sqrt(sqr(x1-x2)+sqr(y1-y2));
  if ((r1+r2)<d)or(abs(r1-r2)>d) then
    writeln(0);
  x2:=x2-x1;
  y2:=y2-y1;
  c:=sqr(x2)+sqr(y2)-sqr(r2)+sqr(r1);
  a:=(sqr(x2)+sqr(y2))*4;
  b:=-4*x2*c;
  c:=sqr(c)-4*sqr(y2*r1);
  d:=sqrt(sqr(b)-4*a*c);
  xr1:=(-b-d)/(2*a);
  xr2:=(-b+d)/(2*a);
  if abs(xr1-xr2)<eps then
  begin
    yr1:=sqrt(sqr(r1)-sqr(xr1))+y1;
  yr2:=-sqrt(sqr(r1)-sqr(xr2))+y1;
  end
  else
  begin
  yr1:=sqrt(sqr(r1)-sqr(xr1))+y1;
  yr2:=sqrt(sqr(r1)-sqr(xr2))+y1;
  end;
  xr1:=xr1+x1;
  xr2:=xr2+x1;
  if (abs(xr1-xr2)<eps)and(abs(yr1-yr2)<eps) then
  begin
    writeln(1);
    writeln(xr1:0:6,' ',yr1:0:6);
  end
  else
  begin
    writeln(2);
    writeln(xr1:0:6,' ',yr1:0:6);
    writeln(xr2:0:6,' ',yr2:0:6);
  end;
end;

begin
  OpenFiles;
  Solve;
  CloseFiles;
end.
