{$N+}
{.$define debug}

{$ifdef debug}
{$R+,Q+}
{$else}
{R-,Q-}
{$endif}

program template;
const
 h = 5010;
 eps = 1e-7;
 {$ifdef debug}
 cinfile = 'input.txt';
 coutfile = 'output.txt';
 {$else}
 cinfile = 'input.txt';
 coutfile = 'output.txt';
 {$endif}
type
 int = longint;
 tpoint = record
  x,y :integer;
 end;
 tpoint2 = record
  x,y :real;
 end;
 tptr = ^tlist;
 tlist = record
  inf :int;
  mark :byte;
  bad :byte;
  next :tptr;
 end;
 tcycle = array [0..2*h] of int;
 pcycle = ^tcycle;
 real = extended;
var
 n,m :int;
 ans :int;
 p :array [1..2*h] of tpoint;
 graph :array [1..2*h] of tptr;
 paint :array [1..2*h] of int;
 prev :array [1..2*h] of int;
 pnt :array [1..2*h] of byte;
 q :array [1..2*h] of int;
 pr :array [1..2*h] of int;
 norun :array [1..2*h] of byte;
 sq :array [1..2*h] of int;
 p1,p2 :array [1..2*h] of int;
 pntan :array [1..2*h] of byte;

procedure init;
begin
 ans := 0;
 n := 0;
 fillchar (graph,sizeof(graph),0);
 fillchar (paint,sizeof(paint),0);
 fillchar (prev,sizeof(prev),0);
 fillchar (norun,sizeof(norun),0);
 fillchar (sq,sizeof(sq),0);
end;

procedure swap (var a,b :tpoint);
var tmp :tpoint;
begin
 tmp := a;
 a := b;
 b := tmp;
end;

procedure add (var list :tptr; value :int);
var x :tptr;
begin
 new (x);
 x^.inf := value;
 x^.mark := 0;
 x^.bad := 0;
 x^.next := list;
 list := x;
end;

procedure addtoanswer (r :int; cycle :pcycle);
begin
 if r = 0 then
  exit;
 inc (ans);
 sq[ans] := r;
end;

function less (a,b :tpoint):boolean;
begin
 if a.x = b.x then
  less := a.y < b.y
 else
  less := a.x < b.x;
end;

function eq (a,b :tpoint):boolean;
begin
 eq := (a.x = b.x) and (a.y = b.y);
end;

function search (x,y :int):int;
var pp :tpoint;
    l,r :int;
    mid :int;
begin
 search := 0;
 pp.x := x;
 pp.y := y;
 l := 1;
 r := n;
 while r-l > 1 do
  begin
   mid := (l+r) shr 1;
   if less (p[mid],pp) then
    l := mid
   else
    r := mid;
  end;
 if eq(p[l],pp) then
  begin
   search := l;
   exit;
  end;
 if eq(p[r],pp) then
  begin
   search := r;
   exit;
  end;
end;

procedure sort (l,r :int);
var i,j :int;
    x :tpoint;
begin
 i := l;
 j := r;
 x := p[l + random(r-l+1)];
 repeat
  while less (p[i],x) do
   inc(i);
  while less (x,p[j]) do
   dec(j);
  if i <= j then
   begin
    swap(p[i],p[j]);
    inc (i);
    dec (j);
   end;
 until i > j;
 if i < r then
  sort (i,r);
 if j > l then
  sort (l,j);
end;

procedure readpoints;
var i,j :int;
    m_ :int;
    pp :array [1..2*h] of tpoint;
    a,b :tpoint;
    k :int;
begin
 assign (input,cinfile);
 reset (input);
 read (m_);
 k := 0;
 for i := 1 to m_ do
  begin
   read (a.x,a.y,b.x,b.y);
   inc (k);
   p[k] := a;
   inc (k);
   p[k] := b;
  end;
 close (input);
 if k = 0 then
  begin
   n := 0;
   exit;
  end;
 sort (1,k);
 pp[1] := p[1];
 n := 1;
 for i := 2 to k do
  if not eq(p[i],p[i-1]) then
   begin
    inc(n);
    pp[n] := p[i];
   end;
 fillchar (p,sizeof(p),0);
 move (pp,p,n*sizeof(p[1]));
end;


procedure readdata;
var i,j :int;
    x1,y1,x2,y2 :int;
    t1,t2 :int;
begin
 assign (input,cinfile);
 reset (input);
 readln (m);
 for i := 1 to m do
  begin
   readln (x1,y1,x2,y2);
   t1 := search (x1,y1);
   t2 := search (x2,y2);
   add (graph[t1],t2);
   add (graph[t2],t1);
  end;
 close (input);
end;

procedure outdata;
var i,j :int;
begin
 assign (output,coutfile);
 rewrite (output);
 writeln (ans);
 for i := 1 to ans do
  writeln ((sq[i]/2):0:5);
 close (output);
end;

procedure dfs (v :int; from :int); forward;
procedure analyze (cycle :pcycle); forward;


function used (a,b :int):boolean;
var x :tptr;
begin
 x := graph[a];
 while not (x^.inf = b) do
  x := x^.next;
 used := x^.mark = 1;
end;

procedure div2 (cycle :pcycle; var c1,c2 :pcycle; u,v :int);
var i :int;
begin
 new (c1);
 fillchar (c1^,sizeof(c1^),0);
 c1^[0] := v-u+2;
 for i := u to v do
  c1^[i-u+1] := cycle^[i];
 c1^[c1^[0]] := cycle^[u];
 {=======}
 new (c2);
 fillchar (c2^,sizeof(c2^),0);
 c2^[0] := 0;
 for i := 1 to u do
  begin
   inc (c2^[0]);
   c2^[c2^[0]] := cycle^[i];
  end;
 for i := v to cycle^[0] do
  begin
   inc (c2^[0]);
   c2^[c2^[0]] := cycle^[i];
  end;
end;

function cross (a,b,c,d :tpoint2):boolean;
var a1,b1,c1 :real;
    a2,b2,c2 :real;
    det :real;
begin
 cross := false;
 a1 := b.y - a.y;
 b1 := a.x - b.x;
 c1 := -a1*a.x - b1*a.y;
 {========}
 a2 := c.y - d.y;
 b2 := d.x - c.x;
 c2 := -a2*c.x - b2*c.y;
 {=========}
 det := a1*b2 - a2*b1;
 if abs (det) < eps then
  exit;
 cross := ((a1*c.x + b1*c.y + c1)*(a1*d.x + b1*d.y + c1) <= 0) and
           ((a2*a.x + b2*a.y + c2)*(a2*b.x + b2*b.y + c2) <= 0);
end;

function test (cycle :pcycle;v :int):boolean;
var a,b :tpoint2;
    c,d :tpoint2;
    r :int;
    i,j :int;

begin
 a.x := p[v].x;
 a.y := p[v].y;
 b.x := 10000*exp(1)*pi;
 b.y := 10000*pi*pi*exp(0.5);
 r := 0;
 for i := 1 to cycle^[0]-1 do
  begin
   c.x := p[cycle^[i]].x;
   c.y := p[cycle^[i]].y;
   d.x := p[cycle^[i+1]].x;
   d.y := p[cycle^[i+1]].y;
   if cross (a,b,c,d) then
    inc (r);
  end;
 test := (r and 1 = 1);
end;

procedure putmark (a,b :int);
var x :tptr;
begin
 x := graph[a];
 while not (x^.inf = b) do
  x := x^.next;
 x^.mark := 1;
 {=======}
 x := graph[b];
 while not (x^.inf = a) do
  x := x^.next;
 x^.mark := 1;
end;

function square (cycle :pcycle):int;
var res :int;
    i,j :int;
begin
 res := 0;
 for i := 1 to cycle^[0]-1 do
  begin
   res := res +
    (p[cycle^[i]].x - p[cycle^[i+1]].x)*(p[cycle^[i]].y + p[cycle^[i+1]].y);
   putmark (cycle^[i],cycle^[i+1]);
  end;
 square := abs(res);
end;

procedure operate (cycle :pcycle;v :int);
var w,t :int;
    cur :int;
    x :tptr;
    i,j :int;
    found :array [1..2] of int;
    f :int;
    delta :int;
    c1,c2 :pcycle;

procedure add (u :int;from :int);
begin
 if pnt[u] = 2 then
  begin
   pnt[u] := 1;
   pr[u] := from;
   if f = 2 then
    exit;
   inc(f);
   found[f] := u;
   exit;
  end;
 if pnt[u] = 1 then
  exit;
 pnt[u] := 1;
 pr[u] := from;
 inc (t);
 q[t] := u;
end;


procedure divise (u,v :int; var c1,c2 :pcycle);
var d1,d2 :int;
    cur :int;
    i,j :int;
begin
 if u > v then
  begin
   u := u xor v;
   v := u xor v;
   u := u xor v;
  end;
 fillchar (p1,sizeof(p1),0);
 fillchar (p2,sizeof(p2),0);
 d1 := 0;
 cur := cycle^[u];
 while not (cur = 0) do
  begin
   inc(d1);
   p1[d1] := cur;
   cur := pr[cur];
  end;
 d2 := 0;
 cur := cycle^[v];
 while not (cur = 0) do
  begin
   inc(d2);
   p2[d2] := cur;
   cur := pr[cur];
  end;
 new (c1);
 fillchar (c1^,sizeof(c1^),0);
 c1^[0] := v-u+1;
 for i := u to v do
  c1^[i-u+1] := cycle^[i];
 for i := 2 to d1 do
  begin
   inc (c1^[0]);
   c1^[c1^[0]] := p1[i];
  end;
 for i := d2-1 downto 2 do
  begin
   inc(c1^[0]);
   c1^[c1^[0]] := p2[i];
  end;
 inc (c1^[0]);
 c1^[c1^[0]] := c1^[1];
 {========}
 new (c2);
 c2^[0] := 0;
 for i := 1 to u-1 do
  begin
   inc (c2^[0]);
   c2^[c2^[0]] := cycle^[i];
  end;
 for i := 1 to d1 do
  begin
   inc (c2^[0]);
   c2^[c2^[0]] := p1[i];
  end;
 for i := d2-1 downto 1 do
  begin
   inc(c2^[0]);
   c2^[c2^[0]] := p2[i];
  end;
 for i := v+1 to cycle^[0] do
  begin
   inc (c2^[0]);
   c2^[c2^[0]] := cycle^[i];
  end;
end;



function pos (u :int):int;
var i :int;
begin
 pos := 0;
 for i := 1 to cycle^[0] do
  if cycle^[i] = u then
   begin
    pos := i;
    exit;
   end;
end;


begin
 f := 0;
 delta := 0;
 fillchar (q,sizeof(q),0);
 fillchar (pnt,sizeof(pnt),0);
 fillchar (pr,sizeof(pr),0);
 for i := 1 to cycle^[0] do
  pnt[cycle^[i]] := 2;
 pnt[v] := 1;
 w := 1;
 t := 1;
 q[1] := v;
 while w <= t do
  begin
   cur := q[w];
   inc (w);
   x := graph[cur];
   while not (x = nil) do
    begin
     add (x^.inf,cur);
     x := x^.next;
    end;
  end;
 if f < 2 then
  begin
   t := ans;
   if f = 1 then
    norun[found[1]] := 1;
   for i := 1 to n do
    if pnt[i] = 1 then
     begin
      dfs(i,0);
      break;
     end;
   if f = 1 then
    norun[found[1]] := 0;
   delta := 0;
   for i := t+1 to ans do
    delta := delta + sq[i];
   addtoanswer (square (cycle) - delta,cycle);
   dispose (cycle);
   exit;
  end;
 divise (pos(found[1]),pos(found[2]),c1,c2);
 dispose (cycle);
 analyze (c1);
 analyze (c2);
end;

function test_ (x,y :real; cycle :pcycle):boolean;
var a,b :tpoint2;
    c,d :tpoint2;
    r :int;
    i,j :int;

begin
 a.x := x;
 a.y := y;
 b.x := 10000*exp(1)*pi;
 b.y := 10000*pi*pi*exp(0.5);
 r := 0;
 for i := 1 to cycle^[0]-1 do
  begin
   c.x := p[cycle^[i]].x;
   c.y := p[cycle^[i]].y;
   d.x := p[cycle^[i+1]].x;
   d.y := p[cycle^[i+1]].y;
   if cross (a,b,c,d) then
    inc (r);
  end;
 test_ := (r and 1 = 1);
end;






procedure analyze (cycle :pcycle);
var i,j :int;
    k :int;
    good :boolean;
    x :tptr;
    c1,c2 :pcycle;
begin
 k := cycle^[0];
 good := false;
 for i := 1 to k-1 do
  if not used (cycle^[i],cycle^[i+1]) then
   begin
    good := true;
    break;
   end;
 if not good then
  exit;
 for i := 1 to k-1 do
  begin
   x := graph[cycle^[i]];
   while not (x = nil) do
    begin
     for j := i+2 to k-1 do
      if cycle^[j] = x^.inf then
       begin
        if (i = 1) and (j = k-1) then
         continue;
        if not test_ ((p[cycle^[i]].x+p[cycle^[j]].x)/2,
                      (p[cycle^[i]].y+p[cycle^[j]].y)/2,cycle) then
                       continue;
        div2 (cycle,c1,c2,i,j);
        dispose (cycle);
        analyze (c1);
        analyze (c2);
        exit;
       end;
     x := x^.next;
    end;
  end;
 fillchar (pntan,sizeof(pntan),0);
 for i := 1 to k do
  pntan[cycle^[i]] := 1;
 for i := 1 to n do
  if pntan[i] = 0 then
   if test (cycle,i) then
    begin
     operate (cycle,i);
     exit;
    end;
 addtoanswer (square (cycle),cycle);
 dispose (cycle);
end;


procedure makecycle (a,b :int);
var cur :int;
    cycle :pcycle;
    k :int;
    good :boolean;
    i,j :int;
    t :int;
begin
 cur := b;
 new (cycle);
 fillchar (cycle^,sizeof(cycle^),0);
 k := 0;
 while not (cur = a) do
  begin
   inc (k);
   cycle^[k] := cur;
   cur := prev[cur];
   if cur = 0 then
    break;
  end;
 if cur = 0 then
  begin
   cur := b;
   t := k;
   while not (cur = 0) do
    begin
     cycle^[k] := cur;
     cur := prev[cur];
     dec (k);
    end;
   k := t;
   cur := a;
   while not (cur = 0) do
    begin
     inc (k);
     cycle^[k] := cur;
     cur := prev[cur];
    end;
   cycle^[0] := k;
  end
 else
  begin
   inc (k);
   cycle^[k] := a;
   inc (k);
   cycle^[k] := cycle^[1];
   cycle^[0] := k;
  end;
 analyze (cycle);
end;

procedure addbad (a,b :int);
var x :tptr;
begin
 x := graph[a];
 while not (x^.inf = b) do
  x := x^.next;
 x^.bad := 1;
 x := graph[b];
 while not (x^.inf = a) do
  x := x^.next;
 x^.bad := 1;
end;

procedure dfs (v :int;from :int);
var x :tptr;
begin
 if norun[v] > 0 then
  exit;
 if paint[v] > 0 then
  begin
   makecycle(v,from);
   addbad (v,from);
   exit;
  end;
 paint[v] := 1;
 prev[v] := from;
 x := graph[v];
 while not (x = nil) do
  begin
   if not (x^.inf = from) and (x^.bad = 0) then
    dfs (x^.inf,v);
   x := x^.next;
  end;
end;

procedure solve;
var i,j :int;
begin
 for i := 1 to n do
  if paint[i] = 0 then
    dfs (i,0);
end;

begin
 init;
 readpoints;
 readdata;
 solve;
 outdata;
end.