{.$define debug}

program template;
const
 h = 5010;
 {$ifdef debug}
 cinfile = 'input.txt';
 coutfile = 'output.txt';
 {$else}
 cinfile = 'input.txt';
 coutfile = 'output.txt';
 {$endif}
type
 int = longint;
 tpoint = record
  x,y :integer;
 end;
 tptr = ^tlist;
 tlist = record
  inf :integer;
  next :tptr;
 end;
var
 n,m :int;
 k :int;
 ans :int;
 p :array [1..2*h] of tpoint;
 graph :array [1..2*h] of tptr;
 paint :array [1..2*h] of integer;
 pnt :array [1..2*h] of int;

procedure init;
begin
 randseed := 11;
 ans := 0;
 n := 0;
 fillchar (graph,sizeof(graph),0);
 fillchar (paint,sizeof(paint),0);
 k := 0;
 fillchar (pnt,sizeof(pnt),0);
end;

procedure add (var list :tptr; value :int);
var x :tptr;
begin
 new (x);
 x^.inf := value;
 x^.next := list;
 list := x;
end;

function less (a,b :tpoint):boolean;
begin
 if a.x = b.x then
  less := a.y < b.y
 else
  less := a.x < b.x;
end;

function q (a,b :tpoint):boolean;
begin
 q := (a.x = b.x) and (a.y = b.y);
end;

function search (x,y :int):int;
var pp :tpoint;
    l,r :int;
    mid :int;
begin
 search := 0;
 pp.x := x;
 pp.y := y;
 l := 1;
 r := n;
 while r-l > 1 do
  begin
   mid := (l+r) shr 1;
   if less (p[mid],pp) then
    l := mid
   else
    r := mid;
  end;
 if q(p[l],pp) then
  begin
   search := l;
   exit;
  end;
 if q(p[r],pp) then
  begin
   search := r;
   exit;
  end;
end;



procedure readdata;
var i,j :int;
    x1,x2,y1,y2 :int;
    t1,t2 :int;
begin
 assign (input,cinfile);
 reset (input);
 read (m);
 for i := 1 to m do
  begin
   read (x1,y1,x2,y2);
   t1 := search(x1,y1);
   t2 := search(x2,y2);
   add (graph[t1],t2);
   add (graph[t2],t1);
  end;
 close (input);
end;

procedure outdata;
var i,j :int;
begin
 assign (output,coutfile);
 rewrite (output);
 for i := 1 to n do
  writeln (p[i].x,' ',p[i].y,' ',paint[i]);
 close (output);
end;

procedure dfs (v :int);
var x :tptr;
begin
 if pnt[v] > 0 then
  exit;
 pnt[v] := k;
 x := graph[v];
 while not (x = nil) do
  begin
   dfs (x^.inf);
   x := x^.next;
  end;
end;

procedure rec (v :int);
var x :tptr;
    col :array [0..5] of integer;
    bad :integer;
    i :integer;
    cur :integer;
    res :int;
begin
 bad := 0;
 if paint[v] > 0 then
  begin
   bad := paint[v];
   paint[v] := 0;
  end;
 fillchar (col,sizeof(col),0);
 x := graph[v];
 while not (x = nil) do
  begin
   inc (col[paint[x^.inf]]);
   x := x^.next;
  end;
 for i := 1 to 5 do
  if col[i] = 0 then
   begin
    paint[v] := i;
    x := graph[v];
    while not (x = nil) do
     begin
      if paint[x^.inf] = 0 then
       rec (x^.inf);
      x := x^.next;
     end;
    exit;
   end;
 res := maxlongint;
 cur := 0;
 for i := 1 to 5 do
  if not (bad = i) and (col[i] < res) then
   begin
    res := col[i];
    cur := i;
   end;
 paint[v] := cur;
 x := graph[v];
 while not (x = nil) do
  begin
   if paint[x^.inf] = paint[v] then
    rec (x^.inf);
   if paint[x^.inf] = 0 then
    rec (x^.inf);
   x := x^.next;
  end;
end;

procedure test;
var i :int;
    x :tptr;
begin
 for i := 1 to n do
  begin
   x := graph[i];
   while not (x = nil) do
    begin
     if paint[x^.inf] = paint[i] then
      writeln ('Kosyak');
     x := x^.next;
    end;
  end;
end;


procedure solve;
var i,j :int;
begin
 k := 0;
 for i := 1 to n do
  if pnt[i] = 0 then
   begin
    inc (k);
    dfs (i);
   end;
 for i := 1 to k do
  for j := 1 to n do
   if pnt[j] = i then
    rec (j);
 {$ifdef debug}
 test;
 {$endif}
end;

procedure swap (var a,b :tpoint);
var tmp :tpoint;
begin
 tmp := a;
 a := b;
 b := tmp;
end;

procedure sort (l,r :int);
var i,j :int;
    x :tpoint;
begin
 i := l;
 j := r;
 x := p[l + random(r-l+1)];
 repeat
  while less (p[i],x) do
   inc(i);
  while less (x,p[j]) do
   dec(j);
  if i <= j then
   begin
    swap(p[i],p[j]);
    inc (i);
    dec (j);
   end;
 until i > j;
 if i < r then
  sort (i,r);
 if j > l then
  sort (l,j);
end;

procedure readpoints;
var i,j :int;
    m_ :int;
    pp :array [1..2*h] of tpoint;
    a,b :tpoint;
begin
 assign (input,cinfile);
 reset (input);
 read (m_);
 for i := 1 to m_ do
  begin
   read (a.x,a.y,b.x,b.y);
   inc (k);
   p[k] := a;
   inc (k);
   p[k] := b;
  end;
 close (input);
 if k = 0 then
  begin
   n := 0;
   exit;
  end;
 sort (1,k);
 pp[1] := p[1];
 n := 1;
 for i := 2 to k do
  if not q(p[i],p[i-1]) then
   begin
    inc(n);
    pp[n] := p[i];
   end;
 fillchar (p,sizeof(p),0);
 move (pp,p,n*sizeof(p[1]));
end;


begin
 init;
 readpoints;
 readdata;
 solve;
 outdata;
end.
