{$IFDEF NORMAL}
  {$I-,Q-,R-,S-}
{$ENDIF NORMAL}
{$IFDEF DEBUG}
  {$I-,Q-,R-,S-}
{$ENDIF DEBUG}
{$IFDEF RELEASE}
  {$I-,Q-,R-,S-}
{$ENDIF RELEASE}
program p21_14_a;

const
  max = 5000;
  eps = 0.0000001;

type
  xy = record
    x, y : longint;
  end;

var
  be : array[1..2 * max] of boolean;
  dots : array[1..max * 2] of xy;
  rebs : array[1..max, 1..2] of xy;
  active : array[1..max * 2] of boolean;
  sqrs : array[1..max] of extended;
  son, next, start : array[0..max * 2] of longint;
  my, mx, nomn, tsqrs, minx, miny, no1, no2, indots, free, i, j, k, m, n : longint;
  wrk : extended;
  sfl : boolean;

function nodot(x, y : longint) : longint;
var
  ps : longint;
begin
  for ps := 1 to indots do
    if (dots[ps].x = x) and (dots[ps].y = y) then begin
      nodot := ps;
      exit;
    end;
  nodot := 0;
end;

procedure adddot(x, y : longint);
begin
  inc(indots);
  dots[indots].x := x;
  dots[indots].y := y;
end;

procedure addlink(x, y : longint);
var
  px, py, pst, ps : longint;
begin
  px := start[x];
  if px = 0 then begin
    start[x] := free;
    free := next[free];
    next[start[x]] := 0;
    son[start[x]] := y;
  end else begin
    while next[px] <> 0 do px := next[px];
    next[px] := free;
    free := next[free];
    px := next[px];
    son[px] := y;
    next[px] := 0;
  end;
  px := start[y];
  if px = 0 then begin
    start[y] := free;
    free := next[free];
    next[start[y]] := 0;
    son[start[y]] := x;
  end else begin
    while next[px] <> 0 do px := next[px];
    next[px] := free;
    free := next[free];
    px := next[px];
    son[px] := x;
    next[px] := 0;
  end;
end;

function getal(y, x : extended) : extended;
begin
  if (abs(y-1) < eps) and (abs(x) = 0) then begin
    getal := pi / 2;
    exit;
  end;
  if (abs(y+1) < eps) and (abs(x) < eps) then begin
    getal := pi + pi / 2;
    exit;
  end;
  if (y >= 0) and (x > 0) then begin
    getal := arctan(y / x);
    exit;
  end;
  if (y >= 0) and (x < 0) then begin
    getal := pi - arctan(- y / x);
    exit;
  end;
  if (y <= 0) and (x < 0) then begin
    getal := pi + arctan(y / x);
    exit;
  end;
  if (y <= 0) and (x > 0) then begin
    getal := 2 * pi - arctan(- y / x);
    exit;
  end;
end;

function getnextturn(x : longint; x1, y1 : extended; d : longint) : longint;
var
  nmin, pj, pk, ps, pw : longint;
  l1, l2, l3, s, len, calph, salph, x2, y2, x3, y3 : extended;
  min, alph : extended;
  fl : boolean;
begin
  ps := start[x];
  x2 := dots[x].x;
  y2 := dots[x].y;
  if d = 1 then min := 10
  else min := -10;
  nmin := maxlongint;

  while ps <> 0 do begin
    if (son[ps] <> 0) and (not be[son[ps]]) then begin
      fl := false;
      x3 := dots[son[ps]].x;
      y3 := dots[son[ps]].y;
      l1 := (x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2);
      l2 := (x2 - x3) * (x2 - x3) + (y2 - y3) * (y2 - y3);
      l1 := sqrt(l1);
      l2 := sqrt(l2);
      len := l1 * l2;
      s := (x1 * y2 - x2 * y1 + x2 * y3 - x3 * y2 + x3 * y1 - x1 * y3);
      if s <= 0 then fl := true;
      salph := (s / len);
      l1 := (sqr(x1 - x2) + sqr(y1 - y2));
      l2 := (sqr(x2 - x3) + sqr(y2 - y3));
      l3 := (sqr(x1 - x3) + sqr(y1 - y3));
      calph := - (l3 - l1 - l2) / (2 * sqrt(l1 * l2));
      alph := getal(salph, calph);
      if (d <> 1) and (alph > min) then begin
        min := alph;
        nmin := son[ps];
      end;
      if (d = 1) and (alph < min) then begin
        min := alph;
        nmin := son[ps];
      end;

      ps := next[ps];
    end else ps := next[ps];
  end;
  getnextturn := nmin;
end;

procedure del(x, y : longint);
var
  ps : longint;
begin
  ps := start[x];
  repeat
    if son[ps] = y then begin
      son[ps] := 0;
      break;
    end;
    ps := next[ps];
  until ps = 0;
  ps := start[y];
  repeat
    if son[ps] = x then begin
      son[ps] := 0;
      break;
    end;
    ps := next[ps];
  until ps = 0;
end;

function getcon(x : longint) : extended;
var
  pj, pk, step : longint;
  xf, yf, xp, yp, s : extended;
begin
  s := 0;
  step := 0;
  fillchar(be, sizeof(be), false);
  pk := x;
  sfl := true;
  while not be[pk] do begin
    inc(step);
    if step = 1 then begin
      pk := getnextturn(pk, 0, -1, step);
      del(x, pk);
      xp := dots[x].x;
      yp := dots[x].y;
      xf := dots[x].x;
      yf := dots[x].y;
      pj := x;
      s := s + {xp * dots[pj].y - dots[pj].x * yp +} dots[pj].x * dots[pk].y - dots[pk].x * dots[pj].y;
    end else begin
      be[pk] := true;
      pj := pk;
      pk := getnextturn(pk, xp, yp, step);
      xp := dots[pj].x;
      yp := dots[pj].y;
      s := s + {xp * dots[pj].y - dots[pj].x * yp +} dots[pj].x * dots[pk].y - dots[pk].x * dots[pj].y;
    end;
    if pk = x then begin
      getcon := abs(s) / 2;
      exit;
    end;
    if pk = maxlongint then begin
      getcon := 0;
      exit;
    end;
  end;
end;


begin
  assign(input, 'input.txt');
  reset(input);
  assign(output, 'output.txt');
  rewrite(output);
  fillchar(rebs, sizeof(rebs), 0);
  read(n);
  for i := 1 to n do read(rebs[i, 1].x, rebs[i, 1].y, rebs[i, 2].x, rebs[i, 2].y);
  fillchar(son, sizeof(son), 0);
  for i := 1 to n * 2 do next[i] := i + 1;
  fillchar(start, sizeof(start), 0);
  indots := 0;
  free := 1;
  for i := 1 to n do begin
    no1 := nodot(rebs[i, 1].x, rebs[i, 1].y);
    if no1 = 0 then begin
      adddot(rebs[i, 1].x, rebs[i, 1].y);
      no1 := indots;
    end;
    no2 := nodot(rebs[i, 2].x, rebs[i, 2].y);
    if no2 = 0 then begin
      adddot(rebs[i, 2].x, rebs[i, 2].y);
      no2 := indots;
    end;
    addlink(no1, no2);
  end;
  fillchar(active, sizeof(active), true);
  tsqrs := 0;
  fillchar(sqrs, sizeof(sqrs), 0);
  wrk := 1;
  for k := 1 to indots do begin
    mx := maxlongint;
    my := maxlongint;
    for j := 1 to indots do begin
      if (dots[j].x < mx) and (active[j]) then begin
        mx := dots[j].x;
        my := dots[j].y;
        nomn := j;
      end;
      if (dots[j].x = mx) and (dots[j].y < my) and (active[j]) then begin
        mx := dots[j].x;
        my := dots[j].y;
        nomn := j;
      end;
    end;
    wrk := getcon(nomn);
    if wrk <> 0 then begin
      inc(tsqrs);
      sqrs[tsqrs] := wrk;
    end else active[nomn] := false;
  end;
  writeln(tsqrs);
  for i := 1 to tsqrs do begin
    writeln(sqrs[i]:0:6);
  end;
  close(output);
end.
