{$I-,Q-,R-,S-}
const
  inputfile = 'input.txt';
  outputfile = 'output.txt';
  md = 11111;
  maxn = 5101;
  eps = 1e-5;

type
  real = double;
  int = longint;
  bool = boolean;
  tpoint = record
    x, y: int;
  end;
  pnode = ^tnode;
  tnode = record
    v: int;
    next: pnode;
  end;
  pd = ^td;
  td = record
    n: int;
    next: pd;
  end;

var
  n, count, i, vb, ve: int;
  t: array[1..maxn * 2]of tpoint;
  g: array[1..maxn * 2]of pnode;
  used: array[1..maxn * 2]of bool;
  b, e: tpoint;
  th: array[0..md]of pd;
  col: array[1..maxn * 2]of int;
  cannot: bool;

function pointeq(var t1, t2: tpoint): bool;
begin
  pointeq := (abs(t1.x - t2.x) < eps) and (abs(t1.y - t2.y) < eps);
end;


function getnum(p: tpoint): int;
var
  i, y: int;
  d: pd;
begin
  y := (md + ((p.x * 1000 mod md + p.y)mod md)) mod md;
  d := th[y];
  while(d <> nil)do begin
    if(pointeq(t[d^.n], p))then begin
      getnum := d^.n;
      exit;
    end;
    d := d^.next;
  end;
  if(d = nil)then begin
    inc(count);
    getnum := count;
    t[count] := p;
    new(d);
    d^.next := th[y];
    d^.n := count;
    th[y] := d;
  end;
end;

procedure addrebro(a, b: int);
var
  da, db: pnode;
begin
  new(da);
  new(db);

  da^.next := g[a];
  da^.v := b;
  g[a] := da;

  db^.next := g[b];
  db^.v := a;
  g[b] := db;
end;

procedure wfs;
var
  d, x: pnode;
  down, up, cur, k: int;
  turn: array[1..maxn * 2]of int;
  cl: array[0..5]of bool;
begin
  k := 1;
  while(true)do begin
    while(k <= count)and(used[k])do
      inc(k);
    if(k = count + 1)then
      break;
    col[k] := 1;
    down := 1;
    up := 2;
    turn[down] := k;
    used[k] := true;
    while(down < up)do begin
      cur := turn[down];
      d := g[cur];
      while(d <> nil)do begin
        if(not used[d^.v])then begin
          x := g[d^.v];
          fillchar(cl, sizeof(cl), 0);
          while(x <> nil)do begin
            if(used[x^.v])then
              cl[col[x^.v]] := true;
            x := x^.next;
          end;
          for i := 1 to 5 do
            if(cl[i] = false)then begin
              col[d^.v] := i;
              break;
            end;
          if(col[d^.v] = 0)then begin
            cannot := true;
            exit;
          end;
          used[d^.v] := true;
          turn[up] := d^.v;
          inc(up);
        end;
        d := d^.next;
      end;
      inc(down);
    end;
  end;
end;

function rec(v: int): bool;
var
  i: int;
  x: pnode;
  cl: array[0..5]of bool;
begin
  fillchar(cl, sizeof(cl), 0);
  used[v] := true;
  x := g[v];
  while(x <> nil)do begin
    if(used[x^.v])then
      cl[col[x^.v]] := true;
    x := x^.next;
  end;

  for i := 1 to 5 do begin
    if(not cl[i])then begin
      col[v] := i;
      x := g[v];
      while(x <> nil)do begin
        if(not used[x^.v])and(not rec(x^.v))then
          break;
        x := x^.next;
      end;
      rec := true;
      exit;
    end;
  end;
  used[v] := false;
  rec := false;
end;

begin
  assign(input, inputfile);
  reset(input);
  assign(output, outputfile);
  rewrite(output);

  read(n);
  for i := 1 to n do begin
    read(b.x, b.y, e.x, e.y);
    vb := getnum(b);
    ve := getnum(e);
    addrebro(vb, ve);
  end;

  fillchar(used, sizeof(used), 0);
  cannot := false;
  wfs;
  if(cannot)then begin
    for i := 1 to count do
      if(not used[i])then
        rec(i);
  end;

  for i := 1 to count do
    writeln(t[i].x, ' ', t[i].y, ' ', col[i]);

  close(output);
  close(input);
end.