{$I-,Q-,R-,S-}
const
     FileIn='input.txt';
     FileOut='output.txt';
     MaxN=5000;
     MaxNodes=MaxN*2;
     MaxColor=5;
type
    PNodeIndex=^TNodeIndex;
    TNodeIndex=record
                     Index: Integer;
                     Next: PNodeIndex;
               end;
    TNode=record
                X, Y: Integer;
                Color: Byte;
                LeftColors: set of Byte;
                Next: PNodeIndex;
          end;
var
   N, NodesCount: LongInt;
   Nodes: array [1..MaxNodes] of TNode;
   LastPointers: array [1..MaxNodes] of PNodeIndex;
   Impossible: Boolean;
   FIFO: array [1..MaxNodes] of Integer;
   FIFOLen: LongInt;

function XYToNNode (aX, aY: Integer): LongInt;
var
   NNode: LongInt;
begin
     for NNode:=1 to NodesCount
         do if (Nodes [NNode].X=aX) and (Nodes [NNode].Y=aY)
               then begin
                    XYToNNode:=NNode;
                    Exit;
               end;
     Inc (NodesCount);
     Nodes [NodesCount].X:=aX;
     Nodes [NodesCount].Y:=aY;
     Nodes [NodesCount].Color:=0;
     Nodes [NodesCount].Next:=nil;
     Nodes [NodesCount].LeftColors:=[1..MaxColor];
     LastPointers [NodesCount]:=nil;
     XYToNNode:=NodesCount;
end;

procedure AddNeighbor (aNode, aNeNode: Integer);
begin
     if LastPointers [aNode]=nil
        then begin
             Nodes [aNode].Next:=New (PNodeIndex);
             Nodes [aNode].Next^.Index:=aNeNode;
             LastPointers [aNode]:=Nodes [aNode].Next;
        end
        else begin
             LastPointers [aNode]^.Next:=New (PNodeIndex);
             LastPointers [aNode]:=LastPointers [aNode]^.Next;
             LastPointers [aNode]^.Index:=aNeNode;
        end;
     LastPointers [aNode]^.Next:=nil;
end;

procedure ReadData;
var
   F: Text;
   NEdge: LongInt;
   X1, Y1, X2, Y2: Integer;
   Node1, Node2: Integer;
begin
     FillChar (LastPointers, SizeOf (LastPointers), 0);
     Assign (F, FileIn);
     Reset (F);
     Readln (F, N);
     for NEdge:=1 to N
         do begin
            Readln (F, X1, Y1, X2, Y2);
            Node1:=XYToNNode (X1, Y1);
            Node2:=XYToNNode (X2, Y2);
            AddNeighbor (Node1, Node2);
            AddNeighbor (Node2, Node1);
         end;
     Close (F);
end;

procedure WriteData;
var
   F: Text;
   NNode: LongInt;
begin
     Assign (F, FileOut);
     Rewrite (F);
     case Impossible of
          false: for NNode:=1 to NodesCount
                     do Writeln (F, Nodes [NNode].X, #32, Nodes [NNode].Y, #32, Nodes [NNode].Color);
          true: Writeln (F, 'IMPOSSIBLE');
     end;
     Close (F);
end;

procedure ProcessNode (aNNode: Integer);
var
   CurNeIndex: PNodeIndex;
   Color: Byte;
begin
     for Color:=1 to MaxColor
         do if Color in Nodes [aNNode].LeftColors
               then Break;
     if Color in Nodes [aNNode].LeftColors
        then begin
             Nodes [aNNode].Color:=Color;
             CurNeIndex:=Nodes [aNNode].Next;
             while Assigned (CurNeIndex)
                   do begin
                      if Nodes [CurNeIndex^.Index].Color=0
                         then begin
                              Inc (FIFOLen);
                              FIFO [FIFOLen]:=CurNeIndex^.Index;
                              Nodes [FIFO [FIFOLen]].LeftColors:=Nodes [FIFO [FIFOLen]].LeftColors-[Color];
                         end;
                      CurNeIndex:=CurNeIndex^.Next;
                   end;
        end
        else Impossible:=true;
end;

procedure Solve;
var
   NFIFONode, NNode: Integer;
begin
     Impossible:=false;
     if N>=1
        then begin
             repeat
                   for NNode:=1 to NodesCount
                       do if Nodes [NNode].Color=0
                             then Break;
                   if Nodes [NNode].Color=0
                      then begin
                           FIFOLen:=1;
                           FIFO [FIFOLen]:=NNode;
                           NFIFONode:=1;
                           while NFIFONode<=FIFOLen
                                 do begin
                                    ProcessNode (FIFO [NFIFONode]);
                                    if Impossible
                                       then Break;
                                    Inc (NFIFONode);
                                 end;
                      end
                      else Break;
             until Impossible;
        end;
end;

procedure Main;
begin
     ReadData;
     Solve;
     WriteData;
end;

begin
     Main;
end.
