{$R-,Q-}
{.$define debug}

program template;
const
 {$ifdef debug}
 h = 20;
 cinfile = 'input.txt';
 coutfile = 'output.txt';
 {$else}
 h = 310;
 cinfile = 'math.in';
 coutfile = 'math.out';
 {$endif}
type
 int = longint;
 real = extended;
 tptr = ^tlist;
 tlist = record
  inf :int;
  w :real;
  next :tptr;
 end;
 tmatrix = array [1..h,1..h] of real;
var
 n :int;
 ans :int;
 graph :array [1..h] of tptr;
 maxpl,maxm :array [1..h] of real;
 paint :array [1..h] of byte;
 none :array [1..h] of byte;
{ gr :array [1..h] of tptr;}
 gr :array [1..h,1..h] of real;
 d :array [1..h] of real;

procedure init;
begin
 ans := 0;
 fillchar (graph,sizeof(graph),0);
 fillchar (maxpl,sizeof(maxpl),0);
 fillchar (maxm,sizeof(maxm),0);
 maxpl[1] := 1;
 fillchar (gr,sizeof(gr),0);
 fillchar (paint,sizeof(paint),0);
 fillchar (none,sizeof(none),0);
end;

procedure add (v :int;var list :tptr;wei :real; num:int);
var x :tptr;
begin
{ if wei > 0 then
  begin
   x := graph[v];
   while not (x = nil) do
    begin
     if (x^.w > wei) and (x^.inf = num) then
      exit;
     x := x^.next;
    end;
  end
 else
  begin
   x := graph[v];
   while not (x = nil) do
    begin
     if (x^.w < wei) and (x^.inf = num) then
      exit;
     x := x^.next;
    end;
  end;}
 new (x);
 x^.inf := num;
 x^.w := wei;
 x^.next := list;
 list := x;
end;

procedure readdata;
var i,j :int;
    k :int;
    c :char;
    a,b :int;
begin
 assign (input,cinfile);
 reset (input);
 readln (n);
 for i := 1 to n do
  begin
   readln (k);
   for j := 1 to k do
    begin
     read (c);
     readln (a,b);
     if c = '*' then
      add (i,graph[i],a,b)
     else
      add (i,graph[i],1/a,b);
    end;
  end;
 close (input);
end;

procedure outdata;
var i,j :int;
begin
 assign (output,coutfile);
 rewrite (output);
 for i := 1 to n do
  begin
   if paint[i] = 0 then
    writeln ('NONE')
   else
    if none[i] = 1 then
     writeln ('INF')
   else
    begin
     if maxpl[i] = 0 then
      writeln (maxm[i])
     else
      writeln (maxpl[i]);
    end;
   end;
 close (output);
end;

procedure dfs (v :int);
var x :tptr;
begin
 if paint[v] > 0 then
  exit;
 paint[v] := 1;
 x := graph[v];
 while not (x = nil) do
  begin
   dfs (x^.inf);
   x := x^.next;
  end;
end;

procedure addit (num :int;list :tlist);
var operand :real;
    t :real;
begin
 operand := 1.0*list.w;
 if not (maxpl[num] = 0) then
   begin
    t := maxpl[num]*operand;
    if t < 0 then
     begin
      if t < maxm[list.inf] then
       maxm[list.inf] := t;
     end
    else
     begin
      if t > maxpl[list.inf] then
       maxpl[list.inf] := t;
     end;
   end;
  if not (maxm[num] = 0) then
   begin
    t := maxm[num]*operand;
    if t < 0 then
     begin
      if t < maxm[list.inf] then
       maxm[list.inf] := t;
     end
    else
     begin
      if t > maxpl[list.inf] then
       maxpl[list.inf] := t;
     end;
   end;
end;

procedure add_ (var list :tptr;w :real; value :int);
var x :tptr;
begin
 new (x);
 x^.inf := value;
 x^.w := w;
 x^.next := list;
 list := x;
end;


procedure solve;
var i,j,k :int;
    x :tptr;
    t :real;

begin
 dfs (1);
 for i := 1 to n do
  for j := 1 to n do
   gr[i,j] := -1e1000;
 for i := 1 to n do
  begin
   x := graph[i];
   while not (x = nil) do
    begin
     t := -ln (abs(x^.w));
{     add_ (gr[i],t,x^.inf);}
     if gr[i,x^.inf] < t then
      gr[i,x^.inf] := t;
     x := x^.next;
    end;
  end;
 for i := 1 to n do
  for j := 1 to n do
   if gr[i,j] = -1e1000 then
    gr[i,j] := 1e1000;
 for k := 1 to n do
  for i := 1 to n do
   for j := 1 to n do
    if gr[i,j] > gr[i,k] + gr[k,j] then
     gr[i,j] := gr[i,k] + gr[k,j];
 for i := 1 to n do
  if (gr[i,i] < 0) and (paint[i] = 1) then
   none[i] := 1;
{ d[1] := 0;
 for i := 2 to n do
  d[i] := 1e1000;
 for i := 1 to n do
  begin
   x := gr[i];
   while not (x = nil) do
    begin
     if d[x^.inf] > d[i] + x^.w then
      d[x^.inf] := d[i] + x^.w;
     x := x^.next;
    end;
  end;
 for i := 1 to n do
  begin
   x := gr[i];
   while not (x = nil) do
    begin
     if d[x^.inf] > d[i] + x^.w then
      none[x^.inf] := 1;
     x := x^.next;
    end;
  end;}





 for j := 1 to n do
   begin
    if (maxpl[j] = 0) and (maxm[j] = 0) then
     continue;
    x := graph[j];
    while not (x = nil) do
     begin
      addit (j,x^);
      x := x^.next;
     end;
   end;
end;

begin
 init;
 readdata;
 solve;
 outdata;
end.