program Bridge_VIRMOS;

const
  maxsup = 1024; {1048576}

type
  ttoken = record
    typ : (_empty,_mast,_kart,_colon,_equ,_play,_left,_right,_and,_or);
    mast,kart : integer;
    numb : longint;
    pl : integer;
  end;
  ttree = record
    typ : (t_mast,t_kart,t_and,t_or);
    ls,rs : integer;
    baseindex : integer;
  end;
  tdata = array [1..50] of boolean;

const
  masts = ['s','h','c','d'];
  karts = ['A','K','Q','J','T','2'..'9'];

var
  ctok : ttoken;
  ch : char;
  ss : string;
  kartin : array [1..4,1..13] of boolean;
  num : integer;
  root : integer;
  tree : array [1..80] of ttree;
  baseno : integer;
  basemast,basekart,basenum,basepl : array [1..80] of integer;
  basetype : array [1..80] of boolean;
  sup : array [0..maxsup] of longint;
  ms : longint;
  fullmap,totalmap : array [1..4] of integer;
  ans : array [1..80] of longint;

function getmast(a : char) : integer;
begin
  case a of
    's' : getmast := 1;
    'h' : getmast := 2;
    'c' : getmast := 3;
    'd' : getmast := 4;
  end;
end;

function getkart(a : char) : integer;
begin
  case a of
    'A' : getkart := 1;
    'K' : getkart := 2;
    'Q' : getkart := 3;
    'J' : getkart := 4;
    'T' : getkart := 5;
    '9' : getkart := 6;
    '8' : getkart := 7;
    '7' : getkart := 8;
    '6' : getkart := 9;
    '5' : getkart := 10;
    '4' : getkart := 11;
    '3' : getkart := 12;
    '2' : getkart := 13;
  end;
end;

procedure rch;
begin
  if ss='' then ch := #0 else
  begin
    ch := ss[1];
    delete(ss,1,1);
  end;
end;

procedure rtok;
var
  ss : string;
  code : word;
begin
  while ch in [' ',#9,#10,#13] do rch;
  if ch=#0 then
    ctok.typ := _empty
  else
  if ch='(' then
  begin
    ctok.typ := _left;
    rch;
  end else
  if ch=')' then
  begin
    ctok.typ := _right;
    rch;
  end else
  if ch='&' then
  begin
    ctok.typ := _and;
    rch;
  end else
  if ch='|' then
  begin
    ctok.typ := _or;
    rch;
  end else
  if ch=':' then
  begin
    ctok.typ := _colon;
    rch;
  end else
  if ch in ['W','E'] then
  begin
    ctok.typ := _play;
    if ch='W' then ctok.pl := 1 else ctok.pl := 2;
    rch;
  end else
  if ch='=' then
  begin
    ctok.typ := _equ;
    rch;
    ss := '';
    while ch in ['0'..'9'] do
    begin
      ss := ss+ch;
      rch;
    end;
    val(ss,ctok.numb,code);
  end else
  if ch in karts then
  begin
    ctok.typ := _kart;
    ctok.kart := getkart(ch);
    rch;
    ctok.mast := getmast(ch);
    rch;
  end else
  if ch in masts then
  begin
    ctok.typ := _mast;
    ctok.mast := getmast(ch);
    rch;
  end;
end;

function expr : integer; forward;

function expr2 : integer;
begin
  if (ctok.typ=_left) then
  begin
    rtok;
    expr2 := expr;
    rtok;
  end else
  if (ctok.typ=_mast) then
  begin
    inc(baseno);
    basetype[baseno] := false;
    basemast[baseno] := ctok.mast;
    rtok;
    rtok;
    basepl[baseno] := ctok.pl;
    rtok;
    basenum[baseno] := ctok.numb;
    rtok;
    inc(num);
    tree[num].typ := t_mast;
    tree[num].baseindex := baseno;
    expr2 := num;
  end else
  if (ctok.typ=_kart) then
  begin
    inc(baseno);
    basetype[baseno] := true;
    basekart[baseno] := ctok.kart;
    basemast[baseno] := ctok.mast;
    rtok;
    rtok;
    basepl[baseno] := ctok.pl;
    rtok;
    inc(num);
    tree[num].typ := t_kart;
    tree[num].baseindex := baseno;
    expr2 := num;
  end;
end;

function expr : integer;
var
  t,tt : integer;
  ttt : ttoken;
begin
  t := expr2;
  while (ctok.typ in [_and,_or]) do
  begin
    ttt := ctok;
    rtok;
    tt := expr2;
    inc(num);
    if ttt.typ = _and then
      tree[num].typ := t_and
    else
      tree[num].typ := t_or;
    tree[num].ls := t;
    tree[num].rs := tt;
    t := num;
  end;
  expr := t;
end;

procedure Inp;
var
  i : integer;
  s : string;
begin
  assign(input,'bridge.in'); reset(input);
  assign(output,'bridge.out'); rewrite(output);
  fillchar(kartin,sizeof(kartin),1);
  readln(s);
  for i:=1 to 4 do
    fullmap[i] := 13;
  for i:=1 to 13 do
  begin
    kartin[getmast(s[2*i]),getkart(s[2*i-1])] := false;
    dec(fullmap[getmast(s[2*i])]);
  end;
  readln(s);
  for i:=1 to 13 do
  begin
    kartin[getmast(s[2*i]),getkart(s[2*i-1])] := false;
    dec(fullmap[getmast(s[2*i])]);
  end;
  readln(ss);
  rch;
  rtok;
  num := 0;
  baseno := 0;
  root := expr;
end;

function c(a,b : longint) : longint;
var
  t : longint;
  i : integer;
begin
  t := 1;
  for i:=1 to a do t:=t*i;
  for i:=1 to b do t:=t div i;
  for i:=1 to a-b do t:=t div i;
  c := t;
end;

procedure fillsup(a : longint);
var
  mtr : array [1..20] of boolean;
  maps : array [1..2,1..4,1..13] of integer;
  mapsno : array [1..2,1..4] of integer;
  i,j,k : integer;
  tmp : longint;
  oa : integer;
  left : array [1..2] of longint;
  t1,t2,t3,t4 : longint;
begin
  sup[a] := 0;
  left[1] := 13;
  left[2] := 13;
  oa := a;
  for i:=1 to baseno do
  begin
    mtr[i] := boolean(a mod 2);
    a := a div 2;
  end;
  for i:=1 to 4 do
  begin
    mapsno[1,i] := 100;
    mapsno[2,i] := 100;
    for j:=1 to 13 do
    begin
      if kartin[i,j] then
      begin
        maps[1,i,j] := 2;
        maps[2,i,j] := 2;
      end
      else
      begin
        maps[1,i,j] := 0;
        maps[2,i,j] := 0;
      end;
    end;
  end;
  for i:=1 to baseno do
  begin
    if not mtr[i] then continue;
    if basetype[i] then
    begin
      if maps[basepl[i],basemast[i],basekart[i]]=0 then
        exit;
      if maps[basepl[i],basemast[i],basekart[i]]=2 then
      begin
        maps[basepl[i],basemast[i],basekart[i]] := 1;
        if maps[3-basepl[i],basemast[i],basekart[i]]=1 then
          exit;
        maps[3-basepl[i],basemast[i],basekart[i]] := 0;
      end;
    end
    else
    begin
      if mapsno[basepl[i],basemast[i]]=100 then
      begin
        mapsno[basepl[i],basemast[i]] := basenum[i];
        if mapsno[3-basepl[i],basemast[i]]=100 then
          mapsno[3-basepl[i],basemast[i]] := fullmap[basemast[i]] - mapsno[basepl[i],basemast[i]]
        else
          if mapsno[3-basepl[i],basemast[i]] <> fullmap[basemast[i]] - mapsno[basepl[i],basemast[i]] then
            exit;
      end
      else
        if mapsno[basepl[i],basemast[i]] <> basenum[i] then
          exit;
    end;
  end;
  totalmap := fullmap;
  for i:=1 to 2 do
    for j:=1 to 4 do
      for k:=1 to 13 do
      begin
        if maps[i,j,k] = 1 then
          totalmap[j] := totalmap[j] - 1;
        if totalmap[j] < 0 then
          exit;
        if maps[i,j,k] = 1 then
          if mapsno[i,j]<>100 then
            mapsno[i,j] := mapsno[i,j] - 1;
        if maps[i,j,k] = 1 then
          left[i] := left[i] - 1;
        if left[i]<0 then exit;
      end;
  for i:=1 to 2 do
  for j:=1 to 4 do
    if (mapsno[i,j]<0) then exit;
  for i:=1 to 4 do
    if mapsno[1,i]<>100 then
      totalmap[i] := 0;
  tmp := 0;
    for t1:=0 to totalmap[1] do
    for t2:=0 to totalmap[2] do
    for t3:=0 to totalmap[3] do
    for t4:=0 to totalmap[4] do
    begin
      if t1+t2+t3+t4<>left[1] then continue;
      tmp := tmp + c(totalmap[1],t1)*c(totalmap[2],t2)*c(totalmap[3],t3)*c(totalmap[4],t4);
    end;
  sup[oa] := tmp;
end;

function count(spec : tdata) : longint;
var
  i,ii,tmp : longint;
  gut,gg,ggg : boolean;
  ttt : longint;
  j : integer;
  temp : integer;
begin
  gut := false;
  gg := false;
  ggg := true;
  for i:=1 to num do
  begin
    if (spec[i]) and gut then gg := true;
    if spec[i] then begin ii := i; gut := true; end;
    if (spec[i]) and not (tree[i].typ in [t_mast,t_kart]) then ggg := false;
  end;
  if not gut then
  begin
    count := 0;
    exit;
  end;
  if not gg then
    if ans[ii]<>-1 then
    begin
      count := ans[ii];
      exit;
    end;
  if ggg then
  begin
    temp := 0;
    for i:=1 to num do
      if spec[i] then
      begin
        j := tree[i].baseindex;
        temp := temp + (1 shl (j-1));
      end;
    tmp := sup[temp];
  end else
  begin

  end;
  if gg then
    ans[ii] := tmp;
  count := tmp;
end;

procedure Run;
var
  i : longint;
  tmp : tdata;
begin
  ms := 1;
  for i:=1 to baseno do
    ms := ms*2;
  for i:=0 to ms-1 do
    fillsup(i);
  fillchar(ans,sizeof(ans),255);
  fillchar(tmp,sizeof(tmp),0);
  tmp[root] := true;
  writeln(count(tmp));
end;

procedure Outp;
begin
  close(input); close(output);
end;

begin
  Inp;
  Run;
  Outp;
end.