{.$define debug}

program template;
const
 {$ifdef debug}
 h = 200;
 cinfile = 'input.txt';
 coutfile = 'output.txt';
 {$else}
 h = 100000;
 cinfile = 'beauty.in';
 coutfile = 'beauty.out';
 {$endif}
type
 int = longint;
 tpoint = record
  x,y :int;
  num :int;
 end;
 tptr = ^ttree;
 ttree = record
{  lo,hi :int;}
  inf :int;
  prev :int;
  l,r :tptr;
 end;
var
 n :int;
 ans :int;
 p :array [1..h] of tpoint;
 yy :array [1..h] of int;
 tree :tptr;
 ind :array [1..h] of int;
 d :array [1..h] of int;
 prev :array [1..h] of int;
 size :int;

procedure init;
begin
 ans := 0;
 fillchar (p,sizeof(p),0);
 randseed := 7;
 fillchar (ind,sizeof(ind),0);
{ fillchar (yy,sizeof(yy),0);}
 fillchar (d,sizeof(d),0);
 fillchar (prev,sizeof(prev),0);
 size := 0;
end;

procedure readdata;
var i,j :int;
begin
 assign (input,cinfile);
 reset (input);
 readln (n);
 for i := 1 to n do
  begin
   readln (p[i].x,p[i].y);
   p[i].num := i;
  end;
 close (input);
end;

procedure outdata;
var i,j :int;
begin
 assign (output,coutfile);
 rewrite (output);
 writeln (ans);
 for i := 1 to n do
  if p[i].num < 0 then
   write (-p[i].num,' ');
 close (output);
end;

procedure swap (var a,b :int);
begin
 a := a xor b;
 b := a xor b;
 a := a xor b;
end;

procedure swappoint (var a,b :tpoint);
var tmp :tpoint;
begin
 tmp := a;
 a := b;
 b := tmp;
end;

function less (a,b :tpoint):boolean;
begin
 if a.x = b.x then
  less := a.y < b.y
 else
  less := a.x < b.x;
end;

procedure sort (l,r :int);
var i,j :int;
    x :int;
begin
 i := l;
 j := r;
 x := yy[l + random(r-l+1)];
 repeat
  while yy[i] < x do
   inc(i);
  while yy[j] > x do
   dec (j);
  if i <= j then
   begin
    if not (i=j) then
     swap (yy[i],yy[j]);
    inc (i);
    dec (j);
   end;
 until i > j;
 if i < r then
  sort (i,r);
 if j > l then
  sort (l,j);
end;

procedure sortpoint (l,r :int);
var i,j :int;
    d :tpoint;
begin
 i := l;
 j := r;
 d := p[l + random(r-l+1)];
 repeat
  while less (p[i],d) do
   inc (i);
  while less (d,p[j]) do
   dec (j);
  if i <= j then
   begin
    swappoint (p[i],p[j]);
    inc (i);
    dec (j);
   end;
 until i > j;
 if i < r then
  sortpoint (i,r);
 if j > l then
  sortpoint (l,j);
end;

function search (y :int):int;
var l,r :int;
    mid :int;
begin
 l := 1;
 r := n;
 while r-l > 1 do
  begin
   mid := (l+r) shr 1;
   if yy[mid] < y then
    l := mid
   else
    r := mid;
  end;
 if yy[l] = y then
  search := l
 else
  search := r;
end;

procedure build (var node :tptr; l,r :int);
begin
 new (node);
 size := size + sizeof(node^);
{ node^.lo := l;
 node^.hi := r;}
 if l = r then
  begin
   node^.l := nil;
   node^.r := nil;
   node^.inf := 0;
   node^.prev := 0;
   exit;
  end;
 build (node^.l,l,(l+r) shr 1);
 build (node^.r,(l+r) shr 1+1,r);
 node^.inf := 0;
 node^.prev := 0;
end;

function rec (lo,hi :int; node :tptr; hh :int; var res :int):int;
begin
 if lo = hi then
  begin
   rec := yy[lo];
   res := node^.prev;
   exit;
  end;
 if (node^.l^.inf > node^.r^.inf) and (hh > (lo+hi) shr 1) then
  begin
   rec := node^.l^.inf;
   res := node^.l^.prev;
   exit;
  end;
 if (node^.l^.inf < node^.r^.inf) and (hh > (lo+hi) shr 1) then
  begin
   rec := rec ((lo+hi) shr 1+1,hi,node^.r,hh,res);
   exit;
  end;
 rec := rec (lo,(lo+hi) shr 1,node^.l,hh,res);
end;

procedure add (lo,hi :int;node :tptr; pos :int; value :int; number :int);
begin
 if lo=hi then
  begin
   if yy[pos] < value then
    yy[pos] := value;
   if node^.inf < value then
    node^.inf := value;
   node^.prev := number;
   exit;
  end;

 if pos > (lo+hi) shr 1 then
  add ((lo+hi) shr 1 + 1,hi,node^.r,pos,value,number)
 else
  add (lo,(lo+hi) shr 1,  node^.l,pos,value,number);

 if node^.l^.inf > node^.inf then
  begin
   node^.inf := node^.l^.inf;
   node^.prev := node^.l^.prev;
  end;
 if node^.r^.inf > node^.inf then
  begin
   node^.inf := node^.r^.inf;
   node^.prev := node^.r^.prev;
  end;
end;


procedure solve;
var i,j :int;
    t :int;
    k :int;
    cur :int;
begin
 for i := 1 to n do
  yy[i] := p[i].y;
 sort (1,n);
 ind[1] := 1;
 for i := 2 to n do
  if yy[i] > yy[i-1] then
   ind[i] := ind[i-1] + 1
  else
   ind[i] := ind[i-1];
 for i := 1 to n do
  p[i].y := ind[search(p[i].y)];
 sortpoint (1,n);
 build (tree,1,n);
 fillchar (yy,sizeof(yy),0);
 i := 1;
 while i <= n do
  begin
   k := 0;
   t := p[i].x;
   while (i <= n) and (p[i].x = t) do
    begin
     inc (k);
     ind[k] := p[i].y;
     inc (i);
    end;
   for j := 1 to k do
    if ind[j] > 1 then
     d[i-k+j-1] := rec (1,n,tree,ind[j]-1,prev[i-k+j-1]) + 1
    else
     d[i-k+j-1] := 1;
   for j := 1 to k do
    add (1,n,tree,ind[j],d[i-k+j-1],i-k+j-1);
  end;
 cur := 1;
 for i := 1 to n do
  if d[i] > d[cur] then
   cur := i;
 ans := d[cur];
 while cur > 0 do
  begin
   p[cur].num := -p[cur].num;
   cur := prev[cur];
  end;
end;

begin
 init;
 readdata;
 solve;
 outdata;
end.