{$I+,Q-,R-,S+}
program         Template;

type
  PEdge         = ^TEdge;
  TEdge         = record
    V, K        : Byte;
    Next        : PEdge;
  end;

  PList         = ^TList;
  TList         = record
    X           : Byte;
    Next        : PList;
  end;

  PRoute        = ^TRoute;
  TRoute        = record
    List        : PList;
    Next        : PRoute;
  end;

  PRule         = ^TRule;
  TRule         = record
    L1, L2      : PList;
    Next        : PRule;
  end;

  TWayList      = array[1..1000] of Integer;

var
  N, M, S       : Integer;
  Roads         : array[1..100] of PEdge;
  Rules         : PRule;
  Ways          : array[1..100, 1..100] of PRoute;
  ThisWay       : PList;

procedure       OpenFiles;
begin
  Assign(Input, 'comm.in');
  Reset(Input);
  Assign(Output, 'comm.out');
  Rewrite(Output);
end;

procedure       CloseFiles;
begin
  Close(Input);
  Close(Output);
end;

procedure       ReadData;
var
  I, A, B       : Integer;
  Road          : PEdge;
begin
  FillChar(Roads, SizeOf(Roads), 0);

  ReadLn(N, M);
  for I := 1 to M do begin
    Read(A, B);

    New(Road);
    Road^.V := B;
    Road^.K := I;
    Road^.Next := Roads[A];

    Roads[A] := Road;
  end;
end;

procedure       AddToList(var List: PList; Elem: Byte);
var
  L             : PList;
begin
  New(L);
  L^.X := Elem;
  L^.Next := List;
  List := L;
end;

procedure       RemoveFromList(var L: PList);
var
  LL            : PList;
begin
  LL := L^.Next;
  Dispose(L);
  L := LL;
end;

procedure       AddList(var R: PRoute; L: PList);
var
  RR            : PRoute;
begin
  New(RR);
  RR^.List := L;
  RR^.Next := R;
  R := RR;
end;

procedure       Rec(V: Integer);
var
  E             : PEdge;
begin
  AddList(Ways[S, V], ThisWay);
  AddToList(ThisWay, V);

  E := Roads[V];
  while E <> nil do begin
    Rec(E^.V);

    E := E^.Next;
  end;
end;

procedure       ApplyRules(Way: PList; var W: TWayList; var Len: Integer);
begin
  Len := 0;
  while Way <> nil do begin
    Inc(Len);
    W[Len] := Way^.X;

    Way := Way^.Next;
  end;
end;

procedure       OutputRules(Route: PRoute);
var
  L1, L2        : PList;
begin
  while Route <> nil do begin
    L1 := Route^.List;

    Route := Route^.Next;
    if Route <> nil then begin
      L2 := Route^.List;

//      ApplyRules(L1);
  //    ApplyRules(L2);

      Route := Route^.Next;
    end;
  end;
end;

procedure       Solve;
var
  I, J          : Integer;
begin
  FillChar(Rules, SizeOf(Rules), 0);
  FillChar(Ways, SizeOf(Ways), 0);

  ThisWay := nil;
  for S := 1 to N do
    Rec(S);

  for I := 1 to N do
    for J := 1 to N do
      OutputRules(Ways[I, J]);

  WriteLn(0);
end;

begin
  OpenFiles;
  ReadData;
  Solve;
  CloseFiles;
end.
