{$I+,Q-,R-,S+}
program         Template;

type
  Extended      = Double;

type
  PEdge         = ^TEdge;
  TEdge         = record
    V           : Integer;
    Weight      : Extended;
    Next        : PEdge;
  end;

var
  N             : LongInt;
  Edges         : array[1..300] of PEdge;
  A             : array[1..300, 1..300] of Extended;
  D             : array[1..300, 1..300] of Extended;
  Ans           : array[1..300] of Extended;
  MMM           : Extended;

procedure       OpenFiles;
begin
  Assign(Input, 'math.in');
  Reset(Input);
  Assign(Output, 'math.out');
  Rewrite(Output);
end;

procedure       CloseFiles;
begin
  Close(Input);
  Close(Output);
end;

procedure       ReadData;
var
  I, J, K, X    : Integer;
  Operation     : Char;
  Val           : Extended;
  E             : PEdge;
begin
  ReadLn(N);

  for I := 1 to N do
    for J := 1 to N do begin
      if I = J then begin
        D[I, J] := 1;
        A[I, J] := 1;
      end else begin
        D[I, J] := -101717;
        A[I, J] := -101717;
      end;
    end;

  FillChar(Edges, SizeOf(Edges), 0);
  for I := 1 to N do begin
    ReadLn(K);
    if K > 0 then
      for J := 1 to K do begin
        Read(Operation);
        ReadLn(Val, X);

        New(E);
        E^.V := X;
        if Operation = '*' then
          E^.Weight := Val
        else
          E^.Weight := 1 / Val;
        E^.Next := Edges[I];
        Edges[I] := E;

        if (E^.Weight > D[I, X]) or (D[I, X] = -101717) or ((I = X) and (D[I, X] = 1)) then begin
          D[I, X] := E^.Weight;
          A[I, X] := E^.Weight;
        end;
      end;
  end;
end;

function        Min(A, B: Extended): Extended;
begin
  if A = -101717 then
    Min := B
  else if B = -101717 then
    Min := A
  else
    if A < B then
      Min := B
    else
      Min := A;
end;

function        Walk(V: Integer): Boolean;
var
  E             : PEdge;
begin
  Walk := True;

  E := Edges[V];
  while E <> nil do begin
    if Ans[E^.V] <> -101718 then begin
      Ans[E^.V] := -101718;
      Walk := False;

      Walk(E^.V);
    end;

    E := E^.Next;
  end;
end;

function        Walk2(SV, V: Integer; W: Extended; First: Boolean): Boolean;
var
  I             : Integer;
begin
  Walk2 := True;

  if (V = SV) and not First then begin
    if W > D[1, I] then begin
      Walk2 := False;
      Exit;
    end else
      Exit;
  end;

  for I := 1 to N do begin
    if (V <> I) and (A[V, I] <> -101717) then begin
      if Ans[I] <> -101718 then
        if not Walk2(SV, I, W * A[V, I], False) then begin
          Ans[I] := -101718;
          Exit;
        end;
    end;
  end;
end;

procedure       Solve(Final: Boolean);
var
  I, J, K       : Integer;
  OK            : Boolean;
begin
  MMM := -101717;
  if not Final then begin
    for K := 1 to N do
      for I := 1 to N do
        for J := 1 to N do
          if (D[I, K] <> -101717) and (D[K, J] <> -101717) then begin
            D[I, J] := Min(D[I, J], D[I, K] * D[K, J]);
            MMM := Min(D[I, J], MMM);
          end;
  end else begin
    for K := 1 to N do
      for I := 1 to N do
        for J := 1 to N do
          if (D[I, K] <> -101717) and (D[K, J] <> -101717) then
            if true {I <> J} then begin
              if Min(D[I, J], D[I, K] * D[K, J]) <> D[I, J] then
                Ans[K] := -101718;
            end else
              if (D[I, J] = 1) and (D[I, K] * D[K, J] <> 1) then
                Ans[K] := -101718;
  end;

  if Final then begin
    repeat
      OK := True;
      for I := 1 to N do begin
        if Ans[I] = -101718 then begin
          if not Walk(I) then
            OK := False;
        end else
{        if not Walk2(I, I, 1, True) then
          OK := False;};

      end;
    until OK;

    for I := 1 to N do
      if (Ans[I] <> D[1, I]) or (Ans[I] = -101718) then
        WriteLn('INF')
      else if D[1, I] = -101717 then
        WriteLn('NONE')
      else
        WriteLn(D[1, I]);
  end else
    for I := 1 to N do
      Ans[I] := D[1, I];
end;

begin
  OpenFiles;
  ReadData;

  Solve(False);
  Solve(True);

  CloseFiles;
end.
