const
     FileIn='comm.in';
     FileOut='comm.out';
     MaxN=100;
     MaxM=1000;
     stUnvisited=0;
     stJustVisited=1;
type
    TNode=record
                State: Byte;
                UsedInPath: Boolean;
          end;
    TFIFOItem=record
                    Node, From: Integer;
              end;
var
   Matrix: array [1..MaxN, 1..MaxN] of Integer;
   N, M: LongInt;
   Nodes: array [1..MaxN] of TNode;
   FIFO: array [1..MaxN] of TFIFOItem;
   FIFOLen: LongInt;
   RulesCount: LongInt;

procedure ReadData;
var
   F: Text;
   NEdge: LongInt;
   FromNode, ToNode: LongInt;
begin
     FillChar (Matrix, SizeOf (Matrix), 0);
     Assign (F, FileIn);
     Reset (F);
     Readln (F, N, M);
     for NEdge:=1 to M
         do begin
            Read (F, FromNode, ToNode);
            Matrix [FromNode, ToNode]:=NEdge;
         end;
     Close (F);
end;

procedure WriteData;
var
   F: Text;
begin
     Assign (F, FileOut);
     Rewrite (F);
     Writeln (F, RulesCount);
     Close (F);
end;

procedure ProcessNode (aNode: LongInt);
var
   NFIFONode, NNode: LongInt;

procedure NewRule;
var
   LocNNode, CurFIFONode, StartFIFONode: LongInt;
begin
     for LocNNode:=1 to N
         do Nodes [LocNNode].UsedInPath:=false;

     for CurFIFONode:=FIFOLen downto 1
         do if FIFO [CurFIFONode].Node=NNode
               then Break;
     CurFIFONode:=FIFO [CurFIFONode].From;
     while FIFO [CurFIFONode].From<>FIFO [CurFIFONode].Node
           do begin
              Nodes [FIFO [CurFIFONode].Node].UsedInPath:=true;
              CurFIFONode:=FIFO [CurFIFONode].From;
           end;
     Nodes [FIFO [CurFIFONode].Node].UsedInPath:=true;

     CurFIFONode:=NFIFONode;
     while not Nodes [FIFO [CurFIFONode].Node].UsedInPath
           do CurFIFONode:=FIFO [CurFIFONode].From;
     StartFIFONode:=CurFIFONode;

     for CurFIFONode:=FIFOLen downto 1
         do if FIFO [CurFIFONode].Node=NNode
               then Break;
     while FIFO [CurFIFONode].From<>CurFIFONode
           do begin
              Write (Matrix [FIFO [FIFO [CurFIFONode].From].Node, FIFO [CurFIFONode].Node], #32);
              CurFIFONode:=FIFO [CurFIFONode].From;
           end;
     Write ('= ', Matrix [FIFO [NFIFONode].Node, NNode], #32);
     CurFIFONode:=NFIFONode;
     while FIFO [CurFIFONode].From<>CurFIFONode
           do begin
              Write (Matrix [FIFO [FIFO [CurFIFONode].From].Node, FIFO [CurFIFONode].Node], #32);
              CurFIFONode:=FIFO [CurFIFONode].From;
           end;
     Writeln;
end;

begin
     FIFOLen:=1;
     FIFO [FIFOLen].Node:=1;
     FIFO [FIFOLen].From:=1;
     NFIFONode:=1;
     while NFIFONode<=FIFOLen
           do begin
              for NNode:=1 to N
                  do if (NNode<>FIFO [NFIFONode].Node) and (Matrix [FIFO [NFIFONode].Node, NNode]>0)
                        then case Nodes [NNode].State of
                                  stJustVisited: NewRule;
                                  stUnvisited: begin
                                                    Nodes [NNode].State:=stJustVisited;
                                                    Inc (FIFOLen);
                                                    FIFO [FIFOLen].Node:=NNode;
                                                    FIFO [FIFOLen].From:=NFIFONode;
                                               end;
                             end;
              Inc (NFIFONode);
           end;
end;

procedure UnvisitAll;
var
   NNode: LongInt;
begin
     for NNode:=1 to N
         do Nodes [NNode].State:=stUnvisited;
end;

procedure Solve;
var
   NNode: LongInt;
begin
{    UnvisitAll;
     for NNode:=1 to N
         do begin
            ProcessNode (NNode);
            UnvisitAll;
         end; }
     RulesCount:=0;
end;

procedure Main;
begin
     ReadData;
     Solve;
     WriteData;
end;

begin
     Main;
end.
