const
     FileIn='beauty.in';
     FileOut='beauty.out';
     MaxN=100000;
type
    TMan=record
               S, B: LongInt;
               IndexBeforeSort: LongInt;
         end;
var
   N: LongInt;
   Men: array [1..MaxN] of TMan;
   AnswerCount: LongInt;
   AnswerList: array [1..MaxN] of LongInt;

procedure ReadData;
var
   F: Text;
   NMan: LongInt;
begin
     Assign (F, FileIn);
     Reset (F);
     Readln (F, N);
     for NMan:=1 to N
         do begin
            Readln (F, Men [NMan].S, Men [NMan].B);
            Men [NMan].IndexBeforeSort:=NMan;
         end;
     Close (F);
end;

procedure WriteData;
var
   F: Text;
   NItem: LongInt;
begin
     Assign (F, FileOut);
     Rewrite (F);
     Writeln (F, AnswerCount);
     for NItem:=1 to AnswerCount-1
         do Write (F, Men [AnswerList [NItem]].IndexBeforeSort, #32);
     Writeln (F, Men [AnswerList [AnswerCount]].IndexBeforeSort);
     Close (F);
end;

function KeyOf (const aMan: TMan): LongInt;
begin
     KeyOf:=Abs (aMan.S-aMan.B);
end;

procedure QSort (aLeft, aRight: LongInt);
var
   i, j: LongInt;
   x, y: TMan;
begin
     i:=aLeft;
     j:=aRight;
     x:=Men [(aLeft+aRight) div 2];
     repeat
           while KeyOf (Men [i])<KeyOf (x)
                 do Inc (i);
           while KeyOf (x)<KeyOf (Men [j])
                 do Dec (j);
           if i<=j
              then begin
                   y:=Men [i];
                   Men [i]:=Men [j];
                   Men [j]:=y;
                   Inc (i);
                   Dec (j);
              end;
     until i>j;
     if aLeft<j
        then QSort (aLeft, j);
     if i<aRight
        then QSort (i, aRight);
end;

procedure Solve;
var
   NMan: LongInt;
   MinS, MinB, MaxS, MaxB: LongInt;
begin
     QSort (1, N);
     AnswerCount:=1;
     AnswerList [1]:=1;
     MinS:=Men [1].S;
     MinB:=Men [1].B;
     MaxS:=Men [1].S;
     MaxB:=Men [1].B;
     for NMan:=2 to N
         do if ((Men [NMan].S<MinS) and (Men [NMan].B<MinB)) or
               ((Men [NMan].S>MaxS) and (Men [NMan].B>MaxB))
               then begin
                    Inc (AnswerCount);
                    AnswerList [AnswerCount]:=NMan;
                    if Men [NMan].S<MinS
                       then MinS:=Men [NMan].S
                       else if Men [NMan].S>MaxS
                               then MaxS:=Men [NMan].S;
                    if Men [NMan].B<MinB
                       then MinB:=Men [NMan].B
                       else if Men [NMan].B>MaxB
                               then MaxB:=Men [NMan].B;
               end;
end;

procedure Main;
begin
     ReadData;
     Solve;
     WriteData;
end;

begin
     Main;
end.
