{.$define debug}
{$ifdef debug}
{$N+,R+,Q+}
{$endif}

program template;
const
 kmax = 10;
 eps = 1e-7;
 {$ifdef debug}
 lo = -6;
 hi = 6;
 delta = 100;
 cinfile = 'input.txt';
 coutfile = 'output.txt';
 {$else}
 lo = -51;
 hi = 51;
 delta = 10000;
 cinfile = 'function.in';
 coutfile = 'function.out';
 {$endif}
type
 int = longint;
 real = extended;
var
 n :real;
 k,m :int;
 c :array [0..kmax] of real;
 c_ :array [0..kmax] of real;
 ans :int;
 d :array [lo*delta..hi*delta] of real;
 a,b :real;
 f :array [lo*delta..hi*delta] of real;
 null :array [1..kmax*100] of int;
 r :array [lo*delta..hi*delta] of int;

procedure init;
begin
 ans := 0;
 m := 0;
 fillchar (d,sizeof(d),0);
 fillchar (c,sizeof(c),0);
 fillchar (f,sizeof(f),0);
 fillchar (c_,sizeof(c_),0);
 fillchar (null,sizeof(null),0);
 fillchar (r,sizeof(r),0);
end;

procedure swap (var a,b :real);
var tmp :real;
begin
 tmp := a;
 a := b;
 b := tmp;
end;

procedure readdata;
var i,j :int;
begin
 assign (input,cinfile);
 reset (input);
 read (n,a,b);
 readln (k);
 for i := k downto 0 do
  read (c[i]);
 close (input);
 if a > b then
  swap (a,b);
end;

procedure outdata;
var i,j :int;
begin
 assign (output,coutfile);
 rewrite (output);
 writeln (ans);
 close (output);
end;

function p (x :real):real;
var t :real;
    i,j :int;
    res :real;
begin
 res := 0;
 t := 1;
 for i := 0 to k do
  begin
   res := res + t*c[i];
   t := t*x;
  end;
 p := res;
end;

function trunc_ (x :real):int;
begin
 if x > 0 then
  trunc_ := trunc(x)
 else
  trunc_ := trunc(x) + 1;
end;


procedure diff;
var i,j :int;

function p_ (x :real):real;
var i :int;
    res :real;
    t :real;
begin
 res := 0;
 t := 1;
 for i := 0 to k-1 do
  begin
   res := res + t*c_[i];
   t := t*x;
  end;
 p_ := res;
end;

begin
 if k <= 1 then
  exit;
 for i := 1 to k do
  c_[i-1] := c[i]*i;
 for i := round(a*delta) to round(b*delta) do
  if abs (p_(i/delta)) < eps then
   begin
    inc (m);
    null[m] := i;
   end;
end;

procedure solve;
var i,j :int;
    min :real;
    a_,b_ :int;
begin
 if b-a < n then
  exit;
 diff;
 for i := round(a*delta) to round(b*delta) do
  f[i] := p(i/delta);
 min := 1e100;
 for i := round(a*delta) to round(a*delta + n*delta) do
  if f[i] < min then
   min := f[i];
 d[round((a+n)*delta)] := min;
 r[round((a+n)*delta)] := trunc_ (min/n + eps);
 for i := round(a*delta) to round(b*delta) do
  begin
   a_ := i - round(n*delta);
   b_ := i;
   if a_ < round(a*delta) then
    a_ := round(a*delta);
   if f[a_] < f[b_] then
    min := f[a_]
   else
    min := f[b_];
   for j := 1 to m do
    if (null[j] >= a_) and (null[j] <= b_) then
     if f[null[j]] < min then
      min := f[null[j]];
   d[i] := min;
  end;
 r[round((a+n)*delta)] := trunc_ (d[round((a+n)*delta)]/n + eps);
 for i := round((a+n)*delta)+1 to round(b*delta)+1 do
  r[i] := r[i - round(n*delta)] + trunc_ (d[i]/n + eps);

 ans := r[round(b*delta)];
end;

begin
 init;
 readdata;
 solve;
 outdata;
end.