{$I+,Q-,R-,S+}
program         Template;

var
  N, A, B       : Double;
  K             : Integer;
  C, F          : array[0..11] of Double;
  Derivatives   : array[1..11, 0..11] of Double;

procedure       OpenFiles;
begin
  Assign(Input, 'function.in');
  Reset(Input);
  Assign(Output, 'function.out');
  Rewrite(Output);
end;

procedure       CloseFiles;
begin
  Close(Input);
  Close(Output);
end;

procedure       ReadData;
var
  I             : Integer;
begin
  ReadLn(N, A, B, K);
  for I := K downto 0 do
    Read(C[I]);
end;

function        Func(X: Double): Double;
var
  FF, XX        : Double;
  I             : Integer;
begin
  FF := C[0]; XX := 1;
  for I := 1 to K do begin
    XX := XX * X;
    FF := FF + C[I] * XX;
  end;

  Func := FF;
end;

function        GetArea(X1, X2: Double): Double;
var
  F1, F2, XX    : Double;
  I             : Integer;
begin
  XX := 1; F1 := 0;
  for I := 1 to K + 1 do begin
    XX := XX * X1;
    F1 := F1 + F[I] * XX;
  end;

  XX := 1; F2 := 0;
  for I := 1 to K + 1 do begin
    XX := XX * X2;
    F2 := F2 + F[I] * XX;
  end;

  GetArea := F2 - F1;
end;

procedure       Derive;
var
  I, J          : Integer;
begin
  FillChar(Derivatives, SizeOf(Derivatives), 0);

  Move(C, Derivatives[K], SizeOf(C));
  for I := K - 1 downto 1 do
    for J := 1 to I do
      Derivatives[I, J] := (J + 1) * Derivatives[I + 1, J + 1];
end;

function        GetArea2(X1, X2: Double): Double;
var
  I             : Double;
  YMin, Y       : Double;
begin
  YMin := 1000; I := X1;
  while I < X2 do begin
    Y := Func(I + 0.05);
    if Y < YMin then
      YMin := Y;

    I := I + 0.1;
  end;

  GetArea2 := (X2 - X1) * YMin;
end;

procedure       Solve;
var
  I             : Integer;
  L             : Double;
  Z, ZC         : LongInt;
begin
  if K = 0 then begin
    WriteLn(0);
    Exit;
  end;

  FillChar(F, SizeOf(F), 0);
  for I := 0 to K do
    F[I + 1] := C[I] / (I + 1);

  Derive;

  Z := 0; L := A;
  while L + N <= B do begin
    ZC := Trunc(GetArea2(L, L + N) / N);
    if ZC > 0 then begin
      Z := Z + ZC;
      L := L + N;
    end else
      L := L + 0.1;
  end;

  WriteLn(Z);
end;

begin
  OpenFiles;
  ReadData;
  Solve;
  CloseFiles;
end.
