{$I+,Q-,R-,S+}
program         Template;

type
  TSequence     = array[1..2000] of Byte;

var
  N, M          : Integer;
  Groups        : array[1..1000] of Integer;
  Sequence      : TSequence;
  RealSequence  : TSequence;
  CurSequence   : TSequence;
  MinLen        : array[1..1234] of Integer;

procedure       OpenFiles;
begin
  Assign(Input, 'japan.in');
  Reset(Input);
  Assign(Output, 'japan.out');
  Rewrite(Output);
end;

procedure       CloseFiles;
begin
  Close(Input);
  Close(Output);
end;

procedure       ReadData;
var
  I             : Integer;
begin
  ReadLn(N);

  Read(M);
  for I := 1 to M do
    Read(Groups[I]);

  for I := 1 to N do
    Read(Sequence[I]);
end;

procedure       Rec(P, G, LG, LFP: Integer);
var
  I             : Integer;
begin
  repeat
    while (P <= N) and (Sequence[P] = 0) do begin
      CurSequence[P] := 0;
      Inc(P);
    end;

    if P > N then begin
      if (G = 0) and (LG = 0) then
        for I := 1 to N do begin
          if RealSequence[I] = 3 then
            RealSequence[I] := CurSequence[I]
          else if RealSequence[I] <> CurSequence[I] then
            RealSequence[I] := 2;
        end;
      Exit;
    end;

    if P + MinLen[M - G + 1] > N + 1 then
      Exit;

    if Sequence[P] = 1 then begin
      CurSequence[P] := 1;
      if LG = 0 then begin
        if P - LFP <= 1 then
          Exit;

        Dec(G);
        LG := Groups[M - G] - 1;
        Inc(P);
      end else begin
        Dec(LG);
        Inc(P);

        if LG = 0 then
          LFP := P - 1;
      end;
    end else begin
      if LG > 0 then begin
        while LG > 0 do begin
          CurSequence[P] := 1;

          Inc(P);
          Dec(LG);

          if (P > N) and (LG > 0) then
            Exit;

          if not (Sequence[P] in [1, 2]) and (LG > 0) then
            Exit;
        end;
        LFP := P - 1;
      end else begin
        if (G > 0) and (P - LFP > 1) then
          Rec(P, G - 1, Groups[M - G + 1], LFP);
        CurSequence[P] := 0;
        Inc(P);
      end;
    end;
  until False;
end;

procedure       Solve;
var
  I             : Integer;
begin
  FillChar(MinLen, SizeOf(MinLen), 0);
  for I := M downto 1 do begin
    if I < M then
      MinLen[I] := MinLen[I + 1] + Groups[I] + 1
    else
      MinLen[I] := Groups[I];
  end;

  for I := 1 to N do
    RealSequence[I] := 3;

  Rec(1, M, 0, -1);
  for I := 1 to N do begin
    Write(RealSequence[I]);
    if I < N then
      Write(' ')
    else
      WriteLn;
  end;
end;

begin
  OpenFiles;
  ReadData;
  Solve;
  CloseFiles;
end.
