const
     FileIn='function.in';
     FileOut='function.out';
     MaxK=10;
     MinAB=-50;
     MaxAB=50;
     Delta=0.01;
     Quality=10;
     MinN=0.1;
     MaxF=1000;
     Eps=1e-7;
var
   K: LongInt;
   N, A, B: Extended;
   Koefs: array [0..MaxK] of Extended;
   MinValues: array [MinAB*Quality..MaxAB*Quality] of Extended;
   Answer: LongInt;

procedure ReadData;
var
   F: Text;
   NKoef: LongInt;
begin
     Assign (F, FileIn);
     Reset (F);
     Readln (F, N, A, B, K);
     for NKoef:=K downto 0
         do Read (F, Koefs [NKoef]);
     Close (F);
end;

procedure WriteData;
var
   F: Text;
begin
     Assign (F, FileOut);
     Rewrite (F);
     Writeln (F, Answer);
     Close (F);
end;

function XToMinIndex (aX: Extended): LongInt;
begin
     XToMinIndex:=Trunc (aX*Quality);
end;

function CalcFunctionForX (aX: Extended): Extended;
var
   PowerX: Extended;
   NKoef: LongInt;
   Value: Extended;
begin
     Value:=Koefs [0];
     PowerX:=1;
     for NKoef:=1 to K
         do begin
            PowerX:=PowerX*aX;
            Value:=Value+Koefs [NKoef]*PowerX;
         end;
     CalcFunctionForX:=Value;
end;

function Min (aA, aB: Extended): Extended;
begin
     if aA<aB
        then Min:=aA
        else Min:=aB;
end;

procedure GetMinValues;
var
   X: Extended;
   Index: LongInt;
begin
     for Index:=XToMinIndex (A) to XToMinIndex (B)
         do MinValues [Index]:=MaxF;
     X:=A;
     while X<=B
           do begin
              Index:=XToMinIndex (X);
              MinValues [Index]:=Min (MinValues [Index], CalcFunctionForX (X));
              X:=X+Delta;
           end;
end;

procedure Swap (var aA, aB: Extended);
var
   T: Extended;
begin
     T:=aA;
     aA:=aB;
     aB:=T;
end;

function CanPutHere (aX: Extended): Boolean;
var
   X: Extended;
begin
     if aX+N>B+Eps
        then begin
             CanPutHere:=false;
             Exit;
        end
        else begin
             X:=aX;
             while X<aX+N
                   do begin
                      if MinValues [XToMinIndex (X)]+Eps<N
                         then begin
                              CanPutHere:=false;
                              XToMinIndex (X);
                              Exit;
                         end;
                       X:=Round ((X+(1/Quality))*Quality)/Quality;
                   end;
        end;
     CanPutHere:=true;
end;

procedure PutHere (aX: Extended);
var
   X: Extended;
   Index: LongInt;
begin
     X:=aX;
     while X+Eps<aX+N
           do begin
              Index:=XToMinIndex (X);
              MinValues [Index]:=MinValues [Index]-N;
              X:=Round ((X+(1/Quality))*Quality)/Quality;
           end;
end;

procedure Solve;
var
   X: Extended;
   I: LongInt;
begin
     if A>B
        then Swap (A, B);
     GetMinValues;
     X:=A;
     Answer:=0;
     while X<=B
           do begin
              while CanPutHere (X)
                    do begin
                       PutHere (X);
                       Inc (Answer);
                    end;
              X:=Round ((X+(1/Quality))*Quality)/Quality;
           end;
end;

procedure Main;
begin
     ReadData;
     Solve;
     WriteData;
end;

begin
     Main;
end.
