uses save;
const
     BreakChars=[#32, ':'];
     MonthsCount=12;
     Months: array [1..MonthsCount] of string=('January', 'February',
            'March', 'April', 'May', 'June', 'July', 'August',
            'September', 'October', 'November', 'December');
     MaxSlots=100000;
var
   SlotsCount: LongInt;
   SlotDates: array [1..MaxSlots] of LongInt;
   Answer: LongInt;

procedure ReadData;
var
   NSlot: LongInt;
begin
     SlotsCount:=GetSlotNumber;
     for NSlot:=1 to SlotsCount
         do SlotDates [NSlot]:=-1;
end;

procedure WriteData;
begin
     LastGame (Answer);
end;

function ExtractWord (const aStr: string; var aNChar: LongInt): string;
var
   ResWord: string;
   NChar: Byte;
begin
     ResWord:='';
     for NChar:=aNChar to Length (aStr)
         do if aStr [NChar] in BreakChars
               then Break
               else ResWord:=ResWord+aStr [NChar];
     aNChar:=NChar+1;
     ExtractWord:=ResWord;
end;

function MonthStrToMonth (aMonthStr: string): LongInt;
var
   NMonth: LongInt;
begin
     for NMonth:=1 to MonthsCount
         do if Months [NMonth]=aMonthStr
               then Break;
     MonthStrToMonth:=NMonth;
end;

function DateToHash (const aStr: string): LongInt;
var
   DayStr, MonthStr, HourStr, MinStr, SecStr: string;
   NChar: LongInt;
   Day, Month, Hour, Min, Sec: LongInt;
   Err: Integer;
begin
     NChar:=1;
     DayStr:=ExtractWord (aStr, NChar);
     MonthStr:=ExtractWord (aStr, NChar);
     HourStr:=ExtractWord (aStr, NChar);
     MinStr:=ExtractWord (aStr, NChar);
     SecStr:=ExtractWord (aStr, NChar);
     Val (DayStr, Day, Err);
     Month:=MonthStrToMonth (MonthStr);
     Val (HourStr, Hour, Err);
     Val (MinStr, Min, Err);
     Val (SecStr, Sec, Err);
     DateToHash:=((((Month-1)*30+(Day-1))*24+Hour)*60+Min)*60+Sec;
end;

function GetDate (aSlot: LongInt): LongInt;
begin
     if aSlot<=MaxSlots
        then begin
             if SlotDates [aSlot]<0
                then SlotDates [aSlot]:=DateToHash (LoadGame (aSlot));
             GetDate:=SlotDates [aSlot];
        end
        else GetDate:=DateToHash (LoadGame (aSlot));
end;

procedure Solve;
var
   Left, Delta: LongInt;
begin
     Answer:=1;
     Delta:=SlotsCount-1;
     repeat
           while (Answer+Delta<=SlotsCount) and (GetDate (Answer+Delta)>GetDate (Answer))
                 do Inc (Answer, Delta);
           Delta:=Delta div 2;
     until Delta=0;
end;

procedure Main;
begin
     ReadData;
     Solve;
     WriteData;
end;

begin
     Main;
end.
