{$I+,Q-,R-,S+}
program         Template;

type
  Int           = Int64;

var
  N, M          : LongInt;
  A, B, CFirst  : array[1..100000] of LongInt;
  Shift         : array[1..100000] of LongInt;
  K             : Int;

procedure       OpenFiles;
begin
  Assign(Input, 'input.txt');
  Reset(Input);
  Assign(Output, 'output.txt');
  Rewrite(Output);
end;

procedure       CloseFiles;
begin
  Close(Input);
  Close(Output);
end;

procedure       ReadData;
var
  I             : LongInt;
begin
  ReadLn(N);
  for I := 1 to N do
    Read(A[I]);
  ReadLn;

  ReadLn(M);
  for I := 1 to M do
    Read(B[I]);
  ReadLn;

  ReadLn(K);
end;

procedure       ASort(L, R: Integer);
var
  I, J, X, T    : LongInt;
begin
  I := L; J := R; X := A[(L + R) div 2];
  repeat
    while A[I] < X do
      Inc(I);
    while A[J] > X do
      Dec(J);

    if I <= J then begin
      if I < J then begin
        T := A[I];
        A[I] := A[J];
        A[J] := T;
      end;

      Inc(I);
      Dec(J);
    end;
  until I > J;

  if I < R then
    ASort(I, R);
  if L < J then
    ASort(L, J);
end;

procedure       BSort(L, R: Integer);
var
  I, J, X, T    : LongInt;
begin
  I := L; J := R; X := B[(L + R) div 2];
  repeat
    while B[I] < X do
      Inc(I);
    while B[J] > X do
      Dec(J);

    if I <= J then begin
      if I < J then begin
        T := B[I];
        B[I] := B[J];
        B[J] := T;
      end;

      Inc(I);
      Dec(J);
    end;
  until I > J;

  if I < R then
    BSort(I, R);
  if L < J then
    BSort(L, J);
end;

procedure       Solve;
var
  I, U, D, KK   : LongInt;
  J, I0, J0     : LongInt;
begin
  ASort(1, N);
  BSort(1, M);

  if K = 1 then begin
    WriteLn(Int(A[1]) + Int(B[1]));
    CloseFiles;
    Halt;
  end else if K = Int(N) * Int(M) then begin
    WriteLn(Int(A[N]) + Int(B[M]));
    CloseFiles;
    Halt;
  end;

  I := 1; KK := 0;
  while I <= M do begin
    U := I; D := I;
    repeat
      Shift[D] := B[D + 1] - B[D];
      if (Int(B[D]) + Int(A[N]) >= Int(B[D + 1]) + Int(A[1])) and (D < M) then
        Inc(D);
    until not (Int(B[D]) + Int(A[N]) >= Int(B[D + 1]) + Int(A[1])) or (D >= M);
    if D + 1 > M then
      Shift[D] := N + 1
    else
      Shift[D] := B[D + 1] - B[D];

    if KK + Int(1 + D - U) * Int(N) < K then
      KK := KK + Int(1 + D - U) * Int(N)
    else begin
      I := 1; J := U; I0 := I; J0 := J;
      while K > KK do begin
        KK := KK + 1;
        while (I > Shift[J]) and (K > KK) do begin
          I := I - Shift[J];
          J := J + 1;

          KK := KK + 1;
        end;

        if K > KK then begin
          I0 := I0 + 1; I := I0; J := J0;
          if I > N then begin
            I := I - Shift[J];
            J := J + 1;

            I0 := I; J0 := J;
          end;
        end;
      end;

      WriteLn(Int(A[I]) + Int(B[J]));
      CloseFiles;
      Halt;
    end;

    I := D + 1;
  end;
end;

begin
  OpenFiles;
  ReadData;
  Solve;
  CloseFiles;
end.
