{$I+,Q-,R-,S-}
const
  inputfile = 'input.txt';
  outputfile = 'output.txt';
  maxn = 101001;
  eps = 1e-6;

type
  real = extended;
  int = longint;
  bool = boolean;
  tarrayint = array[1..maxn]of int;

var
  n, m, i, down, up, mid: int;
  numb, s: real;
  a, b: tarrayint;

procedure sort(var a: tarrayint; n: int);

procedure quicksort(l, r: int);
var
  w, x, i, j: int;
begin
  i := l;
  j := r;
  x := a[i + random(j - i + 1)];
  repeat
    while(x > a[i])do
      inc(i);
    while(x < a[j])do
      dec(j);
    if(i <= j)then begin
      w := a[i];
      a[i] := a[j];
      a[j] := w;

      inc(i);
      dec(j);
    end;
  until i > j;

  if(i < r)then
    quicksort(i, r);
  if(l < j)then
    quicksort(l, j);
end;

begin
  quicksort(1, n);
end;

function getcount(s, x: int): real;
var
  down, up, mid: int;
begin
  down := 1;
  up := m;
  while(down  + 1 < up)do begin
    mid := (down + up) div 2;
    if(b[mid] + a[s] <= x)then
      down := mid
    else
      up := mid;
  end;
  if(b[up] + a[s] <= x)then
    getcount := up
  else
    if(b[down] + a[s] <= x)then
      getcount := down
    else
      getcount := down - 1;
end;

begin
  randseed := 23;
  assign(input, inputfile);
  reset(input);
  assign(output, outputfile);
  rewrite(output);
  read(n);
  for i := 1 to n do
    read(a[i]);
  read(m);
  for i := 1 to m do
    read(b[i]);
  read(numb);

  sort(a, n);
  sort(b, m);

  down := a[1] + b[1];
  up := a[n] + b[m];

  while(down + 1 < up)do begin
    mid := (down + up) div 2;
    s := 0.0;
    for i := 1 to n do
      s := s + getcount(i, mid);
    if(s + eps < numb)then
      down := mid
    else
      up := mid;
  end;

  s := 0.0;
  for i := 1 to n do
    s := s + getcount(i, down);
  if(s + eps >= numb)then
    writeln(down)
  else
    write(up);
  close(output);
  close(input);
end.