const
     FileIn='input.txt';
     FileOut='output.txt';
     MaxN=1000;
     Delta=1;
type
    TRange=record
                 St, En: LongInt;
           end;
var
   N, S: LongInt;
   Ranges: array [1..MaxN] of TRange;
   Answer: LongInt;

procedure ReadData;
var
   F: Text;
   NRange: LongInt;
begin
     Assign (F, FileIn);
     Reset (F);
     Readln (F, N, S);
     for NRange:=1 to N
         do Readln (F, Ranges [NRange].St, Ranges [NRange].En);
     Close (F);
end;

procedure WriteData;
var
   F: Text;
begin
     Assign (F, FileOut);
     Rewrite (F);
     Writeln (F, Answer);
     Close (F);
end;

procedure QSort (aLeft, aRight: LongInt);
var
  i, j: LongInt;
  x, y: TRange;
begin
     i:=aLeft;
     j:=aRight;
     x:=Ranges [(aLeft+aRight) div 2];
     repeat
           while Ranges [i].En<x.En
                 do Inc (i);
           while x.En<Ranges [j].En
                 do Dec (j);
           if i<=j
              then begin
                   y:=Ranges [i];
                   Ranges [i]:=Ranges [j];
                   Ranges [j]:=y;
                   Inc (i);
                   Dec (j);
              end;
     until i > j;
     if aLeft<j
        then QSort (aLeft, j);
     if i<aRight
        then QSort (i, aRight);
end;

function Max (aA, aB: LongInt): LongInt;
begin
     if aA<aB
        then Max:=aB
        else Max:=aA;
end;

procedure Solve;
var
   LastPost, NewPost: LongInt;
   NRange: LongInt;
begin
     if N>=2
        then QSort (1, N);
     LastPost:=-1;
     Answer:=0;
     for NRange:=1 to N
         do begin
            NewPost:=Max (LastPost+Delta, Ranges [NRange].St);
            if NewPost<=Ranges [NRange].En
               then begin
                    LastPost:=NewPost;
                    Inc (Answer);
               end;
         end;
end;

procedure Main;
begin
     ReadData;
     Solve;
     WriteData;
end;

begin
     Main;
end.
